/* umockdev.c generated by valac 0.56.14, the Vala compiler
 * generated from umockdev.vala, do not modify */

/*
 * Copyright (C) 2012-2013 Canonical Ltd.
 * Author: Martin Pitt <martin.pitt@ubuntu.com>
 *
 * umockdev is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * umockdev is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * SECTION:umockdev
 * @title: umockdev
 * @short_description: Build a test bed for testing software that handles Linux
 * hardware devices.
 *
 * Please see README.md about an overview of the parts of umockdev, and how
 * they fit together.
 */
/**
 * SECTION:functions
 * @title: global functions
 * @short_description: Global functions
 *
 * These work independently from #UMockdevTestbed objects.
 */
/**
 * SECTION:umockdeverror
 * @title: umockdev errors
 * @short_description: #GError types for parsing umockdev files
 * hardware devices.
 *
 * See #GError for more information on error domains.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include "umockdev.h"
#include "uevent_sender.h"
#include <glib-object.h>
#include "umockdev-utils.h"
#include <unistd.h>
#include <gio/gio.h>
#include <stdarg.h>
#include <sys/socket.h>
#include "linux/input.h"
#include <time.h>
#include <pty.h>
#include <termios.h>
#include "selinux/selinux.h"
#include <stdio.h>
#include <sys/select.h>
#include <sys/time.h>
#include <errno.h>
#include <gobject/gvaluecollector.h>
#include <gio/gunixsocketaddress.h>
#include <sys/stat.h>
#include <sys/types.h>

#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))

#define UMOCKDEV_TYPE_SCRIPT_RUNNER (umockdev_script_runner_get_type ())
#define UMOCKDEV_SCRIPT_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_SCRIPT_RUNNER, UMockdevScriptRunner))
#define UMOCKDEV_SCRIPT_RUNNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_SCRIPT_RUNNER, UMockdevScriptRunnerClass))
#define UMOCKDEV_IS_SCRIPT_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_SCRIPT_RUNNER))
#define UMOCKDEV_IS_SCRIPT_RUNNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_SCRIPT_RUNNER))
#define UMOCKDEV_SCRIPT_RUNNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_SCRIPT_RUNNER, UMockdevScriptRunnerClass))

typedef struct _UMockdevScriptRunner UMockdevScriptRunner;
typedef struct _UMockdevScriptRunnerClass UMockdevScriptRunnerClass;

#define UMOCKDEV_TYPE_SOCKET_SERVER (umockdev_socket_server_get_type ())
#define UMOCKDEV_SOCKET_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_SOCKET_SERVER, UMockdevSocketServer))
#define UMOCKDEV_SOCKET_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_SOCKET_SERVER, UMockdevSocketServerClass))
#define UMOCKDEV_IS_SOCKET_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_SOCKET_SERVER))
#define UMOCKDEV_IS_SOCKET_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_SOCKET_SERVER))
#define UMOCKDEV_SOCKET_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_SOCKET_SERVER, UMockdevSocketServerClass))

typedef struct _UMockdevSocketServer UMockdevSocketServer;
typedef struct _UMockdevSocketServerClass UMockdevSocketServerClass;
enum  {
	UMOCKDEV_TESTBED_0_PROPERTY,
	UMOCKDEV_TESTBED_NUM_PROPERTIES
};
static GParamSpec* umockdev_testbed_properties[UMOCKDEV_TESTBED_NUM_PROPERTIES];
#define _umockdev_socket_server_unref0(var) ((var == NULL) ? NULL : (var = (umockdev_socket_server_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _uevent_sender_close0(var) ((var == NULL) ? NULL : (var = (uevent_sender_close (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

#define UMOCKDEV_TYPE_IOCTL_SPI_BASE (umockdev_ioctl_spi_base_get_type ())
#define UMOCKDEV_IOCTL_SPI_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_SPI_BASE, UMockdevIoctlSpiBase))
#define UMOCKDEV_IOCTL_SPI_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_SPI_BASE, UMockdevIoctlSpiBaseClass))
#define UMOCKDEV_IS_IOCTL_SPI_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_SPI_BASE))
#define UMOCKDEV_IS_IOCTL_SPI_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_SPI_BASE))
#define UMOCKDEV_IOCTL_SPI_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_SPI_BASE, UMockdevIoctlSpiBaseClass))

typedef struct _UMockdevIoctlSpiBase UMockdevIoctlSpiBase;
typedef struct _UMockdevIoctlSpiBaseClass UMockdevIoctlSpiBaseClass;

#define UMOCKDEV_TYPE_IOCTL_SPI_HANDLER (umockdev_ioctl_spi_handler_get_type ())
#define UMOCKDEV_IOCTL_SPI_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER, UMockdevIoctlSpiHandler))
#define UMOCKDEV_IOCTL_SPI_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER, UMockdevIoctlSpiHandlerClass))
#define UMOCKDEV_IS_IOCTL_SPI_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER))
#define UMOCKDEV_IS_IOCTL_SPI_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER))
#define UMOCKDEV_IOCTL_SPI_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_SPI_HANDLER, UMockdevIoctlSpiHandlerClass))

typedef struct _UMockdevIoctlSpiHandler UMockdevIoctlSpiHandler;
typedef struct _UMockdevIoctlSpiHandlerClass UMockdevIoctlSpiHandlerClass;

#define UMOCKDEV_TYPE_IOCTL_TREE_HANDLER (umockdev_ioctl_tree_handler_get_type ())
#define UMOCKDEV_IOCTL_TREE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandler))
#define UMOCKDEV_IOCTL_TREE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandlerClass))
#define UMOCKDEV_IS_IOCTL_TREE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER))
#define UMOCKDEV_IS_IOCTL_TREE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER))
#define UMOCKDEV_IOCTL_TREE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandlerClass))

typedef struct _UMockdevIoctlTreeHandler UMockdevIoctlTreeHandler;
typedef struct _UMockdevIoctlTreeHandlerClass UMockdevIoctlTreeHandlerClass;

#define UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER (umockdev_ioctl_usb_pcap_handler_get_type ())
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandler))
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandlerClass))
#define UMOCKDEV_IS_IOCTL_USB_PCAP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER))
#define UMOCKDEV_IS_IOCTL_USB_PCAP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER))
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandlerClass))

typedef struct _UMockdevIoctlUsbPcapHandler UMockdevIoctlUsbPcapHandler;
typedef struct _UMockdevIoctlUsbPcapHandlerClass UMockdevIoctlUsbPcapHandlerClass;
#define _umockdev_script_runner_unref0(var) ((var == NULL) ? NULL : (var = (umockdev_script_runner_unref (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _UMockdevScriptRunnerPrivate UMockdevScriptRunnerPrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _UMockdevParamSpecScriptRunner UMockdevParamSpecScriptRunner;
typedef struct _UMockdevSocketServerPrivate UMockdevSocketServerPrivate;
typedef struct _UMockdevParamSpecSocketServer UMockdevParamSpecSocketServer;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Block1Data {
	int _ref_count_;
	GMainLoop* loop;
};

struct _UMockdevTestbedPrivate {
	gchar* root_dir;
	gchar* sys_dir;
	GRegex* re_record_val;
	GRegex* re_record_keyval;
	GRegex* re_record_optval;
	uevent_sender* ev_sender;
	GHashTable* dev_fd;
	GHashTable* dev_script_runner;
	UMockdevSocketServer* socket_server;
	GHashTable* custom_handlers;
	GThread* worker_thread;
	GMainContext* worker_ctx;
	GMainLoop* worker_loop;
};

struct _UMockdevScriptRunner {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UMockdevScriptRunnerPrivate * priv;
};

struct _UMockdevScriptRunnerClass {
	GTypeClass parent_class;
	void (*finalize) (UMockdevScriptRunner *self);
};

struct _UMockdevScriptRunnerPrivate {
	gchar* _device;
	gchar* script_file;
	GThread* thread;
	FILE* script;
	gint fd;
	gboolean running;
	guint fuzz;
};

struct _UMockdevParamSpecScriptRunner {
	GParamSpec parent_instance;
};

struct _UMockdevSocketServer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UMockdevSocketServerPrivate * priv;
};

struct _UMockdevSocketServerClass {
	GTypeClass parent_class;
	void (*finalize) (UMockdevSocketServer *self);
};

struct _UMockdevSocketServerPrivate {
	GSocket** listen_sockets;
	gint listen_sockets_length1;
	gint _listen_sockets_size_;
	GHashTable* socket_scriptfile;
	GHashTable* script_runners;
	GThread* thread;
	gboolean running;
	gint ctrl_r;
	gint ctrl_w;
};

struct _UMockdevParamSpecSocketServer {
	GParamSpec parent_instance;
};

/**
 * UMockdevError:
 * @UMOCKDEV_ERROR_PARSE:
 * There is a malformed or missing line in the device description.
 * @UMOCKDEV_ERROR_VALUE:
 * A value in the device description has an invalid value, for example a device
 * path does not start with "/devices/".
 *
 * Error codes for parsing umockdev files.
 */

VALA_EXTERN gboolean umockdev___in_mock_env_initialized;
gboolean umockdev___in_mock_env_initialized = FALSE;
VALA_EXTERN gboolean umockdev___in_mock_env_result;
gboolean umockdev___in_mock_env_result = FALSE;
static gint UMockdevTestbed_private_offset;
static gpointer umockdev_testbed_parent_class = NULL;
static GHashTable* umockdev_testbed_bus_lookup_table;
static GHashTable* umockdev_testbed_bus_lookup_table = NULL;
static gint UMockdevScriptRunner_private_offset;
static gpointer umockdev_script_runner_parent_class = NULL;
static gint UMockdevSocketServer_private_offset;
static gpointer umockdev_socket_server_parent_class = NULL;

VALA_EXTERN void umockdev_checked_mkdir (const gchar* path,
                             gint mode);
VALA_EXTERN void umockdev_checked_mkdir_with_parents (const gchar* path,
                                          gint mode);
VALA_EXTERN GThread* umockdev_create_worker_thread (GMainLoop* loop);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda4_ (Block1Data* _data1_);
static gpointer ___lambda4__gthread_func (gpointer self);
VALA_EXTERN gpointer umockdev_script_runner_ref (gpointer instance);
VALA_EXTERN void umockdev_script_runner_unref (gpointer instance);
VALA_EXTERN GParamSpec* umockdev_param_spec_script_runner (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void umockdev_value_set_script_runner (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void umockdev_value_take_script_runner (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer umockdev_value_get_script_runner (const GValue* value);
VALA_EXTERN GType umockdev_script_runner_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer umockdev_socket_server_ref (gpointer instance);
VALA_EXTERN void umockdev_socket_server_unref (gpointer instance);
VALA_EXTERN GParamSpec* umockdev_param_spec_socket_server (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void umockdev_value_set_socket_server (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void umockdev_value_take_socket_server (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer umockdev_value_get_socket_server (const GValue* value);
VALA_EXTERN GType umockdev_socket_server_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void umockdev_script_runner_stop (UMockdevScriptRunner* self);
static void _umockdev_testbed___lambda5_ (UMockdevTestbed* self,
                                   const gchar* key,
                                   UMockdevIoctlBase* val);
VALA_EXTERN void umockdev_ioctl_base_unregister_path (UMockdevIoctlBase* self,
                                          const gchar* devnode);
static void __umockdev_testbed___lambda5__gh_func (gconstpointer key,
                                            gconstpointer value,
                                            gpointer self);
VALA_EXTERN void umockdev_socket_server_stop (UMockdevSocketServer* self);
static void _g_free0_ (gpointer var);
static void _umockdev_script_runner_unref0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN void umockdev_ioctl_base_register_path (UMockdevIoctlBase* self,
                                        GMainContext* ctx,
                                        const gchar* devnode,
                                        const gchar* sockpath);
static gchar* umockdev_testbed_get_attribute (UMockdevTestbed* self,
                                       const gchar* devpath,
                                       const gchar* name);
static gchar* umockdev_testbed_add_devicev_no_uevent (UMockdevTestbed* self,
                                               const gchar* subsystem,
                                               const gchar* name,
                                               const gchar* parent,
                                               gchar** attributes,
                                               gchar** properties);
static gboolean umockdev_testbed_subsystem_is_bus (const gchar* subsystem);
VALA_EXTERN gchar* umockdev_make_dotdots (const gchar* path);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gchar* umockdev_find_devnode (const gchar* devpath);
static gchar* umockdev_testbed_add_dev_from_string (UMockdevTestbed* self,
                                             const gchar* data,
                                             GError** error);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
VALA_EXTERN UMockdevIoctlSpiHandler* umockdev_ioctl_spi_handler_new (const gchar* file);
VALA_EXTERN UMockdevIoctlSpiHandler* umockdev_ioctl_spi_handler_construct (GType object_type,
                                                               const gchar* file);
VALA_EXTERN GType umockdev_ioctl_spi_base_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType umockdev_ioctl_spi_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UMockdevIoctlTreeHandler* umockdev_ioctl_tree_handler_new (const gchar* file);
VALA_EXTERN UMockdevIoctlTreeHandler* umockdev_ioctl_tree_handler_construct (GType object_type,
                                                                 const gchar* file);
VALA_EXTERN GType umockdev_ioctl_tree_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType umockdev_ioctl_usb_pcap_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UMockdevIoctlUsbPcapHandler* umockdev_ioctl_usb_pcap_handler_new (const gchar* file,
                                                                  gint bus,
                                                                  gint device);
VALA_EXTERN UMockdevIoctlUsbPcapHandler* umockdev_ioctl_usb_pcap_handler_construct (GType object_type,
                                                                        const gchar* file,
                                                                        gint bus,
                                                                        gint device);
VALA_EXTERN UMockdevScriptRunner* umockdev_script_runner_new (const gchar* device,
                                                  const gchar* script_file,
                                                  gint fd,
                                                  GError** error);
VALA_EXTERN UMockdevScriptRunner* umockdev_script_runner_construct (GType object_type,
                                                        const gchar* device,
                                                        const gchar* script_file,
                                                        gint fd,
                                                        GError** error);
VALA_EXTERN UMockdevSocketServer* umockdev_socket_server_new (void);
VALA_EXTERN UMockdevSocketServer* umockdev_socket_server_construct (GType object_type);
VALA_EXTERN void umockdev_socket_server_add (UMockdevSocketServer* self,
                                 const gchar* sock_path,
                                 gint fd,
                                 const gchar* record_file);
VALA_EXTERN gchar* umockdev_script_runner_encode (guint8* data,
                                      gint data_length1);
static GHashTable* umockdev_testbed_create_bus_lookup (void);
static gchar* umockdev_testbed_record_parse_line (UMockdevTestbed* self,
                                           const gchar* data,
                                           gchar* type,
                                           gchar** key,
                                           gchar** val);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN guint8* umockdev_decode_hex (const gchar* data,
                             gint* result_length1,
                             GError** error);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void umockdev_testbed_create_node_for_device (UMockdevTestbed* self,
                                              const gchar* subsystem,
                                              const gchar* node_path,
                                              guint8* node_contents,
                                              gint node_contents_length1,
                                              const gchar* majmin,
                                              const gchar* selinux_context,
                                              GError** error);
static void umockdev_testbed_set_selinux_context (UMockdevTestbed* self,
                                           const gchar* path,
                                           const gchar* context);
static void umockdev_testbed_finalize (GObject * obj);
static GType umockdev_testbed_get_type_once (void);
VALA_EXTERN guint8 umockdev_hexdigit (gchar c);
static void umockdev_script_runner_set_device (UMockdevScriptRunner* self,
                                        const gchar* value);
static void* umockdev_script_runner_run (UMockdevScriptRunner* self);
static gpointer _umockdev_script_runner_run_gthread_func (gpointer self);
VALA_EXTERN const gchar* umockdev_script_runner_get_device (UMockdevScriptRunner* self);
static guint8* umockdev_script_runner_next_line (UMockdevScriptRunner* self,
                                          gchar* op,
                                          guint32* delta,
                                          gint* result_length1);
static void umockdev_script_runner_op_write (UMockdevScriptRunner* self,
                                      guint8* data,
                                      gint data_length1,
                                      guint32 delta);
static guint8* umockdev_script_runner_decode (const gchar* quoted,
                                       gint* result_length1);
static guint umockdev_script_runner_hamming (guint8* d1,
                                      gint d1_length1,
                                      guint8* d2,
                                      gint d2_length1);
static void _vala_array_add12 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add13 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add14 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add15 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add16 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add17 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add18 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void _vala_array_add19 (guint8* * array,
                        gint* length,
                        gint* size,
                        guint8 value);
static void umockdev_script_runner_finalize (UMockdevScriptRunner * obj);
static GType umockdev_script_runner_get_type_once (void);
static void* umockdev_socket_server_run (UMockdevSocketServer* self);
static gpointer _umockdev_socket_server_run_gthread_func (gpointer self);
static void _vala_array_add20 (GSocket** * array,
                        gint* length,
                        gint* size,
                        GSocket* value);
static void umockdev_socket_server_finalize (UMockdevSocketServer * obj);
static GType umockdev_socket_server_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

void
umockdev_checked_mkdir (const gchar* path,
                        gint mode)
{
#line 30 "../src/umockdev.vala"
	g_return_if_fail (path != NULL);
#line 32 "../src/umockdev.vala"
	if (g_mkdir (path, mode) < 0) {
#line 33 "../src/umockdev.vala"
		g_error ("umockdev.vala:33: cannot create directory %s: %m", path);
#line 516 "umockdev.c"
	}
}

void
umockdev_checked_mkdir_with_parents (const gchar* path,
                                     gint mode)
{
#line 36 "../src/umockdev.vala"
	g_return_if_fail (path != NULL);
#line 38 "../src/umockdev.vala"
	if (g_mkdir_with_parents (path, mode) < 0) {
#line 39 "../src/umockdev.vala"
		g_error ("umockdev.vala:39: cannot create directory with parents %s: %m", path);
#line 530 "umockdev.c"
	}
}

/**
 * UMockdevTestbed:
 *
 * The #UMockdevTestbed class builds a temporary sandbox for mock devices.
 * You can add a number of devices including arbitrary sysfs attributes and
 * udev properties, and then run your software in that test bed that is
 * independent of the actual hardware it is running on.  With this you can
 * simulate particular hardware in virtual environments up to some degree,
 * without needing any particular privileges or disturbing the whole system.
 *
 * You can either add devices by specifying individual device paths,
 * properties, and attributes, or use the umockdev-record tool to create a human
 * readable/editable record of a real device (and all its parents) and load
 * that into the testbed with umockdev_testbed_add_from_string().
 *
 * Instantiating a #UMockdevTestbed object creates a temporary directory with
 * an empty sysfs tree and sets the $UMOCKDEV_DIR environment variable so that
 * programs subsequently started under umockdev-wrapper will use the test bed
 * instead of the system's real sysfs.
 */
static gpointer
_g_main_loop_ref0 (gpointer self)
{
#line 74 "../src/umockdev.vala"
	return self ? g_main_loop_ref (self) : NULL;
#line 559 "umockdev.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 74 "../src/umockdev.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 74 "../src/umockdev.vala"
	return _data1_;
#line 569 "umockdev.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 74 "../src/umockdev.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 74 "../src/umockdev.vala"
		_g_main_loop_unref0 (_data1_->loop);
#line 74 "../src/umockdev.vala"
		g_slice_free (Block1Data, _data1_);
#line 583 "umockdev.c"
	}
}

static gpointer
_g_main_context_ref0 (gpointer self)
{
#line 78 "../src/umockdev.vala"
	return self ? g_main_context_ref (self) : NULL;
#line 592 "umockdev.c"
}

static void
__lambda4_ (Block1Data* _data1_)
{
	GMainContext* ctx = NULL;
	GMainContext* _tmp0_;
	GMainContext* _tmp1_;
#line 78 "../src/umockdev.vala"
	_tmp0_ = g_main_loop_get_context (_data1_->loop);
#line 78 "../src/umockdev.vala"
	_tmp1_ = _g_main_context_ref0 (_tmp0_);
#line 78 "../src/umockdev.vala"
	ctx = _tmp1_;
#line 80 "../src/umockdev.vala"
	g_main_context_push_thread_default (ctx);
#line 81 "../src/umockdev.vala"
	g_main_loop_run (_data1_->loop);
#line 82 "../src/umockdev.vala"
	g_main_context_pop_thread_default (ctx);
#line 77 "../src/umockdev.vala"
	_g_main_context_unref0 (ctx);
#line 615 "umockdev.c"
}

static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
#line 77 "../src/umockdev.vala"
	__lambda4_ (self);
#line 624 "umockdev.c"
	result = NULL;
#line 77 "../src/umockdev.vala"
	block1_data_unref (self);
#line 77 "../src/umockdev.vala"
	return result;
#line 630 "umockdev.c"
}

GThread*
umockdev_create_worker_thread (GMainLoop* loop)
{
	Block1Data* _data1_;
	GMainLoop* _tmp0_;
	GThread* _tmp1_;
	GThread* result;
#line 74 "../src/umockdev.vala"
	g_return_val_if_fail (loop != NULL, NULL);
#line 74 "../src/umockdev.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 74 "../src/umockdev.vala"
	_data1_->_ref_count_ = 1;
#line 74 "../src/umockdev.vala"
	_tmp0_ = _g_main_loop_ref0 (loop);
#line 74 "../src/umockdev.vala"
	_g_main_loop_unref0 (_data1_->loop);
#line 74 "../src/umockdev.vala"
	_data1_->loop = _tmp0_;
#line 77 "../src/umockdev.vala"
	_tmp1_ = g_thread_new ("umockdev-testbed-worker", ___lambda4__gthread_func, block1_data_ref (_data1_));
#line 77 "../src/umockdev.vala"
	result = _tmp1_;
#line 77 "../src/umockdev.vala"
	block1_data_unref (_data1_);
#line 77 "../src/umockdev.vala"
	_data1_ = NULL;
#line 77 "../src/umockdev.vala"
	return result;
#line 662 "umockdev.c"
}

static inline gpointer
umockdev_testbed_get_instance_private (UMockdevTestbed* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevTestbed_private_offset);
}

static void
_umockdev_testbed___lambda5_ (UMockdevTestbed* self,
                              const gchar* key,
                              UMockdevIoctlBase* val)
{
#line 137 "../src/umockdev.vala"
	g_return_if_fail (key != NULL);
#line 137 "../src/umockdev.vala"
	g_return_if_fail (val != NULL);
#line 138 "../src/umockdev.vala"
	umockdev_ioctl_base_unregister_path (val, key);
#line 682 "umockdev.c"
}

static void
__umockdev_testbed___lambda5__gh_func (gconstpointer key,
                                       gconstpointer value,
                                       gpointer self)
{
#line 137 "../src/umockdev.vala"
	_umockdev_testbed___lambda5_ ((UMockdevTestbed*) self, (const gchar*) key, (UMockdevIoctlBase*) value);
#line 692 "umockdev.c"
}

/**
     * umockdev_testbed_new:
     *
     * Create a new #UMockdevTestbed object. This is initially empty, call
     * methods like #umockdev_testbed_add_device or
     * #umockdev_testbed_add_from_string to fill it.
     *
     * Returns: The newly created #UMockdevTestbed object.
     */
static void
_g_free0_ (gpointer var)
{
#line 112 "../src/umockdev.vala"
	var = (g_free (var), NULL);
#line 709 "umockdev.c"
}

static void
_umockdev_script_runner_unref0_ (gpointer var)
{
#line 113 "../src/umockdev.vala"
	(var == NULL) ? NULL : (var = (umockdev_script_runner_unref (var), NULL));
#line 717 "umockdev.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 114 "../src/umockdev.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 725 "umockdev.c"
}

UMockdevTestbed*
umockdev_testbed_construct (GType object_type)
{
	UMockdevTestbed * self = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* bus_path = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* class_path = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	GHashFunc _tmp11_;
	GEqualFunc _tmp12_;
	GHashTable* _tmp13_;
	GHashFunc _tmp14_;
	GEqualFunc _tmp15_;
	GHashTable* _tmp16_;
	GHashFunc _tmp17_;
	GEqualFunc _tmp18_;
	GHashTable* _tmp19_;
	const gchar* _tmp20_;
	GMainContext* _tmp21_;
	GMainContext* _tmp22_;
	GMainLoop* _tmp23_;
	GMainLoop* _tmp24_;
	GThread* _tmp25_;
	UMockdevIoctlBase* handler = NULL;
	UMockdevIoctlBase* _tmp26_;
	gchar* sockpath = NULL;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	GMainContext* _tmp29_;
	const gchar* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 96 "../src/umockdev.vala"
	self = (UMockdevTestbed*) g_object_new (object_type, NULL);
#line 766 "umockdev.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 99 "../src/umockdev.vala"
		_tmp1_ = g_dir_make_tmp ("umockdev.XXXXXX", &_inner_error0_);
#line 99 "../src/umockdev.vala"
		_tmp0_ = _tmp1_;
#line 99 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 779 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 99 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../src/umockdev.vala"
			return NULL;
#line 788 "umockdev.c"
		}
#line 99 "../src/umockdev.vala"
		_tmp2_ = _tmp0_;
#line 99 "../src/umockdev.vala"
		_tmp0_ = NULL;
#line 99 "../src/umockdev.vala"
		_g_free0 (self->priv->root_dir);
#line 99 "../src/umockdev.vala"
		self->priv->root_dir = _tmp2_;
#line 98 "../src/umockdev.vala"
		_g_free0 (_tmp0_);
#line 800 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
#line 98 "../src/umockdev.vala"
		e = _inner_error0_;
#line 98 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 101 "../src/umockdev.vala"
		_tmp3_ = e->message;
#line 101 "../src/umockdev.vala"
		g_error ("umockdev.vala:101: Cannot create temporary directory: %s", _tmp3_);
#line 98 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 817 "umockdev.c"
	}
	__finally0:
#line 98 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 98 "../src/umockdev.vala"
		return NULL;
#line 828 "umockdev.c"
	}
#line 103 "../src/umockdev.vala"
	_tmp4_ = self->priv->root_dir;
#line 103 "../src/umockdev.vala"
	_tmp5_ = g_build_filename (_tmp4_, "sys", NULL);
#line 103 "../src/umockdev.vala"
	_g_free0 (self->priv->sys_dir);
#line 103 "../src/umockdev.vala"
	self->priv->sys_dir = _tmp5_;
#line 104 "../src/umockdev.vala"
	_tmp6_ = self->priv->sys_dir;
#line 104 "../src/umockdev.vala"
	umockdev_checked_mkdir (_tmp6_, 0755);
#line 107 "../src/umockdev.vala"
	_tmp7_ = self->priv->sys_dir;
#line 107 "../src/umockdev.vala"
	_tmp8_ = g_build_filename (_tmp7_, "bus", NULL);
#line 107 "../src/umockdev.vala"
	bus_path = _tmp8_;
#line 108 "../src/umockdev.vala"
	umockdev_checked_mkdir (bus_path, 0755);
#line 109 "../src/umockdev.vala"
	_tmp9_ = self->priv->sys_dir;
#line 109 "../src/umockdev.vala"
	_tmp10_ = g_build_filename (_tmp9_, "class", NULL);
#line 109 "../src/umockdev.vala"
	class_path = _tmp10_;
#line 110 "../src/umockdev.vala"
	umockdev_checked_mkdir (class_path, 0755);
#line 112 "../src/umockdev.vala"
	_tmp11_ = g_str_hash;
#line 112 "../src/umockdev.vala"
	_tmp12_ = g_str_equal;
#line 112 "../src/umockdev.vala"
	_tmp13_ = g_hash_table_new_full (_tmp11_, _tmp12_, _g_free0_, NULL);
#line 112 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->dev_fd);
#line 112 "../src/umockdev.vala"
	self->priv->dev_fd = _tmp13_;
#line 113 "../src/umockdev.vala"
	_tmp14_ = g_str_hash;
#line 113 "../src/umockdev.vala"
	_tmp15_ = g_str_equal;
#line 113 "../src/umockdev.vala"
	_tmp16_ = g_hash_table_new_full (_tmp14_, _tmp15_, _g_free0_, _umockdev_script_runner_unref0_);
#line 113 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->dev_script_runner);
#line 113 "../src/umockdev.vala"
	self->priv->dev_script_runner = _tmp16_;
#line 114 "../src/umockdev.vala"
	_tmp17_ = g_str_hash;
#line 114 "../src/umockdev.vala"
	_tmp18_ = g_str_equal;
#line 114 "../src/umockdev.vala"
	_tmp19_ = g_hash_table_new_full (_tmp17_, _tmp18_, _g_free0_, _g_object_unref0_);
#line 114 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->custom_handlers);
#line 114 "../src/umockdev.vala"
	self->priv->custom_handlers = _tmp19_;
#line 116 "../src/umockdev.vala"
	_tmp20_ = self->priv->root_dir;
#line 116 "../src/umockdev.vala"
	umockdev_utils_checked_setenv ("UMOCKDEV_DIR", _tmp20_);
#line 118 "../src/umockdev.vala"
	_tmp21_ = g_main_context_new ();
#line 118 "../src/umockdev.vala"
	_g_main_context_unref0 (self->priv->worker_ctx);
#line 118 "../src/umockdev.vala"
	self->priv->worker_ctx = _tmp21_;
#line 119 "../src/umockdev.vala"
	_tmp22_ = self->priv->worker_ctx;
#line 119 "../src/umockdev.vala"
	_tmp23_ = g_main_loop_new (_tmp22_, FALSE);
#line 119 "../src/umockdev.vala"
	_g_main_loop_unref0 (self->priv->worker_loop);
#line 119 "../src/umockdev.vala"
	self->priv->worker_loop = _tmp23_;
#line 120 "../src/umockdev.vala"
	_tmp24_ = self->priv->worker_loop;
#line 120 "../src/umockdev.vala"
	_tmp25_ = umockdev_create_worker_thread (_tmp24_);
#line 120 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->worker_thread);
#line 120 "../src/umockdev.vala"
	self->priv->worker_thread = _tmp25_;
#line 123 "../src/umockdev.vala"
	_tmp26_ = umockdev_ioctl_base_new ();
#line 123 "../src/umockdev.vala"
	handler = _tmp26_;
#line 124 "../src/umockdev.vala"
	_tmp27_ = self->priv->root_dir;
#line 124 "../src/umockdev.vala"
	_tmp28_ = g_build_filename (_tmp27_, "ioctl", "_default", NULL);
#line 124 "../src/umockdev.vala"
	sockpath = _tmp28_;
#line 125 "../src/umockdev.vala"
	_tmp29_ = self->priv->worker_ctx;
#line 125 "../src/umockdev.vala"
	umockdev_ioctl_base_register_path (handler, _tmp29_, "_default", sockpath);
#line 127 "../src/umockdev.vala"
	_tmp30_ = self->priv->root_dir;
#line 127 "../src/umockdev.vala"
	g_debug ("umockdev.vala:127: Created udev test bed %s", _tmp30_);
#line 96 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 96 "../src/umockdev.vala"
	_g_object_unref0 (handler);
#line 96 "../src/umockdev.vala"
	_g_free0 (class_path);
#line 96 "../src/umockdev.vala"
	_g_free0 (bus_path);
#line 96 "../src/umockdev.vala"
	return self;
#line 942 "umockdev.c"
}

UMockdevTestbed*
umockdev_testbed_new (void)
{
#line 96 "../src/umockdev.vala"
	return umockdev_testbed_construct (UMOCKDEV_TYPE_TESTBED);
#line 950 "umockdev.c"
}

/**
     * umockdev_testbed_get_root_dir:
     * @self: A #UMockdevTestbed.
     *
     * Get the root directory for the testbed. This is mostly useful for
     * setting up the "dev/" or "proc/" testbed directories in this root
     * directory. For getting the mocked "sys/" dir, use
     * #umockdev_testbed_get_sys_dir.
     *
     * Returns: The testbed's root directory.
     */
gchar*
umockdev_testbed_get_root_dir (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 171 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 173 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 173 "../src/umockdev.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 173 "../src/umockdev.vala"
	result = _tmp1_;
#line 173 "../src/umockdev.vala"
	return result;
#line 980 "umockdev.c"
}

/**
     * umockdev_testbed_get_sys_dir:
     * @self: A #UMockdevTestbed.
     *
     * Get the sysfs directory for the testbed.
     *
     * Returns: The testbed's sysfs directory.
     */
gchar*
umockdev_testbed_get_sys_dir (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 184 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 186 "../src/umockdev.vala"
	_tmp0_ = self->priv->sys_dir;
#line 186 "../src/umockdev.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 186 "../src/umockdev.vala"
	result = _tmp1_;
#line 186 "../src/umockdev.vala"
	return result;
#line 1007 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name
     * @value: Attribute string value
     *
     * Set a text sysfs attribute for a device.
     */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1566 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1567 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1567 "glib-2.0.vapi"
	res_length1 = -1;
#line 1567 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1568 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1568 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1568 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1569 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1569 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1569 "glib-2.0.vapi"
	if (result_length1) {
#line 1569 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1053 "umockdev.c"
	}
#line 1569 "glib-2.0.vapi"
	result = _tmp2_;
#line 1569 "glib-2.0.vapi"
	return result;
#line 1059 "umockdev.c"
}

void
umockdev_testbed_set_attribute (UMockdevTestbed* self,
                                const gchar* devpath,
                                const gchar* name,
                                const gchar* value)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 198 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 198 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 198 "../src/umockdev.vala"
	g_return_if_fail (value != NULL);
#line 200 "../src/umockdev.vala"
	_tmp0_ = string_get_data (value, &_tmp1_);
#line 200 "../src/umockdev.vala"
	_tmp0__length1 = _tmp1_;
#line 200 "../src/umockdev.vala"
	_tmp2_ = _tmp0_;
#line 200 "../src/umockdev.vala"
	_tmp2__length1 = _tmp0__length1;
#line 200 "../src/umockdev.vala"
	umockdev_testbed_set_attribute_binary (self, devpath, name, _tmp2_, (gint) _tmp2__length1);
#line 1091 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute_binary:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name (may contain leading directories like
     *        "queue/rotational")
     * @value: Attribute binary value
     * @value_length1: Length of @value in bytes.
     *
     * Set a binary sysfs attribute for a device.
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 1121 "umockdev.c"
}

void
umockdev_testbed_set_attribute_binary (UMockdevTestbed* self,
                                       const gchar* devpath,
                                       const gchar* name,
                                       guint8* value,
                                       gint value_length1)
{
	gchar* attr_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 214 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 214 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 216 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 216 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, name, NULL);
#line 216 "../src/umockdev.vala"
	attr_path = _tmp1_;
#line 217 "../src/umockdev.vala"
	if (string_contains (name, "/")) {
#line 1149 "umockdev.c"
		gchar* d = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
#line 218 "../src/umockdev.vala"
		_tmp2_ = attr_path;
#line 218 "../src/umockdev.vala"
		_tmp3_ = g_path_get_dirname (_tmp2_);
#line 218 "../src/umockdev.vala"
		d = _tmp3_;
#line 219 "../src/umockdev.vala"
		_tmp4_ = d;
#line 219 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp4_, 0755);
#line 217 "../src/umockdev.vala"
		_g_free0 (d);
#line 1166 "umockdev.c"
	}
	{
		const gchar* _tmp5_;
#line 223 "../src/umockdev.vala"
		_tmp5_ = attr_path;
#line 223 "../src/umockdev.vala"
		g_file_set_contents (_tmp5_, (const char*) value, (gsize) value_length1, &_inner_error0_);
#line 223 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1178 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 223 "../src/umockdev.vala"
			_g_free0 (attr_path);
#line 223 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 223 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 223 "../src/umockdev.vala"
			return;
#line 1189 "umockdev.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_;
#line 222 "../src/umockdev.vala"
		e = _inner_error0_;
#line 222 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 225 "../src/umockdev.vala"
		_tmp6_ = e->message;
#line 225 "../src/umockdev.vala"
		g_error ("umockdev.vala:225: Cannot write attribute file: %s", _tmp6_);
#line 222 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 1207 "umockdev.c"
	}
	__finally0:
#line 222 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/umockdev.vala"
		_g_free0 (attr_path);
#line 222 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 222 "../src/umockdev.vala"
		return;
#line 1220 "umockdev.c"
	}
#line 214 "../src/umockdev.vala"
	_g_free0 (attr_path);
#line 1224 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute_int:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name (may contain leading directories like
     *        "queue/rotational")
     * @value: Attribute integer value
     *
     * Set an integer sysfs attribute for a device.
     */
void
umockdev_testbed_set_attribute_int (UMockdevTestbed* self,
                                    const gchar* devpath,
                                    const gchar* name,
                                    gint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 239 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 239 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 241 "../src/umockdev.vala"
	_tmp0_ = g_strdup_printf ("%i", value);
#line 241 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 241 "../src/umockdev.vala"
	umockdev_testbed_set_attribute (self, devpath, name, _tmp1_);
#line 241 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 1259 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute_hex:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name
     * @value: Attribute integer value
     *
     * Set an integer sysfs attribute for a device. Set an integer udev
     * property for a device. @value is interpreted as a hexadecimal number.
     * For example, for value==31 this sets the attribute contents to "1f".
     */
void
umockdev_testbed_set_attribute_hex (UMockdevTestbed* self,
                                    const gchar* devpath,
                                    const gchar* name,
                                    guint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 255 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 255 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 257 "../src/umockdev.vala"
	_tmp0_ = g_strdup_printf ("%x", value);
#line 257 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 257 "../src/umockdev.vala"
	umockdev_testbed_set_attribute (self, devpath, name, _tmp1_);
#line 257 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 1295 "umockdev.c"
}

/**
     * umockdev_testbed_set_attribute_link:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Attribute name
     * @value: Attribute link target value
     *
     * Set a symlink sysfs attribute for a device; this is primarily important
     * for setting "driver" links.
     */
void
umockdev_testbed_set_attribute_link (UMockdevTestbed* self,
                                     const gchar* devpath,
                                     const gchar* name,
                                     const gchar* value)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* dir = NULL;
	gchar* _tmp2_;
#line 270 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 270 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 270 "../src/umockdev.vala"
	g_return_if_fail (value != NULL);
#line 272 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 272 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, name, NULL);
#line 272 "../src/umockdev.vala"
	path = _tmp1_;
#line 273 "../src/umockdev.vala"
	_tmp2_ = g_path_get_dirname (path);
#line 273 "../src/umockdev.vala"
	dir = _tmp2_;
#line 274 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (dir, 0755);
#line 275 "../src/umockdev.vala"
	if (symlink (value, path) < 0) {
#line 276 "../src/umockdev.vala"
		g_error ("umockdev.vala:276: Cannot create symlink %s: %m", path);
#line 1343 "umockdev.c"
	}
#line 270 "../src/umockdev.vala"
	_g_free0 (dir);
#line 270 "../src/umockdev.vala"
	_g_free0 (path);
#line 1349 "umockdev.c"
}

static gchar*
umockdev_testbed_get_attribute (UMockdevTestbed* self,
                                const gchar* devpath,
                                const gchar* name)
{
	gchar* read = NULL;
	gchar* attr_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 280 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 280 "../src/umockdev.vala"
	g_return_val_if_fail (devpath != NULL, NULL);
#line 280 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 282 "../src/umockdev.vala"
	read = NULL;
#line 283 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 283 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, name, NULL);
#line 283 "../src/umockdev.vala"
	attr_path = _tmp1_;
#line 1377 "umockdev.c"
	{
		gchar* _tmp2_ = NULL;
#line 286 "../src/umockdev.vala"
		g_file_get_contents (attr_path, &_tmp2_, NULL, &_inner_error0_);
#line 286 "../src/umockdev.vala"
		_g_free0 (read);
#line 286 "../src/umockdev.vala"
		read = _tmp2_;
#line 286 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 286 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1390 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 286 "../src/umockdev.vala"
			_g_free0 (attr_path);
#line 286 "../src/umockdev.vala"
			_g_free0 (read);
#line 286 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 286 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 286 "../src/umockdev.vala"
			return NULL;
#line 1403 "umockdev.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
#line 285 "../src/umockdev.vala"
		e = _inner_error0_;
#line 285 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 288 "../src/umockdev.vala"
		_tmp3_ = e->message;
#line 288 "../src/umockdev.vala"
		g_error ("umockdev.vala:288: Cannot read attribute file: %s", _tmp3_);
#line 285 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 1421 "umockdev.c"
	}
	__finally0:
#line 285 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "../src/umockdev.vala"
		_g_free0 (attr_path);
#line 285 "../src/umockdev.vala"
		_g_free0 (read);
#line 285 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 285 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 285 "../src/umockdev.vala"
		return NULL;
#line 1436 "umockdev.c"
	}
#line 290 "../src/umockdev.vala"
	result = read;
#line 290 "../src/umockdev.vala"
	_g_free0 (attr_path);
#line 290 "../src/umockdev.vala"
	return result;
#line 1444 "umockdev.c"
}

/**
     * umockdev_testbed_get_property:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Property name
     *
     * Get a string udev property for a device. Note that this is mostly for
     * testing umockdev itself; for real application testing, use
     * libudev/gudev.
     *
     * Returns: property value, or %NULL if it does not exist
     */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 1479 "umockdev.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 1488 "umockdev.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1507 "umockdev.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1511 "umockdev.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1517 "umockdev.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1527 "umockdev.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1535 "umockdev.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1539 "umockdev.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 1545 "umockdev.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 1555 "umockdev.c"
}

gchar*
umockdev_testbed_get_property (UMockdevTestbed* self,
                               const gchar* devpath,
                               const gchar* name)
{
	gchar* uevent_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* ret = NULL;
	GFile* f = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	gchar* prefix = NULL;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 305 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 305 "../src/umockdev.vala"
	g_return_val_if_fail (devpath != NULL, NULL);
#line 305 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 307 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 307 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, "uevent", NULL);
#line 307 "../src/umockdev.vala"
	uevent_path = _tmp1_;
#line 308 "../src/umockdev.vala"
	ret = NULL;
#line 310 "../src/umockdev.vala"
	_tmp2_ = uevent_path;
#line 310 "../src/umockdev.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 310 "../src/umockdev.vala"
	f = _tmp3_;
#line 311 "../src/umockdev.vala"
	_tmp4_ = g_strconcat (name, "=", NULL);
#line 311 "../src/umockdev.vala"
	prefix = _tmp4_;
#line 1598 "umockdev.c"
	{
		GFileInputStream* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFileInputStream* _tmp7_;
		GDataInputStream* inp = NULL;
		GDataInputStream* _tmp8_;
		gchar* line = NULL;
		gsize len = 0UL;
		GDataInputStream* _tmp22_;
#line 313 "../src/umockdev.vala"
		_tmp6_ = f;
#line 313 "../src/umockdev.vala"
		_tmp7_ = g_file_read (_tmp6_, NULL, &_inner_error0_);
#line 313 "../src/umockdev.vala"
		_tmp5_ = _tmp7_;
#line 313 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1616 "umockdev.c"
			goto __catch0_g_error;
		}
#line 313 "../src/umockdev.vala"
		_tmp8_ = g_data_input_stream_new ((GInputStream*) _tmp5_);
#line 313 "../src/umockdev.vala"
		inp = _tmp8_;
#line 316 "../src/umockdev.vala"
		while (TRUE) {
#line 1625 "umockdev.c"
			gchar* _tmp9_ = NULL;
			GDataInputStream* _tmp10_;
			gsize _tmp11_ = 0UL;
			gchar* _tmp12_;
			gchar* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
#line 316 "../src/umockdev.vala"
			_tmp10_ = inp;
#line 316 "../src/umockdev.vala"
			_tmp12_ = g_data_input_stream_read_line (_tmp10_, &_tmp11_, NULL, &_inner_error0_);
#line 316 "../src/umockdev.vala"
			len = _tmp11_;
#line 316 "../src/umockdev.vala"
			_tmp9_ = _tmp12_;
#line 316 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 316 "../src/umockdev.vala"
				_g_free0 (line);
#line 316 "../src/umockdev.vala"
				_g_object_unref0 (inp);
#line 316 "../src/umockdev.vala"
				_g_object_unref0 (_tmp5_);
#line 1650 "umockdev.c"
				goto __catch0_g_error;
			}
#line 316 "../src/umockdev.vala"
			_tmp13_ = _tmp9_;
#line 316 "../src/umockdev.vala"
			_tmp9_ = NULL;
#line 316 "../src/umockdev.vala"
			_g_free0 (line);
#line 316 "../src/umockdev.vala"
			line = _tmp13_;
#line 316 "../src/umockdev.vala"
			_tmp14_ = line;
#line 316 "../src/umockdev.vala"
			if (!(_tmp14_ != NULL)) {
#line 316 "../src/umockdev.vala"
				_g_free0 (_tmp9_);
#line 316 "../src/umockdev.vala"
				break;
#line 1669 "umockdev.c"
			}
#line 317 "../src/umockdev.vala"
			_tmp15_ = line;
#line 317 "../src/umockdev.vala"
			_tmp16_ = prefix;
#line 317 "../src/umockdev.vala"
			if (g_str_has_prefix (_tmp15_, _tmp16_)) {
#line 1677 "umockdev.c"
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gchar* _tmp21_;
#line 318 "../src/umockdev.vala"
				_tmp17_ = line;
#line 318 "../src/umockdev.vala"
				_tmp18_ = prefix;
#line 318 "../src/umockdev.vala"
				_tmp19_ = strlen (_tmp18_);
#line 318 "../src/umockdev.vala"
				_tmp20_ = _tmp19_;
#line 318 "../src/umockdev.vala"
				_tmp21_ = string_substring (_tmp17_, (glong) _tmp20_, (glong) -1);
#line 318 "../src/umockdev.vala"
				_g_free0 (ret);
#line 318 "../src/umockdev.vala"
				ret = _tmp21_;
#line 319 "../src/umockdev.vala"
				_g_free0 (_tmp9_);
#line 319 "../src/umockdev.vala"
				break;
#line 1701 "umockdev.c"
			}
#line 316 "../src/umockdev.vala"
			_g_free0 (_tmp9_);
#line 1705 "umockdev.c"
		}
#line 322 "../src/umockdev.vala"
		_tmp22_ = inp;
#line 322 "../src/umockdev.vala"
		g_input_stream_close ((GInputStream*) _tmp22_, NULL, &_inner_error0_);
#line 322 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 322 "../src/umockdev.vala"
			_g_free0 (line);
#line 322 "../src/umockdev.vala"
			_g_object_unref0 (inp);
#line 322 "../src/umockdev.vala"
			_g_object_unref0 (_tmp5_);
#line 1719 "umockdev.c"
			goto __catch0_g_error;
		}
#line 312 "../src/umockdev.vala"
		_g_free0 (line);
#line 312 "../src/umockdev.vala"
		_g_object_unref0 (inp);
#line 312 "../src/umockdev.vala"
		_g_object_unref0 (_tmp5_);
#line 1728 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp23_;
#line 312 "../src/umockdev.vala"
		e = _inner_error0_;
#line 312 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 324 "../src/umockdev.vala"
		_tmp23_ = e->message;
#line 324 "../src/umockdev.vala"
		g_error ("umockdev.vala:324: Cannot read uevent file: %s", _tmp23_);
#line 312 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 1745 "umockdev.c"
	}
	__finally0:
#line 312 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 312 "../src/umockdev.vala"
		_g_free0 (prefix);
#line 312 "../src/umockdev.vala"
		_g_object_unref0 (f);
#line 312 "../src/umockdev.vala"
		_g_free0 (ret);
#line 312 "../src/umockdev.vala"
		_g_free0 (uevent_path);
#line 312 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 312 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 312 "../src/umockdev.vala"
		return NULL;
#line 1764 "umockdev.c"
	}
#line 327 "../src/umockdev.vala"
	result = ret;
#line 327 "../src/umockdev.vala"
	_g_free0 (prefix);
#line 327 "../src/umockdev.vala"
	_g_object_unref0 (f);
#line 327 "../src/umockdev.vala"
	_g_free0 (uevent_path);
#line 327 "../src/umockdev.vala"
	return result;
#line 1776 "umockdev.c"
}

/**
     * umockdev_testbed_set_property:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Property name
     * @value: Property string value
     *
     * Set a string udev property for a device.
     */
void
umockdev_testbed_set_property (UMockdevTestbed* self,
                               const gchar* devpath,
                               const gchar* name,
                               const gchar* value)
{
	gchar* uevent_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* props = NULL;
	gchar* _tmp2_;
	gchar* real_value = NULL;
	gboolean _tmp3_ = FALSE;
	GFile* f = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	gboolean existing = FALSE;
	gchar* prefix = NULL;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 339 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 339 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 339 "../src/umockdev.vala"
	g_return_if_fail (value != NULL);
#line 341 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 341 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, devpath, "uevent", NULL);
#line 341 "../src/umockdev.vala"
	uevent_path = _tmp1_;
#line 342 "../src/umockdev.vala"
	_tmp2_ = g_strdup ("");
#line 342 "../src/umockdev.vala"
	props = _tmp2_;
#line 346 "../src/umockdev.vala"
	if (g_strcmp0 (name, "DEVNAME") == 0) {
#line 346 "../src/umockdev.vala"
		_tmp3_ = g_str_has_prefix (value, "/dev/");
#line 1830 "umockdev.c"
	} else {
#line 346 "../src/umockdev.vala"
		_tmp3_ = FALSE;
#line 1834 "umockdev.c"
	}
#line 346 "../src/umockdev.vala"
	if (_tmp3_) {
#line 1838 "umockdev.c"
		gchar* _tmp4_;
#line 347 "../src/umockdev.vala"
		_tmp4_ = string_substring (value, (glong) 5, (glong) -1);
#line 347 "../src/umockdev.vala"
		_g_free0 (real_value);
#line 347 "../src/umockdev.vala"
		real_value = _tmp4_;
#line 1846 "umockdev.c"
	} else {
		gchar* _tmp5_;
#line 349 "../src/umockdev.vala"
		_tmp5_ = g_strdup (value);
#line 349 "../src/umockdev.vala"
		_g_free0 (real_value);
#line 349 "../src/umockdev.vala"
		real_value = _tmp5_;
#line 1855 "umockdev.c"
	}
#line 353 "../src/umockdev.vala"
	_tmp6_ = uevent_path;
#line 353 "../src/umockdev.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 353 "../src/umockdev.vala"
	f = _tmp7_;
#line 354 "../src/umockdev.vala"
	existing = FALSE;
#line 355 "../src/umockdev.vala"
	_tmp8_ = g_strconcat (name, "=", NULL);
#line 355 "../src/umockdev.vala"
	prefix = _tmp8_;
#line 1869 "umockdev.c"
	{
		GFileInputStream* _tmp9_ = NULL;
		GFile* _tmp10_;
		GFileInputStream* _tmp11_;
		GDataInputStream* inp = NULL;
		GDataInputStream* _tmp12_;
		gchar* line = NULL;
		gsize len = 0UL;
		GDataInputStream* _tmp34_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		guint8* _tmp45_;
		gint _tmp45__length1;
		gint _tmp46_ = 0;
		guint8* _tmp47_;
		gint _tmp47__length1;
#line 357 "../src/umockdev.vala"
		_tmp10_ = f;
#line 357 "../src/umockdev.vala"
		_tmp11_ = g_file_read (_tmp10_, NULL, &_inner_error0_);
#line 357 "../src/umockdev.vala"
		_tmp9_ = _tmp11_;
#line 357 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1894 "umockdev.c"
			goto __catch0_g_error;
		}
#line 357 "../src/umockdev.vala"
		_tmp12_ = g_data_input_stream_new ((GInputStream*) _tmp9_);
#line 357 "../src/umockdev.vala"
		inp = _tmp12_;
#line 360 "../src/umockdev.vala"
		while (TRUE) {
#line 1903 "umockdev.c"
			gchar* _tmp13_ = NULL;
			GDataInputStream* _tmp14_;
			gsize _tmp15_ = 0UL;
			gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
#line 360 "../src/umockdev.vala"
			_tmp14_ = inp;
#line 360 "../src/umockdev.vala"
			_tmp16_ = g_data_input_stream_read_line (_tmp14_, &_tmp15_, NULL, &_inner_error0_);
#line 360 "../src/umockdev.vala"
			len = _tmp15_;
#line 360 "../src/umockdev.vala"
			_tmp13_ = _tmp16_;
#line 360 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "../src/umockdev.vala"
				_g_free0 (line);
#line 360 "../src/umockdev.vala"
				_g_object_unref0 (inp);
#line 360 "../src/umockdev.vala"
				_g_object_unref0 (_tmp9_);
#line 1928 "umockdev.c"
				goto __catch0_g_error;
			}
#line 360 "../src/umockdev.vala"
			_tmp17_ = _tmp13_;
#line 360 "../src/umockdev.vala"
			_tmp13_ = NULL;
#line 360 "../src/umockdev.vala"
			_g_free0 (line);
#line 360 "../src/umockdev.vala"
			line = _tmp17_;
#line 360 "../src/umockdev.vala"
			_tmp18_ = line;
#line 360 "../src/umockdev.vala"
			if (!(_tmp18_ != NULL)) {
#line 360 "../src/umockdev.vala"
				_g_free0 (_tmp13_);
#line 360 "../src/umockdev.vala"
				break;
#line 1947 "umockdev.c"
			}
#line 361 "../src/umockdev.vala"
			_tmp19_ = line;
#line 361 "../src/umockdev.vala"
			_tmp20_ = prefix;
#line 361 "../src/umockdev.vala"
			if (g_str_has_prefix (_tmp19_, _tmp20_)) {
#line 1955 "umockdev.c"
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 362 "../src/umockdev.vala"
				existing = TRUE;
#line 363 "../src/umockdev.vala"
				_tmp21_ = props;
#line 363 "../src/umockdev.vala"
				_tmp22_ = prefix;
#line 363 "../src/umockdev.vala"
				_tmp23_ = real_value;
#line 363 "../src/umockdev.vala"
				_tmp24_ = g_strconcat (_tmp22_, _tmp23_, NULL);
#line 363 "../src/umockdev.vala"
				_tmp25_ = _tmp24_;
#line 363 "../src/umockdev.vala"
				_tmp26_ = g_strconcat (_tmp25_, "\n", NULL);
#line 363 "../src/umockdev.vala"
				_tmp27_ = _tmp26_;
#line 363 "../src/umockdev.vala"
				_tmp28_ = g_strconcat (_tmp21_, _tmp27_, NULL);
#line 363 "../src/umockdev.vala"
				_g_free0 (props);
#line 363 "../src/umockdev.vala"
				props = _tmp28_;
#line 363 "../src/umockdev.vala"
				_g_free0 (_tmp27_);
#line 363 "../src/umockdev.vala"
				_g_free0 (_tmp25_);
#line 1990 "umockdev.c"
			} else {
				const gchar* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
#line 365 "../src/umockdev.vala"
				_tmp29_ = props;
#line 365 "../src/umockdev.vala"
				_tmp30_ = line;
#line 365 "../src/umockdev.vala"
				_tmp31_ = g_strconcat (_tmp30_, "\n", NULL);
#line 365 "../src/umockdev.vala"
				_tmp32_ = _tmp31_;
#line 365 "../src/umockdev.vala"
				_tmp33_ = g_strconcat (_tmp29_, _tmp32_, NULL);
#line 365 "../src/umockdev.vala"
				_g_free0 (props);
#line 365 "../src/umockdev.vala"
				props = _tmp33_;
#line 365 "../src/umockdev.vala"
				_g_free0 (_tmp32_);
#line 2013 "umockdev.c"
			}
#line 360 "../src/umockdev.vala"
			_g_free0 (_tmp13_);
#line 2017 "umockdev.c"
		}
#line 368 "../src/umockdev.vala"
		_tmp34_ = inp;
#line 368 "../src/umockdev.vala"
		g_input_stream_close ((GInputStream*) _tmp34_, NULL, &_inner_error0_);
#line 368 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 368 "../src/umockdev.vala"
			_g_free0 (line);
#line 368 "../src/umockdev.vala"
			_g_object_unref0 (inp);
#line 368 "../src/umockdev.vala"
			_g_object_unref0 (_tmp9_);
#line 2031 "umockdev.c"
			goto __catch0_g_error;
		}
#line 371 "../src/umockdev.vala"
		if (!existing) {
#line 2036 "umockdev.c"
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
#line 372 "../src/umockdev.vala"
			_tmp35_ = props;
#line 372 "../src/umockdev.vala"
			_tmp36_ = prefix;
#line 372 "../src/umockdev.vala"
			_tmp37_ = real_value;
#line 372 "../src/umockdev.vala"
			_tmp38_ = g_strconcat (_tmp36_, _tmp37_, NULL);
#line 372 "../src/umockdev.vala"
			_tmp39_ = _tmp38_;
#line 372 "../src/umockdev.vala"
			_tmp40_ = g_strconcat (_tmp39_, "\n", NULL);
#line 372 "../src/umockdev.vala"
			_tmp41_ = _tmp40_;
#line 372 "../src/umockdev.vala"
			_tmp42_ = g_strconcat (_tmp35_, _tmp41_, NULL);
#line 372 "../src/umockdev.vala"
			_g_free0 (props);
#line 372 "../src/umockdev.vala"
			props = _tmp42_;
#line 372 "../src/umockdev.vala"
			_g_free0 (_tmp41_);
#line 372 "../src/umockdev.vala"
			_g_free0 (_tmp39_);
#line 2069 "umockdev.c"
		}
#line 375 "../src/umockdev.vala"
		_tmp43_ = uevent_path;
#line 375 "../src/umockdev.vala"
		_tmp44_ = props;
#line 375 "../src/umockdev.vala"
		_tmp45_ = string_get_data (_tmp44_, &_tmp46_);
#line 375 "../src/umockdev.vala"
		_tmp45__length1 = _tmp46_;
#line 375 "../src/umockdev.vala"
		_tmp47_ = _tmp45_;
#line 375 "../src/umockdev.vala"
		_tmp47__length1 = _tmp45__length1;
#line 375 "../src/umockdev.vala"
		g_file_set_contents (_tmp43_, (const char*) _tmp47_, (gsize) _tmp47__length1, &_inner_error0_);
#line 375 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 375 "../src/umockdev.vala"
			_g_free0 (line);
#line 375 "../src/umockdev.vala"
			_g_object_unref0 (inp);
#line 375 "../src/umockdev.vala"
			_g_object_unref0 (_tmp9_);
#line 2093 "umockdev.c"
			goto __catch0_g_error;
		}
#line 356 "../src/umockdev.vala"
		_g_free0 (line);
#line 356 "../src/umockdev.vala"
		_g_object_unref0 (inp);
#line 356 "../src/umockdev.vala"
		_g_object_unref0 (_tmp9_);
#line 2102 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp48_;
#line 356 "../src/umockdev.vala"
		e = _inner_error0_;
#line 356 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 377 "../src/umockdev.vala"
		_tmp48_ = e->message;
#line 377 "../src/umockdev.vala"
		g_error ("umockdev.vala:377: Cannot update uevent file: %s", _tmp48_);
#line 356 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 2119 "umockdev.c"
	}
	__finally0:
#line 356 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "../src/umockdev.vala"
		_g_free0 (prefix);
#line 356 "../src/umockdev.vala"
		_g_object_unref0 (f);
#line 356 "../src/umockdev.vala"
		_g_free0 (real_value);
#line 356 "../src/umockdev.vala"
		_g_free0 (props);
#line 356 "../src/umockdev.vala"
		_g_free0 (uevent_path);
#line 356 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 356 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 356 "../src/umockdev.vala"
		return;
#line 2140 "umockdev.c"
	}
#line 339 "../src/umockdev.vala"
	_g_free0 (prefix);
#line 339 "../src/umockdev.vala"
	_g_object_unref0 (f);
#line 339 "../src/umockdev.vala"
	_g_free0 (real_value);
#line 339 "../src/umockdev.vala"
	_g_free0 (props);
#line 339 "../src/umockdev.vala"
	_g_free0 (uevent_path);
#line 2152 "umockdev.c"
}

/**
     * umockdev_testbed_set_property_int:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Property name
     * @value: Property integer value
     *
     * Set an integer udev property for a device.
     */
void
umockdev_testbed_set_property_int (UMockdevTestbed* self,
                                   const gchar* devpath,
                                   const gchar* name,
                                   gint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 390 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 390 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 390 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 392 "../src/umockdev.vala"
	_tmp0_ = g_strdup_printf ("%i", value);
#line 392 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 392 "../src/umockdev.vala"
	umockdev_testbed_set_property (self, devpath, name, _tmp1_);
#line 392 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 2186 "umockdev.c"
}

/**
     * umockdev_testbed_set_property_hex:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @name: Property name
     * @value: Property integer value
     *
     * Set an integer udev property for a device. @value is interpreted as a
     * hexadecimal number. For example, for value==31 this sets the property's
     * value to "1f".
     */
void
umockdev_testbed_set_property_hex (UMockdevTestbed* self,
                                   const gchar* devpath,
                                   const gchar* name,
                                   guint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 406 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 406 "../src/umockdev.vala"
	g_return_if_fail (name != NULL);
#line 408 "../src/umockdev.vala"
	_tmp0_ = g_strdup_printf ("%x", value);
#line 408 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 408 "../src/umockdev.vala"
	umockdev_testbed_set_property (self, devpath, name, _tmp1_);
#line 408 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 2222 "umockdev.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2246 "umockdev.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 2254 "umockdev.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 2260 "umockdev.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 2282 "umockdev.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2304 "umockdev.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2308 "umockdev.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2314 "umockdev.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2318 "umockdev.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2322 "umockdev.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 2330 "umockdev.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2358 "umockdev.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 2367 "umockdev.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2381 "umockdev.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 2390 "umockdev.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 2404 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2413 "umockdev.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 2422 "umockdev.c"
}

static gchar*
umockdev_testbed_add_devicev_no_uevent (UMockdevTestbed* self,
                                        const gchar* subsystem,
                                        const gchar* name,
                                        const gchar* parent,
                                        gchar** attributes,
                                        gchar** properties)
{
	gchar* dev_path = NULL;
	gchar* dev_node = NULL;
	gchar* dev_dir = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gchar* dev_path_no_sys = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* props = NULL;
	gchar* _tmp64_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	gchar* result;
#line 411 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 411 "../src/umockdev.vala"
	g_return_val_if_fail (subsystem != NULL, NULL);
#line 411 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 416 "../src/umockdev.vala"
	dev_node = NULL;
#line 418 "../src/umockdev.vala"
	if (parent != NULL) {
#line 2461 "umockdev.c"
		gchar* _tmp0_;
#line 419 "../src/umockdev.vala"
		if (!g_str_has_prefix (parent, "/sys/")) {
#line 420 "../src/umockdev.vala"
			g_critical ("umockdev.vala:420: add_devicev(): parent device %s does not start with" \
" /sys/", parent);
#line 421 "../src/umockdev.vala"
			result = NULL;
#line 421 "../src/umockdev.vala"
			_g_free0 (dev_node);
#line 421 "../src/umockdev.vala"
			_g_free0 (dev_path);
#line 421 "../src/umockdev.vala"
			return result;
#line 2475 "umockdev.c"
		}
#line 423 "../src/umockdev.vala"
		if (!g_file_test (parent, G_FILE_TEST_IS_DIR)) {
#line 424 "../src/umockdev.vala"
			g_critical ("umockdev.vala:424: add_devicev(): parent device %s does not exist", parent);
#line 425 "../src/umockdev.vala"
			result = NULL;
#line 425 "../src/umockdev.vala"
			_g_free0 (dev_node);
#line 425 "../src/umockdev.vala"
			_g_free0 (dev_path);
#line 425 "../src/umockdev.vala"
			return result;
#line 2489 "umockdev.c"
		}
#line 427 "../src/umockdev.vala"
		_tmp0_ = g_build_filename (parent, name, NULL);
#line 427 "../src/umockdev.vala"
		_g_free0 (dev_path);
#line 427 "../src/umockdev.vala"
		dev_path = _tmp0_;
#line 2497 "umockdev.c"
	} else {
		gchar* _tmp1_;
#line 429 "../src/umockdev.vala"
		_tmp1_ = g_build_filename ("/sys/devices", name, NULL);
#line 429 "../src/umockdev.vala"
		_g_free0 (dev_path);
#line 429 "../src/umockdev.vala"
		dev_path = _tmp1_;
#line 2506 "umockdev.c"
	}
#line 430 "../src/umockdev.vala"
	_tmp2_ = self->priv->root_dir;
#line 430 "../src/umockdev.vala"
	_tmp3_ = dev_path;
#line 430 "../src/umockdev.vala"
	_tmp4_ = g_build_filename (_tmp2_, _tmp3_, NULL);
#line 430 "../src/umockdev.vala"
	dev_dir = _tmp4_;
#line 433 "../src/umockdev.vala"
	_tmp6_ = dev_dir;
#line 433 "../src/umockdev.vala"
	if (g_file_test (_tmp6_, G_FILE_TEST_EXISTS)) {
#line 2520 "umockdev.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 434 "../src/umockdev.vala"
		_tmp7_ = dev_dir;
#line 434 "../src/umockdev.vala"
		_tmp8_ = g_build_filename (_tmp7_, "uevent", NULL);
#line 434 "../src/umockdev.vala"
		_tmp9_ = _tmp8_;
#line 434 "../src/umockdev.vala"
		_tmp5_ = g_file_test (_tmp9_, G_FILE_TEST_EXISTS);
#line 434 "../src/umockdev.vala"
		_g_free0 (_tmp9_);
#line 2534 "umockdev.c"
	} else {
#line 433 "../src/umockdev.vala"
		_tmp5_ = FALSE;
#line 2538 "umockdev.c"
	}
#line 433 "../src/umockdev.vala"
	if (_tmp5_) {
#line 2542 "umockdev.c"
		const gchar* _tmp10_;
#line 435 "../src/umockdev.vala"
		_tmp10_ = dev_dir;
#line 435 "../src/umockdev.vala"
		g_error ("umockdev.vala:435: device %s already exists", _tmp10_);
#line 2548 "umockdev.c"
	}
#line 437 "../src/umockdev.vala"
	_tmp11_ = dev_path;
#line 437 "../src/umockdev.vala"
	_tmp12_ = dev_path;
#line 437 "../src/umockdev.vala"
	_tmp13_ = string_substring (_tmp11_, (glong) string_index_of (_tmp12_, "/devices/", 0), (glong) -1);
#line 437 "../src/umockdev.vala"
	dev_path_no_sys = _tmp13_;
#line 440 "../src/umockdev.vala"
	_tmp14_ = dev_dir;
#line 440 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp14_, 0755);
#line 441 "../src/umockdev.vala"
	if (!umockdev_testbed_subsystem_is_bus (subsystem)) {
#line 2564 "umockdev.c"
		gchar* class_dir = NULL;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 443 "../src/umockdev.vala"
		_tmp15_ = self->priv->sys_dir;
#line 443 "../src/umockdev.vala"
		_tmp16_ = g_build_filename (_tmp15_, "class", subsystem, NULL);
#line 443 "../src/umockdev.vala"
		class_dir = _tmp16_;
#line 444 "../src/umockdev.vala"
		_tmp17_ = class_dir;
#line 444 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp17_, 0755);
#line 447 "../src/umockdev.vala"
		_tmp18_ = dev_path;
#line 447 "../src/umockdev.vala"
		_tmp19_ = umockdev_make_dotdots (_tmp18_);
#line 447 "../src/umockdev.vala"
		_tmp20_ = _tmp19_;
#line 447 "../src/umockdev.vala"
		_tmp21_ = g_build_filename (_tmp20_, "class", subsystem, NULL);
#line 447 "../src/umockdev.vala"
		_tmp22_ = _tmp21_;
#line 447 "../src/umockdev.vala"
		_tmp23_ = dev_dir;
#line 447 "../src/umockdev.vala"
		_tmp24_ = g_build_filename (_tmp23_, "subsystem", NULL);
#line 447 "../src/umockdev.vala"
		_tmp25_ = _tmp24_;
#line 447 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp22_, _tmp25_) == 0, "FileUtils.symlink(Path.build_filename(make_dotdots(dev_path), \"class\", subsystem),                                      Path.build_filename(dev_dir, \"subsystem\")) == 0");
#line 447 "../src/umockdev.vala"
		_g_free0 (_tmp25_);
#line 447 "../src/umockdev.vala"
		_g_free0 (_tmp22_);
#line 447 "../src/umockdev.vala"
		_g_free0 (_tmp20_);
#line 453 "../src/umockdev.vala"
		_tmp26_ = dev_path_no_sys;
#line 453 "../src/umockdev.vala"
		_tmp27_ = g_build_filename ("..", "..", _tmp26_, NULL);
#line 453 "../src/umockdev.vala"
		_tmp28_ = _tmp27_;
#line 453 "../src/umockdev.vala"
		_tmp29_ = class_dir;
#line 453 "../src/umockdev.vala"
		_tmp30_ = g_path_get_basename (name);
#line 453 "../src/umockdev.vala"
		_tmp31_ = _tmp30_;
#line 453 "../src/umockdev.vala"
		_tmp32_ = g_build_filename (_tmp29_, _tmp31_, NULL);
#line 453 "../src/umockdev.vala"
		_tmp33_ = _tmp32_;
#line 453 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp28_, _tmp33_) == 0, "FileUtils.symlink(Path.build_filename(\"..\", \"..\", dev_path_no_sys),                                      Path.build_filename(class_dir, Path.get_basename(name))) == 0");
#line 453 "../src/umockdev.vala"
		_g_free0 (_tmp33_);
#line 453 "../src/umockdev.vala"
		_g_free0 (_tmp31_);
#line 453 "../src/umockdev.vala"
		_g_free0 (_tmp28_);
#line 441 "../src/umockdev.vala"
		_g_free0 (class_dir);
#line 2645 "umockdev.c"
	} else {
		gchar* bus_dir = NULL;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 457 "../src/umockdev.vala"
		_tmp34_ = self->priv->sys_dir;
#line 457 "../src/umockdev.vala"
		_tmp35_ = g_build_filename (_tmp34_, "bus", subsystem, "devices", NULL);
#line 457 "../src/umockdev.vala"
		bus_dir = _tmp35_;
#line 458 "../src/umockdev.vala"
		_tmp36_ = bus_dir;
#line 458 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp36_, 0755);
#line 459 "../src/umockdev.vala"
		_tmp37_ = dev_path_no_sys;
#line 459 "../src/umockdev.vala"
		_tmp38_ = g_build_filename ("..", "..", "..", _tmp37_, NULL);
#line 459 "../src/umockdev.vala"
		_tmp39_ = _tmp38_;
#line 459 "../src/umockdev.vala"
		_tmp40_ = bus_dir;
#line 459 "../src/umockdev.vala"
		_tmp41_ = g_path_get_basename (name);
#line 459 "../src/umockdev.vala"
		_tmp42_ = _tmp41_;
#line 459 "../src/umockdev.vala"
		_tmp43_ = g_build_filename (_tmp40_, _tmp42_, NULL);
#line 459 "../src/umockdev.vala"
		_tmp44_ = _tmp43_;
#line 459 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp39_, _tmp44_) == 0, "FileUtils.symlink(Path.build_filename(\"..\", \"..\", \"..\", dev_path_no_sys),                                      Path.build_filename(bus_dir, Path.get_basename(name))) == 0");
#line 459 "../src/umockdev.vala"
		_g_free0 (_tmp44_);
#line 459 "../src/umockdev.vala"
		_g_free0 (_tmp42_);
#line 459 "../src/umockdev.vala"
		_g_free0 (_tmp39_);
#line 463 "../src/umockdev.vala"
		_tmp45_ = dev_path;
#line 463 "../src/umockdev.vala"
		_tmp46_ = umockdev_make_dotdots (_tmp45_);
#line 463 "../src/umockdev.vala"
		_tmp47_ = _tmp46_;
#line 463 "../src/umockdev.vala"
		_tmp48_ = g_build_filename (_tmp47_, "bus", subsystem, NULL);
#line 463 "../src/umockdev.vala"
		_tmp49_ = _tmp48_;
#line 463 "../src/umockdev.vala"
		_tmp50_ = dev_dir;
#line 463 "../src/umockdev.vala"
		_tmp51_ = g_build_filename (_tmp50_, "subsystem", NULL);
#line 463 "../src/umockdev.vala"
		_tmp52_ = _tmp51_;
#line 463 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp49_, _tmp52_) == 0, "FileUtils.symlink(Path.build_filename(make_dotdots(dev_path), \"bus\", subsystem),                                      Path.build_filename(dev_dir, \"subsystem\")) == 0");
#line 463 "../src/umockdev.vala"
		_g_free0 (_tmp52_);
#line 463 "../src/umockdev.vala"
		_g_free0 (_tmp49_);
#line 463 "../src/umockdev.vala"
		_g_free0 (_tmp47_);
#line 441 "../src/umockdev.vala"
		_g_free0 (bus_dir);
#line 2727 "umockdev.c"
	}
#line 468 "../src/umockdev.vala"
	if (g_strcmp0 (subsystem, "block") == 0) {
#line 2731 "umockdev.c"
		gchar* block_dir = NULL;
		const gchar* _tmp53_;
		gchar* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
#line 469 "../src/umockdev.vala"
		_tmp53_ = self->priv->sys_dir;
#line 469 "../src/umockdev.vala"
		_tmp54_ = g_build_filename (_tmp53_, "block", NULL);
#line 469 "../src/umockdev.vala"
		block_dir = _tmp54_;
#line 470 "../src/umockdev.vala"
		_tmp55_ = block_dir;
#line 470 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp55_, 0755);
#line 471 "../src/umockdev.vala"
		_tmp56_ = dev_path_no_sys;
#line 471 "../src/umockdev.vala"
		_tmp57_ = g_build_filename ("..", _tmp56_, NULL);
#line 471 "../src/umockdev.vala"
		_tmp58_ = _tmp57_;
#line 471 "../src/umockdev.vala"
		_tmp59_ = block_dir;
#line 471 "../src/umockdev.vala"
		_tmp60_ = g_path_get_basename (name);
#line 471 "../src/umockdev.vala"
		_tmp61_ = _tmp60_;
#line 471 "../src/umockdev.vala"
		_tmp62_ = g_build_filename (_tmp59_, _tmp61_, NULL);
#line 471 "../src/umockdev.vala"
		_tmp63_ = _tmp62_;
#line 471 "../src/umockdev.vala"
		_vala_assert (symlink (_tmp58_, _tmp63_) == 0, "FileUtils.symlink(Path.build_filename(\"..\", dev_path_no_sys),                                      Path.build_filename(block_dir, Path.get_basename(name))) == 0");
#line 471 "../src/umockdev.vala"
		_g_free0 (_tmp63_);
#line 471 "../src/umockdev.vala"
		_g_free0 (_tmp61_);
#line 471 "../src/umockdev.vala"
		_g_free0 (_tmp58_);
#line 468 "../src/umockdev.vala"
		_g_free0 (block_dir);
#line 2780 "umockdev.c"
	}
#line 476 "../src/umockdev.vala"
	_tmp64_ = g_strdup ("");
#line 476 "../src/umockdev.vala"
	props = _tmp64_;
#line 2786 "umockdev.c"
	{
		gint i = 0;
#line 477 "../src/umockdev.vala"
		i = 0;
#line 2791 "umockdev.c"
		{
			gboolean _tmp65_ = FALSE;
#line 477 "../src/umockdev.vala"
			_tmp65_ = TRUE;
#line 477 "../src/umockdev.vala"
			while (TRUE) {
#line 2798 "umockdev.c"
				gboolean _tmp66_ = FALSE;
				const gchar* _tmp67_;
#line 477 "../src/umockdev.vala"
				if (!_tmp65_) {
#line 477 "../src/umockdev.vala"
					i += 2;
#line 2805 "umockdev.c"
				}
#line 477 "../src/umockdev.vala"
				_tmp65_ = FALSE;
#line 477 "../src/umockdev.vala"
				if (!(i < (_vala_array_length (properties) - 1))) {
#line 477 "../src/umockdev.vala"
					break;
#line 2813 "umockdev.c"
				}
#line 479 "../src/umockdev.vala"
				_tmp67_ = properties[i];
#line 479 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp67_, "DEVNAME") == 0) {
#line 2819 "umockdev.c"
					const gchar* _tmp68_;
#line 479 "../src/umockdev.vala"
					_tmp68_ = properties[i + 1];
#line 479 "../src/umockdev.vala"
					_tmp66_ = g_str_has_prefix (_tmp68_, "/dev/");
#line 2825 "umockdev.c"
				} else {
#line 479 "../src/umockdev.vala"
					_tmp66_ = FALSE;
#line 2829 "umockdev.c"
				}
#line 479 "../src/umockdev.vala"
				if (_tmp66_) {
#line 2833 "umockdev.c"
					const gchar* _tmp69_;
					gchar* _tmp70_;
					const gchar* _tmp71_;
					const gchar* _tmp72_;
					gchar* _tmp73_;
					gchar* _tmp74_;
					gchar* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
#line 480 "../src/umockdev.vala"
					_tmp69_ = properties[i + 1];
#line 480 "../src/umockdev.vala"
					_tmp70_ = string_substring (_tmp69_, (glong) 5, (glong) -1);
#line 480 "../src/umockdev.vala"
					_g_free0 (dev_node);
#line 480 "../src/umockdev.vala"
					dev_node = _tmp70_;
#line 481 "../src/umockdev.vala"
					_tmp71_ = props;
#line 481 "../src/umockdev.vala"
					_tmp72_ = dev_node;
#line 481 "../src/umockdev.vala"
					_tmp73_ = g_strconcat ("DEVNAME=", _tmp72_, NULL);
#line 481 "../src/umockdev.vala"
					_tmp74_ = _tmp73_;
#line 481 "../src/umockdev.vala"
					_tmp75_ = g_strconcat (_tmp74_, "\n", NULL);
#line 481 "../src/umockdev.vala"
					_tmp76_ = _tmp75_;
#line 481 "../src/umockdev.vala"
					_tmp77_ = g_strconcat (_tmp71_, _tmp76_, NULL);
#line 481 "../src/umockdev.vala"
					_g_free0 (props);
#line 481 "../src/umockdev.vala"
					props = _tmp77_;
#line 481 "../src/umockdev.vala"
					_g_free0 (_tmp76_);
#line 481 "../src/umockdev.vala"
					_g_free0 (_tmp74_);
#line 2873 "umockdev.c"
				} else {
					const gchar* _tmp78_;
					const gchar* _tmp79_;
					gchar* _tmp80_;
					gchar* _tmp81_;
					const gchar* _tmp82_;
					gchar* _tmp83_;
					gchar* _tmp84_;
					gchar* _tmp85_;
					gchar* _tmp86_;
					gchar* _tmp87_;
#line 483 "../src/umockdev.vala"
					_tmp78_ = props;
#line 483 "../src/umockdev.vala"
					_tmp79_ = properties[i];
#line 483 "../src/umockdev.vala"
					_tmp80_ = g_strconcat (_tmp79_, "=", NULL);
#line 483 "../src/umockdev.vala"
					_tmp81_ = _tmp80_;
#line 483 "../src/umockdev.vala"
					_tmp82_ = properties[i + 1];
#line 483 "../src/umockdev.vala"
					_tmp83_ = g_strconcat (_tmp81_, _tmp82_, NULL);
#line 483 "../src/umockdev.vala"
					_tmp84_ = _tmp83_;
#line 483 "../src/umockdev.vala"
					_tmp85_ = g_strconcat (_tmp84_, "\n", NULL);
#line 483 "../src/umockdev.vala"
					_tmp86_ = _tmp85_;
#line 483 "../src/umockdev.vala"
					_tmp87_ = g_strconcat (_tmp78_, _tmp86_, NULL);
#line 483 "../src/umockdev.vala"
					_g_free0 (props);
#line 483 "../src/umockdev.vala"
					props = _tmp87_;
#line 483 "../src/umockdev.vala"
					_g_free0 (_tmp86_);
#line 483 "../src/umockdev.vala"
					_g_free0 (_tmp84_);
#line 483 "../src/umockdev.vala"
					_g_free0 (_tmp81_);
#line 2915 "umockdev.c"
				}
			}
		}
	}
#line 485 "../src/umockdev.vala"
	if ((_vala_array_length (properties) % 2) != 0) {
#line 2922 "umockdev.c"
		const gchar* _tmp88_;
#line 486 "../src/umockdev.vala"
		_tmp88_ = properties[_vala_array_length (properties) - 1];
#line 486 "../src/umockdev.vala"
		g_warning ("umockdev.vala:486: add_devicev: Ignoring property key '%s' without val" \
"ue", _tmp88_);
#line 2928 "umockdev.c"
	}
#line 487 "../src/umockdev.vala"
	_tmp89_ = dev_path;
#line 487 "../src/umockdev.vala"
	_tmp90_ = props;
#line 487 "../src/umockdev.vala"
	umockdev_testbed_set_attribute (self, _tmp89_, "uevent", _tmp90_);
#line 2936 "umockdev.c"
	{
		gint i = 0;
#line 490 "../src/umockdev.vala"
		i = 0;
#line 2941 "umockdev.c"
		{
			gboolean _tmp91_ = FALSE;
#line 490 "../src/umockdev.vala"
			_tmp91_ = TRUE;
#line 490 "../src/umockdev.vala"
			while (TRUE) {
#line 2948 "umockdev.c"
				const gchar* _tmp92_;
				const gchar* _tmp93_;
				const gchar* _tmp94_;
				gboolean _tmp95_ = FALSE;
				const gchar* _tmp96_;
#line 490 "../src/umockdev.vala"
				if (!_tmp91_) {
#line 490 "../src/umockdev.vala"
					i += 2;
#line 2958 "umockdev.c"
				}
#line 490 "../src/umockdev.vala"
				_tmp91_ = FALSE;
#line 490 "../src/umockdev.vala"
				if (!(i < (_vala_array_length (attributes) - 1))) {
#line 490 "../src/umockdev.vala"
					break;
#line 2966 "umockdev.c"
				}
#line 491 "../src/umockdev.vala"
				_tmp92_ = dev_path;
#line 491 "../src/umockdev.vala"
				_tmp93_ = attributes[i];
#line 491 "../src/umockdev.vala"
				_tmp94_ = attributes[i + 1];
#line 491 "../src/umockdev.vala"
				umockdev_testbed_set_attribute (self, _tmp92_, _tmp93_, _tmp94_);
#line 492 "../src/umockdev.vala"
				_tmp96_ = attributes[i];
#line 492 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp96_, "dev") == 0) {
#line 2980 "umockdev.c"
					const gchar* _tmp97_;
#line 492 "../src/umockdev.vala"
					_tmp97_ = dev_node;
#line 492 "../src/umockdev.vala"
					_tmp95_ = _tmp97_ != NULL;
#line 2986 "umockdev.c"
				} else {
#line 492 "../src/umockdev.vala"
					_tmp95_ = FALSE;
#line 2990 "umockdev.c"
				}
#line 492 "../src/umockdev.vala"
				if (_tmp95_) {
#line 2994 "umockdev.c"
					gchar* val = NULL;
					const gchar* _tmp98_;
					gchar* _tmp99_;
					gchar* infodir = NULL;
					const gchar* _tmp100_;
					gchar* _tmp101_;
					const gchar* _tmp102_;
					const gchar* _tmp103_;
					const gchar* _tmp104_;
					const gchar* _tmp105_;
					gchar* _tmp106_;
					gchar* _tmp107_;
					gchar* _tmp108_;
					gchar* _tmp109_;
					const gchar* _tmp110_ = NULL;
					const gchar* _tmp111_;
					gchar* sysdev_dir = NULL;
					const gchar* _tmp112_;
					gchar* _tmp113_;
					const gchar* _tmp114_;
					gchar* dest = NULL;
					const gchar* _tmp115_;
					const gchar* _tmp116_;
					gchar* _tmp117_;
					const gchar* _tmp118_;
#line 493 "../src/umockdev.vala"
					_tmp98_ = attributes[i + 1];
#line 493 "../src/umockdev.vala"
					_tmp99_ = string_strip (_tmp98_);
#line 493 "../src/umockdev.vala"
					val = _tmp99_;
#line 495 "../src/umockdev.vala"
					_tmp100_ = self->priv->root_dir;
#line 495 "../src/umockdev.vala"
					_tmp101_ = g_build_filename (_tmp100_, "dev", ".node", NULL);
#line 495 "../src/umockdev.vala"
					infodir = _tmp101_;
#line 496 "../src/umockdev.vala"
					_tmp102_ = infodir;
#line 496 "../src/umockdev.vala"
					umockdev_checked_mkdir_with_parents (_tmp102_, 0755);
#line 497 "../src/umockdev.vala"
					_tmp103_ = val;
#line 497 "../src/umockdev.vala"
					_tmp104_ = infodir;
#line 497 "../src/umockdev.vala"
					_tmp105_ = dev_node;
#line 497 "../src/umockdev.vala"
					_tmp106_ = string_replace (_tmp105_, "/", "_");
#line 497 "../src/umockdev.vala"
					_tmp107_ = _tmp106_;
#line 497 "../src/umockdev.vala"
					_tmp108_ = g_build_filename (_tmp104_, _tmp107_, NULL);
#line 497 "../src/umockdev.vala"
					_tmp109_ = _tmp108_;
#line 497 "../src/umockdev.vala"
					_vala_assert (symlink (_tmp103_, _tmp109_) == 0, "FileUtils.symlink(val, Path.build_filename(infodir, dev_node.replace(\"/\", \"_\"))) == 0");
#line 497 "../src/umockdev.vala"
					_g_free0 (_tmp109_);
#line 497 "../src/umockdev.vala"
					_g_free0 (_tmp107_);
#line 501 "../src/umockdev.vala"
					_tmp111_ = dev_path;
#line 501 "../src/umockdev.vala"
					if (string_contains (_tmp111_, "/block/")) {
#line 501 "../src/umockdev.vala"
						_tmp110_ = "block";
#line 3062 "umockdev.c"
					} else {
#line 501 "../src/umockdev.vala"
						_tmp110_ = "char";
#line 3066 "umockdev.c"
					}
#line 500 "../src/umockdev.vala"
					_tmp112_ = self->priv->sys_dir;
#line 500 "../src/umockdev.vala"
					_tmp113_ = g_build_filename (_tmp112_, "dev", _tmp110_, NULL);
#line 500 "../src/umockdev.vala"
					sysdev_dir = _tmp113_;
#line 502 "../src/umockdev.vala"
					_tmp114_ = sysdev_dir;
#line 502 "../src/umockdev.vala"
					umockdev_checked_mkdir_with_parents (_tmp114_, 0755);
#line 503 "../src/umockdev.vala"
					_tmp115_ = sysdev_dir;
#line 503 "../src/umockdev.vala"
					_tmp116_ = val;
#line 503 "../src/umockdev.vala"
					_tmp117_ = g_build_filename (_tmp115_, _tmp116_, NULL);
#line 503 "../src/umockdev.vala"
					dest = _tmp117_;
#line 504 "../src/umockdev.vala"
					_tmp118_ = dest;
#line 504 "../src/umockdev.vala"
					if (!g_file_test (_tmp118_, G_FILE_TEST_EXISTS)) {
#line 3090 "umockdev.c"
						const gchar* _tmp119_;
						gchar* _tmp120_;
						gchar* _tmp121_;
						gchar* _tmp122_;
						gchar* _tmp123_;
						const gchar* _tmp124_;
						gboolean _tmp125_;
#line 505 "../src/umockdev.vala"
						_tmp119_ = dev_path;
#line 505 "../src/umockdev.vala"
						_tmp120_ = string_substring (_tmp119_, (glong) 5, (glong) -1);
#line 505 "../src/umockdev.vala"
						_tmp121_ = _tmp120_;
#line 505 "../src/umockdev.vala"
						_tmp122_ = g_strconcat ("../../", _tmp121_, NULL);
#line 505 "../src/umockdev.vala"
						_tmp123_ = _tmp122_;
#line 505 "../src/umockdev.vala"
						_tmp124_ = dest;
#line 505 "../src/umockdev.vala"
						_tmp125_ = symlink (_tmp123_, _tmp124_) < 0;
#line 505 "../src/umockdev.vala"
						_g_free0 (_tmp123_);
#line 505 "../src/umockdev.vala"
						_g_free0 (_tmp121_);
#line 505 "../src/umockdev.vala"
						if (_tmp125_) {
#line 3118 "umockdev.c"
							const gchar* _tmp126_;
							const gchar* _tmp127_;
							gchar* _tmp128_;
							gchar* _tmp129_;
#line 506 "../src/umockdev.vala"
							_tmp126_ = dest;
#line 506 "../src/umockdev.vala"
							_tmp127_ = dev_path;
#line 506 "../src/umockdev.vala"
							_tmp128_ = string_substring (_tmp127_, (glong) 5, (glong) -1);
#line 506 "../src/umockdev.vala"
							_tmp129_ = _tmp128_;
#line 506 "../src/umockdev.vala"
							g_error ("umockdev.vala:506: add_device %s: failed to symlink %s to %s: %m", name, _tmp126_, _tmp129_);
#line 506 "../src/umockdev.vala"
							_g_free0 (_tmp129_);
#line 3135 "umockdev.c"
						}
					}
#line 492 "../src/umockdev.vala"
					_g_free0 (dest);
#line 492 "../src/umockdev.vala"
					_g_free0 (sysdev_dir);
#line 492 "../src/umockdev.vala"
					_g_free0 (infodir);
#line 492 "../src/umockdev.vala"
					_g_free0 (val);
#line 3146 "umockdev.c"
				}
			}
		}
	}
#line 511 "../src/umockdev.vala"
	if ((_vala_array_length (attributes) % 2) != 0) {
#line 3153 "umockdev.c"
		const gchar* _tmp130_;
#line 512 "../src/umockdev.vala"
		_tmp130_ = attributes[_vala_array_length (attributes) - 1];
#line 512 "../src/umockdev.vala"
		g_warning ("umockdev.vala:512: add_devicev: Ignoring attribute key '%s' without va" \
"lue", _tmp130_);
#line 3159 "umockdev.c"
	}
#line 514 "../src/umockdev.vala"
	result = dev_path;
#line 514 "../src/umockdev.vala"
	_g_free0 (props);
#line 514 "../src/umockdev.vala"
	_g_free0 (dev_path_no_sys);
#line 514 "../src/umockdev.vala"
	_g_free0 (dev_dir);
#line 514 "../src/umockdev.vala"
	_g_free0 (dev_node);
#line 514 "../src/umockdev.vala"
	return result;
#line 3173 "umockdev.c"
}

/**
     * umockdev_testbed_add_devicev:
     * @self: A #UMockdevTestbed.
     * @subsystem: The subsystem name, e. g. "usb"
     * @name: The device name; arbitrary, but needs to be unique within the testbed
     * @parent: (allow-none): device path of the parent device. Use %NULL for a
     *          top-level device.
     * @attributes: (array zero-terminated=1):
     *              A list of device sysfs attributes, alternating names and
     *              values, terminated with %NULL:
     *              { "key1", "value1", "key2", "value2", ..., NULL }
     * @properties: (array zero-terminated=1):
     *              A list of device udev properties; same format as @attributes
     *
     * This method is mostly meant for language bindings (where it is named
     * umockdev_testbed_add_device()). For C programs it is usually more convenient to
     * use umockdev_testbed_add_device().
     *
     * Add a new device to the testbed. A Linux kernel device always has a
     * subsystem (such as "usb" or "pci"), and a device name. The test bed only
     * builds a very simple sysfs structure without nested namespaces, so it
     * requires device names to be unique. Some gudev client programs might make
     * assumptions about the name (e. g. a SCSI disk block device should be called
     * sdaN). A device also has an arbitrary number of sysfs attributes and udev
     * properties; usually you should specify them upon creation, but it is also
     * possible to change them later on with umockdev_testbed_set_attribute() and
     * umockdev_testbed_set_property().
     *
     * If the pseudo-property "__DEVCONTEXT" is present, the SELinux context of the device's
     * DEVNODE will be set to that value.
     *
     * This will synthesize an "add" uevent.
     *
     * Returns: The sysfs path for the newly created device. Free with g_free().
     *
     * Rename to: umockdev_testbed_add_device
     */
gchar*
umockdev_testbed_add_devicev (UMockdevTestbed* self,
                              const gchar* subsystem,
                              const gchar* name,
                              const gchar* parent,
                              gchar** attributes,
                              gchar** properties)
{
	gchar* dev_path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* result;
#line 554 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 554 "../src/umockdev.vala"
	g_return_val_if_fail (subsystem != NULL, NULL);
#line 554 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 558 "../src/umockdev.vala"
	_tmp0_ = umockdev_testbed_add_devicev_no_uevent (self, subsystem, name, parent, attributes, properties);
#line 558 "../src/umockdev.vala"
	dev_path = _tmp0_;
#line 560 "../src/umockdev.vala"
	_tmp2_ = dev_path;
#line 560 "../src/umockdev.vala"
	if (_tmp2_ != NULL) {
#line 560 "../src/umockdev.vala"
		_tmp1_ = umockdev_in_mock_environment ();
#line 3242 "umockdev.c"
	} else {
#line 560 "../src/umockdev.vala"
		_tmp1_ = FALSE;
#line 3246 "umockdev.c"
	}
#line 560 "../src/umockdev.vala"
	if (_tmp1_) {
#line 3250 "umockdev.c"
		const gchar* _tmp3_;
#line 561 "../src/umockdev.vala"
		_tmp3_ = dev_path;
#line 561 "../src/umockdev.vala"
		umockdev_testbed_uevent (self, _tmp3_, "add");
#line 3256 "umockdev.c"
	}
#line 563 "../src/umockdev.vala"
	result = dev_path;
#line 563 "../src/umockdev.vala"
	return result;
#line 3262 "umockdev.c"
}

/**
     * umockdev_testbed_add_device: (skip)
     * @self: A #UMockdevTestbed.
     * @subsystem: The subsystem name, e. g. "usb"
     * @name: The device name; arbitrary, but needs to be unique within the testbed
     * @parent: (allow-none): device path of the parent device. Use %NULL for a
     *          top-level device.
     * @...: Arbitrarily many pairs of sysfs attributes (alternating names and
     *       values), terminated by %NULL, followed by arbitrarily many pairs of udev
     *       properties, terminated by another %NULL.
     *
     * Add a new device to the testbed. A Linux kernel device always has a
     * subsystem (such as "usb" or "pci"), and a device name. The test bed only
     * builds a very simple sysfs structure without nested namespaces, so it
     * requires device names to be unique. Some gudev client programs might make
     * assumptions about the name (e. g. a SCSI disk block device should be called
     * sdaN). A device also has an arbitrary number of sysfs attributes and udev
     * properties; usually you should specify them upon creation, but it is also
     * possible to change them later on with umockdev_testbed_set_attribute() and
     * umockdev_testbed_set_property().
     *
     * If the pseudo-property "__DEVCONTEXT" is present, the SELinux context of the device's
     * DEVNODE will be set to that value.
     *
     * This will synthesize an "add" uevent.
     *
     * Example:
     *   |[
     *   umockdev_testbed_add_device (testbed, "usb", "dev1", NULL,
     *                              "idVendor", "0815", "idProduct", "AFFE", NULL,
     *                              "ID_MODEL", "KoolGadget", NULL);
     *   ]|
     *
     * Returns: The sysfs path for the newly created device. Free with g_free().
     */
static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 619 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 619 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 619 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3312 "umockdev.c"
	}
#line 619 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 619 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 3318 "umockdev.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 621 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 621 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 621 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3333 "umockdev.c"
	}
#line 621 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 621 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 3339 "umockdev.c"
}

gchar*
umockdev_testbed_add_device (UMockdevTestbed* self,
                             const gchar* subsystem,
                             const gchar* name,
                             const gchar* parent,
                             ...)
{
	gchar** attributes = NULL;
	gchar** _tmp0_;
	gint attributes_length1;
	gint _attributes_size_;
	gchar** properties = NULL;
	gchar** _tmp1_;
	gint properties_length1;
	gint _properties_size_;
	gint arg_set = 0;
	va_list l = {0};
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* result;
#line 601 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 601 "../src/umockdev.vala"
	g_return_val_if_fail (subsystem != NULL, NULL);
#line 601 "../src/umockdev.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 603 "../src/umockdev.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 603 "../src/umockdev.vala"
	attributes = _tmp0_;
#line 603 "../src/umockdev.vala"
	attributes_length1 = 0;
#line 603 "../src/umockdev.vala"
	_attributes_size_ = attributes_length1;
#line 604 "../src/umockdev.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 604 "../src/umockdev.vala"
	properties = _tmp1_;
#line 604 "../src/umockdev.vala"
	properties_length1 = 0;
#line 604 "../src/umockdev.vala"
	_properties_size_ = properties_length1;
#line 605 "../src/umockdev.vala"
	arg_set = 0;
#line 609 "../src/umockdev.vala"
	va_start (l, parent);
#line 610 "../src/umockdev.vala"
	while (TRUE) {
#line 3393 "umockdev.c"
		gchar* arg = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
#line 611 "../src/umockdev.vala"
		_tmp2_ = va_arg (l, gchar*);
#line 611 "../src/umockdev.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 611 "../src/umockdev.vala"
		arg = _tmp3_;
#line 612 "../src/umockdev.vala"
		_tmp4_ = arg;
#line 612 "../src/umockdev.vala"
		if (_tmp4_ == NULL) {
#line 3408 "umockdev.c"
			gint _tmp5_;
#line 613 "../src/umockdev.vala"
			arg_set = arg_set + 1;
#line 613 "../src/umockdev.vala"
			_tmp5_ = arg_set;
#line 613 "../src/umockdev.vala"
			if (_tmp5_ > 1) {
#line 614 "../src/umockdev.vala"
				_g_free0 (arg);
#line 614 "../src/umockdev.vala"
				break;
#line 3420 "umockdev.c"
			} else {
#line 616 "../src/umockdev.vala"
				_g_free0 (arg);
#line 616 "../src/umockdev.vala"
				continue;
#line 3426 "umockdev.c"
			}
		}
#line 618 "../src/umockdev.vala"
		if (arg_set == 0) {
#line 3431 "umockdev.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 619 "../src/umockdev.vala"
			_tmp6_ = arg;
#line 619 "../src/umockdev.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 619 "../src/umockdev.vala"
			_vala_array_add1 (&attributes, &attributes_length1, &_attributes_size_, _tmp7_);
#line 3440 "umockdev.c"
		} else {
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 621 "../src/umockdev.vala"
			_tmp8_ = arg;
#line 621 "../src/umockdev.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 621 "../src/umockdev.vala"
			_vala_array_add2 (&properties, &properties_length1, &_properties_size_, _tmp9_);
#line 3450 "umockdev.c"
		}
#line 610 "../src/umockdev.vala"
		_g_free0 (arg);
#line 3454 "umockdev.c"
	}
#line 624 "../src/umockdev.vala"
	_tmp10_ = attributes;
#line 624 "../src/umockdev.vala"
	_tmp10__length1 = attributes_length1;
#line 624 "../src/umockdev.vala"
	_tmp11_ = properties;
#line 624 "../src/umockdev.vala"
	_tmp11__length1 = properties_length1;
#line 624 "../src/umockdev.vala"
	_tmp12_ = umockdev_testbed_add_devicev (self, subsystem, name, parent, _tmp10_, _tmp11_);
#line 624 "../src/umockdev.vala"
	result = _tmp12_;
#line 624 "../src/umockdev.vala"
	va_end (l);
#line 624 "../src/umockdev.vala"
	properties = (_vala_array_free (properties, properties_length1, (GDestroyNotify) g_free), NULL);
#line 624 "../src/umockdev.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 624 "../src/umockdev.vala"
	return result;
#line 3476 "umockdev.c"
}

/**
     * umockdev_testbed_remove_device:
     * @self: A #UMockdevTestbed.
     * @syspath: Sysfs path of device
     *
     * Remove a device from the testbed. This removes the sysfs directory, the
     * /sys/class/ link, the device node, and all other information related to
     * it. Note that this will also remove all child devices (i. e.
     * subdirectories of @syspath).
     */
void
umockdev_testbed_remove_device (UMockdevTestbed* self,
                                const gchar* syspath)
{
	gchar* real_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* devname = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* subsystem = NULL;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp63_;
	GError* _inner_error0_ = NULL;
#line 637 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 637 "../src/umockdev.vala"
	g_return_if_fail (syspath != NULL);
#line 639 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 639 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, syspath, NULL);
#line 639 "../src/umockdev.vala"
	real_path = _tmp1_;
#line 640 "../src/umockdev.vala"
	_tmp2_ = g_path_get_basename (syspath);
#line 640 "../src/umockdev.vala"
	devname = _tmp2_;
#line 642 "../src/umockdev.vala"
	_tmp3_ = real_path;
#line 642 "../src/umockdev.vala"
	if (!g_file_test (_tmp3_, G_FILE_TEST_IS_DIR)) {
#line 643 "../src/umockdev.vala"
		g_critical ("umockdev.vala:643: umockdev_testbed_remove_device(): device %s does no" \
"t exist", syspath);
#line 644 "../src/umockdev.vala"
		_g_free0 (devname);
#line 644 "../src/umockdev.vala"
		_g_free0 (real_path);
#line 644 "../src/umockdev.vala"
		return;
#line 3538 "umockdev.c"
	}
	{
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 651 "../src/umockdev.vala"
		_tmp5_ = real_path;
#line 651 "../src/umockdev.vala"
		_tmp6_ = g_build_filename (_tmp5_, "subsystem", NULL);
#line 651 "../src/umockdev.vala"
		_tmp7_ = _tmp6_;
#line 651 "../src/umockdev.vala"
		_tmp8_ = g_file_read_link (_tmp7_, &_inner_error0_);
#line 651 "../src/umockdev.vala"
		_tmp9_ = _tmp8_;
#line 651 "../src/umockdev.vala"
		_g_free0 (_tmp7_);
#line 651 "../src/umockdev.vala"
		_tmp4_ = _tmp9_;
#line 651 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 651 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3566 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 651 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 651 "../src/umockdev.vala"
			_g_free0 (devname);
#line 651 "../src/umockdev.vala"
			_g_free0 (real_path);
#line 651 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 651 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 651 "../src/umockdev.vala"
			return;
#line 3581 "umockdev.c"
		}
#line 650 "../src/umockdev.vala"
		_tmp10_ = g_path_get_basename (_tmp4_);
#line 650 "../src/umockdev.vala"
		_g_free0 (subsystem);
#line 650 "../src/umockdev.vala"
		subsystem = _tmp10_;
#line 649 "../src/umockdev.vala"
		_g_free0 (_tmp4_);
#line 3591 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 649 "../src/umockdev.vala"
		e = _inner_error0_;
#line 649 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 653 "../src/umockdev.vala"
		_tmp11_ = e;
#line 653 "../src/umockdev.vala"
		_tmp12_ = _tmp11_->message;
#line 653 "../src/umockdev.vala"
		g_critical ("umockdev.vala:653: umockdev_testbed_remove_device(): cannot determine " \
"subsystem of %s: %s", syspath, _tmp12_);
#line 655 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 655 "../src/umockdev.vala"
		_g_free0 (subsystem);
#line 655 "../src/umockdev.vala"
		_g_free0 (devname);
#line 655 "../src/umockdev.vala"
		_g_free0 (real_path);
#line 655 "../src/umockdev.vala"
		return;
#line 3619 "umockdev.c"
	}
	__finally0:
#line 649 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 649 "../src/umockdev.vala"
		_g_free0 (subsystem);
#line 649 "../src/umockdev.vala"
		_g_free0 (devname);
#line 649 "../src/umockdev.vala"
		_g_free0 (real_path);
#line 649 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 649 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 649 "../src/umockdev.vala"
		return;
#line 3636 "umockdev.c"
	}
	{
		gchar* dev_maj_min = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* dev_node = NULL;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
#line 661 "../src/umockdev.vala"
		_tmp13_ = real_path;
#line 661 "../src/umockdev.vala"
		_tmp14_ = g_build_filename (_tmp13_, "dev", NULL);
#line 661 "../src/umockdev.vala"
		_tmp15_ = _tmp14_;
#line 661 "../src/umockdev.vala"
		g_file_get_contents (_tmp15_, &_tmp16_, NULL, &_inner_error0_);
#line 661 "../src/umockdev.vala"
		_g_free0 (dev_maj_min);
#line 661 "../src/umockdev.vala"
		dev_maj_min = _tmp16_;
#line 661 "../src/umockdev.vala"
		_g_free0 (_tmp15_);
#line 661 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 661 "../src/umockdev.vala"
			_g_free0 (dev_maj_min);
#line 661 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3673 "umockdev.c"
				goto __catch1_g_file_error;
			}
#line 661 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 661 "../src/umockdev.vala"
			_g_free0 (devname);
#line 661 "../src/umockdev.vala"
			_g_free0 (real_path);
#line 661 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 661 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 661 "../src/umockdev.vala"
			return;
#line 3688 "umockdev.c"
		}
#line 663 "../src/umockdev.vala"
		if (string_contains (syspath, "/block/")) {
#line 663 "../src/umockdev.vala"
			_tmp17_ = "block";
#line 3694 "umockdev.c"
		} else {
#line 663 "../src/umockdev.vala"
			_tmp17_ = "char";
#line 3698 "umockdev.c"
		}
#line 662 "../src/umockdev.vala"
		_tmp18_ = self->priv->sys_dir;
#line 662 "../src/umockdev.vala"
		_tmp19_ = dev_maj_min;
#line 662 "../src/umockdev.vala"
		_tmp20_ = g_build_filename (_tmp18_, "dev", _tmp17_, _tmp19_, NULL);
#line 662 "../src/umockdev.vala"
		_tmp21_ = _tmp20_;
#line 662 "../src/umockdev.vala"
		g_unlink (_tmp21_);
#line 662 "../src/umockdev.vala"
		_g_free0 (_tmp21_);
#line 665 "../src/umockdev.vala"
		_tmp22_ = real_path;
#line 665 "../src/umockdev.vala"
		_tmp23_ = umockdev_find_devnode (_tmp22_);
#line 665 "../src/umockdev.vala"
		dev_node = _tmp23_;
#line 666 "../src/umockdev.vala"
		_tmp24_ = dev_node;
#line 666 "../src/umockdev.vala"
		if (_tmp24_ != NULL) {
#line 3722 "umockdev.c"
			gchar* real_node = NULL;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 667 "../src/umockdev.vala"
			_tmp25_ = self->priv->root_dir;
#line 667 "../src/umockdev.vala"
			_tmp26_ = dev_node;
#line 667 "../src/umockdev.vala"
			_tmp27_ = g_build_filename (_tmp25_, _tmp26_, NULL);
#line 667 "../src/umockdev.vala"
			real_node = _tmp27_;
#line 668 "../src/umockdev.vala"
			_tmp28_ = real_node;
#line 668 "../src/umockdev.vala"
			g_unlink (_tmp28_);
#line 669 "../src/umockdev.vala"
			_tmp29_ = real_node;
#line 669 "../src/umockdev.vala"
			_tmp30_ = g_path_get_dirname (_tmp29_);
#line 669 "../src/umockdev.vala"
			_tmp31_ = _tmp30_;
#line 669 "../src/umockdev.vala"
			g_rmdir (_tmp31_);
#line 669 "../src/umockdev.vala"
			_g_free0 (_tmp31_);
#line 670 "../src/umockdev.vala"
			_tmp32_ = self->priv->root_dir;
#line 670 "../src/umockdev.vala"
			_tmp33_ = dev_node;
#line 670 "../src/umockdev.vala"
			_tmp34_ = string_substring (_tmp33_, (glong) 5, (glong) -1);
#line 670 "../src/umockdev.vala"
			_tmp35_ = _tmp34_;
#line 670 "../src/umockdev.vala"
			_tmp36_ = string_replace (_tmp35_, "/", "_");
#line 670 "../src/umockdev.vala"
			_tmp37_ = _tmp36_;
#line 670 "../src/umockdev.vala"
			_tmp38_ = g_build_filename (_tmp32_, "dev", ".node", _tmp37_, NULL);
#line 670 "../src/umockdev.vala"
			_tmp39_ = _tmp38_;
#line 670 "../src/umockdev.vala"
			g_unlink (_tmp39_);
#line 670 "../src/umockdev.vala"
			_g_free0 (_tmp39_);
#line 670 "../src/umockdev.vala"
			_g_free0 (_tmp37_);
#line 670 "../src/umockdev.vala"
			_g_free0 (_tmp35_);
#line 666 "../src/umockdev.vala"
			_g_free0 (real_node);
#line 3787 "umockdev.c"
		}
#line 659 "../src/umockdev.vala"
		_g_free0 (dev_node);
#line 659 "../src/umockdev.vala"
		_g_free0 (dev_maj_min);
#line 3793 "umockdev.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
#line 659 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 3800 "umockdev.c"
	}
	__finally1:
#line 659 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 659 "../src/umockdev.vala"
		_g_free0 (subsystem);
#line 659 "../src/umockdev.vala"
		_g_free0 (devname);
#line 659 "../src/umockdev.vala"
		_g_free0 (real_path);
#line 659 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 659 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 659 "../src/umockdev.vala"
		return;
#line 3817 "umockdev.c"
	}
#line 675 "../src/umockdev.vala"
	_tmp40_ = self->priv->sys_dir;
#line 675 "../src/umockdev.vala"
	_tmp41_ = subsystem;
#line 675 "../src/umockdev.vala"
	_tmp42_ = devname;
#line 675 "../src/umockdev.vala"
	_tmp43_ = g_build_filename (_tmp40_, "class", _tmp41_, _tmp42_, NULL);
#line 675 "../src/umockdev.vala"
	_tmp44_ = _tmp43_;
#line 675 "../src/umockdev.vala"
	g_unlink (_tmp44_);
#line 675 "../src/umockdev.vala"
	_g_free0 (_tmp44_);
#line 676 "../src/umockdev.vala"
	_tmp45_ = self->priv->sys_dir;
#line 676 "../src/umockdev.vala"
	_tmp46_ = subsystem;
#line 676 "../src/umockdev.vala"
	_tmp47_ = g_build_filename (_tmp45_, "class", _tmp46_, NULL);
#line 676 "../src/umockdev.vala"
	_tmp48_ = _tmp47_;
#line 676 "../src/umockdev.vala"
	g_rmdir (_tmp48_);
#line 676 "../src/umockdev.vala"
	_g_free0 (_tmp48_);
#line 678 "../src/umockdev.vala"
	_tmp49_ = subsystem;
#line 678 "../src/umockdev.vala"
	if (umockdev_testbed_subsystem_is_bus (_tmp49_)) {
#line 3849 "umockdev.c"
		const gchar* _tmp50_;
		const gchar* _tmp51_;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		const gchar* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
#line 679 "../src/umockdev.vala"
		_tmp50_ = self->priv->sys_dir;
#line 679 "../src/umockdev.vala"
		_tmp51_ = subsystem;
#line 679 "../src/umockdev.vala"
		_tmp52_ = devname;
#line 679 "../src/umockdev.vala"
		_tmp53_ = g_build_filename (_tmp50_, "bus", _tmp51_, "devices", _tmp52_, NULL);
#line 679 "../src/umockdev.vala"
		_tmp54_ = _tmp53_;
#line 679 "../src/umockdev.vala"
		g_unlink (_tmp54_);
#line 679 "../src/umockdev.vala"
		_g_free0 (_tmp54_);
#line 680 "../src/umockdev.vala"
		_tmp55_ = self->priv->sys_dir;
#line 680 "../src/umockdev.vala"
		_tmp56_ = subsystem;
#line 680 "../src/umockdev.vala"
		_tmp57_ = g_build_filename (_tmp55_, "bus", _tmp56_, "devices", NULL);
#line 680 "../src/umockdev.vala"
		_tmp58_ = _tmp57_;
#line 680 "../src/umockdev.vala"
		g_rmdir (_tmp58_);
#line 680 "../src/umockdev.vala"
		_g_free0 (_tmp58_);
#line 681 "../src/umockdev.vala"
		_tmp59_ = self->priv->sys_dir;
#line 681 "../src/umockdev.vala"
		_tmp60_ = subsystem;
#line 681 "../src/umockdev.vala"
		_tmp61_ = g_build_filename (_tmp59_, "bus", _tmp60_, NULL);
#line 681 "../src/umockdev.vala"
		_tmp62_ = _tmp61_;
#line 681 "../src/umockdev.vala"
		g_rmdir (_tmp62_);
#line 681 "../src/umockdev.vala"
		_g_free0 (_tmp62_);
#line 3901 "umockdev.c"
	}
#line 684 "../src/umockdev.vala"
	_tmp63_ = real_path;
#line 684 "../src/umockdev.vala"
	umockdev_utils_remove_dir (_tmp63_, TRUE);
#line 637 "../src/umockdev.vala"
	_g_free0 (subsystem);
#line 637 "../src/umockdev.vala"
	_g_free0 (devname);
#line 637 "../src/umockdev.vala"
	_g_free0 (real_path);
#line 3913 "umockdev.c"
}

/**
     * umockdev_testbed_add_from_string:
     * @self: A #UMockdevTestbed.
     * @data: Description of the device(s) as generated with umockdev-record
     * @error: return location for a GError, or %NULL
     *
     * Add a set of devices to the testbed from a textual description. This reads
     * the format generated by the umockdev-record tool.
     *
     * Each paragraph defines one device. A line starts with a type tag (like 'E'),
     * followed by a colon, followed by either a value or a "key=value" assignment,
     * depending on the type tag. A device description must start with a 'P:' line.
     * Available type tags are:
     * <itemizedlist>
     *   <listitem><type>P:</type> <emphasis>path</emphasis>: device path in sysfs, starting with
     *             <filename>/devices/</filename>; must occur exactly once at the
     *             start of device definition</listitem>
     *   <listitem><type>E:</type> <emphasis>key=value</emphasis>: udev property
     *             </listitem>
     *   <listitem><type>A:</type> <emphasis>key=value</emphasis>: ASCII sysfs
     *             attribute, with backslash-style escaping of \ (\\) and newlines
     *             (\n)</listitem>
     *   <listitem><type>H:</type> <emphasis>key=value</emphasis>: binary sysfs
     *             attribute, with the value being written as continuous hex string
     *             (e. g. 0081FE0A..)</listitem>
     *   <listitem><type>N:</type> <emphasis>devname</emphasis>[=<emphasis>contents</emphasis>]:
     *             device node name (without the <filename>/dev/</filename>
     *             prefix); if <emphasis>contents</emphasis> is given (encoded in a
     *             continuous hex string), it creates a
     *             <filename>/dev/devname</filename> in the mock environment with
     *             the given contents, otherwise the created dev file will be a
     *             pty; see #umockdev_testbed_get_dev_fd for details.</listitem>
     *   <listitem><type>S:</type> <emphasis>linkname</emphasis>: device node
     *             symlink (without the <filename>/dev/</filename> prefix); ignored right
     *             now.</listitem>
     * </itemizedlist>
     *
     * Returns: %TRUE on success, %FALSE if the data is invalid and an error
     *          occurred.
     */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 3970 "umockdev.c"
}

gboolean
umockdev_testbed_add_from_string (UMockdevTestbed* self,
                                  const gchar* data,
                                  GError** error)
{
	gchar* cur_data = NULL;
	gchar* _tmp18_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 727 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 727 "../src/umockdev.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 3986 "umockdev.c"
	{
		GRegex* _tmp0_;
		GRegex* _tmp5_;
		GRegex* _tmp10_;
#line 731 "../src/umockdev.vala"
		_tmp0_ = self->priv->re_record_val;
#line 731 "../src/umockdev.vala"
		if (_tmp0_ == NULL) {
#line 3995 "umockdev.c"
			GRegex* _tmp1_ = NULL;
			GRegex* _tmp2_;
			GRegex* _tmp4_;
#line 732 "../src/umockdev.vala"
			_tmp2_ = g_regex_new ("^([PS]): (.*)(?>\n|$)", 0, 0, &_inner_error0_);
#line 732 "../src/umockdev.vala"
			_tmp1_ = _tmp2_;
#line 732 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4005 "umockdev.c"
				gboolean _tmp3_ = FALSE;
#line 732 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4009 "umockdev.c"
					goto __catch0_g_regex_error;
				}
#line 732 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 732 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 732 "../src/umockdev.vala"
				return _tmp3_;
#line 4018 "umockdev.c"
			}
#line 732 "../src/umockdev.vala"
			_tmp4_ = _tmp1_;
#line 732 "../src/umockdev.vala"
			_tmp1_ = NULL;
#line 732 "../src/umockdev.vala"
			_g_regex_unref0 (self->priv->re_record_val);
#line 732 "../src/umockdev.vala"
			self->priv->re_record_val = _tmp4_;
#line 731 "../src/umockdev.vala"
			_g_regex_unref0 (_tmp1_);
#line 4030 "umockdev.c"
		}
#line 733 "../src/umockdev.vala"
		_tmp5_ = self->priv->re_record_keyval;
#line 733 "../src/umockdev.vala"
		if (_tmp5_ == NULL) {
#line 4036 "umockdev.c"
			GRegex* _tmp6_ = NULL;
			GRegex* _tmp7_;
			GRegex* _tmp9_;
#line 734 "../src/umockdev.vala"
			_tmp7_ = g_regex_new ("^([EAHL]): ([^=\n]+)=(.*)(?>\n|$)", 0, 0, &_inner_error0_);
#line 734 "../src/umockdev.vala"
			_tmp6_ = _tmp7_;
#line 734 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4046 "umockdev.c"
				gboolean _tmp8_ = FALSE;
#line 734 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4050 "umockdev.c"
					goto __catch0_g_regex_error;
				}
#line 734 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 734 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 734 "../src/umockdev.vala"
				return _tmp8_;
#line 4059 "umockdev.c"
			}
#line 734 "../src/umockdev.vala"
			_tmp9_ = _tmp6_;
#line 734 "../src/umockdev.vala"
			_tmp6_ = NULL;
#line 734 "../src/umockdev.vala"
			_g_regex_unref0 (self->priv->re_record_keyval);
#line 734 "../src/umockdev.vala"
			self->priv->re_record_keyval = _tmp9_;
#line 733 "../src/umockdev.vala"
			_g_regex_unref0 (_tmp6_);
#line 4071 "umockdev.c"
		}
#line 735 "../src/umockdev.vala"
		_tmp10_ = self->priv->re_record_optval;
#line 735 "../src/umockdev.vala"
		if (_tmp10_ == NULL) {
#line 4077 "umockdev.c"
			GRegex* _tmp11_ = NULL;
			GRegex* _tmp12_;
			GRegex* _tmp14_;
#line 736 "../src/umockdev.vala"
			_tmp12_ = g_regex_new ("^([N]): ([^=\n]+)(?>=([0-9A-F]+))?(?>\n|$)", 0, 0, &_inner_error0_);
#line 736 "../src/umockdev.vala"
			_tmp11_ = _tmp12_;
#line 736 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4087 "umockdev.c"
				gboolean _tmp13_ = FALSE;
#line 736 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4091 "umockdev.c"
					goto __catch0_g_regex_error;
				}
#line 736 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 736 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 736 "../src/umockdev.vala"
				return _tmp13_;
#line 4100 "umockdev.c"
			}
#line 736 "../src/umockdev.vala"
			_tmp14_ = _tmp11_;
#line 736 "../src/umockdev.vala"
			_tmp11_ = NULL;
#line 736 "../src/umockdev.vala"
			_g_regex_unref0 (self->priv->re_record_optval);
#line 736 "../src/umockdev.vala"
			self->priv->re_record_optval = _tmp14_;
#line 735 "../src/umockdev.vala"
			_g_regex_unref0 (_tmp11_);
#line 4112 "umockdev.c"
		}
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		const gchar* _tmp15_;
#line 730 "../src/umockdev.vala"
		e = _inner_error0_;
#line 730 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 738 "../src/umockdev.vala"
		_tmp15_ = e->message;
#line 738 "../src/umockdev.vala"
		g_error ("umockdev.vala:738: Internal error, cannot create regex: %s", _tmp15_);
#line 730 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 4130 "umockdev.c"
	}
	__finally0:
#line 730 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 730 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 4137 "umockdev.c"
			gboolean _tmp16_ = FALSE;
#line 730 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 730 "../src/umockdev.vala"
			return _tmp16_;
#line 4143 "umockdev.c"
		} else {
			gboolean _tmp17_ = FALSE;
#line 730 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 730 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 730 "../src/umockdev.vala"
			return _tmp17_;
#line 4152 "umockdev.c"
		}
	}
#line 741 "../src/umockdev.vala"
	_tmp18_ = g_strdup (data);
#line 741 "../src/umockdev.vala"
	cur_data = _tmp18_;
#line 742 "../src/umockdev.vala"
	while (TRUE) {
#line 4161 "umockdev.c"
		const gchar* _tmp19_;
		gchar* _tmp20_ = NULL;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp25_;
#line 742 "../src/umockdev.vala"
		_tmp19_ = cur_data;
#line 742 "../src/umockdev.vala"
		if (!(string_get (_tmp19_, (glong) 0) != '\0')) {
#line 742 "../src/umockdev.vala"
			break;
#line 4173 "umockdev.c"
		}
#line 743 "../src/umockdev.vala"
		_tmp21_ = cur_data;
#line 743 "../src/umockdev.vala"
		_tmp22_ = umockdev_testbed_add_dev_from_string (self, _tmp21_, &_inner_error0_);
#line 743 "../src/umockdev.vala"
		_tmp20_ = _tmp22_;
#line 743 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 743 "../src/umockdev.vala"
			if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 4185 "umockdev.c"
				gboolean _tmp23_ = FALSE;
#line 743 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 743 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 743 "../src/umockdev.vala"
				return _tmp23_;
#line 4193 "umockdev.c"
			} else {
				gboolean _tmp24_ = FALSE;
#line 743 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 743 "../src/umockdev.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 743 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 743 "../src/umockdev.vala"
				return _tmp24_;
#line 4204 "umockdev.c"
			}
		}
#line 743 "../src/umockdev.vala"
		_tmp25_ = _tmp20_;
#line 743 "../src/umockdev.vala"
		_tmp20_ = NULL;
#line 743 "../src/umockdev.vala"
		_g_free0 (cur_data);
#line 743 "../src/umockdev.vala"
		cur_data = _tmp25_;
#line 742 "../src/umockdev.vala"
		_g_free0 (_tmp20_);
#line 4217 "umockdev.c"
	}
#line 745 "../src/umockdev.vala"
	result = TRUE;
#line 745 "../src/umockdev.vala"
	_g_free0 (cur_data);
#line 745 "../src/umockdev.vala"
	return result;
#line 4225 "umockdev.c"
}

/**
     * umockdev_testbed_add_from_file:
     * @self: A #UMockdevTestbed.
     * @path: Path to file with description of the device(s) as generated with umockdev-record
     * @error: return location for a GError, or %NULL
     *
     * Add a set of devices to the testbed from a textual description. This
     * reads a file with the format generated by the umockdev-record tool, and
     * is mostly a convenience wrapper around
     * @umockdev_testbed_add_from_string.
     *
     * Returns: %TRUE on success, %FALSE if the @path cannot be read or thhe
     *          data is invalid and an error occurred.
     */
gboolean
umockdev_testbed_add_from_file (UMockdevTestbed* self,
                                const gchar* path,
                                GError** error)
{
	gchar* contents = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 762 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 762 "../src/umockdev.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 766 "../src/umockdev.vala"
	g_file_get_contents (path, &_tmp0_, NULL, &_inner_error0_);
#line 766 "../src/umockdev.vala"
	_g_free0 (contents);
#line 766 "../src/umockdev.vala"
	contents = _tmp0_;
#line 766 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 766 "../src/umockdev.vala"
		if ((_inner_error0_->domain == UMOCKDEV_ERROR) || (_inner_error0_->domain == G_FILE_ERROR)) {
#line 4267 "umockdev.c"
			gboolean _tmp1_ = FALSE;
#line 766 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 766 "../src/umockdev.vala"
			_g_free0 (contents);
#line 766 "../src/umockdev.vala"
			return _tmp1_;
#line 4275 "umockdev.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 766 "../src/umockdev.vala"
			_g_free0 (contents);
#line 766 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 766 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 766 "../src/umockdev.vala"
			return _tmp2_;
#line 4286 "umockdev.c"
		}
	}
#line 767 "../src/umockdev.vala"
	_tmp4_ = contents;
#line 767 "../src/umockdev.vala"
	_tmp3_ = umockdev_testbed_add_from_string (self, _tmp4_, &_inner_error0_);
#line 767 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 767 "../src/umockdev.vala"
		if ((_inner_error0_->domain == UMOCKDEV_ERROR) || (_inner_error0_->domain == G_FILE_ERROR)) {
#line 4297 "umockdev.c"
			gboolean _tmp5_ = FALSE;
#line 767 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 767 "../src/umockdev.vala"
			_g_free0 (contents);
#line 767 "../src/umockdev.vala"
			return _tmp5_;
#line 4305 "umockdev.c"
		} else {
			gboolean _tmp6_ = FALSE;
#line 767 "../src/umockdev.vala"
			_g_free0 (contents);
#line 767 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 767 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 767 "../src/umockdev.vala"
			return _tmp6_;
#line 4316 "umockdev.c"
		}
	}
#line 767 "../src/umockdev.vala"
	result = _tmp3_;
#line 767 "../src/umockdev.vala"
	_g_free0 (contents);
#line 767 "../src/umockdev.vala"
	return result;
#line 4325 "umockdev.c"
}

/**
     * umockdev_testbed_uevent:
     * @self: A #UMockdevTestbed.
     * @devpath: The full device path, as returned by #umockdev_testbed_add_device()
     * @action: "add", "remove", or "change"
     *
     * Generate an uevent for a device.
     */
void
umockdev_testbed_uevent (UMockdevTestbed* self,
                         const gchar* devpath,
                         const gchar* action)
{
	uevent_sender* _tmp0_;
	gchar* uevent_path = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* properties = NULL;
	gchar* _tmp6_;
	uevent_sender* _tmp10_;
	const gchar* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 778 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 778 "../src/umockdev.vala"
	g_return_if_fail (devpath != NULL);
#line 778 "../src/umockdev.vala"
	g_return_if_fail (action != NULL);
#line 780 "../src/umockdev.vala"
	_tmp0_ = self->priv->ev_sender;
#line 780 "../src/umockdev.vala"
	if (_tmp0_ == NULL) {
#line 4360 "umockdev.c"
		const gchar* _tmp1_;
		uevent_sender* _tmp2_;
		uevent_sender* _tmp3_;
#line 781 "../src/umockdev.vala"
		g_debug ("umockdev.vala:781: umockdev_testbed_uevent: lazily initializing uevent" \
"_sender");
#line 782 "../src/umockdev.vala"
		_tmp1_ = self->priv->root_dir;
#line 782 "../src/umockdev.vala"
		_tmp2_ = uevent_sender_open (_tmp1_);
#line 782 "../src/umockdev.vala"
		_uevent_sender_close0 (self->priv->ev_sender);
#line 782 "../src/umockdev.vala"
		self->priv->ev_sender = _tmp2_;
#line 783 "../src/umockdev.vala"
		_tmp3_ = self->priv->ev_sender;
#line 783 "../src/umockdev.vala"
		_vala_assert (_tmp3_ != NULL, "this.ev_sender != null");
#line 4378 "umockdev.c"
	}
#line 785 "../src/umockdev.vala"
	g_debug ("umockdev.vala:785: umockdev_testbed_uevent: sending uevent %s for devi" \
"ce %s", action, devpath);
#line 787 "../src/umockdev.vala"
	_tmp4_ = self->priv->root_dir;
#line 787 "../src/umockdev.vala"
	_tmp5_ = g_build_filename (_tmp4_, devpath, "uevent", NULL);
#line 787 "../src/umockdev.vala"
	uevent_path = _tmp5_;
#line 788 "../src/umockdev.vala"
	_tmp6_ = g_strdup ("");
#line 788 "../src/umockdev.vala"
	properties = _tmp6_;
#line 4392 "umockdev.c"
	{
		gchar* _tmp7_ = NULL;
#line 790 "../src/umockdev.vala"
		g_file_get_contents (uevent_path, &_tmp7_, NULL, &_inner_error0_);
#line 790 "../src/umockdev.vala"
		_g_free0 (properties);
#line 790 "../src/umockdev.vala"
		properties = _tmp7_;
#line 790 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 790 "../src/umockdev.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 4405 "umockdev.c"
				goto __catch0_g_file_error;
			}
#line 790 "../src/umockdev.vala"
			_g_free0 (properties);
#line 790 "../src/umockdev.vala"
			_g_free0 (uevent_path);
#line 790 "../src/umockdev.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 790 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 790 "../src/umockdev.vala"
			return;
#line 4418 "umockdev.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 789 "../src/umockdev.vala"
		e = _inner_error0_;
#line 789 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 792 "../src/umockdev.vala"
		_tmp8_ = e;
#line 792 "../src/umockdev.vala"
		_tmp9_ = _tmp8_->message;
#line 792 "../src/umockdev.vala"
		g_debug ("umockdev.vala:792: uevent: devpath %s has no uevent file: %s", devpath, _tmp9_);
#line 789 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 4439 "umockdev.c"
	}
	__finally0:
#line 789 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 789 "../src/umockdev.vala"
		_g_free0 (properties);
#line 789 "../src/umockdev.vala"
		_g_free0 (uevent_path);
#line 789 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 789 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 789 "../src/umockdev.vala"
		return;
#line 4454 "umockdev.c"
	}
#line 794 "../src/umockdev.vala"
	_tmp10_ = self->priv->ev_sender;
#line 794 "../src/umockdev.vala"
	_tmp11_ = properties;
#line 794 "../src/umockdev.vala"
	uevent_sender_send (_tmp10_, devpath, action, _tmp11_);
#line 778 "../src/umockdev.vala"
	_g_free0 (properties);
#line 778 "../src/umockdev.vala"
	_g_free0 (uevent_path);
#line 4466 "umockdev.c"
}

/**
     * umockdev_testbed_attach_ioctl:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) to attach to.
     * @handler: a #UMockdevIoctlBase instance to handle requests
     * @error: return location for a GError, or %NULL
     *
     * Attach an #UMockdevIoctlBase object to handle ioctl, read and write
     * syscalls on the given device file. This allows emulating arbitrary
     * ioctl's and read/write calls for which umockdev does not have builtin
     * support.
     *
     * Returns: %TRUE on success, %FALSE on error.
     * Since: 0.16
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 819 "../src/umockdev.vala"
	return self ? g_object_ref (self) : NULL;
#line 4489 "umockdev.c"
}

gboolean
umockdev_testbed_attach_ioctl (UMockdevTestbed* self,
                               const gchar* dev,
                               UMockdevIoctlBase* handler,
                               GError** error)
{
	GHashTable* _tmp0_;
	gchar* sockpath = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GMainContext* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	UMockdevIoctlBase* _tmp6_;
	gboolean result;
#line 812 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 812 "../src/umockdev.vala"
	g_return_val_if_fail (dev != NULL, FALSE);
#line 812 "../src/umockdev.vala"
	g_return_val_if_fail (handler != NULL, FALSE);
#line 814 "../src/umockdev.vala"
	_tmp0_ = self->priv->custom_handlers;
#line 814 "../src/umockdev.vala"
	_vala_assert (!g_hash_table_contains (_tmp0_, dev), "!this.custom_handlers.contains (dev)");
#line 816 "../src/umockdev.vala"
	_tmp1_ = self->priv->root_dir;
#line 816 "../src/umockdev.vala"
	_tmp2_ = g_build_filename (_tmp1_, "ioctl", dev, NULL);
#line 816 "../src/umockdev.vala"
	sockpath = _tmp2_;
#line 817 "../src/umockdev.vala"
	_tmp3_ = self->priv->worker_ctx;
#line 817 "../src/umockdev.vala"
	umockdev_ioctl_base_register_path (handler, _tmp3_, dev, sockpath);
#line 819 "../src/umockdev.vala"
	_tmp4_ = self->priv->custom_handlers;
#line 819 "../src/umockdev.vala"
	_tmp5_ = g_strdup (dev);
#line 819 "../src/umockdev.vala"
	_tmp6_ = _g_object_ref0 (handler);
#line 819 "../src/umockdev.vala"
	g_hash_table_insert (_tmp4_, _tmp5_, _tmp6_);
#line 821 "../src/umockdev.vala"
	result = TRUE;
#line 821 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 821 "../src/umockdev.vala"
	return result;
#line 4541 "umockdev.c"
}

/**
     * umockdev_testbed_detach_ioctl:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) to detach.
     * @error: return location for a GError, or %NULL
     *
     * Detach a custom #UMockdevIoctlBase object from an device node again. See
     * umockdev_testbed_attach_ioctl(). It is an error to call this function
     * if the path is not currently attached.
     *
     * Returns: %TRUE on success, %FALSE on error.
     * Since: 0.16
     */
gboolean
umockdev_testbed_detach_ioctl (UMockdevTestbed* self,
                               const gchar* dev,
                               GError** error)
{
	UMockdevIoctlBase* handler = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	UMockdevIoctlBase* _tmp2_;
	UMockdevIoctlBase* _tmp3_;
	UMockdevIoctlBase* _tmp6_;
	GHashTable* _tmp7_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 837 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 837 "../src/umockdev.vala"
	g_return_val_if_fail (dev != NULL, FALSE);
#line 839 "../src/umockdev.vala"
	_tmp0_ = self->priv->custom_handlers;
#line 839 "../src/umockdev.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, dev);
#line 839 "../src/umockdev.vala"
	_tmp2_ = _g_object_ref0 ((UMockdevIoctlBase*) _tmp1_);
#line 839 "../src/umockdev.vala"
	handler = _tmp2_;
#line 841 "../src/umockdev.vala"
	_tmp3_ = handler;
#line 841 "../src/umockdev.vala"
	if (_tmp3_ == NULL) {
#line 4587 "umockdev.c"
		GError* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 842 "../src/umockdev.vala"
		_tmp4_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_FOUND, "No handler for device was registered.");
#line 842 "../src/umockdev.vala"
		_inner_error0_ = _tmp4_;
#line 842 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 842 "../src/umockdev.vala"
		_g_object_unref0 (handler);
#line 842 "../src/umockdev.vala"
		return _tmp5_;
#line 4600 "umockdev.c"
	}
#line 844 "../src/umockdev.vala"
	_tmp6_ = handler;
#line 844 "../src/umockdev.vala"
	umockdev_ioctl_base_unregister_path (_tmp6_, dev);
#line 845 "../src/umockdev.vala"
	_tmp7_ = self->priv->custom_handlers;
#line 845 "../src/umockdev.vala"
	g_hash_table_remove (_tmp7_, dev);
#line 847 "../src/umockdev.vala"
	result = TRUE;
#line 847 "../src/umockdev.vala"
	_g_object_unref0 (handler);
#line 847 "../src/umockdev.vala"
	return result;
#line 4616 "umockdev.c"
}

/**
     * umockdev_testbed_load_ioctl:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) for which to load the ioctl record.
     *       %NULL is valid; in this case the ioctl record is associated with
     *       the device node it was recorded from.
     * @recordfile: Path of the ioctl record file.
     * @error: return location for a GError, or %NULL
     *
     * Load an ioctl record file for a particular device into the testbed.
     * ioctl records can be created with umockdev-record --ioctl.
     * They can optionally be xz compressed to save space (but then are
     * required to have an .xz file name suffix).
     *
     * Returns: %TRUE on success, %FALSE if the data is invalid and an error
     *          occurred.
     */
static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
#line 886 "../src/umockdev.vala"
	if (length > 0) {
#line 886 "../src/umockdev.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 4644 "umockdev.c"
	}
#line 886 "../src/umockdev.vala"
	return NULL;
#line 4648 "umockdev.c"
}

gboolean
umockdev_testbed_load_ioctl (UMockdevTestbed* self,
                             const gchar* dev,
                             const gchar* recordfile,
                             GError** error)
{
	gchar* format = NULL;
	gchar* _tmp0_;
	GDataInputStream* recording = NULL;
	gchar* owned_dev = NULL;
	gchar* _tmp1_;
	gchar* line = NULL;
	GDataInputStream* _tmp27_;
	gchar* _tmp28_;
	GMatchInfo* header_matcher = NULL;
	gboolean _tmp38_ = FALSE;
	const gchar* _tmp39_;
	GDataInputStream* _tmp52_;
	gchar* dest = NULL;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* contents = NULL;
	GDataInputStream* _tmp63_;
	gchar* _tmp64_;
	const gchar* _tmp66_;
	gboolean _tmp68_ = FALSE;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	UMockdevIoctlBase* handler = NULL;
	const gchar* _tmp72_;
	gchar* sockpath = NULL;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	gchar* _tmp79_;
	UMockdevIoctlBase* _tmp80_;
	GMainContext* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 867 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 867 "../src/umockdev.vala"
	g_return_val_if_fail (recordfile != NULL, FALSE);
#line 869 "../src/umockdev.vala"
	_tmp0_ = g_strdup ("");
#line 869 "../src/umockdev.vala"
	format = _tmp0_;
#line 873 "../src/umockdev.vala"
	_tmp1_ = g_strdup (dev);
#line 873 "../src/umockdev.vala"
	owned_dev = _tmp1_;
#line 875 "../src/umockdev.vala"
	if (g_str_has_suffix (recordfile, ".xz")) {
#line 4712 "umockdev.c"
		{
			gchar* contents = NULL;
			gint exit = 0;
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_;
			gint _tmp6__length1;
			gchar* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			const gchar* _tmp10_;
			guint8* _tmp11_;
			gint _tmp11__length1;
			gint _tmp12_ = 0;
			guint8* _tmp13_;
			gint _tmp13__length1;
			guint8* _tmp14_;
			gint _tmp14__length1;
			GMemoryInputStream* _tmp15_;
			GMemoryInputStream* _tmp16_;
			GDataInputStream* _tmp17_;
#line 879 "../src/umockdev.vala"
			_tmp2_ = g_strdup ("xz");
#line 879 "../src/umockdev.vala"
			_tmp3_ = g_strdup ("-cd");
#line 879 "../src/umockdev.vala"
			_tmp4_ = g_strdup (recordfile);
#line 879 "../src/umockdev.vala"
			_tmp5_ = g_new0 (gchar*, 3 + 1);
#line 879 "../src/umockdev.vala"
			_tmp5_[0] = _tmp2_;
#line 879 "../src/umockdev.vala"
			_tmp5_[1] = _tmp3_;
#line 879 "../src/umockdev.vala"
			_tmp5_[2] = _tmp4_;
#line 879 "../src/umockdev.vala"
			_tmp6_ = _tmp5_;
#line 879 "../src/umockdev.vala"
			_tmp6__length1 = 3;
#line 879 "../src/umockdev.vala"
			g_spawn_sync (NULL, _tmp6_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp7_, NULL, &_tmp8_, &_inner_error0_);
#line 879 "../src/umockdev.vala"
			_g_free0 (contents);
#line 879 "../src/umockdev.vala"
			contents = _tmp7_;
#line 879 "../src/umockdev.vala"
			exit = _tmp8_;
#line 879 "../src/umockdev.vala"
			_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 879 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4765 "umockdev.c"
				gboolean _tmp9_ = FALSE;
#line 879 "../src/umockdev.vala"
				_g_free0 (contents);
#line 879 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 4771 "umockdev.c"
					goto __catch0_g_spawn_error;
				}
#line 879 "../src/umockdev.vala"
				_g_free0 (owned_dev);
#line 879 "../src/umockdev.vala"
				_g_object_unref0 (recording);
#line 879 "../src/umockdev.vala"
				_g_free0 (format);
#line 879 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 879 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 879 "../src/umockdev.vala"
				return _tmp9_;
#line 4786 "umockdev.c"
			}
#line 885 "../src/umockdev.vala"
			_vala_assert (exit == 0, "exit == 0");
#line 886 "../src/umockdev.vala"
			_tmp10_ = contents;
#line 886 "../src/umockdev.vala"
			_tmp11_ = string_get_data (_tmp10_, &_tmp12_);
#line 886 "../src/umockdev.vala"
			_tmp11__length1 = _tmp12_;
#line 886 "../src/umockdev.vala"
			_tmp13_ = _tmp11_;
#line 886 "../src/umockdev.vala"
			_tmp13__length1 = _tmp11__length1;
#line 886 "../src/umockdev.vala"
			_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup1 (_tmp13_, _tmp13__length1) : _tmp13_;
#line 886 "../src/umockdev.vala"
			_tmp14__length1 = _tmp13__length1;
#line 886 "../src/umockdev.vala"
			_tmp15_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp14_, _tmp14__length1, NULL);
#line 886 "../src/umockdev.vala"
			_tmp16_ = _tmp15_;
#line 886 "../src/umockdev.vala"
			_tmp17_ = g_data_input_stream_new ((GInputStream*) _tmp16_);
#line 886 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 886 "../src/umockdev.vala"
			recording = _tmp17_;
#line 886 "../src/umockdev.vala"
			_g_object_unref0 (_tmp16_);
#line 876 "../src/umockdev.vala"
			_g_free0 (contents);
#line 4818 "umockdev.c"
		}
		goto __finally0;
		__catch0_g_spawn_error:
		{
			GError* e = NULL;
			const gchar* _tmp18_;
#line 876 "../src/umockdev.vala"
			e = _inner_error0_;
#line 876 "../src/umockdev.vala"
			_inner_error0_ = NULL;
#line 888 "../src/umockdev.vala"
			_tmp18_ = e->message;
#line 888 "../src/umockdev.vala"
			g_error ("umockdev.vala:888: Cannot call xz to decompress %s: %s", recordfile, _tmp18_);
#line 876 "../src/umockdev.vala"
			_g_error_free0 (e);
#line 4835 "umockdev.c"
		}
		__finally0:
#line 876 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4840 "umockdev.c"
			gboolean _tmp19_ = FALSE;
#line 876 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 876 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 876 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 876 "../src/umockdev.vala"
			_g_free0 (format);
#line 876 "../src/umockdev.vala"
			return _tmp19_;
#line 4852 "umockdev.c"
		}
	} else {
		GFileInputStream* _tmp20_ = NULL;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFileInputStream* _tmp23_;
		GFileInputStream* _tmp24_;
		GDataInputStream* _tmp26_;
#line 891 "../src/umockdev.vala"
		_tmp21_ = g_file_new_for_path (recordfile);
#line 891 "../src/umockdev.vala"
		_tmp22_ = _tmp21_;
#line 891 "../src/umockdev.vala"
		_tmp23_ = g_file_read (_tmp22_, NULL, &_inner_error0_);
#line 891 "../src/umockdev.vala"
		_tmp24_ = _tmp23_;
#line 891 "../src/umockdev.vala"
		_g_object_unref0 (_tmp22_);
#line 891 "../src/umockdev.vala"
		_tmp20_ = _tmp24_;
#line 891 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4875 "umockdev.c"
			gboolean _tmp25_ = FALSE;
#line 891 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 891 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 891 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 891 "../src/umockdev.vala"
			_g_free0 (format);
#line 891 "../src/umockdev.vala"
			return _tmp25_;
#line 4887 "umockdev.c"
		}
#line 891 "../src/umockdev.vala"
		_tmp26_ = g_data_input_stream_new ((GInputStream*) _tmp20_);
#line 891 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 891 "../src/umockdev.vala"
		recording = _tmp26_;
#line 875 "../src/umockdev.vala"
		_g_object_unref0 (_tmp20_);
#line 4897 "umockdev.c"
	}
#line 896 "../src/umockdev.vala"
	_tmp27_ = recording;
#line 896 "../src/umockdev.vala"
	_tmp28_ = g_data_input_stream_read_line (_tmp27_, NULL, NULL, &_inner_error0_);
#line 896 "../src/umockdev.vala"
	line = _tmp28_;
#line 896 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4907 "umockdev.c"
		gboolean _tmp29_ = FALSE;
#line 896 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 896 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 896 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 896 "../src/umockdev.vala"
		_g_free0 (format);
#line 896 "../src/umockdev.vala"
		return _tmp29_;
#line 4919 "umockdev.c"
	}
#line 897 "../src/umockdev.vala"
	while (TRUE) {
#line 4923 "umockdev.c"
		gboolean _tmp30_ = FALSE;
		const gchar* _tmp31_;
		gchar* _tmp33_ = NULL;
		GDataInputStream* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp37_;
#line 897 "../src/umockdev.vala"
		_tmp31_ = line;
#line 897 "../src/umockdev.vala"
		if (_tmp31_ != NULL) {
#line 4934 "umockdev.c"
			const gchar* _tmp32_;
#line 897 "../src/umockdev.vala"
			_tmp32_ = line;
#line 897 "../src/umockdev.vala"
			_tmp30_ = g_str_has_prefix (_tmp32_, "#");
#line 4940 "umockdev.c"
		} else {
#line 897 "../src/umockdev.vala"
			_tmp30_ = FALSE;
#line 4944 "umockdev.c"
		}
#line 897 "../src/umockdev.vala"
		if (!_tmp30_) {
#line 897 "../src/umockdev.vala"
			break;
#line 4950 "umockdev.c"
		}
#line 898 "../src/umockdev.vala"
		_tmp34_ = recording;
#line 898 "../src/umockdev.vala"
		_tmp35_ = g_data_input_stream_read_line (_tmp34_, NULL, NULL, &_inner_error0_);
#line 898 "../src/umockdev.vala"
		_tmp33_ = _tmp35_;
#line 898 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4960 "umockdev.c"
			gboolean _tmp36_ = FALSE;
#line 898 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 898 "../src/umockdev.vala"
			_g_free0 (line);
#line 898 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 898 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 898 "../src/umockdev.vala"
			_g_free0 (format);
#line 898 "../src/umockdev.vala"
			return _tmp36_;
#line 4974 "umockdev.c"
		}
#line 898 "../src/umockdev.vala"
		_tmp37_ = _tmp33_;
#line 898 "../src/umockdev.vala"
		_tmp33_ = NULL;
#line 898 "../src/umockdev.vala"
		_g_free0 (line);
#line 898 "../src/umockdev.vala"
		line = _tmp37_;
#line 897 "../src/umockdev.vala"
		_g_free0 (_tmp33_);
#line 4986 "umockdev.c"
	}
#line 901 "../src/umockdev.vala"
	header_matcher = NULL;
#line 902 "../src/umockdev.vala"
	_tmp39_ = line;
#line 902 "../src/umockdev.vala"
	if (_tmp39_ != NULL) {
#line 4994 "umockdev.c"
		GRegex* _tmp40_ = NULL;
		GRegex* _tmp41_;
		const gchar* _tmp43_;
		GMatchInfo* _tmp44_ = NULL;
		gboolean _tmp45_;
#line 902 "../src/umockdev.vala"
		_tmp41_ = g_regex_new ("^@DEV (.*?)( \\((?P<format>[^)]*)\\))?(\n|$)", 0, 0, &_inner_error0_);
#line 902 "../src/umockdev.vala"
		_tmp40_ = _tmp41_;
#line 902 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5006 "umockdev.c"
			gboolean _tmp42_ = FALSE;
#line 902 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 902 "../src/umockdev.vala"
			_g_match_info_unref0 (header_matcher);
#line 902 "../src/umockdev.vala"
			_g_free0 (line);
#line 902 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 902 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 902 "../src/umockdev.vala"
			_g_free0 (format);
#line 902 "../src/umockdev.vala"
			return _tmp42_;
#line 5022 "umockdev.c"
		}
#line 902 "../src/umockdev.vala"
		_tmp43_ = line;
#line 902 "../src/umockdev.vala"
		_tmp45_ = g_regex_match (_tmp40_, _tmp43_, 0, &_tmp44_);
#line 902 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 902 "../src/umockdev.vala"
		header_matcher = _tmp44_;
#line 902 "../src/umockdev.vala"
		_tmp38_ = _tmp45_;
#line 902 "../src/umockdev.vala"
		_g_regex_unref0 (_tmp40_);
#line 5036 "umockdev.c"
	} else {
#line 902 "../src/umockdev.vala"
		_tmp38_ = FALSE;
#line 5040 "umockdev.c"
	}
#line 902 "../src/umockdev.vala"
	if (_tmp38_) {
#line 5044 "umockdev.c"
		const gchar* _tmp46_;
		GMatchInfo* _tmp49_;
		gchar* _tmp50_;
#line 903 "../src/umockdev.vala"
		_tmp46_ = owned_dev;
#line 903 "../src/umockdev.vala"
		if (_tmp46_ == NULL) {
#line 5052 "umockdev.c"
			GMatchInfo* _tmp47_;
			gchar* _tmp48_;
#line 904 "../src/umockdev.vala"
			_tmp47_ = header_matcher;
#line 904 "../src/umockdev.vala"
			_tmp48_ = g_match_info_fetch (_tmp47_, 1);
#line 904 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 904 "../src/umockdev.vala"
			owned_dev = _tmp48_;
#line 5063 "umockdev.c"
		}
#line 906 "../src/umockdev.vala"
		_tmp49_ = header_matcher;
#line 906 "../src/umockdev.vala"
		_tmp50_ = g_match_info_fetch_named (_tmp49_, "format");
#line 906 "../src/umockdev.vala"
		_g_free0 (format);
#line 906 "../src/umockdev.vala"
		format = _tmp50_;
#line 5073 "umockdev.c"
	} else {
		const gchar* _tmp51_;
#line 907 "../src/umockdev.vala"
		_tmp51_ = owned_dev;
#line 907 "../src/umockdev.vala"
		if (_tmp51_ == NULL) {
#line 908 "../src/umockdev.vala"
			g_error ("umockdev.vala:908: null passed for device node, but recording %s has n" \
"o @DEV header", recordfile);
#line 5082 "umockdev.c"
		}
	}
#line 911 "../src/umockdev.vala"
	_tmp52_ = recording;
#line 911 "../src/umockdev.vala"
	g_seekable_seek ((GSeekable*) _tmp52_, (gint64) 0, G_SEEK_SET, NULL, &_inner_error0_);
#line 911 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5091 "umockdev.c"
		gboolean _tmp53_ = FALSE;
#line 911 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 911 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 911 "../src/umockdev.vala"
		_g_free0 (line);
#line 911 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 911 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 911 "../src/umockdev.vala"
		_g_free0 (format);
#line 911 "../src/umockdev.vala"
		return _tmp53_;
#line 5107 "umockdev.c"
	}
#line 913 "../src/umockdev.vala"
	_tmp54_ = self->priv->root_dir;
#line 913 "../src/umockdev.vala"
	_tmp55_ = owned_dev;
#line 913 "../src/umockdev.vala"
	_tmp56_ = g_strconcat (_tmp55_, ".tree", NULL);
#line 913 "../src/umockdev.vala"
	_tmp57_ = _tmp56_;
#line 913 "../src/umockdev.vala"
	_tmp58_ = g_build_filename (_tmp54_, "ioctl", _tmp57_, NULL);
#line 913 "../src/umockdev.vala"
	_tmp59_ = _tmp58_;
#line 913 "../src/umockdev.vala"
	_g_free0 (_tmp57_);
#line 913 "../src/umockdev.vala"
	dest = _tmp59_;
#line 914 "../src/umockdev.vala"
	_tmp60_ = dest;
#line 914 "../src/umockdev.vala"
	_tmp61_ = g_path_get_dirname (_tmp60_);
#line 914 "../src/umockdev.vala"
	_tmp62_ = _tmp61_;
#line 914 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp62_, 0755);
#line 914 "../src/umockdev.vala"
	_g_free0 (_tmp62_);
#line 916 "../src/umockdev.vala"
	_tmp63_ = recording;
#line 916 "../src/umockdev.vala"
	_tmp64_ = g_data_input_stream_read_upto (_tmp63_, "", (gssize) 0, NULL, NULL, &_inner_error0_);
#line 916 "../src/umockdev.vala"
	contents = _tmp64_;
#line 916 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5143 "umockdev.c"
		gboolean _tmp65_ = FALSE;
#line 916 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 916 "../src/umockdev.vala"
		_g_free0 (dest);
#line 916 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 916 "../src/umockdev.vala"
		_g_free0 (line);
#line 916 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 916 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 916 "../src/umockdev.vala"
		_g_free0 (format);
#line 916 "../src/umockdev.vala"
		return _tmp65_;
#line 5161 "umockdev.c"
	}
#line 917 "../src/umockdev.vala"
	_tmp66_ = contents;
#line 917 "../src/umockdev.vala"
	if (_tmp66_ == NULL) {
#line 5167 "umockdev.c"
		gchar* _tmp67_;
#line 918 "../src/umockdev.vala"
		_tmp67_ = g_strdup ("");
#line 918 "../src/umockdev.vala"
		_g_free0 (contents);
#line 918 "../src/umockdev.vala"
		contents = _tmp67_;
#line 5175 "umockdev.c"
	}
#line 919 "../src/umockdev.vala"
	_tmp69_ = dest;
#line 919 "../src/umockdev.vala"
	_tmp70_ = contents;
#line 919 "../src/umockdev.vala"
	_tmp68_ = g_file_set_contents (_tmp69_, _tmp70_, (gssize) -1, &_inner_error0_);
#line 919 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5185 "umockdev.c"
		gboolean _tmp71_ = FALSE;
#line 919 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 919 "../src/umockdev.vala"
		_g_free0 (contents);
#line 919 "../src/umockdev.vala"
		_g_free0 (dest);
#line 919 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 919 "../src/umockdev.vala"
		_g_free0 (line);
#line 919 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 919 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 919 "../src/umockdev.vala"
		_g_free0 (format);
#line 919 "../src/umockdev.vala"
		return _tmp71_;
#line 5205 "umockdev.c"
	}
#line 919 "../src/umockdev.vala"
	if (!_tmp68_) {
#line 920 "../src/umockdev.vala"
		result = FALSE;
#line 920 "../src/umockdev.vala"
		_g_free0 (contents);
#line 920 "../src/umockdev.vala"
		_g_free0 (dest);
#line 920 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 920 "../src/umockdev.vala"
		_g_free0 (line);
#line 920 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 920 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 920 "../src/umockdev.vala"
		_g_free0 (format);
#line 920 "../src/umockdev.vala"
		return result;
#line 5227 "umockdev.c"
	}
#line 923 "../src/umockdev.vala"
	_tmp72_ = format;
#line 923 "../src/umockdev.vala"
	if (g_strcmp0 (_tmp72_, "SPI") == 0) {
#line 5233 "umockdev.c"
		const gchar* _tmp73_;
		UMockdevIoctlSpiHandler* _tmp74_;
#line 924 "../src/umockdev.vala"
		_tmp73_ = dest;
#line 924 "../src/umockdev.vala"
		_tmp74_ = umockdev_ioctl_spi_handler_new (_tmp73_);
#line 924 "../src/umockdev.vala"
		_g_object_unref0 (handler);
#line 924 "../src/umockdev.vala"
		handler = (UMockdevIoctlBase*) _tmp74_;
#line 5244 "umockdev.c"
	} else {
		const gchar* _tmp75_;
		UMockdevIoctlTreeHandler* _tmp76_;
#line 926 "../src/umockdev.vala"
		_tmp75_ = dest;
#line 926 "../src/umockdev.vala"
		_tmp76_ = umockdev_ioctl_tree_handler_new (_tmp75_);
#line 926 "../src/umockdev.vala"
		_g_object_unref0 (handler);
#line 926 "../src/umockdev.vala"
		handler = (UMockdevIoctlBase*) _tmp76_;
#line 5256 "umockdev.c"
	}
#line 928 "../src/umockdev.vala"
	_tmp77_ = self->priv->root_dir;
#line 928 "../src/umockdev.vala"
	_tmp78_ = owned_dev;
#line 928 "../src/umockdev.vala"
	_tmp79_ = g_build_filename (_tmp77_, "ioctl", _tmp78_, NULL);
#line 928 "../src/umockdev.vala"
	sockpath = _tmp79_;
#line 929 "../src/umockdev.vala"
	_tmp80_ = handler;
#line 929 "../src/umockdev.vala"
	_tmp81_ = self->priv->worker_ctx;
#line 929 "../src/umockdev.vala"
	_tmp82_ = owned_dev;
#line 929 "../src/umockdev.vala"
	_tmp83_ = sockpath;
#line 929 "../src/umockdev.vala"
	umockdev_ioctl_base_register_path (_tmp80_, _tmp81_, _tmp82_, _tmp83_);
#line 931 "../src/umockdev.vala"
	result = TRUE;
#line 931 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 931 "../src/umockdev.vala"
	_g_object_unref0 (handler);
#line 931 "../src/umockdev.vala"
	_g_free0 (contents);
#line 931 "../src/umockdev.vala"
	_g_free0 (dest);
#line 931 "../src/umockdev.vala"
	_g_match_info_unref0 (header_matcher);
#line 931 "../src/umockdev.vala"
	_g_free0 (line);
#line 931 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 931 "../src/umockdev.vala"
	_g_object_unref0 (recording);
#line 931 "../src/umockdev.vala"
	_g_free0 (format);
#line 931 "../src/umockdev.vala"
	return result;
#line 5298 "umockdev.c"
}

/**
     * umockdev_testbed_load_pcap:
     * @self: A #UMockdevTestbed.
     * @sysfs: sysfs path for device (/sys/...)
     * @recordfile: Path of the pcap or pcapng file.
     * @error: return location for a GError, or %NULL
     *
     * Load a USB pcap/pcapng recording created using e.g. wireshark.
     * The device must have been added previously as the device path in /dev
     * as well as the bus and device numbers need to be extraced from the udev
     * information.
     *
     * Returns: %TRUE on success, %FALSE if the recording could not be loaded
     * Since: 0.16
     */
gboolean
umockdev_testbed_load_pcap (UMockdevTestbed* self,
                            const gchar* sysfs,
                            const gchar* recordfile,
                            GError** error)
{
	gchar* owned_dev = NULL;
	gchar* sockpath = NULL;
	gint busnum = 0;
	gint devnum = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	UMockdevIoctlUsbPcapHandler* handler = NULL;
	UMockdevIoctlUsbPcapHandler* _tmp13_;
	GMainContext* _tmp14_;
	gboolean result;
#line 949 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 949 "../src/umockdev.vala"
	g_return_val_if_fail (sysfs != NULL, FALSE);
#line 949 "../src/umockdev.vala"
	g_return_val_if_fail (recordfile != NULL, FALSE);
#line 956 "../src/umockdev.vala"
	_tmp0_ = umockdev_testbed_get_attribute (self, sysfs, "busnum");
#line 956 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 956 "../src/umockdev.vala"
	busnum = atoi (_tmp1_);
#line 956 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 957 "../src/umockdev.vala"
	_tmp2_ = umockdev_testbed_get_attribute (self, sysfs, "devnum");
#line 957 "../src/umockdev.vala"
	_tmp3_ = _tmp2_;
#line 957 "../src/umockdev.vala"
	devnum = atoi (_tmp3_);
#line 957 "../src/umockdev.vala"
	_g_free0 (_tmp3_);
#line 959 "../src/umockdev.vala"
	_tmp4_ = g_strdup_printf ("%03d", busnum);
#line 959 "../src/umockdev.vala"
	_tmp5_ = _tmp4_;
#line 959 "../src/umockdev.vala"
	_tmp6_ = g_strdup_printf ("%03d", devnum);
#line 959 "../src/umockdev.vala"
	_tmp7_ = _tmp6_;
#line 959 "../src/umockdev.vala"
	_tmp8_ = g_build_filename ("/dev", "bus", "usb", _tmp5_, _tmp7_, NULL);
#line 959 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 959 "../src/umockdev.vala"
	owned_dev = _tmp8_;
#line 959 "../src/umockdev.vala"
	_g_free0 (_tmp7_);
#line 959 "../src/umockdev.vala"
	_g_free0 (_tmp5_);
#line 962 "../src/umockdev.vala"
	_tmp9_ = self->priv->root_dir;
#line 962 "../src/umockdev.vala"
	_tmp10_ = g_build_filename (_tmp9_, "ioctl", owned_dev, NULL);
#line 962 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 962 "../src/umockdev.vala"
	sockpath = _tmp10_;
#line 964 "../src/umockdev.vala"
	_tmp11_ = g_path_get_dirname (sockpath);
#line 964 "../src/umockdev.vala"
	_tmp12_ = _tmp11_;
#line 964 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp12_, 0755);
#line 964 "../src/umockdev.vala"
	_g_free0 (_tmp12_);
#line 966 "../src/umockdev.vala"
	_tmp13_ = umockdev_ioctl_usb_pcap_handler_new (recordfile, busnum, devnum);
#line 966 "../src/umockdev.vala"
	handler = _tmp13_;
#line 967 "../src/umockdev.vala"
	_tmp14_ = self->priv->worker_ctx;
#line 967 "../src/umockdev.vala"
	umockdev_ioctl_base_register_path ((UMockdevIoctlBase*) handler, _tmp14_, owned_dev, sockpath);
#line 969 "../src/umockdev.vala"
	result = TRUE;
#line 969 "../src/umockdev.vala"
	_g_object_unref0 (handler);
#line 969 "../src/umockdev.vala"
	_g_free0 (sockpath);
#line 969 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 969 "../src/umockdev.vala"
	return result;
#line 5417 "umockdev.c"
}

/**
     * umockdev_testbed_load_script:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) for which to load the script record.
     *       %NULL is valid; in this case the script is associated with
     *       the device node it was recorded from.
     * @recordfile: Path of the script record file.
     * @error: return location for a GError, or %NULL
     *
     * Load a script record file for a particular device into the testbed.
     * script records can be created with umockdev-record --script.
     *
     * Returns: %TRUE on success, %FALSE if @recordfile is invalid and an error
     *          occurred.
     */
gboolean
umockdev_testbed_load_script (UMockdevTestbed* self,
                              const gchar* dev,
                              const gchar* recordfile,
                              GError** error)
{
	gchar* owned_dev = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GHashTable* _tmp29_;
	const gchar* _tmp30_;
	gint fd = 0;
	const gchar* _tmp31_;
	UMockdevScriptRunner* _tmp38_ = NULL;
	const gchar* _tmp39_;
	UMockdevScriptRunner* _tmp40_;
	GHashTable* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	UMockdevScriptRunner* _tmp45_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 987 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 987 "../src/umockdev.vala"
	g_return_val_if_fail (recordfile != NULL, FALSE);
#line 990 "../src/umockdev.vala"
	_tmp0_ = g_strdup (dev);
#line 990 "../src/umockdev.vala"
	owned_dev = _tmp0_;
#line 991 "../src/umockdev.vala"
	_tmp1_ = owned_dev;
#line 991 "../src/umockdev.vala"
	if (_tmp1_ == NULL) {
#line 5469 "umockdev.c"
		GFileInputStream* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFileInputStream* _tmp5_;
		GFileInputStream* _tmp6_;
		GDataInputStream* recording = NULL;
		GDataInputStream* _tmp8_;
		gchar* line = NULL;
		GDataInputStream* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp20_;
		GMatchInfo* header_matcher = NULL;
		GRegex* _tmp21_ = NULL;
		GRegex* _tmp22_;
		const gchar* _tmp24_;
		GMatchInfo* _tmp25_ = NULL;
		gboolean _tmp26_;
		GMatchInfo* _tmp27_;
		gchar* _tmp28_;
#line 992 "../src/umockdev.vala"
		_tmp3_ = g_file_new_for_path (recordfile);
#line 992 "../src/umockdev.vala"
		_tmp4_ = _tmp3_;
#line 992 "../src/umockdev.vala"
		_tmp5_ = g_file_read (_tmp4_, NULL, &_inner_error0_);
#line 992 "../src/umockdev.vala"
		_tmp6_ = _tmp5_;
#line 992 "../src/umockdev.vala"
		_g_object_unref0 (_tmp4_);
#line 992 "../src/umockdev.vala"
		_tmp2_ = _tmp6_;
#line 992 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5503 "umockdev.c"
			gboolean _tmp7_ = FALSE;
#line 992 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 992 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 992 "../src/umockdev.vala"
			return _tmp7_;
#line 5511 "umockdev.c"
		}
#line 992 "../src/umockdev.vala"
		_tmp8_ = g_data_input_stream_new ((GInputStream*) _tmp2_);
#line 992 "../src/umockdev.vala"
		recording = _tmp8_;
#line 995 "../src/umockdev.vala"
		_tmp9_ = recording;
#line 995 "../src/umockdev.vala"
		_tmp10_ = g_data_input_stream_read_line (_tmp9_, NULL, NULL, &_inner_error0_);
#line 995 "../src/umockdev.vala"
		line = _tmp10_;
#line 995 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5525 "umockdev.c"
			gboolean _tmp11_ = FALSE;
#line 995 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 995 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 995 "../src/umockdev.vala"
			_g_object_unref0 (_tmp2_);
#line 995 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 995 "../src/umockdev.vala"
			return _tmp11_;
#line 5537 "umockdev.c"
		}
#line 996 "../src/umockdev.vala"
		while (TRUE) {
#line 5541 "umockdev.c"
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
			gchar* _tmp15_ = NULL;
			GDataInputStream* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp19_;
#line 996 "../src/umockdev.vala"
			_tmp13_ = line;
#line 996 "../src/umockdev.vala"
			if (_tmp13_ != NULL) {
#line 5552 "umockdev.c"
				const gchar* _tmp14_;
#line 996 "../src/umockdev.vala"
				_tmp14_ = line;
#line 996 "../src/umockdev.vala"
				_tmp12_ = g_str_has_prefix (_tmp14_, "#");
#line 5558 "umockdev.c"
			} else {
#line 996 "../src/umockdev.vala"
				_tmp12_ = FALSE;
#line 5562 "umockdev.c"
			}
#line 996 "../src/umockdev.vala"
			if (!_tmp12_) {
#line 996 "../src/umockdev.vala"
				break;
#line 5568 "umockdev.c"
			}
#line 997 "../src/umockdev.vala"
			_tmp16_ = recording;
#line 997 "../src/umockdev.vala"
			_tmp17_ = g_data_input_stream_read_line (_tmp16_, NULL, NULL, &_inner_error0_);
#line 997 "../src/umockdev.vala"
			_tmp15_ = _tmp17_;
#line 997 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5578 "umockdev.c"
				gboolean _tmp18_ = FALSE;
#line 997 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 997 "../src/umockdev.vala"
				_g_free0 (line);
#line 997 "../src/umockdev.vala"
				_g_object_unref0 (recording);
#line 997 "../src/umockdev.vala"
				_g_object_unref0 (_tmp2_);
#line 997 "../src/umockdev.vala"
				_g_free0 (owned_dev);
#line 997 "../src/umockdev.vala"
				return _tmp18_;
#line 5592 "umockdev.c"
			}
#line 997 "../src/umockdev.vala"
			_tmp19_ = _tmp15_;
#line 997 "../src/umockdev.vala"
			_tmp15_ = NULL;
#line 997 "../src/umockdev.vala"
			_g_free0 (line);
#line 997 "../src/umockdev.vala"
			line = _tmp19_;
#line 996 "../src/umockdev.vala"
			_g_free0 (_tmp15_);
#line 5604 "umockdev.c"
		}
#line 1000 "../src/umockdev.vala"
		_tmp20_ = line;
#line 1000 "../src/umockdev.vala"
		if (_tmp20_ == NULL) {
#line 1001 "../src/umockdev.vala"
			g_error ("umockdev.vala:1001: script recording %s has no non-comment content", recordfile);
#line 5612 "umockdev.c"
		}
#line 1004 "../src/umockdev.vala"
		_tmp22_ = g_regex_new ("^d 0 (.*)(\n|$)", 0, 0, &_inner_error0_);
#line 1004 "../src/umockdev.vala"
		_tmp21_ = _tmp22_;
#line 1004 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5620 "umockdev.c"
			gboolean _tmp23_ = FALSE;
#line 1004 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1004 "../src/umockdev.vala"
			_g_match_info_unref0 (header_matcher);
#line 1004 "../src/umockdev.vala"
			_g_free0 (line);
#line 1004 "../src/umockdev.vala"
			_g_object_unref0 (recording);
#line 1004 "../src/umockdev.vala"
			_g_object_unref0 (_tmp2_);
#line 1004 "../src/umockdev.vala"
			_g_free0 (owned_dev);
#line 1004 "../src/umockdev.vala"
			return _tmp23_;
#line 5636 "umockdev.c"
		}
#line 1004 "../src/umockdev.vala"
		_tmp24_ = line;
#line 1004 "../src/umockdev.vala"
		_tmp26_ = g_regex_match (_tmp21_, _tmp24_, 0, &_tmp25_);
#line 1004 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 1004 "../src/umockdev.vala"
		header_matcher = _tmp25_;
#line 1004 "../src/umockdev.vala"
		if (!_tmp26_) {
#line 1005 "../src/umockdev.vala"
			g_error ("umockdev.vala:1005: null passed for device node, but recording %s has " \
"no d 0 header", recordfile);
#line 5650 "umockdev.c"
		}
#line 1006 "../src/umockdev.vala"
		_tmp27_ = header_matcher;
#line 1006 "../src/umockdev.vala"
		_tmp28_ = g_match_info_fetch (_tmp27_, 1);
#line 1006 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1006 "../src/umockdev.vala"
		owned_dev = _tmp28_;
#line 991 "../src/umockdev.vala"
		_g_regex_unref0 (_tmp21_);
#line 991 "../src/umockdev.vala"
		_g_match_info_unref0 (header_matcher);
#line 991 "../src/umockdev.vala"
		_g_free0 (line);
#line 991 "../src/umockdev.vala"
		_g_object_unref0 (recording);
#line 991 "../src/umockdev.vala"
		_g_object_unref0 (_tmp2_);
#line 5670 "umockdev.c"
	}
#line 1009 "../src/umockdev.vala"
	_tmp29_ = self->priv->dev_script_runner;
#line 1009 "../src/umockdev.vala"
	_tmp30_ = owned_dev;
#line 1009 "../src/umockdev.vala"
	_vala_assert (!g_hash_table_contains (_tmp29_, _tmp30_), "!this.dev_script_runner.contains (owned_dev)");
#line 1011 "../src/umockdev.vala"
	_tmp31_ = owned_dev;
#line 1011 "../src/umockdev.vala"
	fd = umockdev_testbed_get_dev_fd (self, _tmp31_);
#line 1012 "../src/umockdev.vala"
	if (fd < 0) {
#line 5684 "umockdev.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		GError* _tmp35_;
		GError* _tmp36_;
		gboolean _tmp37_ = FALSE;
#line 1013 "../src/umockdev.vala"
		_tmp32_ = owned_dev;
#line 1013 "../src/umockdev.vala"
		_tmp33_ = g_strconcat (_tmp32_, " is not a device suitable for scripts", NULL);
#line 1013 "../src/umockdev.vala"
		_tmp34_ = _tmp33_;
#line 1013 "../src/umockdev.vala"
		_tmp35_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_INVAL, _tmp34_);
#line 1013 "../src/umockdev.vala"
		_tmp36_ = _tmp35_;
#line 1013 "../src/umockdev.vala"
		_g_free0 (_tmp34_);
#line 1013 "../src/umockdev.vala"
		_inner_error0_ = _tmp36_;
#line 1013 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1013 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1013 "../src/umockdev.vala"
		return _tmp37_;
#line 5711 "umockdev.c"
	}
#line 1015 "../src/umockdev.vala"
	_tmp39_ = owned_dev;
#line 1015 "../src/umockdev.vala"
	_tmp40_ = umockdev_script_runner_new (_tmp39_, recordfile, fd, &_inner_error0_);
#line 1015 "../src/umockdev.vala"
	_tmp38_ = _tmp40_;
#line 1015 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5721 "umockdev.c"
		gboolean _tmp41_ = FALSE;
#line 1015 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1015 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1015 "../src/umockdev.vala"
		return _tmp41_;
#line 5729 "umockdev.c"
	}
#line 1015 "../src/umockdev.vala"
	_tmp42_ = self->priv->dev_script_runner;
#line 1015 "../src/umockdev.vala"
	_tmp43_ = owned_dev;
#line 1015 "../src/umockdev.vala"
	_tmp44_ = g_strdup (_tmp43_);
#line 1015 "../src/umockdev.vala"
	_tmp45_ = _tmp38_;
#line 1015 "../src/umockdev.vala"
	_tmp38_ = NULL;
#line 1015 "../src/umockdev.vala"
	g_hash_table_insert (_tmp42_, _tmp44_, _tmp45_);
#line 1016 "../src/umockdev.vala"
	result = TRUE;
#line 1016 "../src/umockdev.vala"
	_umockdev_script_runner_unref0 (_tmp38_);
#line 1016 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 1016 "../src/umockdev.vala"
	return result;
#line 5751 "umockdev.c"
}

/**
     * umockdev_testbed_load_socket_script:
     * @self: A #UMockdevTestbed.
     * @path: Unix socket path
     * @type: Unix socket type (#SOCK_STREAM, #SOCK_DGRAM)
     * @recordfile: Path of the script record file.
     * @error: return location for a GError, or %NULL
     *
     * Add an Unix socket to the testbed that is backed by a recorded script.
     * Clients can connect to the socket using @path (i. e. without the testbed
     * prefix).
     *
     * Returns: %TRUE on success, %FALSE if the @path or @type are
     *          invalid and an error occurred.
     */
gboolean
umockdev_testbed_load_socket_script (UMockdevTestbed* self,
                                     const gchar* path,
                                     gint type,
                                     const gchar* recordfile,
                                     GError** error)
{
	gint fd = 0;
	gchar* real_path = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	UMockdevSocketServer* _tmp11_;
	UMockdevSocketServer* _tmp13_;
	const gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1034 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1034 "../src/umockdev.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1034 "../src/umockdev.vala"
	g_return_val_if_fail (recordfile != NULL, FALSE);
#line 1036 "../src/umockdev.vala"
	fd = socket (AF_UNIX, type, 0);
#line 1037 "../src/umockdev.vala"
	if (fd < 0) {
#line 5798 "umockdev.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
#line 1038 "../src/umockdev.vala"
		_tmp0_ = g_strdup_printf ("Cannot create socket type %i: %m", type);
#line 1038 "../src/umockdev.vala"
		_tmp1_ = _tmp0_;
#line 1038 "../src/umockdev.vala"
		_tmp2_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_INVAL, _tmp1_);
#line 1038 "../src/umockdev.vala"
		_tmp3_ = _tmp2_;
#line 1038 "../src/umockdev.vala"
		_g_free0 (_tmp1_);
#line 1038 "../src/umockdev.vala"
		_inner_error0_ = _tmp3_;
#line 1038 "../src/umockdev.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 5817 "umockdev.c"
			gboolean _tmp4_ = FALSE;
#line 1038 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1038 "../src/umockdev.vala"
			return _tmp4_;
#line 5823 "umockdev.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 1038 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1038 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1038 "../src/umockdev.vala"
			return _tmp5_;
#line 5832 "umockdev.c"
		}
	}
#line 1040 "../src/umockdev.vala"
	_tmp6_ = self->priv->root_dir;
#line 1040 "../src/umockdev.vala"
	_tmp7_ = g_build_filename (_tmp6_, path, NULL);
#line 1040 "../src/umockdev.vala"
	real_path = _tmp7_;
#line 1041 "../src/umockdev.vala"
	_tmp8_ = real_path;
#line 1041 "../src/umockdev.vala"
	_tmp9_ = g_path_get_dirname (_tmp8_);
#line 1041 "../src/umockdev.vala"
	_tmp10_ = _tmp9_;
#line 1041 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp10_, 0755);
#line 1041 "../src/umockdev.vala"
	_g_free0 (_tmp10_);
#line 1044 "../src/umockdev.vala"
	_tmp11_ = self->priv->socket_server;
#line 1044 "../src/umockdev.vala"
	if (_tmp11_ == NULL) {
#line 5855 "umockdev.c"
		UMockdevSocketServer* _tmp12_;
#line 1045 "../src/umockdev.vala"
		_tmp12_ = umockdev_socket_server_new ();
#line 1045 "../src/umockdev.vala"
		_umockdev_socket_server_unref0 (self->priv->socket_server);
#line 1045 "../src/umockdev.vala"
		self->priv->socket_server = _tmp12_;
#line 5863 "umockdev.c"
	}
#line 1047 "../src/umockdev.vala"
	_tmp13_ = self->priv->socket_server;
#line 1047 "../src/umockdev.vala"
	_tmp14_ = real_path;
#line 1047 "../src/umockdev.vala"
	umockdev_socket_server_add (_tmp13_, _tmp14_, fd, recordfile);
#line 1048 "../src/umockdev.vala"
	result = TRUE;
#line 1048 "../src/umockdev.vala"
	_g_free0 (real_path);
#line 1048 "../src/umockdev.vala"
	return result;
#line 5877 "umockdev.c"
}

/**
     * umockdev_testbed_load_evemu_events:
     * @self: A #UMockdevTestbed.
     * @dev: Device path (/dev/...) for which to load the evemu events.
     *       %NULL is valid; in this case the events are associated with
     *       the device node it was recorded from.
     * @eventsfile: Path of the evemu events file.
     * @error: return location for a GError, or %NULL
     *
     * Load an evemu event file for a particular device into the testbed. These
     * have a very simple line-based format with 4 fields that represent the
     * data in a struct input_event:
     *
     *  E: sec.usec evtype(hex) evcode(hex) evvalue
     *
     * The timestamps in those are absolute, and are usually as they were at
     * record time. When loading them into umockdev they are interpreted
     * relatively: the first event happens immediately, and the time to the
     * next event is the difference between the corresponding timestamps in the
     * .event file.
     *
     * Returns: %TRUE on success, %FALSE if @eventsfile is invalid and an error
     *          occurred.
     */
static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result;
#line 839 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 840 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, _base);
#line 840 "glib-2.0.vapi"
	return result;
#line 5915 "umockdev.c"
}

static gulong
ulong_parse (const gchar* str,
             guint _base)
{
	gulong result;
#line 366 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0UL);
#line 367 "glib-2.0.vapi"
	result = strtoul (str, NULL, (gint) _base);
#line 367 "glib-2.0.vapi"
	return result;
#line 5929 "umockdev.c"
}

gboolean
umockdev_testbed_load_evemu_events (UMockdevTestbed* self,
                                    const gchar* dev,
                                    const gchar* eventsfile,
                                    GError** error)
{
	GFile* f_ev = NULL;
	GFile* _tmp0_;
	GFileInputStream* _tmp1_ = NULL;
	GFile* _tmp2_;
	GFileInputStream* _tmp3_;
	GDataInputStream* s_ev = NULL;
	GDataInputStream* _tmp5_;
	gchar* line = NULL;
	gchar* recorded_dev = NULL;
	gsize len = 0UL;
	GMatchInfo* match = NULL;
	struct input_event ev = {0};
	struct input_event _tmp6_ = {0};
	GRegex* default_dev_re = NULL;
	GRegex* _tmp7_;
	GRegex* event_re = NULL;
	GRegex* _tmp9_;
	gchar* script_file = NULL;
	gint script_fd = 0;
	gchar* _tmp11_ = NULL;
	gint _tmp12_;
	gint delay = 0;
	gboolean first = FALSE;
	gchar* owned_dev = NULL;
	gchar* _tmp75_;
	const gchar* _tmp76_;
	gboolean ret = FALSE;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp83_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1075 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1075 "../src/umockdev.vala"
	g_return_val_if_fail (eventsfile != NULL, FALSE);
#line 1078 "../src/umockdev.vala"
	_tmp0_ = g_file_new_for_path (eventsfile);
#line 1078 "../src/umockdev.vala"
	f_ev = _tmp0_;
#line 1079 "../src/umockdev.vala"
	_tmp2_ = f_ev;
#line 1079 "../src/umockdev.vala"
	_tmp3_ = g_file_read (_tmp2_, NULL, &_inner_error0_);
#line 1079 "../src/umockdev.vala"
	_tmp1_ = _tmp3_;
#line 1079 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5986 "umockdev.c"
		gboolean _tmp4_ = FALSE;
#line 1079 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1079 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1079 "../src/umockdev.vala"
		return _tmp4_;
#line 5994 "umockdev.c"
	}
#line 1079 "../src/umockdev.vala"
	_tmp5_ = g_data_input_stream_new ((GInputStream*) _tmp1_);
#line 1079 "../src/umockdev.vala"
	s_ev = _tmp5_;
#line 1081 "../src/umockdev.vala"
	recorded_dev = NULL;
#line 1084 "../src/umockdev.vala"
	ev = _tmp6_;
#line 1085 "../src/umockdev.vala"
	_tmp7_ = g_regex_new ("^# device (.*)$", 0, 0, &_inner_error0_);
#line 1085 "../src/umockdev.vala"
	default_dev_re = _tmp7_;
#line 1085 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6010 "umockdev.c"
		gboolean _tmp8_ = FALSE;
#line 1085 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1085 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1085 "../src/umockdev.vala"
		_g_free0 (recorded_dev);
#line 1085 "../src/umockdev.vala"
		_g_free0 (line);
#line 1085 "../src/umockdev.vala"
		_g_object_unref0 (s_ev);
#line 1085 "../src/umockdev.vala"
		_g_object_unref0 (_tmp1_);
#line 1085 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1085 "../src/umockdev.vala"
		return _tmp8_;
#line 6028 "umockdev.c"
	}
#line 1086 "../src/umockdev.vala"
	_tmp9_ = g_regex_new ("^E: ([0-9]+)\\.([0-9]+) +([0-9a-fA-F]+) +([0-9a-fA-F]+) +(-?[0-9]+) *#" \
"?", 0, 0, &_inner_error0_);
#line 1086 "../src/umockdev.vala"
	event_re = _tmp9_;
#line 1086 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6036 "umockdev.c"
		gboolean _tmp10_ = FALSE;
#line 1086 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1086 "../src/umockdev.vala"
		_g_regex_unref0 (default_dev_re);
#line 1086 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1086 "../src/umockdev.vala"
		_g_free0 (recorded_dev);
#line 1086 "../src/umockdev.vala"
		_g_free0 (line);
#line 1086 "../src/umockdev.vala"
		_g_object_unref0 (s_ev);
#line 1086 "../src/umockdev.vala"
		_g_object_unref0 (_tmp1_);
#line 1086 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1086 "../src/umockdev.vala"
		return _tmp10_;
#line 6056 "umockdev.c"
	}
#line 1089 "../src/umockdev.vala"
	_tmp12_ = g_file_open_tmp ("evemu.XXXXXX.script", &_tmp11_, &_inner_error0_);
#line 1089 "../src/umockdev.vala"
	_g_free0 (script_file);
#line 1089 "../src/umockdev.vala"
	script_file = _tmp11_;
#line 1089 "../src/umockdev.vala"
	script_fd = _tmp12_;
#line 1089 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6068 "umockdev.c"
		gboolean _tmp13_ = FALSE;
#line 1089 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1089 "../src/umockdev.vala"
		_g_free0 (script_file);
#line 1089 "../src/umockdev.vala"
		_g_regex_unref0 (event_re);
#line 1089 "../src/umockdev.vala"
		_g_regex_unref0 (default_dev_re);
#line 1089 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1089 "../src/umockdev.vala"
		_g_free0 (recorded_dev);
#line 1089 "../src/umockdev.vala"
		_g_free0 (line);
#line 1089 "../src/umockdev.vala"
		_g_object_unref0 (s_ev);
#line 1089 "../src/umockdev.vala"
		_g_object_unref0 (_tmp1_);
#line 1089 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1089 "../src/umockdev.vala"
		return _tmp13_;
#line 6092 "umockdev.c"
	}
#line 1090 "../src/umockdev.vala"
	delay = 0;
#line 1091 "../src/umockdev.vala"
	first = TRUE;
#line 1093 "../src/umockdev.vala"
	while (TRUE) {
#line 6100 "umockdev.c"
		gchar* _tmp14_ = NULL;
		GDataInputStream* _tmp15_;
		gsize _tmp16_ = 0UL;
		gchar* _tmp17_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		GRegex* _tmp21_;
		const gchar* _tmp22_;
		GMatchInfo* _tmp23_ = NULL;
		gboolean _tmp24_;
		GRegex* _tmp27_;
		const gchar* _tmp28_;
		GMatchInfo* _tmp29_ = NULL;
		gboolean _tmp30_;
		time_t ev_sec = 0;
		GMatchInfo* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		time_t _tmp36_;
		time_t ev_usec = 0;
		GMatchInfo* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		time_t _tmp40_;
		GMatchInfo* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GMatchInfo* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		GMatchInfo* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		guint8* ev_data = NULL;
		guint8* _tmp52_;
		gint ev_data_length1;
		gint _ev_data_size_;
		guint8* _tmp53_;
		gint _tmp53__length1;
		guint8* _tmp54_;
		gint _tmp54__length1;
		gchar* script_line = NULL;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		guint8* _tmp61_;
		gint _tmp61__length1;
		gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
		const gchar* _tmp72_;
		gint _tmp73_;
		gint _tmp74_;
#line 1093 "../src/umockdev.vala"
		_tmp15_ = s_ev;
#line 1093 "../src/umockdev.vala"
		_tmp17_ = g_data_input_stream_read_line (_tmp15_, &_tmp16_, NULL, &_inner_error0_);
#line 1093 "../src/umockdev.vala"
		len = _tmp16_;
#line 1093 "../src/umockdev.vala"
		_tmp14_ = _tmp17_;
#line 1093 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6174 "umockdev.c"
			gboolean _tmp18_ = FALSE;
#line 1093 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1093 "../src/umockdev.vala"
			_g_free0 (script_file);
#line 1093 "../src/umockdev.vala"
			_g_regex_unref0 (event_re);
#line 1093 "../src/umockdev.vala"
			_g_regex_unref0 (default_dev_re);
#line 1093 "../src/umockdev.vala"
			_g_match_info_unref0 (match);
#line 1093 "../src/umockdev.vala"
			_g_free0 (recorded_dev);
#line 1093 "../src/umockdev.vala"
			_g_free0 (line);
#line 1093 "../src/umockdev.vala"
			_g_object_unref0 (s_ev);
#line 1093 "../src/umockdev.vala"
			_g_object_unref0 (_tmp1_);
#line 1093 "../src/umockdev.vala"
			_g_object_unref0 (f_ev);
#line 1093 "../src/umockdev.vala"
			return _tmp18_;
#line 6198 "umockdev.c"
		}
#line 1093 "../src/umockdev.vala"
		_tmp19_ = _tmp14_;
#line 1093 "../src/umockdev.vala"
		_tmp14_ = NULL;
#line 1093 "../src/umockdev.vala"
		_g_free0 (line);
#line 1093 "../src/umockdev.vala"
		line = _tmp19_;
#line 1093 "../src/umockdev.vala"
		_tmp20_ = line;
#line 1093 "../src/umockdev.vala"
		if (!(_tmp20_ != NULL)) {
#line 1093 "../src/umockdev.vala"
			_g_free0 (_tmp14_);
#line 1093 "../src/umockdev.vala"
			break;
#line 6216 "umockdev.c"
		}
#line 1094 "../src/umockdev.vala"
		_tmp21_ = default_dev_re;
#line 1094 "../src/umockdev.vala"
		_tmp22_ = line;
#line 1094 "../src/umockdev.vala"
		_tmp24_ = g_regex_match (_tmp21_, _tmp22_, 0, &_tmp23_);
#line 1094 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1094 "../src/umockdev.vala"
		match = _tmp23_;
#line 1094 "../src/umockdev.vala"
		if (_tmp24_) {
#line 6230 "umockdev.c"
			GMatchInfo* _tmp25_;
			gchar* _tmp26_;
#line 1095 "../src/umockdev.vala"
			_tmp25_ = match;
#line 1095 "../src/umockdev.vala"
			_tmp26_ = g_match_info_fetch (_tmp25_, 1);
#line 1095 "../src/umockdev.vala"
			_g_free0 (recorded_dev);
#line 1095 "../src/umockdev.vala"
			recorded_dev = _tmp26_;
#line 1096 "../src/umockdev.vala"
			_g_free0 (_tmp14_);
#line 1096 "../src/umockdev.vala"
			continue;
#line 6245 "umockdev.c"
		}
#line 1099 "../src/umockdev.vala"
		_tmp27_ = event_re;
#line 1099 "../src/umockdev.vala"
		_tmp28_ = line;
#line 1099 "../src/umockdev.vala"
		_tmp30_ = g_regex_match (_tmp27_, _tmp28_, 0, &_tmp29_);
#line 1099 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1099 "../src/umockdev.vala"
		match = _tmp29_;
#line 1099 "../src/umockdev.vala"
		if (!_tmp30_) {
#line 6259 "umockdev.c"
			const gchar* _tmp31_;
#line 1100 "../src/umockdev.vala"
			_tmp31_ = line;
#line 1100 "../src/umockdev.vala"
			if (!g_str_has_prefix (_tmp31_, "#")) {
#line 6265 "umockdev.c"
				const gchar* _tmp32_;
#line 1101 "../src/umockdev.vala"
				_tmp32_ = line;
#line 1101 "../src/umockdev.vala"
				g_warning ("umockdev.vala:1101: Ignoring invalid line in %s: %s", eventsfile, _tmp32_);
#line 6271 "umockdev.c"
			}
#line 1102 "../src/umockdev.vala"
			_g_free0 (_tmp14_);
#line 1102 "../src/umockdev.vala"
			continue;
#line 6277 "umockdev.c"
		}
#line 1104 "../src/umockdev.vala"
		_tmp33_ = match;
#line 1104 "../src/umockdev.vala"
		_tmp34_ = g_match_info_fetch (_tmp33_, 1);
#line 1104 "../src/umockdev.vala"
		_tmp35_ = _tmp34_;
#line 1104 "../src/umockdev.vala"
		_tmp36_ = (time_t) uint64_parse (_tmp35_, (guint) 0);
#line 1104 "../src/umockdev.vala"
		_g_free0 (_tmp35_);
#line 1104 "../src/umockdev.vala"
		ev_sec = _tmp36_;
#line 1105 "../src/umockdev.vala"
		_tmp37_ = match;
#line 1105 "../src/umockdev.vala"
		_tmp38_ = g_match_info_fetch (_tmp37_, 2);
#line 1105 "../src/umockdev.vala"
		_tmp39_ = _tmp38_;
#line 1105 "../src/umockdev.vala"
		_tmp40_ = (time_t) uint64_parse (_tmp39_, (guint) 0);
#line 1105 "../src/umockdev.vala"
		_g_free0 (_tmp39_);
#line 1105 "../src/umockdev.vala"
		ev_usec = _tmp40_;
#line 1106 "../src/umockdev.vala"
		if (first) {
#line 1107 "../src/umockdev.vala"
			delay = 0;
#line 1108 "../src/umockdev.vala"
			first = FALSE;
#line 6309 "umockdev.c"
		} else {
			struct input_event _tmp41_;
			struct input_event _tmp42_;
#line 1110 "../src/umockdev.vala"
			_tmp41_ = ev;
#line 1110 "../src/umockdev.vala"
			_tmp42_ = ev;
#line 1110 "../src/umockdev.vala"
			delay = (((gint) (ev_sec - _tmp41_.input_event_sec)) * 1000) + (((gint) (ev_usec - _tmp42_.input_event_usec)) / 1000);
#line 1111 "../src/umockdev.vala"
			if (delay < 0) {
#line 1112 "../src/umockdev.vala"
				delay = 0;
#line 6323 "umockdev.c"
			}
		}
#line 1114 "../src/umockdev.vala"
		ev.input_event_sec = ev_sec;
#line 1115 "../src/umockdev.vala"
		ev.input_event_usec = (glong) ev_usec;
#line 1116 "../src/umockdev.vala"
		_tmp43_ = match;
#line 1116 "../src/umockdev.vala"
		_tmp44_ = g_match_info_fetch (_tmp43_, 3);
#line 1116 "../src/umockdev.vala"
		_tmp45_ = _tmp44_;
#line 1116 "../src/umockdev.vala"
		ev.type = (guint16) ulong_parse (_tmp45_, (guint) 16);
#line 1116 "../src/umockdev.vala"
		_g_free0 (_tmp45_);
#line 1117 "../src/umockdev.vala"
		_tmp46_ = match;
#line 1117 "../src/umockdev.vala"
		_tmp47_ = g_match_info_fetch (_tmp46_, 4);
#line 1117 "../src/umockdev.vala"
		_tmp48_ = _tmp47_;
#line 1117 "../src/umockdev.vala"
		ev.code = (guint16) ulong_parse (_tmp48_, (guint) 16);
#line 1117 "../src/umockdev.vala"
		_g_free0 (_tmp48_);
#line 1118 "../src/umockdev.vala"
		_tmp49_ = match;
#line 1118 "../src/umockdev.vala"
		_tmp50_ = g_match_info_fetch (_tmp49_, 5);
#line 1118 "../src/umockdev.vala"
		_tmp51_ = _tmp50_;
#line 1118 "../src/umockdev.vala"
		ev.value = (gint32) atoi (_tmp51_);
#line 1118 "../src/umockdev.vala"
		_g_free0 (_tmp51_);
#line 1120 "../src/umockdev.vala"
		_tmp52_ = g_new0 (guint8, sizeof (struct input_event));
#line 1120 "../src/umockdev.vala"
		ev_data = _tmp52_;
#line 1120 "../src/umockdev.vala"
		ev_data_length1 = sizeof (struct input_event);
#line 1120 "../src/umockdev.vala"
		_ev_data_size_ = ev_data_length1;
#line 1121 "../src/umockdev.vala"
		_tmp53_ = ev_data;
#line 1121 "../src/umockdev.vala"
		_tmp53__length1 = ev_data_length1;
#line 1121 "../src/umockdev.vala"
		_tmp54_ = ev_data;
#line 1121 "../src/umockdev.vala"
		_tmp54__length1 = ev_data_length1;
#line 1121 "../src/umockdev.vala"
		memcpy (_tmp53_, &ev, (gsize) _tmp54__length1);
#line 1122 "../src/umockdev.vala"
		_tmp55_ = g_strdup_printf ("%i", delay);
#line 1122 "../src/umockdev.vala"
		_tmp56_ = _tmp55_;
#line 1122 "../src/umockdev.vala"
		_tmp57_ = g_strconcat ("r ", _tmp56_, NULL);
#line 1122 "../src/umockdev.vala"
		_tmp58_ = _tmp57_;
#line 1122 "../src/umockdev.vala"
		_tmp59_ = g_strconcat (_tmp58_, " ", NULL);
#line 1122 "../src/umockdev.vala"
		_tmp60_ = _tmp59_;
#line 1122 "../src/umockdev.vala"
		_tmp61_ = ev_data;
#line 1122 "../src/umockdev.vala"
		_tmp61__length1 = ev_data_length1;
#line 1122 "../src/umockdev.vala"
		_tmp62_ = umockdev_script_runner_encode (_tmp61_, (gint) _tmp61__length1);
#line 1122 "../src/umockdev.vala"
		_tmp63_ = _tmp62_;
#line 1122 "../src/umockdev.vala"
		_tmp64_ = g_strconcat (_tmp60_, _tmp63_, NULL);
#line 1122 "../src/umockdev.vala"
		_tmp65_ = _tmp64_;
#line 1122 "../src/umockdev.vala"
		_tmp66_ = g_strconcat (_tmp65_, "\n", NULL);
#line 1122 "../src/umockdev.vala"
		_tmp67_ = _tmp66_;
#line 1122 "../src/umockdev.vala"
		_g_free0 (_tmp65_);
#line 1122 "../src/umockdev.vala"
		_g_free0 (_tmp63_);
#line 1122 "../src/umockdev.vala"
		_g_free0 (_tmp60_);
#line 1122 "../src/umockdev.vala"
		_g_free0 (_tmp58_);
#line 1122 "../src/umockdev.vala"
		_g_free0 (_tmp56_);
#line 1122 "../src/umockdev.vala"
		script_line = _tmp67_;
#line 1123 "../src/umockdev.vala"
		_tmp68_ = script_line;
#line 1123 "../src/umockdev.vala"
		_tmp69_ = script_line;
#line 1123 "../src/umockdev.vala"
		_tmp70_ = strlen (_tmp69_);
#line 1123 "../src/umockdev.vala"
		_tmp71_ = _tmp70_;
#line 1123 "../src/umockdev.vala"
		_tmp72_ = script_line;
#line 1123 "../src/umockdev.vala"
		_tmp73_ = strlen (_tmp72_);
#line 1123 "../src/umockdev.vala"
		_tmp74_ = _tmp73_;
#line 1123 "../src/umockdev.vala"
		_vala_assert (write (script_fd, _tmp68_, (gsize) _tmp71_) == ((gssize) _tmp74_), "Posix.write(script_fd, script_line, script_line.length) == script_line.length");
#line 1093 "../src/umockdev.vala"
		_g_free0 (script_line);
#line 1093 "../src/umockdev.vala"
		ev_data = (g_free (ev_data), NULL);
#line 1093 "../src/umockdev.vala"
		_g_free0 (_tmp14_);
#line 6440 "umockdev.c"
	}
#line 1126 "../src/umockdev.vala"
	close (script_fd);
#line 1128 "../src/umockdev.vala"
	_tmp75_ = g_strdup (dev);
#line 1128 "../src/umockdev.vala"
	owned_dev = _tmp75_;
#line 1129 "../src/umockdev.vala"
	_tmp76_ = owned_dev;
#line 1129 "../src/umockdev.vala"
	if (_tmp76_ == NULL) {
#line 6452 "umockdev.c"
		const gchar* _tmp77_;
		const gchar* _tmp78_;
		gchar* _tmp79_;
#line 1130 "../src/umockdev.vala"
		_tmp77_ = recorded_dev;
#line 1130 "../src/umockdev.vala"
		if (_tmp77_ == NULL) {
#line 1131 "../src/umockdev.vala"
			g_error ("umockdev.vala:1131: null passed for device node, but recording %s has " \
"no '# device' header", eventsfile);
#line 6462 "umockdev.c"
		}
#line 1132 "../src/umockdev.vala"
		_tmp78_ = recorded_dev;
#line 1132 "../src/umockdev.vala"
		_tmp79_ = g_strdup (_tmp78_);
#line 1132 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1132 "../src/umockdev.vala"
		owned_dev = _tmp79_;
#line 6472 "umockdev.c"
	}
#line 1135 "../src/umockdev.vala"
	_tmp80_ = owned_dev;
#line 1135 "../src/umockdev.vala"
	_tmp81_ = script_file;
#line 1135 "../src/umockdev.vala"
	ret = umockdev_testbed_load_script (self, _tmp80_, _tmp81_, &_inner_error0_);
#line 1135 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6482 "umockdev.c"
		gboolean _tmp82_ = FALSE;
#line 1135 "../src/umockdev.vala"
		g_propagate_error (error, _inner_error0_);
#line 1135 "../src/umockdev.vala"
		_g_free0 (owned_dev);
#line 1135 "../src/umockdev.vala"
		_g_free0 (script_file);
#line 1135 "../src/umockdev.vala"
		_g_regex_unref0 (event_re);
#line 1135 "../src/umockdev.vala"
		_g_regex_unref0 (default_dev_re);
#line 1135 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1135 "../src/umockdev.vala"
		_g_free0 (recorded_dev);
#line 1135 "../src/umockdev.vala"
		_g_free0 (line);
#line 1135 "../src/umockdev.vala"
		_g_object_unref0 (s_ev);
#line 1135 "../src/umockdev.vala"
		_g_object_unref0 (_tmp1_);
#line 1135 "../src/umockdev.vala"
		_g_object_unref0 (f_ev);
#line 1135 "../src/umockdev.vala"
		return _tmp82_;
#line 6508 "umockdev.c"
	}
#line 1136 "../src/umockdev.vala"
	_tmp83_ = script_file;
#line 1136 "../src/umockdev.vala"
	g_unlink (_tmp83_);
#line 1137 "../src/umockdev.vala"
	result = ret;
#line 1137 "../src/umockdev.vala"
	_g_free0 (owned_dev);
#line 1137 "../src/umockdev.vala"
	_g_free0 (script_file);
#line 1137 "../src/umockdev.vala"
	_g_regex_unref0 (event_re);
#line 1137 "../src/umockdev.vala"
	_g_regex_unref0 (default_dev_re);
#line 1137 "../src/umockdev.vala"
	_g_match_info_unref0 (match);
#line 1137 "../src/umockdev.vala"
	_g_free0 (recorded_dev);
#line 1137 "../src/umockdev.vala"
	_g_free0 (line);
#line 1137 "../src/umockdev.vala"
	_g_object_unref0 (s_ev);
#line 1137 "../src/umockdev.vala"
	_g_object_unref0 (_tmp1_);
#line 1137 "../src/umockdev.vala"
	_g_object_unref0 (f_ev);
#line 1137 "../src/umockdev.vala"
	return result;
#line 6538 "umockdev.c"
}

static GHashTable*
umockdev_testbed_create_bus_lookup (void)
{
	GHashTable* lookup = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	gchar* _tmp94_;
	gchar* _tmp95_;
	gchar* _tmp96_;
	gchar* _tmp97_;
	gchar* _tmp98_;
	gchar* _tmp99_;
	gchar* _tmp100_;
	gchar* _tmp101_;
	gchar* _tmp102_;
	gchar* _tmp103_;
	gchar* _tmp104_;
	gchar* _tmp105_;
	gchar* _tmp106_;
	gchar* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	gchar* _tmp110_;
	gchar* _tmp111_;
	gchar* _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	gchar* _tmp115_;
	gchar* _tmp116_;
	gchar* _tmp117_;
	gchar* _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	gchar* _tmp121_;
	gchar* _tmp122_;
	gchar* _tmp123_;
	gchar* _tmp124_;
	gchar* _tmp125_;
	gchar* _tmp126_;
	gchar* _tmp127_;
	gchar* _tmp128_;
	gchar* _tmp129_;
	gchar* _tmp130_;
	gchar* _tmp131_;
	gchar* _tmp132_;
	GHashTable* result;
#line 1143 "../src/umockdev.vala"
	_tmp0_ = g_str_hash;
#line 1143 "../src/umockdev.vala"
	_tmp1_ = g_str_equal;
#line 1143 "../src/umockdev.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 1143 "../src/umockdev.vala"
	lookup = _tmp2_;
#line 1146 "../src/umockdev.vala"
	_tmp3_ = g_strdup ("ac97");
#line 1146 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp3_, NULL);
#line 1147 "../src/umockdev.vala"
	_tmp4_ = g_strdup ("ac97bus");
#line 1147 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp4_, NULL);
#line 1148 "../src/umockdev.vala"
	_tmp5_ = g_strdup ("acpi");
#line 1148 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp5_, NULL);
#line 1149 "../src/umockdev.vala"
	_tmp6_ = g_strdup ("amba");
#line 1149 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp6_, NULL);
#line 1150 "../src/umockdev.vala"
	_tmp7_ = g_strdup ("anybuss");
#line 1150 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp7_, NULL);
#line 1151 "../src/umockdev.vala"
	_tmp8_ = g_strdup ("aoa-soundbus");
#line 1151 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp8_, NULL);
#line 1152 "../src/umockdev.vala"
	_tmp9_ = g_strdup ("ap");
#line 1152 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp9_, NULL);
#line 1153 "../src/umockdev.vala"
	_tmp10_ = g_strdup ("aprbus");
#line 1153 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp10_, NULL);
#line 1154 "../src/umockdev.vala"
	_tmp11_ = g_strdup ("bcma");
#line 1154 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp11_, NULL);
#line 1155 "../src/umockdev.vala"
	_tmp12_ = g_strdup ("bttv-sub");
#line 1155 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp12_, NULL);
#line 1156 "../src/umockdev.vala"
	_tmp13_ = g_strdup ("ccw");
#line 1156 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp13_, NULL);
#line 1157 "../src/umockdev.vala"
	_tmp14_ = g_strdup ("ccwgroup");
#line 1157 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp14_, NULL);
#line 1158 "../src/umockdev.vala"
	_tmp15_ = g_strdup ("cdmm");
#line 1158 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp15_, NULL);
#line 1159 "../src/umockdev.vala"
	_tmp16_ = g_strdup ("cec");
#line 1159 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp16_, NULL);
#line 1160 "../src/umockdev.vala"
	_tmp17_ = g_strdup ("coreboot");
#line 1160 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp17_, NULL);
#line 1161 "../src/umockdev.vala"
	_tmp18_ = g_strdup ("coresight");
#line 1161 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp18_, NULL);
#line 1162 "../src/umockdev.vala"
	_tmp19_ = g_strdup ("cosm_bus");
#line 1162 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp19_, NULL);
#line 1163 "../src/umockdev.vala"
	_tmp20_ = g_strdup ("counter");
#line 1163 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp20_, NULL);
#line 1164 "../src/umockdev.vala"
	_tmp21_ = g_strdup ("css");
#line 1164 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp21_, NULL);
#line 1165 "../src/umockdev.vala"
	_tmp22_ = g_strdup ("dax");
#line 1165 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp22_, NULL);
#line 1166 "../src/umockdev.vala"
	_tmp23_ = g_strdup ("dio");
#line 1166 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp23_, NULL);
#line 1167 "../src/umockdev.vala"
	_tmp24_ = g_strdup ("ecard");
#line 1167 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp24_, NULL);
#line 1168 "../src/umockdev.vala"
	_tmp25_ = g_strdup ("eisa");
#line 1168 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp25_, NULL);
#line 1169 "../src/umockdev.vala"
	_tmp26_ = g_strdup ("event_source");
#line 1169 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp26_, NULL);
#line 1170 "../src/umockdev.vala"
	_tmp27_ = g_strdup ("fcoe");
#line 1170 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp27_, NULL);
#line 1171 "../src/umockdev.vala"
	_tmp28_ = g_strdup ("firewire");
#line 1171 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp28_, NULL);
#line 1172 "../src/umockdev.vala"
	_tmp29_ = g_strdup ("fsi");
#line 1172 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp29_, NULL);
#line 1173 "../src/umockdev.vala"
	_tmp30_ = g_strdup ("fsl-mc");
#line 1173 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp30_, NULL);
#line 1174 "../src/umockdev.vala"
	_tmp31_ = g_strdup ("gameport");
#line 1174 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp31_, NULL);
#line 1175 "../src/umockdev.vala"
	_tmp32_ = g_strdup ("gbphy");
#line 1175 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp32_, NULL);
#line 1176 "../src/umockdev.vala"
	_tmp33_ = g_strdup ("genpd");
#line 1176 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp33_, NULL);
#line 1177 "../src/umockdev.vala"
	_tmp34_ = g_strdup ("gio");
#line 1177 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp34_, NULL);
#line 1178 "../src/umockdev.vala"
	_tmp35_ = g_strdup ("gpio");
#line 1178 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp35_, NULL);
#line 1179 "../src/umockdev.vala"
	_tmp36_ = g_strdup ("greybus");
#line 1179 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp36_, NULL);
#line 1180 "../src/umockdev.vala"
	_tmp37_ = g_strdup ("hdaudio");
#line 1180 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp37_, NULL);
#line 1181 "../src/umockdev.vala"
	_tmp38_ = g_strdup ("hid");
#line 1181 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp38_, NULL);
#line 1182 "../src/umockdev.vala"
	_tmp39_ = g_strdup ("host1x");
#line 1182 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp39_, NULL);
#line 1183 "../src/umockdev.vala"
	_tmp40_ = g_strdup ("hsi");
#line 1183 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp40_, NULL);
#line 1184 "../src/umockdev.vala"
	_tmp41_ = g_strdup ("i2c");
#line 1184 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp41_, NULL);
#line 1185 "../src/umockdev.vala"
	_tmp42_ = g_strdup ("i3c");
#line 1185 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp42_, NULL);
#line 1186 "../src/umockdev.vala"
	_tmp43_ = g_strdup ("ibmebus");
#line 1186 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp43_, NULL);
#line 1187 "../src/umockdev.vala"
	_tmp44_ = g_strdup ("ide");
#line 1187 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp44_, NULL);
#line 1188 "../src/umockdev.vala"
	_tmp45_ = g_strdup ("iio");
#line 1188 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp45_, NULL);
#line 1189 "../src/umockdev.vala"
	_tmp46_ = g_strdup ("iio");
#line 1189 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp46_, NULL);
#line 1190 "../src/umockdev.vala"
	_tmp47_ = g_strdup ("intel_th");
#line 1190 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp47_, NULL);
#line 1191 "../src/umockdev.vala"
	_tmp48_ = g_strdup ("ipack");
#line 1191 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp48_, NULL);
#line 1192 "../src/umockdev.vala"
	_tmp49_ = g_strdup ("isa");
#line 1192 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp49_, NULL);
#line 1193 "../src/umockdev.vala"
	_tmp50_ = g_strdup ("iscsi_flashnode");
#line 1193 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp50_, NULL);
#line 1194 "../src/umockdev.vala"
	_tmp51_ = g_strdup ("ishtp");
#line 1194 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp51_, NULL);
#line 1195 "../src/umockdev.vala"
	_tmp52_ = g_strdup ("iucv");
#line 1195 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp52_, NULL);
#line 1196 "../src/umockdev.vala"
	_tmp53_ = g_strdup ("locomo-bus");
#line 1196 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp53_, NULL);
#line 1197 "../src/umockdev.vala"
	_tmp54_ = g_strdup ("logicmodule");
#line 1197 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp54_, NULL);
#line 1198 "../src/umockdev.vala"
	_tmp55_ = g_strdup ("macio");
#line 1198 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp55_, NULL);
#line 1199 "../src/umockdev.vala"
	_tmp56_ = g_strdup ("maple");
#line 1199 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp56_, NULL);
#line 1200 "../src/umockdev.vala"
	_tmp57_ = g_strdup ("matrix");
#line 1200 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp57_, NULL);
#line 1201 "../src/umockdev.vala"
	_tmp58_ = g_strdup ("mcb");
#line 1201 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp58_, NULL);
#line 1202 "../src/umockdev.vala"
	_tmp59_ = g_strdup ("mcp");
#line 1202 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp59_, NULL);
#line 1203 "../src/umockdev.vala"
	_tmp60_ = g_strdup ("mdev");
#line 1203 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp60_, NULL);
#line 1204 "../src/umockdev.vala"
	_tmp61_ = g_strdup ("mdio_bus");
#line 1204 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp61_, NULL);
#line 1205 "../src/umockdev.vala"
	_tmp62_ = g_strdup ("media");
#line 1205 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp62_, NULL);
#line 1206 "../src/umockdev.vala"
	_tmp63_ = g_strdup ("mei");
#line 1206 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp63_, NULL);
#line 1207 "../src/umockdev.vala"
	_tmp64_ = g_strdup ("memstick");
#line 1207 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp64_, NULL);
#line 1208 "../src/umockdev.vala"
	_tmp65_ = g_strdup ("mic_bus");
#line 1208 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp65_, NULL);
#line 1209 "../src/umockdev.vala"
	_tmp66_ = g_strdup ("mipi-dsi");
#line 1209 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp66_, NULL);
#line 1210 "../src/umockdev.vala"
	_tmp67_ = g_strdup ("mmc_rpmb");
#line 1210 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp67_, NULL);
#line 1211 "../src/umockdev.vala"
	_tmp68_ = g_strdup ("mmc");
#line 1211 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp68_, NULL);
#line 1212 "../src/umockdev.vala"
	_tmp69_ = g_strdup ("most");
#line 1212 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp69_, NULL);
#line 1213 "../src/umockdev.vala"
	_tmp70_ = g_strdup ("nd");
#line 1213 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp70_, NULL);
#line 1214 "../src/umockdev.vala"
	_tmp71_ = g_strdup ("netdevsim");
#line 1214 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp71_, NULL);
#line 1215 "../src/umockdev.vala"
	_tmp72_ = g_strdup ("ntb_transport");
#line 1215 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp72_, NULL);
#line 1216 "../src/umockdev.vala"
	_tmp73_ = g_strdup ("ntb");
#line 1216 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp73_, NULL);
#line 1217 "../src/umockdev.vala"
	_tmp74_ = g_strdup ("nubus");
#line 1217 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp74_, NULL);
#line 1218 "../src/umockdev.vala"
	_tmp75_ = g_strdup ("nvmem");
#line 1218 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp75_, NULL);
#line 1219 "../src/umockdev.vala"
	_tmp76_ = g_strdup ("parisc");
#line 1219 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp76_, NULL);
#line 1220 "../src/umockdev.vala"
	_tmp77_ = g_strdup ("parport");
#line 1220 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp77_, NULL);
#line 1221 "../src/umockdev.vala"
	_tmp78_ = g_strdup ("pci-epf");
#line 1221 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp78_, NULL);
#line 1222 "../src/umockdev.vala"
	_tmp79_ = g_strdup ("pci");
#line 1222 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp79_, NULL);
#line 1223 "../src/umockdev.vala"
	_tmp80_ = g_strdup ("pcmcia");
#line 1223 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp80_, NULL);
#line 1224 "../src/umockdev.vala"
	_tmp81_ = g_strdup ("platform");
#line 1224 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp81_, NULL);
#line 1225 "../src/umockdev.vala"
	_tmp82_ = g_strdup ("pnp");
#line 1225 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp82_, NULL);
#line 1226 "../src/umockdev.vala"
	_tmp83_ = g_strdup ("ps3_system_bus");
#line 1226 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp83_, NULL);
#line 1227 "../src/umockdev.vala"
	_tmp84_ = g_strdup ("pseudo");
#line 1227 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp84_, NULL);
#line 1228 "../src/umockdev.vala"
	_tmp85_ = g_strdup ("rapidio");
#line 1228 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp85_, NULL);
#line 1229 "../src/umockdev.vala"
	_tmp86_ = g_strdup ("rbd");
#line 1229 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp86_, NULL);
#line 1230 "../src/umockdev.vala"
	_tmp87_ = g_strdup ("rmi4");
#line 1230 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp87_, NULL);
#line 1231 "../src/umockdev.vala"
	_tmp88_ = g_strdup ("rpmsg");
#line 1231 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp88_, NULL);
#line 1232 "../src/umockdev.vala"
	_tmp89_ = g_strdup ("sa1111-rab");
#line 1232 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp89_, NULL);
#line 1233 "../src/umockdev.vala"
	_tmp90_ = g_strdup ("scif_bus");
#line 1233 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp90_, NULL);
#line 1234 "../src/umockdev.vala"
	_tmp91_ = g_strdup ("scif_peer_bus");
#line 1234 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp91_, NULL);
#line 1235 "../src/umockdev.vala"
	_tmp92_ = g_strdup ("scm");
#line 1235 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp92_, NULL);
#line 1236 "../src/umockdev.vala"
	_tmp93_ = g_strdup ("scmi_protocol");
#line 1236 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp93_, NULL);
#line 1237 "../src/umockdev.vala"
	_tmp94_ = g_strdup ("scsi");
#line 1237 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp94_, NULL);
#line 1238 "../src/umockdev.vala"
	_tmp95_ = g_strdup ("sdio");
#line 1238 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp95_, NULL);
#line 1239 "../src/umockdev.vala"
	_tmp96_ = g_strdup ("serial");
#line 1239 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp96_, NULL);
#line 1240 "../src/umockdev.vala"
	_tmp97_ = g_strdup ("serio");
#line 1240 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp97_, NULL);
#line 1241 "../src/umockdev.vala"
	_tmp98_ = g_strdup ("siox");
#line 1241 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp98_, NULL);
#line 1242 "../src/umockdev.vala"
	_tmp99_ = g_strdup ("slimbus");
#line 1242 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp99_, NULL);
#line 1243 "../src/umockdev.vala"
	_tmp100_ = g_strdup ("snd_seq");
#line 1243 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp100_, NULL);
#line 1244 "../src/umockdev.vala"
	_tmp101_ = g_strdup ("soc");
#line 1244 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp101_, NULL);
#line 1245 "../src/umockdev.vala"
	_tmp102_ = g_strdup ("soundwire");
#line 1245 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp102_, NULL);
#line 1246 "../src/umockdev.vala"
	_tmp103_ = g_strdup ("spi");
#line 1246 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp103_, NULL);
#line 1247 "../src/umockdev.vala"
	_tmp104_ = g_strdup ("spmi");
#line 1247 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp104_, NULL);
#line 1248 "../src/umockdev.vala"
	_tmp105_ = g_strdup ("ssb");
#line 1248 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp105_, NULL);
#line 1249 "../src/umockdev.vala"
	_tmp106_ = g_strdup ("sunxi-rsb");
#line 1249 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp106_, NULL);
#line 1250 "../src/umockdev.vala"
	_tmp107_ = g_strdup ("superhyway");
#line 1250 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp107_, NULL);
#line 1251 "../src/umockdev.vala"
	_tmp108_ = g_strdup ("tc");
#line 1251 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp108_, NULL);
#line 1252 "../src/umockdev.vala"
	_tmp109_ = g_strdup ("tcm_loop_bus");
#line 1252 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp109_, NULL);
#line 1253 "../src/umockdev.vala"
	_tmp110_ = g_strdup ("tee");
#line 1253 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp110_, NULL);
#line 1254 "../src/umockdev.vala"
	_tmp111_ = g_strdup ("thunderbolt");
#line 1254 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp111_, NULL);
#line 1255 "../src/umockdev.vala"
	_tmp112_ = g_strdup ("tifm");
#line 1255 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp112_, NULL);
#line 1256 "../src/umockdev.vala"
	_tmp113_ = g_strdup ("tiocx");
#line 1256 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp113_, NULL);
#line 1257 "../src/umockdev.vala"
	_tmp114_ = g_strdup ("typec");
#line 1257 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp114_, NULL);
#line 1258 "../src/umockdev.vala"
	_tmp115_ = g_strdup ("ulpi");
#line 1258 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp115_, NULL);
#line 1259 "../src/umockdev.vala"
	_tmp116_ = g_strdup ("umc");
#line 1259 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp116_, NULL);
#line 1260 "../src/umockdev.vala"
	_tmp117_ = g_strdup ("usb-serial");
#line 1260 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp117_, NULL);
#line 1261 "../src/umockdev.vala"
	_tmp118_ = g_strdup ("usb");
#line 1261 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp118_, NULL);
#line 1262 "../src/umockdev.vala"
	_tmp119_ = g_strdup ("usb");
#line 1262 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp119_, NULL);
#line 1263 "../src/umockdev.vala"
	_tmp120_ = g_strdup ("uwb");
#line 1263 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp120_, NULL);
#line 1264 "../src/umockdev.vala"
	_tmp121_ = g_strdup ("vio");
#line 1264 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp121_, NULL);
#line 1265 "../src/umockdev.vala"
	_tmp122_ = g_strdup ("virtio");
#line 1265 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp122_, NULL);
#line 1266 "../src/umockdev.vala"
	_tmp123_ = g_strdup ("visorbus");
#line 1266 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp123_, NULL);
#line 1267 "../src/umockdev.vala"
	_tmp124_ = g_strdup ("vlynq");
#line 1267 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp124_, NULL);
#line 1268 "../src/umockdev.vala"
	_tmp125_ = g_strdup ("vmbus");
#line 1268 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp125_, NULL);
#line 1269 "../src/umockdev.vala"
	_tmp126_ = g_strdup ("vme");
#line 1269 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp126_, NULL);
#line 1270 "../src/umockdev.vala"
	_tmp127_ = g_strdup ("vop_bus");
#line 1270 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp127_, NULL);
#line 1271 "../src/umockdev.vala"
	_tmp128_ = g_strdup ("w1");
#line 1271 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp128_, NULL);
#line 1272 "../src/umockdev.vala"
	_tmp129_ = g_strdup ("wmi_bus");
#line 1272 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp129_, NULL);
#line 1273 "../src/umockdev.vala"
	_tmp130_ = g_strdup ("xen-backend");
#line 1273 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp130_, NULL);
#line 1274 "../src/umockdev.vala"
	_tmp131_ = g_strdup ("xen");
#line 1274 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp131_, NULL);
#line 1275 "../src/umockdev.vala"
	_tmp132_ = g_strdup ("zorro");
#line 1275 "../src/umockdev.vala"
	g_hash_table_insert (lookup, _tmp132_, NULL);
#line 1277 "../src/umockdev.vala"
	result = lookup;
#line 1277 "../src/umockdev.vala"
	return result;
#line 7211 "umockdev.c"
}

static gboolean
umockdev_testbed_subsystem_is_bus (const gchar* subsystem)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp2_;
	gboolean result;
#line 1280 "../src/umockdev.vala"
	g_return_val_if_fail (subsystem != NULL, FALSE);
#line 1281 "../src/umockdev.vala"
	_tmp0_ = umockdev_testbed_bus_lookup_table;
#line 1281 "../src/umockdev.vala"
	if (_tmp0_ == NULL) {
#line 7226 "umockdev.c"
		GHashTable* _tmp1_;
#line 1282 "../src/umockdev.vala"
		_tmp1_ = umockdev_testbed_create_bus_lookup ();
#line 1282 "../src/umockdev.vala"
		_g_hash_table_unref0 (umockdev_testbed_bus_lookup_table);
#line 1282 "../src/umockdev.vala"
		umockdev_testbed_bus_lookup_table = _tmp1_;
#line 7234 "umockdev.c"
	}
#line 1285 "../src/umockdev.vala"
	_tmp2_ = umockdev_testbed_bus_lookup_table;
#line 1285 "../src/umockdev.vala"
	result = g_hash_table_contains (_tmp2_, subsystem);
#line 1285 "../src/umockdev.vala"
	return result;
#line 7242 "umockdev.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1324 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1324 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1324 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7257 "umockdev.c"
	}
#line 1324 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1324 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7263 "umockdev.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1325 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1325 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1325 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7278 "umockdev.c"
	}
#line 1325 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1325 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7284 "umockdev.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1329 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1329 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1329 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7299 "umockdev.c"
	}
#line 1329 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1329 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7305 "umockdev.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1331 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1331 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1331 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7320 "umockdev.c"
	}
#line 1331 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1331 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7326 "umockdev.c"
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1337 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1337 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1337 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7341 "umockdev.c"
	}
#line 1337 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1337 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7347 "umockdev.c"
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1338 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1338 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1338 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7362 "umockdev.c"
	}
#line 1338 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1338 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7368 "umockdev.c"
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 1350 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1350 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1350 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7383 "umockdev.c"
	}
#line 1350 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1350 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7389 "umockdev.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1351 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1351 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1351 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7404 "umockdev.c"
	}
#line 1351 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1351 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7410 "umockdev.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1374 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1374 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1374 "../src/umockdev.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7425 "umockdev.c"
	}
#line 1374 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1374 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 7431 "umockdev.c"
}

static gchar*
umockdev_testbed_add_dev_from_string (UMockdevTestbed* self,
                                      const gchar* data,
                                      GError** error)
{
	gchar type = '\0';
	gchar* key = NULL;
	gchar* val = NULL;
	gchar* devpath = NULL;
	gchar* subsystem = NULL;
	gchar* majmin = NULL;
	gchar* cur_data = NULL;
	gchar* _tmp0_;
	gchar* devnode_path = NULL;
	guint8* devnode_contents = NULL;
	guint8* _tmp1_;
	gint devnode_contents_length1;
	gint _devnode_contents_size_;
	gchar** devnode_links = NULL;
	gchar** _tmp2_;
	gint devnode_links_length1;
	gint _devnode_links_size_;
	const gchar* _tmp3_;
	gchar _tmp4_ = '\0';
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	const gchar* _tmp11_;
	const gchar* _tmp14_;
	gchar** attrs = NULL;
	gchar** _tmp15_;
	gint attrs_length1;
	gint _attrs_size_;
	gchar** binattrs = NULL;
	gchar** _tmp16_;
	gint binattrs_length1;
	gint _binattrs_size_;
	gchar** linkattrs = NULL;
	gchar** _tmp17_;
	gint linkattrs_length1;
	gint _linkattrs_size_;
	gchar** props = NULL;
	gchar** _tmp18_;
	gint props_length1;
	gint _props_size_;
	gchar* selinux_context = NULL;
	const gchar* _tmp83_;
	const gchar* _tmp86_;
	const gchar* _tmp87_;
	gchar* syspath = NULL;
	const gchar* _tmp88_;
	const gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gchar** _tmp92_;
	gint _tmp92__length1;
	gchar** _tmp93_;
	gint _tmp93__length1;
	gchar* _tmp94_;
	gchar* _tmp95_;
	const gchar* _tmp113_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1288 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1288 "../src/umockdev.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 1293 "../src/umockdev.vala"
	devpath = NULL;
#line 1294 "../src/umockdev.vala"
	subsystem = NULL;
#line 1295 "../src/umockdev.vala"
	majmin = NULL;
#line 1296 "../src/umockdev.vala"
	_tmp0_ = g_strdup (data);
#line 1296 "../src/umockdev.vala"
	cur_data = _tmp0_;
#line 1297 "../src/umockdev.vala"
	devnode_path = NULL;
#line 1298 "../src/umockdev.vala"
	_tmp1_ = g_new0 (guint8, 0);
#line 1298 "../src/umockdev.vala"
	devnode_contents = _tmp1_;
#line 1298 "../src/umockdev.vala"
	devnode_contents_length1 = 0;
#line 1298 "../src/umockdev.vala"
	_devnode_contents_size_ = devnode_contents_length1;
#line 1299 "../src/umockdev.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 1299 "../src/umockdev.vala"
	devnode_links = _tmp2_;
#line 1299 "../src/umockdev.vala"
	devnode_links_length1 = 0;
#line 1299 "../src/umockdev.vala"
	_devnode_links_size_ = devnode_links_length1;
#line 1301 "../src/umockdev.vala"
	_tmp3_ = cur_data;
#line 1301 "../src/umockdev.vala"
	_tmp7_ = umockdev_testbed_record_parse_line (self, _tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 1301 "../src/umockdev.vala"
	type = _tmp4_;
#line 1301 "../src/umockdev.vala"
	_g_free0 (key);
#line 1301 "../src/umockdev.vala"
	key = _tmp5_;
#line 1301 "../src/umockdev.vala"
	_g_free0 (devpath);
#line 1301 "../src/umockdev.vala"
	devpath = _tmp6_;
#line 1301 "../src/umockdev.vala"
	_g_free0 (cur_data);
#line 1301 "../src/umockdev.vala"
	cur_data = _tmp7_;
#line 1302 "../src/umockdev.vala"
	_tmp9_ = cur_data;
#line 1302 "../src/umockdev.vala"
	if (_tmp9_ == NULL) {
#line 1302 "../src/umockdev.vala"
		_tmp8_ = TRUE;
#line 7555 "umockdev.c"
	} else {
#line 1302 "../src/umockdev.vala"
		_tmp8_ = type != 'P';
#line 7559 "umockdev.c"
	}
#line 1302 "../src/umockdev.vala"
	if (_tmp8_) {
#line 7563 "umockdev.c"
		GError* _tmp10_;
#line 1303 "../src/umockdev.vala"
		_tmp10_ = g_error_new_literal (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "device descriptions must start with a \"P: /devices/path/...\" line");
#line 1303 "../src/umockdev.vala"
		_inner_error0_ = _tmp10_;
#line 1303 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1303 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1303 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1303 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1303 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1303 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1303 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1303 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1303 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1303 "../src/umockdev.vala"
			_g_free0 (val);
#line 1303 "../src/umockdev.vala"
			_g_free0 (key);
#line 1303 "../src/umockdev.vala"
			return NULL;
#line 7593 "umockdev.c"
		} else {
#line 1303 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1303 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1303 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1303 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1303 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1303 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1303 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1303 "../src/umockdev.vala"
			_g_free0 (val);
#line 1303 "../src/umockdev.vala"
			_g_free0 (key);
#line 1303 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1303 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1303 "../src/umockdev.vala"
			return NULL;
#line 7619 "umockdev.c"
		}
	}
#line 1304 "../src/umockdev.vala"
	_tmp11_ = devpath;
#line 1304 "../src/umockdev.vala"
	if (!g_str_has_prefix (_tmp11_, "/devices/")) {
#line 7626 "umockdev.c"
		const gchar* _tmp12_;
		GError* _tmp13_;
#line 1305 "../src/umockdev.vala"
		_tmp12_ = devpath;
#line 1305 "../src/umockdev.vala"
		_tmp13_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_VALUE, "invalid device path '%s': must start with /devices/", _tmp12_);
#line 1305 "../src/umockdev.vala"
		_inner_error0_ = _tmp13_;
#line 1305 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1305 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1305 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1305 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1305 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1305 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1305 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1305 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1305 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1305 "../src/umockdev.vala"
			_g_free0 (val);
#line 1305 "../src/umockdev.vala"
			_g_free0 (key);
#line 1305 "../src/umockdev.vala"
			return NULL;
#line 7659 "umockdev.c"
		} else {
#line 1305 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1305 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1305 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1305 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1305 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1305 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1305 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1305 "../src/umockdev.vala"
			_g_free0 (val);
#line 1305 "../src/umockdev.vala"
			_g_free0 (key);
#line 1305 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1305 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1305 "../src/umockdev.vala"
			return NULL;
#line 7685 "umockdev.c"
		}
	}
#line 1307 "../src/umockdev.vala"
	_tmp14_ = devpath;
#line 1307 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1307: parsing device description for %s", _tmp14_);
#line 1309 "../src/umockdev.vala"
	_tmp15_ = g_new0 (gchar*, 0 + 1);
#line 1309 "../src/umockdev.vala"
	attrs = _tmp15_;
#line 1309 "../src/umockdev.vala"
	attrs_length1 = 0;
#line 1309 "../src/umockdev.vala"
	_attrs_size_ = attrs_length1;
#line 1310 "../src/umockdev.vala"
	_tmp16_ = g_new0 (gchar*, 0 + 1);
#line 1310 "../src/umockdev.vala"
	binattrs = _tmp16_;
#line 1310 "../src/umockdev.vala"
	binattrs_length1 = 0;
#line 1310 "../src/umockdev.vala"
	_binattrs_size_ = binattrs_length1;
#line 1311 "../src/umockdev.vala"
	_tmp17_ = g_new0 (gchar*, 0 + 1);
#line 1311 "../src/umockdev.vala"
	linkattrs = _tmp17_;
#line 1311 "../src/umockdev.vala"
	linkattrs_length1 = 0;
#line 1311 "../src/umockdev.vala"
	_linkattrs_size_ = linkattrs_length1;
#line 1312 "../src/umockdev.vala"
	_tmp18_ = g_new0 (gchar*, 0 + 1);
#line 1312 "../src/umockdev.vala"
	props = _tmp18_;
#line 1312 "../src/umockdev.vala"
	props_length1 = 0;
#line 1312 "../src/umockdev.vala"
	_props_size_ = props_length1;
#line 1313 "../src/umockdev.vala"
	selinux_context = NULL;
#line 1316 "../src/umockdev.vala"
	while (TRUE) {
#line 7728 "umockdev.c"
		gboolean _tmp19_ = FALSE;
		const gchar* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		const gchar* _tmp24_;
		gchar _tmp25_ = '\0';
		gchar* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
		const gchar* _tmp29_;
#line 1316 "../src/umockdev.vala"
		_tmp20_ = cur_data;
#line 1316 "../src/umockdev.vala"
		_tmp21_ = strlen (_tmp20_);
#line 1316 "../src/umockdev.vala"
		_tmp22_ = _tmp21_;
#line 1316 "../src/umockdev.vala"
		if (_tmp22_ > 0) {
#line 7747 "umockdev.c"
			const gchar* _tmp23_;
#line 1316 "../src/umockdev.vala"
			_tmp23_ = cur_data;
#line 1316 "../src/umockdev.vala"
			_tmp19_ = string_get (_tmp23_, (glong) 0) != '\n';
#line 7753 "umockdev.c"
		} else {
#line 1316 "../src/umockdev.vala"
			_tmp19_ = FALSE;
#line 7757 "umockdev.c"
		}
#line 1316 "../src/umockdev.vala"
		if (!_tmp19_) {
#line 1316 "../src/umockdev.vala"
			break;
#line 7763 "umockdev.c"
		}
#line 1317 "../src/umockdev.vala"
		_tmp24_ = cur_data;
#line 1317 "../src/umockdev.vala"
		_tmp28_ = umockdev_testbed_record_parse_line (self, _tmp24_, &_tmp25_, &_tmp26_, &_tmp27_);
#line 1317 "../src/umockdev.vala"
		type = _tmp25_;
#line 1317 "../src/umockdev.vala"
		_g_free0 (key);
#line 1317 "../src/umockdev.vala"
		key = _tmp26_;
#line 1317 "../src/umockdev.vala"
		_g_free0 (val);
#line 1317 "../src/umockdev.vala"
		val = _tmp27_;
#line 1317 "../src/umockdev.vala"
		_g_free0 (cur_data);
#line 1317 "../src/umockdev.vala"
		cur_data = _tmp28_;
#line 1318 "../src/umockdev.vala"
		_tmp29_ = cur_data;
#line 1318 "../src/umockdev.vala"
		if (_tmp29_ == NULL) {
#line 7787 "umockdev.c"
			const gchar* _tmp30_;
			GError* _tmp31_;
#line 1319 "../src/umockdev.vala"
			_tmp30_ = devpath;
#line 1319 "../src/umockdev.vala"
			_tmp31_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "malformed attribute or property line in description of device %s", _tmp30_);
#line 1319 "../src/umockdev.vala"
			_inner_error0_ = _tmp31_;
#line 1319 "../src/umockdev.vala"
			if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1319 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 1319 "../src/umockdev.vala"
				_g_free0 (selinux_context);
#line 1319 "../src/umockdev.vala"
				props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				devnode_contents = (g_free (devnode_contents), NULL);
#line 1319 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1319 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 1319 "../src/umockdev.vala"
				_g_free0 (majmin);
#line 1319 "../src/umockdev.vala"
				_g_free0 (subsystem);
#line 1319 "../src/umockdev.vala"
				_g_free0 (devpath);
#line 1319 "../src/umockdev.vala"
				_g_free0 (val);
#line 1319 "../src/umockdev.vala"
				_g_free0 (key);
#line 1319 "../src/umockdev.vala"
				return NULL;
#line 7830 "umockdev.c"
			} else {
#line 1319 "../src/umockdev.vala"
				_g_free0 (selinux_context);
#line 1319 "../src/umockdev.vala"
				props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "../src/umockdev.vala"
				devnode_contents = (g_free (devnode_contents), NULL);
#line 1319 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1319 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 1319 "../src/umockdev.vala"
				_g_free0 (majmin);
#line 1319 "../src/umockdev.vala"
				_g_free0 (subsystem);
#line 1319 "../src/umockdev.vala"
				_g_free0 (devpath);
#line 1319 "../src/umockdev.vala"
				_g_free0 (val);
#line 1319 "../src/umockdev.vala"
				_g_free0 (key);
#line 1319 "../src/umockdev.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1319 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 1319 "../src/umockdev.vala"
				return NULL;
#line 7866 "umockdev.c"
			}
		}
#line 1322 "../src/umockdev.vala"
		switch (type) {
#line 1322 "../src/umockdev.vala"
			case 'H':
#line 7873 "umockdev.c"
			{
				const gchar* _tmp32_;
				gchar* _tmp33_;
				const gchar* _tmp34_;
				gchar* _tmp35_;
#line 1324 "../src/umockdev.vala"
				_tmp32_ = key;
#line 1324 "../src/umockdev.vala"
				_tmp33_ = g_strdup (_tmp32_);
#line 1324 "../src/umockdev.vala"
				_vala_array_add3 (&binattrs, &binattrs_length1, &_binattrs_size_, _tmp33_);
#line 1325 "../src/umockdev.vala"
				_tmp34_ = val;
#line 1325 "../src/umockdev.vala"
				_tmp35_ = g_strdup (_tmp34_);
#line 1325 "../src/umockdev.vala"
				_vala_array_add4 (&binattrs, &binattrs_length1, &_binattrs_size_, _tmp35_);
#line 1326 "../src/umockdev.vala"
				break;
#line 7893 "umockdev.c"
			}
#line 1322 "../src/umockdev.vala"
			case 'A':
#line 7897 "umockdev.c"
			{
				const gchar* _tmp36_;
				gchar* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_;
				const gchar* _tmp40_;
				gchar* _tmp41_;
				const gchar* _tmp42_;
#line 1329 "../src/umockdev.vala"
				_tmp36_ = key;
#line 1329 "../src/umockdev.vala"
				_tmp37_ = g_strdup (_tmp36_);
#line 1329 "../src/umockdev.vala"
				_vala_array_add5 (&attrs, &attrs_length1, &_attrs_size_, _tmp37_);
#line 1330 "../src/umockdev.vala"
				_tmp38_ = val;
#line 1330 "../src/umockdev.vala"
				_tmp39_ = g_strcompress (_tmp38_);
#line 1330 "../src/umockdev.vala"
				_g_free0 (val);
#line 1330 "../src/umockdev.vala"
				val = _tmp39_;
#line 1331 "../src/umockdev.vala"
				_tmp40_ = val;
#line 1331 "../src/umockdev.vala"
				_tmp41_ = g_strdup (_tmp40_);
#line 1331 "../src/umockdev.vala"
				_vala_array_add6 (&attrs, &attrs_length1, &_attrs_size_, _tmp41_);
#line 1332 "../src/umockdev.vala"
				_tmp42_ = key;
#line 1332 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp42_, "dev") == 0) {
#line 7930 "umockdev.c"
					const gchar* _tmp43_;
					gchar* _tmp44_;
#line 1333 "../src/umockdev.vala"
					_tmp43_ = val;
#line 1333 "../src/umockdev.vala"
					_tmp44_ = g_strdup (_tmp43_);
#line 1333 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1333 "../src/umockdev.vala"
					majmin = _tmp44_;
#line 7941 "umockdev.c"
				}
#line 1334 "../src/umockdev.vala"
				break;
#line 7945 "umockdev.c"
			}
#line 1322 "../src/umockdev.vala"
			case 'L':
#line 7949 "umockdev.c"
			{
				const gchar* _tmp45_;
				gchar* _tmp46_;
				const gchar* _tmp47_;
				gchar* _tmp48_;
#line 1337 "../src/umockdev.vala"
				_tmp45_ = key;
#line 1337 "../src/umockdev.vala"
				_tmp46_ = g_strdup (_tmp45_);
#line 1337 "../src/umockdev.vala"
				_vala_array_add7 (&linkattrs, &linkattrs_length1, &_linkattrs_size_, _tmp46_);
#line 1338 "../src/umockdev.vala"
				_tmp47_ = val;
#line 1338 "../src/umockdev.vala"
				_tmp48_ = g_strdup (_tmp47_);
#line 1338 "../src/umockdev.vala"
				_vala_array_add8 (&linkattrs, &linkattrs_length1, &_linkattrs_size_, _tmp48_);
#line 1339 "../src/umockdev.vala"
				break;
#line 7969 "umockdev.c"
			}
#line 1322 "../src/umockdev.vala"
			case 'E':
#line 7973 "umockdev.c"
			{
				const gchar* _tmp49_;
				const gchar* _tmp55_;
				gchar* _tmp56_;
				const gchar* _tmp57_;
				gchar* _tmp58_;
				const gchar* _tmp59_;
#line 1342 "../src/umockdev.vala"
				_tmp49_ = key;
#line 1342 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp49_, "__DEVCONTEXT") == 0) {
#line 7985 "umockdev.c"
					const gchar* _tmp50_;
					const gchar* _tmp53_;
					gchar* _tmp54_;
#line 1343 "../src/umockdev.vala"
					_tmp50_ = selinux_context;
#line 1343 "../src/umockdev.vala"
					if (_tmp50_ != NULL) {
#line 7993 "umockdev.c"
						const gchar* _tmp51_;
						GError* _tmp52_;
#line 1344 "../src/umockdev.vala"
						_tmp51_ = devpath;
#line 1344 "../src/umockdev.vala"
						_tmp52_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_VALUE, "duplicate __DEVCONTEXT property in description of device %s", _tmp51_);
#line 1344 "../src/umockdev.vala"
						_inner_error0_ = _tmp52_;
#line 1344 "../src/umockdev.vala"
						if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1344 "../src/umockdev.vala"
							g_propagate_error (error, _inner_error0_);
#line 1344 "../src/umockdev.vala"
							_g_free0 (selinux_context);
#line 1344 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1344 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1344 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1344 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1344 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1344 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1344 "../src/umockdev.vala"
							_g_free0 (val);
#line 1344 "../src/umockdev.vala"
							_g_free0 (key);
#line 1344 "../src/umockdev.vala"
							return NULL;
#line 8036 "umockdev.c"
						} else {
#line 1344 "../src/umockdev.vala"
							_g_free0 (selinux_context);
#line 1344 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1344 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1344 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1344 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1344 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1344 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1344 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1344 "../src/umockdev.vala"
							_g_free0 (val);
#line 1344 "../src/umockdev.vala"
							_g_free0 (key);
#line 1344 "../src/umockdev.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1344 "../src/umockdev.vala"
							g_clear_error (&_inner_error0_);
#line 1344 "../src/umockdev.vala"
							return NULL;
#line 8072 "umockdev.c"
						}
					}
#line 1346 "../src/umockdev.vala"
					_tmp53_ = val;
#line 1346 "../src/umockdev.vala"
					_tmp54_ = g_strdup (_tmp53_);
#line 1346 "../src/umockdev.vala"
					_g_free0 (selinux_context);
#line 1346 "../src/umockdev.vala"
					selinux_context = _tmp54_;
#line 1347 "../src/umockdev.vala"
					break;
#line 8085 "umockdev.c"
				}
#line 1350 "../src/umockdev.vala"
				_tmp55_ = key;
#line 1350 "../src/umockdev.vala"
				_tmp56_ = g_strdup (_tmp55_);
#line 1350 "../src/umockdev.vala"
				_vala_array_add9 (&props, &props_length1, &_props_size_, _tmp56_);
#line 1351 "../src/umockdev.vala"
				_tmp57_ = val;
#line 1351 "../src/umockdev.vala"
				_tmp58_ = g_strdup (_tmp57_);
#line 1351 "../src/umockdev.vala"
				_vala_array_add10 (&props, &props_length1, &_props_size_, _tmp58_);
#line 1352 "../src/umockdev.vala"
				_tmp59_ = key;
#line 1352 "../src/umockdev.vala"
				if (g_strcmp0 (_tmp59_, "SUBSYSTEM") == 0) {
#line 8103 "umockdev.c"
					const gchar* _tmp60_;
					const gchar* _tmp63_;
					gchar* _tmp64_;
#line 1353 "../src/umockdev.vala"
					_tmp60_ = subsystem;
#line 1353 "../src/umockdev.vala"
					if (_tmp60_ != NULL) {
#line 8111 "umockdev.c"
						const gchar* _tmp61_;
						GError* _tmp62_;
#line 1354 "../src/umockdev.vala"
						_tmp61_ = devpath;
#line 1354 "../src/umockdev.vala"
						_tmp62_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_VALUE, "duplicate SUBSYSTEM property in description of device %s", _tmp61_);
#line 1354 "../src/umockdev.vala"
						_inner_error0_ = _tmp62_;
#line 1354 "../src/umockdev.vala"
						if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1354 "../src/umockdev.vala"
							g_propagate_error (error, _inner_error0_);
#line 1354 "../src/umockdev.vala"
							_g_free0 (selinux_context);
#line 1354 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1354 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1354 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1354 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1354 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1354 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1354 "../src/umockdev.vala"
							_g_free0 (val);
#line 1354 "../src/umockdev.vala"
							_g_free0 (key);
#line 1354 "../src/umockdev.vala"
							return NULL;
#line 8154 "umockdev.c"
						} else {
#line 1354 "../src/umockdev.vala"
							_g_free0 (selinux_context);
#line 1354 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1354 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1354 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1354 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1354 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1354 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1354 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1354 "../src/umockdev.vala"
							_g_free0 (val);
#line 1354 "../src/umockdev.vala"
							_g_free0 (key);
#line 1354 "../src/umockdev.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1354 "../src/umockdev.vala"
							g_clear_error (&_inner_error0_);
#line 1354 "../src/umockdev.vala"
							return NULL;
#line 8190 "umockdev.c"
						}
					}
#line 1356 "../src/umockdev.vala"
					_tmp63_ = val;
#line 1356 "../src/umockdev.vala"
					_tmp64_ = g_strdup (_tmp63_);
#line 1356 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1356 "../src/umockdev.vala"
					subsystem = _tmp64_;
#line 8201 "umockdev.c"
				}
#line 1358 "../src/umockdev.vala"
				break;
#line 8205 "umockdev.c"
			}
#line 1322 "../src/umockdev.vala"
			case 'P':
#line 8209 "umockdev.c"
			{
				const gchar* _tmp65_;
				GError* _tmp66_;
#line 1361 "../src/umockdev.vala"
				_tmp65_ = devpath;
#line 1361 "../src/umockdev.vala"
				_tmp66_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "invalid P: line in description of device %s", _tmp65_);
#line 1361 "../src/umockdev.vala"
				_inner_error0_ = _tmp66_;
#line 1361 "../src/umockdev.vala"
				if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1361 "../src/umockdev.vala"
					g_propagate_error (error, _inner_error0_);
#line 1361 "../src/umockdev.vala"
					_g_free0 (selinux_context);
#line 1361 "../src/umockdev.vala"
					props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1361 "../src/umockdev.vala"
					_g_free0 (devnode_path);
#line 1361 "../src/umockdev.vala"
					_g_free0 (cur_data);
#line 1361 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1361 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1361 "../src/umockdev.vala"
					_g_free0 (devpath);
#line 1361 "../src/umockdev.vala"
					_g_free0 (val);
#line 1361 "../src/umockdev.vala"
					_g_free0 (key);
#line 1361 "../src/umockdev.vala"
					return NULL;
#line 8253 "umockdev.c"
				} else {
#line 1361 "../src/umockdev.vala"
					_g_free0 (selinux_context);
#line 1361 "../src/umockdev.vala"
					props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1361 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1361 "../src/umockdev.vala"
					_g_free0 (devnode_path);
#line 1361 "../src/umockdev.vala"
					_g_free0 (cur_data);
#line 1361 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1361 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1361 "../src/umockdev.vala"
					_g_free0 (devpath);
#line 1361 "../src/umockdev.vala"
					_g_free0 (val);
#line 1361 "../src/umockdev.vala"
					_g_free0 (key);
#line 1361 "../src/umockdev.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1361 "../src/umockdev.vala"
					g_clear_error (&_inner_error0_);
#line 1361 "../src/umockdev.vala"
					return NULL;
#line 8289 "umockdev.c"
				}
			}
#line 1322 "../src/umockdev.vala"
			case 'N':
#line 8294 "umockdev.c"
			{
				const gchar* _tmp67_;
				const gchar* _tmp68_;
				gchar* _tmp69_;
				const gchar* _tmp70_;
#line 1365 "../src/umockdev.vala"
				_tmp67_ = self->priv->root_dir;
#line 1365 "../src/umockdev.vala"
				_tmp68_ = key;
#line 1365 "../src/umockdev.vala"
				_tmp69_ = g_build_filename (_tmp67_, "dev", _tmp68_, NULL);
#line 1365 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1365 "../src/umockdev.vala"
				devnode_path = _tmp69_;
#line 1366 "../src/umockdev.vala"
				_tmp70_ = val;
#line 1366 "../src/umockdev.vala"
				if (_tmp70_ != NULL) {
#line 8314 "umockdev.c"
					guint8* _tmp71_ = NULL;
					const gchar* _tmp72_;
					gint _tmp73_ = 0;
					guint8* _tmp74_;
					gint _tmp71__length1;
					gint __tmp71__size_;
					guint8* _tmp75_;
					gint _tmp75__length1;
#line 1367 "../src/umockdev.vala"
					_tmp72_ = val;
#line 1367 "../src/umockdev.vala"
					_tmp74_ = umockdev_decode_hex (_tmp72_, &_tmp73_, &_inner_error0_);
#line 1367 "../src/umockdev.vala"
					_tmp71_ = _tmp74_;
#line 1367 "../src/umockdev.vala"
					_tmp71__length1 = _tmp73_;
#line 1367 "../src/umockdev.vala"
					__tmp71__size_ = _tmp71__length1;
#line 1367 "../src/umockdev.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1367 "../src/umockdev.vala"
						if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1367 "../src/umockdev.vala"
							g_propagate_error (error, _inner_error0_);
#line 1367 "../src/umockdev.vala"
							_g_free0 (selinux_context);
#line 1367 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1367 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1367 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1367 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1367 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1367 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1367 "../src/umockdev.vala"
							_g_free0 (val);
#line 1367 "../src/umockdev.vala"
							_g_free0 (key);
#line 1367 "../src/umockdev.vala"
							return NULL;
#line 8369 "umockdev.c"
						} else {
#line 1367 "../src/umockdev.vala"
							_g_free0 (selinux_context);
#line 1367 "../src/umockdev.vala"
							props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1367 "../src/umockdev.vala"
							devnode_contents = (g_free (devnode_contents), NULL);
#line 1367 "../src/umockdev.vala"
							_g_free0 (devnode_path);
#line 1367 "../src/umockdev.vala"
							_g_free0 (cur_data);
#line 1367 "../src/umockdev.vala"
							_g_free0 (majmin);
#line 1367 "../src/umockdev.vala"
							_g_free0 (subsystem);
#line 1367 "../src/umockdev.vala"
							_g_free0 (devpath);
#line 1367 "../src/umockdev.vala"
							_g_free0 (val);
#line 1367 "../src/umockdev.vala"
							_g_free0 (key);
#line 1367 "../src/umockdev.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1367 "../src/umockdev.vala"
							g_clear_error (&_inner_error0_);
#line 1367 "../src/umockdev.vala"
							return NULL;
#line 8405 "umockdev.c"
						}
					}
#line 1367 "../src/umockdev.vala"
					_tmp75_ = _tmp71_;
#line 1367 "../src/umockdev.vala"
					_tmp75__length1 = _tmp71__length1;
#line 1367 "../src/umockdev.vala"
					_tmp71_ = NULL;
#line 1367 "../src/umockdev.vala"
					_tmp71__length1 = 0;
#line 1367 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1367 "../src/umockdev.vala"
					devnode_contents = _tmp75_;
#line 1367 "../src/umockdev.vala"
					devnode_contents_length1 = _tmp75__length1;
#line 1367 "../src/umockdev.vala"
					_devnode_contents_size_ = devnode_contents_length1;
#line 1366 "../src/umockdev.vala"
					_tmp71_ = (g_free (_tmp71_), NULL);
#line 8426 "umockdev.c"
				}
#line 1368 "../src/umockdev.vala"
				break;
#line 8430 "umockdev.c"
			}
#line 1322 "../src/umockdev.vala"
			case 'S':
#line 8434 "umockdev.c"
			{
				const gchar* _tmp76_;
				const gchar* _tmp79_;
				const gchar* _tmp80_;
				gchar* _tmp81_;
#line 1372 "../src/umockdev.vala"
				_tmp76_ = val;
#line 1372 "../src/umockdev.vala"
				if (_tmp76_ == NULL) {
#line 8444 "umockdev.c"
					const gchar* _tmp77_;
					GError* _tmp78_;
#line 1373 "../src/umockdev.vala"
					_tmp77_ = devpath;
#line 1373 "../src/umockdev.vala"
					_tmp78_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "invalid S: line in description of device %s", _tmp77_);
#line 1373 "../src/umockdev.vala"
					_inner_error0_ = _tmp78_;
#line 1373 "../src/umockdev.vala"
					if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1373 "../src/umockdev.vala"
						g_propagate_error (error, _inner_error0_);
#line 1373 "../src/umockdev.vala"
						_g_free0 (selinux_context);
#line 1373 "../src/umockdev.vala"
						props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						devnode_contents = (g_free (devnode_contents), NULL);
#line 1373 "../src/umockdev.vala"
						_g_free0 (devnode_path);
#line 1373 "../src/umockdev.vala"
						_g_free0 (cur_data);
#line 1373 "../src/umockdev.vala"
						_g_free0 (majmin);
#line 1373 "../src/umockdev.vala"
						_g_free0 (subsystem);
#line 1373 "../src/umockdev.vala"
						_g_free0 (devpath);
#line 1373 "../src/umockdev.vala"
						_g_free0 (val);
#line 1373 "../src/umockdev.vala"
						_g_free0 (key);
#line 1373 "../src/umockdev.vala"
						return NULL;
#line 8487 "umockdev.c"
					} else {
#line 1373 "../src/umockdev.vala"
						_g_free0 (selinux_context);
#line 1373 "../src/umockdev.vala"
						props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "../src/umockdev.vala"
						devnode_contents = (g_free (devnode_contents), NULL);
#line 1373 "../src/umockdev.vala"
						_g_free0 (devnode_path);
#line 1373 "../src/umockdev.vala"
						_g_free0 (cur_data);
#line 1373 "../src/umockdev.vala"
						_g_free0 (majmin);
#line 1373 "../src/umockdev.vala"
						_g_free0 (subsystem);
#line 1373 "../src/umockdev.vala"
						_g_free0 (devpath);
#line 1373 "../src/umockdev.vala"
						_g_free0 (val);
#line 1373 "../src/umockdev.vala"
						_g_free0 (key);
#line 1373 "../src/umockdev.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1373 "../src/umockdev.vala"
						g_clear_error (&_inner_error0_);
#line 1373 "../src/umockdev.vala"
						return NULL;
#line 8523 "umockdev.c"
					}
				}
#line 1374 "../src/umockdev.vala"
				_tmp79_ = self->priv->root_dir;
#line 1374 "../src/umockdev.vala"
				_tmp80_ = val;
#line 1374 "../src/umockdev.vala"
				_tmp81_ = g_build_filename (_tmp79_, "dev", _tmp80_, NULL);
#line 1374 "../src/umockdev.vala"
				_vala_array_add11 (&devnode_links, &devnode_links_length1, &_devnode_links_size_, _tmp81_);
#line 1375 "../src/umockdev.vala"
				break;
#line 8536 "umockdev.c"
			}
			default:
			{
				GError* _tmp82_;
#line 1378 "../src/umockdev.vala"
				_tmp82_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "Unknown line type '%c'\n", (gint) type);
#line 1378 "../src/umockdev.vala"
				_inner_error0_ = _tmp82_;
#line 1378 "../src/umockdev.vala"
				if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1378 "../src/umockdev.vala"
					g_propagate_error (error, _inner_error0_);
#line 1378 "../src/umockdev.vala"
					_g_free0 (selinux_context);
#line 1378 "../src/umockdev.vala"
					props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1378 "../src/umockdev.vala"
					_g_free0 (devnode_path);
#line 1378 "../src/umockdev.vala"
					_g_free0 (cur_data);
#line 1378 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1378 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1378 "../src/umockdev.vala"
					_g_free0 (devpath);
#line 1378 "../src/umockdev.vala"
					_g_free0 (val);
#line 1378 "../src/umockdev.vala"
					_g_free0 (key);
#line 1378 "../src/umockdev.vala"
					return NULL;
#line 8579 "umockdev.c"
				} else {
#line 1378 "../src/umockdev.vala"
					_g_free0 (selinux_context);
#line 1378 "../src/umockdev.vala"
					props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/umockdev.vala"
					devnode_contents = (g_free (devnode_contents), NULL);
#line 1378 "../src/umockdev.vala"
					_g_free0 (devnode_path);
#line 1378 "../src/umockdev.vala"
					_g_free0 (cur_data);
#line 1378 "../src/umockdev.vala"
					_g_free0 (majmin);
#line 1378 "../src/umockdev.vala"
					_g_free0 (subsystem);
#line 1378 "../src/umockdev.vala"
					_g_free0 (devpath);
#line 1378 "../src/umockdev.vala"
					_g_free0 (val);
#line 1378 "../src/umockdev.vala"
					_g_free0 (key);
#line 1378 "../src/umockdev.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1378 "../src/umockdev.vala"
					g_clear_error (&_inner_error0_);
#line 1378 "../src/umockdev.vala"
					return NULL;
#line 8615 "umockdev.c"
				}
			}
		}
	}
#line 1382 "../src/umockdev.vala"
	_tmp83_ = subsystem;
#line 1382 "../src/umockdev.vala"
	if (_tmp83_ == NULL) {
#line 8624 "umockdev.c"
		const gchar* _tmp84_;
		GError* _tmp85_;
#line 1383 "../src/umockdev.vala"
		_tmp84_ = devpath;
#line 1383 "../src/umockdev.vala"
		_tmp85_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_VALUE, "missing SUBSYSTEM property in description of device %s", _tmp84_);
#line 1383 "../src/umockdev.vala"
		_inner_error0_ = _tmp85_;
#line 1383 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1383 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1383 "../src/umockdev.vala"
			_g_free0 (selinux_context);
#line 1383 "../src/umockdev.vala"
			props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1383 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1383 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1383 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1383 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1383 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1383 "../src/umockdev.vala"
			_g_free0 (val);
#line 1383 "../src/umockdev.vala"
			_g_free0 (key);
#line 1383 "../src/umockdev.vala"
			return NULL;
#line 8667 "umockdev.c"
		} else {
#line 1383 "../src/umockdev.vala"
			_g_free0 (selinux_context);
#line 1383 "../src/umockdev.vala"
			props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1383 "../src/umockdev.vala"
			devnode_contents = (g_free (devnode_contents), NULL);
#line 1383 "../src/umockdev.vala"
			_g_free0 (devnode_path);
#line 1383 "../src/umockdev.vala"
			_g_free0 (cur_data);
#line 1383 "../src/umockdev.vala"
			_g_free0 (majmin);
#line 1383 "../src/umockdev.vala"
			_g_free0 (subsystem);
#line 1383 "../src/umockdev.vala"
			_g_free0 (devpath);
#line 1383 "../src/umockdev.vala"
			_g_free0 (val);
#line 1383 "../src/umockdev.vala"
			_g_free0 (key);
#line 1383 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1383 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1383 "../src/umockdev.vala"
			return NULL;
#line 8703 "umockdev.c"
		}
	}
#line 1385 "../src/umockdev.vala"
	_tmp86_ = devpath;
#line 1385 "../src/umockdev.vala"
	_tmp87_ = subsystem;
#line 1385 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1385: creating device %s (subsystem %s)", _tmp86_, _tmp87_);
#line 1386 "../src/umockdev.vala"
	_tmp88_ = subsystem;
#line 1386 "../src/umockdev.vala"
	_tmp89_ = devpath;
#line 1386 "../src/umockdev.vala"
	_tmp90_ = string_substring (_tmp89_, (glong) 9, (glong) -1);
#line 1386 "../src/umockdev.vala"
	_tmp91_ = _tmp90_;
#line 1386 "../src/umockdev.vala"
	_tmp92_ = attrs;
#line 1386 "../src/umockdev.vala"
	_tmp92__length1 = attrs_length1;
#line 1386 "../src/umockdev.vala"
	_tmp93_ = props;
#line 1386 "../src/umockdev.vala"
	_tmp93__length1 = props_length1;
#line 1386 "../src/umockdev.vala"
	_tmp94_ = umockdev_testbed_add_devicev_no_uevent (self, _tmp88_, _tmp91_, NULL, _tmp92_, _tmp93_);
#line 1386 "../src/umockdev.vala"
	_tmp95_ = _tmp94_;
#line 1386 "../src/umockdev.vala"
	_g_free0 (_tmp91_);
#line 1386 "../src/umockdev.vala"
	syspath = _tmp95_;
#line 8736 "umockdev.c"
	{
		gint i = 0;
#line 1391 "../src/umockdev.vala"
		i = 0;
#line 8741 "umockdev.c"
		{
			gboolean _tmp96_ = FALSE;
#line 1391 "../src/umockdev.vala"
			_tmp96_ = TRUE;
#line 1391 "../src/umockdev.vala"
			while (TRUE) {
#line 8748 "umockdev.c"
				gchar** _tmp97_;
				gint _tmp97__length1;
				guint8* _tmp98_ = NULL;
				gchar** _tmp99_;
				gint _tmp99__length1;
				const gchar* _tmp100_;
				gint _tmp101_ = 0;
				guint8* _tmp102_;
				gint _tmp98__length1;
				gint __tmp98__size_;
				const gchar* _tmp103_;
				gchar** _tmp104_;
				gint _tmp104__length1;
				const gchar* _tmp105_;
#line 1391 "../src/umockdev.vala"
				if (!_tmp96_) {
#line 1391 "../src/umockdev.vala"
					i += 2;
#line 8767 "umockdev.c"
				}
#line 1391 "../src/umockdev.vala"
				_tmp96_ = FALSE;
#line 1391 "../src/umockdev.vala"
				_tmp97_ = binattrs;
#line 1391 "../src/umockdev.vala"
				_tmp97__length1 = binattrs_length1;
#line 1391 "../src/umockdev.vala"
				if (!(i < _tmp97__length1)) {
#line 1391 "../src/umockdev.vala"
					break;
#line 8779 "umockdev.c"
				}
#line 1392 "../src/umockdev.vala"
				_tmp99_ = binattrs;
#line 1392 "../src/umockdev.vala"
				_tmp99__length1 = binattrs_length1;
#line 1392 "../src/umockdev.vala"
				_tmp100_ = _tmp99_[i + 1];
#line 1392 "../src/umockdev.vala"
				_tmp102_ = umockdev_decode_hex (_tmp100_, &_tmp101_, &_inner_error0_);
#line 1392 "../src/umockdev.vala"
				_tmp98_ = _tmp102_;
#line 1392 "../src/umockdev.vala"
				_tmp98__length1 = _tmp101_;
#line 1392 "../src/umockdev.vala"
				__tmp98__size_ = _tmp98__length1;
#line 1392 "../src/umockdev.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1392 "../src/umockdev.vala"
					if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1392 "../src/umockdev.vala"
						g_propagate_error (error, _inner_error0_);
#line 1392 "../src/umockdev.vala"
						_g_free0 (syspath);
#line 1392 "../src/umockdev.vala"
						_g_free0 (selinux_context);
#line 1392 "../src/umockdev.vala"
						props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						devnode_contents = (g_free (devnode_contents), NULL);
#line 1392 "../src/umockdev.vala"
						_g_free0 (devnode_path);
#line 1392 "../src/umockdev.vala"
						_g_free0 (cur_data);
#line 1392 "../src/umockdev.vala"
						_g_free0 (majmin);
#line 1392 "../src/umockdev.vala"
						_g_free0 (subsystem);
#line 1392 "../src/umockdev.vala"
						_g_free0 (devpath);
#line 1392 "../src/umockdev.vala"
						_g_free0 (val);
#line 1392 "../src/umockdev.vala"
						_g_free0 (key);
#line 1392 "../src/umockdev.vala"
						return NULL;
#line 8833 "umockdev.c"
					} else {
#line 1392 "../src/umockdev.vala"
						_g_free0 (syspath);
#line 1392 "../src/umockdev.vala"
						_g_free0 (selinux_context);
#line 1392 "../src/umockdev.vala"
						props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1392 "../src/umockdev.vala"
						devnode_contents = (g_free (devnode_contents), NULL);
#line 1392 "../src/umockdev.vala"
						_g_free0 (devnode_path);
#line 1392 "../src/umockdev.vala"
						_g_free0 (cur_data);
#line 1392 "../src/umockdev.vala"
						_g_free0 (majmin);
#line 1392 "../src/umockdev.vala"
						_g_free0 (subsystem);
#line 1392 "../src/umockdev.vala"
						_g_free0 (devpath);
#line 1392 "../src/umockdev.vala"
						_g_free0 (val);
#line 1392 "../src/umockdev.vala"
						_g_free0 (key);
#line 1392 "../src/umockdev.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1392 "../src/umockdev.vala"
						g_clear_error (&_inner_error0_);
#line 1392 "../src/umockdev.vala"
						return NULL;
#line 8871 "umockdev.c"
					}
				}
#line 1392 "../src/umockdev.vala"
				_tmp103_ = syspath;
#line 1392 "../src/umockdev.vala"
				_tmp104_ = binattrs;
#line 1392 "../src/umockdev.vala"
				_tmp104__length1 = binattrs_length1;
#line 1392 "../src/umockdev.vala"
				_tmp105_ = _tmp104_[i];
#line 1392 "../src/umockdev.vala"
				umockdev_testbed_set_attribute_binary (self, _tmp103_, _tmp105_, _tmp98_, (gint) _tmp98__length1);
#line 1391 "../src/umockdev.vala"
				_tmp98_ = (g_free (_tmp98_), NULL);
#line 8886 "umockdev.c"
			}
		}
	}
	{
		gint i = 0;
#line 1395 "../src/umockdev.vala"
		i = 0;
#line 8894 "umockdev.c"
		{
			gboolean _tmp106_ = FALSE;
#line 1395 "../src/umockdev.vala"
			_tmp106_ = TRUE;
#line 1395 "../src/umockdev.vala"
			while (TRUE) {
#line 8901 "umockdev.c"
				gchar** _tmp107_;
				gint _tmp107__length1;
				const gchar* _tmp108_;
				gchar** _tmp109_;
				gint _tmp109__length1;
				const gchar* _tmp110_;
				gchar** _tmp111_;
				gint _tmp111__length1;
				const gchar* _tmp112_;
#line 1395 "../src/umockdev.vala"
				if (!_tmp106_) {
#line 1395 "../src/umockdev.vala"
					i += 2;
#line 8915 "umockdev.c"
				}
#line 1395 "../src/umockdev.vala"
				_tmp106_ = FALSE;
#line 1395 "../src/umockdev.vala"
				_tmp107_ = linkattrs;
#line 1395 "../src/umockdev.vala"
				_tmp107__length1 = linkattrs_length1;
#line 1395 "../src/umockdev.vala"
				if (!(i < _tmp107__length1)) {
#line 1395 "../src/umockdev.vala"
					break;
#line 8927 "umockdev.c"
				}
#line 1396 "../src/umockdev.vala"
				_tmp108_ = syspath;
#line 1396 "../src/umockdev.vala"
				_tmp109_ = linkattrs;
#line 1396 "../src/umockdev.vala"
				_tmp109__length1 = linkattrs_length1;
#line 1396 "../src/umockdev.vala"
				_tmp110_ = _tmp109_[i];
#line 1396 "../src/umockdev.vala"
				_tmp111_ = linkattrs;
#line 1396 "../src/umockdev.vala"
				_tmp111__length1 = linkattrs_length1;
#line 1396 "../src/umockdev.vala"
				_tmp112_ = _tmp111_[i + 1];
#line 1396 "../src/umockdev.vala"
				umockdev_testbed_set_attribute_link (self, _tmp108_, _tmp110_, _tmp112_);
#line 8945 "umockdev.c"
			}
		}
	}
#line 1399 "../src/umockdev.vala"
	_tmp113_ = devnode_path;
#line 1399 "../src/umockdev.vala"
	if (_tmp113_ != NULL) {
#line 8953 "umockdev.c"
		const gchar* _tmp114_;
		const gchar* _tmp115_;
		guint8* _tmp116_;
		gint _tmp116__length1;
		const gchar* _tmp117_;
		const gchar* _tmp118_;
#line 1400 "../src/umockdev.vala"
		_tmp114_ = subsystem;
#line 1400 "../src/umockdev.vala"
		_tmp115_ = devnode_path;
#line 1400 "../src/umockdev.vala"
		_tmp116_ = devnode_contents;
#line 1400 "../src/umockdev.vala"
		_tmp116__length1 = devnode_contents_length1;
#line 1400 "../src/umockdev.vala"
		_tmp117_ = majmin;
#line 1400 "../src/umockdev.vala"
		_tmp118_ = selinux_context;
#line 1400 "../src/umockdev.vala"
		umockdev_testbed_create_node_for_device (self, _tmp114_, _tmp115_, _tmp116_, (gint) _tmp116__length1, _tmp117_, _tmp118_, &_inner_error0_);
#line 1400 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1400 "../src/umockdev.vala"
			if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1400 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 1400 "../src/umockdev.vala"
				_g_free0 (syspath);
#line 1400 "../src/umockdev.vala"
				_g_free0 (selinux_context);
#line 1400 "../src/umockdev.vala"
				props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				devnode_contents = (g_free (devnode_contents), NULL);
#line 1400 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1400 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 1400 "../src/umockdev.vala"
				_g_free0 (majmin);
#line 1400 "../src/umockdev.vala"
				_g_free0 (subsystem);
#line 1400 "../src/umockdev.vala"
				_g_free0 (devpath);
#line 1400 "../src/umockdev.vala"
				_g_free0 (val);
#line 1400 "../src/umockdev.vala"
				_g_free0 (key);
#line 1400 "../src/umockdev.vala"
				return NULL;
#line 9012 "umockdev.c"
			} else {
#line 1400 "../src/umockdev.vala"
				_g_free0 (syspath);
#line 1400 "../src/umockdev.vala"
				_g_free0 (selinux_context);
#line 1400 "../src/umockdev.vala"
				props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1400 "../src/umockdev.vala"
				devnode_contents = (g_free (devnode_contents), NULL);
#line 1400 "../src/umockdev.vala"
				_g_free0 (devnode_path);
#line 1400 "../src/umockdev.vala"
				_g_free0 (cur_data);
#line 1400 "../src/umockdev.vala"
				_g_free0 (majmin);
#line 1400 "../src/umockdev.vala"
				_g_free0 (subsystem);
#line 1400 "../src/umockdev.vala"
				_g_free0 (devpath);
#line 1400 "../src/umockdev.vala"
				_g_free0 (val);
#line 1400 "../src/umockdev.vala"
				_g_free0 (key);
#line 1400 "../src/umockdev.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1400 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 1400 "../src/umockdev.vala"
				return NULL;
#line 9050 "umockdev.c"
			}
		}
		{
			gint i = 0;
#line 1403 "../src/umockdev.vala"
			i = 0;
#line 9057 "umockdev.c"
			{
				gboolean _tmp119_ = FALSE;
#line 1403 "../src/umockdev.vala"
				_tmp119_ = TRUE;
#line 1403 "../src/umockdev.vala"
				while (TRUE) {
#line 9064 "umockdev.c"
					gchar** _tmp121_;
					gint _tmp121__length1;
					gchar** _tmp122_;
					gint _tmp122__length1;
					const gchar* _tmp123_;
					gchar* _tmp124_;
					gchar* _tmp125_;
					const gchar* _tmp126_;
					gchar** _tmp127_;
					gint _tmp127__length1;
					const gchar* _tmp128_;
#line 1403 "../src/umockdev.vala"
					if (!_tmp119_) {
#line 9078 "umockdev.c"
						gint _tmp120_;
#line 1403 "../src/umockdev.vala"
						_tmp120_ = i;
#line 1403 "../src/umockdev.vala"
						i = _tmp120_ + 1;
#line 9084 "umockdev.c"
					}
#line 1403 "../src/umockdev.vala"
					_tmp119_ = FALSE;
#line 1403 "../src/umockdev.vala"
					_tmp121_ = devnode_links;
#line 1403 "../src/umockdev.vala"
					_tmp121__length1 = devnode_links_length1;
#line 1403 "../src/umockdev.vala"
					if (!(i < _tmp121__length1)) {
#line 1403 "../src/umockdev.vala"
						break;
#line 9096 "umockdev.c"
					}
#line 1404 "../src/umockdev.vala"
					_tmp122_ = devnode_links;
#line 1404 "../src/umockdev.vala"
					_tmp122__length1 = devnode_links_length1;
#line 1404 "../src/umockdev.vala"
					_tmp123_ = _tmp122_[i];
#line 1404 "../src/umockdev.vala"
					_tmp124_ = g_path_get_dirname (_tmp123_);
#line 1404 "../src/umockdev.vala"
					_tmp125_ = _tmp124_;
#line 1404 "../src/umockdev.vala"
					umockdev_checked_mkdir_with_parents (_tmp125_, 0755);
#line 1404 "../src/umockdev.vala"
					_g_free0 (_tmp125_);
#line 1405 "../src/umockdev.vala"
					_tmp126_ = devnode_path;
#line 1405 "../src/umockdev.vala"
					_tmp127_ = devnode_links;
#line 1405 "../src/umockdev.vala"
					_tmp127__length1 = devnode_links_length1;
#line 1405 "../src/umockdev.vala"
					_tmp128_ = _tmp127_[i];
#line 1405 "../src/umockdev.vala"
					if (symlink (_tmp126_, _tmp128_) < 0) {
#line 9122 "umockdev.c"
						gchar** _tmp129_;
						gint _tmp129__length1;
						const gchar* _tmp130_;
						const gchar* _tmp131_;
						const gchar* _tmp132_;
#line 1406 "../src/umockdev.vala"
						_tmp129_ = devnode_links;
#line 1406 "../src/umockdev.vala"
						_tmp129__length1 = devnode_links_length1;
#line 1406 "../src/umockdev.vala"
						_tmp130_ = _tmp129_[i];
#line 1406 "../src/umockdev.vala"
						_tmp131_ = devnode_path;
#line 1406 "../src/umockdev.vala"
						_tmp132_ = devpath;
#line 1406 "../src/umockdev.vala"
						g_warning ("umockdev.vala:1406: failed to create %s -> %s symlink for device %s: %" \
"m", _tmp130_, _tmp131_, _tmp132_);
#line 9140 "umockdev.c"
					}
				}
			}
		}
	}
#line 1412 "../src/umockdev.vala"
	while (TRUE) {
#line 9148 "umockdev.c"
		gboolean _tmp133_ = FALSE;
		const gchar* _tmp134_;
		const gchar* _tmp136_;
		const gchar* _tmp137_;
		gchar* _tmp138_;
#line 1412 "../src/umockdev.vala"
		_tmp134_ = cur_data;
#line 1412 "../src/umockdev.vala"
		if (string_get (_tmp134_, (glong) 0) != '\0') {
#line 9158 "umockdev.c"
			const gchar* _tmp135_;
#line 1412 "../src/umockdev.vala"
			_tmp135_ = cur_data;
#line 1412 "../src/umockdev.vala"
			_tmp133_ = string_get (_tmp135_, (glong) 0) == '\n';
#line 9164 "umockdev.c"
		} else {
#line 1412 "../src/umockdev.vala"
			_tmp133_ = FALSE;
#line 9168 "umockdev.c"
		}
#line 1412 "../src/umockdev.vala"
		if (!_tmp133_) {
#line 1412 "../src/umockdev.vala"
			break;
#line 9174 "umockdev.c"
		}
#line 1413 "../src/umockdev.vala"
		_tmp136_ = cur_data;
#line 1413 "../src/umockdev.vala"
		_tmp137_ = g_utf8_next_char (_tmp136_);
#line 1413 "../src/umockdev.vala"
		_tmp138_ = g_strdup (_tmp137_);
#line 1413 "../src/umockdev.vala"
		_g_free0 (cur_data);
#line 1413 "../src/umockdev.vala"
		cur_data = _tmp138_;
#line 9186 "umockdev.c"
	}
#line 1415 "../src/umockdev.vala"
	if (umockdev_in_mock_environment ()) {
#line 9190 "umockdev.c"
		const gchar* _tmp139_;
#line 1416 "../src/umockdev.vala"
		_tmp139_ = syspath;
#line 1416 "../src/umockdev.vala"
		umockdev_testbed_uevent (self, _tmp139_, "add");
#line 9196 "umockdev.c"
	}
#line 1418 "../src/umockdev.vala"
	result = cur_data;
#line 1418 "../src/umockdev.vala"
	_g_free0 (syspath);
#line 1418 "../src/umockdev.vala"
	_g_free0 (selinux_context);
#line 1418 "../src/umockdev.vala"
	props = (_vala_array_free (props, props_length1, (GDestroyNotify) g_free), NULL);
#line 1418 "../src/umockdev.vala"
	linkattrs = (_vala_array_free (linkattrs, linkattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1418 "../src/umockdev.vala"
	binattrs = (_vala_array_free (binattrs, binattrs_length1, (GDestroyNotify) g_free), NULL);
#line 1418 "../src/umockdev.vala"
	attrs = (_vala_array_free (attrs, attrs_length1, (GDestroyNotify) g_free), NULL);
#line 1418 "../src/umockdev.vala"
	devnode_links = (_vala_array_free (devnode_links, devnode_links_length1, (GDestroyNotify) g_free), NULL);
#line 1418 "../src/umockdev.vala"
	devnode_contents = (g_free (devnode_contents), NULL);
#line 1418 "../src/umockdev.vala"
	_g_free0 (devnode_path);
#line 1418 "../src/umockdev.vala"
	_g_free0 (majmin);
#line 1418 "../src/umockdev.vala"
	_g_free0 (subsystem);
#line 1418 "../src/umockdev.vala"
	_g_free0 (devpath);
#line 1418 "../src/umockdev.vala"
	_g_free0 (val);
#line 1418 "../src/umockdev.vala"
	_g_free0 (key);
#line 1418 "../src/umockdev.vala"
	return result;
#line 9230 "umockdev.c"
}

static void
umockdev_testbed_create_node_for_device (UMockdevTestbed* self,
                                         const gchar* subsystem,
                                         const gchar* node_path,
                                         guint8* node_contents,
                                         gint node_contents_length1,
                                         const gchar* majmin,
                                         const gchar* selinux_context,
                                         GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint ptym = 0;
	gint ptys = 0;
	gchar* ptyname_array = NULL;
	gchar* _tmp5_;
	gint ptyname_array_length1;
	gint _ptyname_array_size_;
	gchar* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_;
	gchar* ptyname = NULL;
	gchar* _tmp10_;
	gint _tmp10__length1;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	struct termios ios = {0};
	struct termios _tmp13_ = {0};
	gint _tmp14_;
	struct termios _tmp15_;
	const gchar* _tmp16_;
	gchar* devname = NULL;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gchar* _tmp31_;
	GHashTable* _tmp32_;
	const gchar* _tmp33_;
	GHashTable* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	GError* _inner_error0_ = NULL;
#line 1421 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1421 "../src/umockdev.vala"
	g_return_if_fail (subsystem != NULL);
#line 1421 "../src/umockdev.vala"
	g_return_if_fail (node_path != NULL);
#line 1426 "../src/umockdev.vala"
	_tmp0_ = g_path_get_dirname (node_path);
#line 1426 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 1426 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp1_, 0755);
#line 1426 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 1429 "../src/umockdev.vala"
	if (node_contents_length1 > 0) {
#line 1429 "../src/umockdev.vala"
		_tmp3_ = TRUE;
#line 9297 "umockdev.c"
	} else {
#line 1429 "../src/umockdev.vala"
		_tmp3_ = g_strcmp0 (subsystem, "block") == 0;
#line 9301 "umockdev.c"
	}
#line 1429 "../src/umockdev.vala"
	if (_tmp3_) {
#line 1429 "../src/umockdev.vala"
		_tmp2_ = TRUE;
#line 9307 "umockdev.c"
	} else {
#line 1429 "../src/umockdev.vala"
		_tmp2_ = g_strcmp0 (subsystem, "usb") == 0;
#line 9311 "umockdev.c"
	}
#line 1429 "../src/umockdev.vala"
	if (_tmp2_) {
#line 9315 "umockdev.c"
		{
#line 1431 "../src/umockdev.vala"
			g_debug ("umockdev.vala:1431: create_node_for_device: creating file device %s", node_path);
#line 1432 "../src/umockdev.vala"
			g_file_set_contents (node_path, (const char*) node_contents, (gsize) node_contents_length1, &_inner_error0_);
#line 1432 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1432 "../src/umockdev.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 9325 "umockdev.c"
					goto __catch0_g_file_error;
				}
#line 1432 "../src/umockdev.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1432 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 1432 "../src/umockdev.vala"
				return;
#line 9334 "umockdev.c"
			}
#line 1435 "../src/umockdev.vala"
			if (g_strcmp0 (subsystem, "block") == 0) {
#line 1436 "../src/umockdev.vala"
				g_chmod (node_path, 01644);
#line 9340 "umockdev.c"
			}
		}
		goto __finally0;
		__catch0_g_file_error:
		{
			GError* e = NULL;
			const gchar* _tmp4_;
#line 1430 "../src/umockdev.vala"
			e = _inner_error0_;
#line 1430 "../src/umockdev.vala"
			_inner_error0_ = NULL;
#line 1438 "../src/umockdev.vala"
			_tmp4_ = e->message;
#line 1438 "../src/umockdev.vala"
			g_error ("umockdev.vala:1438: Cannot create dev node file: %s", _tmp4_);
#line 1430 "../src/umockdev.vala"
			_g_error_free0 (e);
#line 9358 "umockdev.c"
		}
		__finally0:
#line 1430 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1430 "../src/umockdev.vala"
			if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1430 "../src/umockdev.vala"
				g_propagate_error (error, _inner_error0_);
#line 1430 "../src/umockdev.vala"
				return;
#line 9369 "umockdev.c"
			} else {
#line 1430 "../src/umockdev.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1430 "../src/umockdev.vala"
				g_clear_error (&_inner_error0_);
#line 1430 "../src/umockdev.vala"
				return;
#line 9377 "umockdev.c"
			}
		}
#line 1441 "../src/umockdev.vala"
		umockdev_testbed_set_selinux_context (self, node_path, selinux_context);
#line 1442 "../src/umockdev.vala"
		return;
#line 9384 "umockdev.c"
	}
#line 1447 "../src/umockdev.vala"
	_tmp5_ = g_new0 (gchar, 8192);
#line 1447 "../src/umockdev.vala"
	ptyname_array = _tmp5_;
#line 1447 "../src/umockdev.vala"
	ptyname_array_length1 = 8192;
#line 1447 "../src/umockdev.vala"
	_ptyname_array_size_ = ptyname_array_length1;
#line 1448 "../src/umockdev.vala"
	_tmp6_ = ptyname_array;
#line 1448 "../src/umockdev.vala"
	_tmp6__length1 = ptyname_array_length1;
#line 1448 "../src/umockdev.vala"
	_tmp9_ = openpty (&_tmp7_, &_tmp8_, _tmp6_, NULL, NULL);
#line 1448 "../src/umockdev.vala"
	ptym = _tmp7_;
#line 1448 "../src/umockdev.vala"
	ptys = _tmp8_;
#line 1448 "../src/umockdev.vala"
	if (_tmp9_ < 0) {
#line 1449 "../src/umockdev.vala"
		g_error ("umockdev.vala:1449: umockdev Testbed.create_node_for_device: openpty()" \
" failed: %m");
#line 9408 "umockdev.c"
	}
#line 1450 "../src/umockdev.vala"
	_tmp10_ = ptyname_array;
#line 1450 "../src/umockdev.vala"
	_tmp10__length1 = ptyname_array_length1;
#line 1450 "../src/umockdev.vala"
	_tmp11_ = g_strdup ((const gchar*) _tmp10_);
#line 1450 "../src/umockdev.vala"
	ptyname = _tmp11_;
#line 1451 "../src/umockdev.vala"
	_tmp12_ = ptyname;
#line 1451 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1451: create_node_for_device: creating pty device %s: go" \
"t pty %s", node_path, _tmp12_);
#line 1452 "../src/umockdev.vala"
	close (ptys);
#line 1457 "../src/umockdev.vala"
	_tmp14_ = tcgetattr (ptym, &_tmp13_);
#line 1457 "../src/umockdev.vala"
	ios = _tmp13_;
#line 1457 "../src/umockdev.vala"
	_vala_assert (_tmp14_ == 0, "Posix.tcgetattr (ptym, out ios) == 0");
#line 1458 "../src/umockdev.vala"
	ios.c_iflag = ios.c_iflag & (~((IGNCR | INLCR) | ICRNL));
#line 1459 "../src/umockdev.vala"
	ios.c_oflag = ios.c_oflag & (~(ONLCR | OCRNL));
#line 1460 "../src/umockdev.vala"
	ios.c_lflag = ios.c_lflag & (~(ICANON | ECHO));
#line 1461 "../src/umockdev.vala"
	cfmakeraw (&ios);
#line 1462 "../src/umockdev.vala"
	_tmp15_ = ios;
#line 1462 "../src/umockdev.vala"
	_vala_assert (tcsetattr (ptym, TCSANOW, &_tmp15_) == 0, "Posix.tcsetattr (ptym, Posix.TCSANOW, ios) == 0");
#line 1464 "../src/umockdev.vala"
	_tmp16_ = ptyname;
#line 1464 "../src/umockdev.vala"
	_vala_assert (symlink (_tmp16_, node_path) == 0, "FileUtils.symlink (ptyname, node_path) == 0");
#line 1468 "../src/umockdev.vala"
	if (majmin != NULL) {
#line 9448 "umockdev.c"
		gchar* mapdir = NULL;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* dest = NULL;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
#line 1469 "../src/umockdev.vala"
		_tmp17_ = self->priv->root_dir;
#line 1469 "../src/umockdev.vala"
		_tmp18_ = g_build_filename (_tmp17_, "dev", ".ptymap", NULL);
#line 1469 "../src/umockdev.vala"
		mapdir = _tmp18_;
#line 1470 "../src/umockdev.vala"
		_tmp19_ = mapdir;
#line 1470 "../src/umockdev.vala"
		umockdev_checked_mkdir_with_parents (_tmp19_, 0755);
#line 1471 "../src/umockdev.vala"
		_tmp20_ = mapdir;
#line 1471 "../src/umockdev.vala"
		_tmp21_ = ptyname;
#line 1471 "../src/umockdev.vala"
		_tmp22_ = string_replace (_tmp21_, "/", "_");
#line 1471 "../src/umockdev.vala"
		_tmp23_ = _tmp22_;
#line 1471 "../src/umockdev.vala"
		_tmp24_ = g_build_filename (_tmp20_, _tmp23_, NULL);
#line 1471 "../src/umockdev.vala"
		_tmp25_ = _tmp24_;
#line 1471 "../src/umockdev.vala"
		_g_free0 (_tmp23_);
#line 1471 "../src/umockdev.vala"
		dest = _tmp25_;
#line 1472 "../src/umockdev.vala"
		_tmp26_ = dest;
#line 1472 "../src/umockdev.vala"
		g_debug ("umockdev.vala:1472: create_node_for_device: creating ptymap symlink %s", _tmp26_);
#line 1473 "../src/umockdev.vala"
		_tmp27_ = dest;
#line 1473 "../src/umockdev.vala"
		_vala_assert (symlink (majmin, _tmp27_) == 0, "FileUtils.symlink(majmin, dest) == 0");
#line 1468 "../src/umockdev.vala"
		_g_free0 (dest);
#line 1468 "../src/umockdev.vala"
		_g_free0 (mapdir);
#line 9500 "umockdev.c"
	}
#line 1477 "../src/umockdev.vala"
	_tmp28_ = self->priv->root_dir;
#line 1477 "../src/umockdev.vala"
	_tmp29_ = strlen (_tmp28_);
#line 1477 "../src/umockdev.vala"
	_tmp30_ = _tmp29_;
#line 1477 "../src/umockdev.vala"
	_tmp31_ = string_substring (node_path, (glong) _tmp30_, (glong) -1);
#line 1477 "../src/umockdev.vala"
	devname = _tmp31_;
#line 1478 "../src/umockdev.vala"
	_tmp32_ = self->priv->dev_fd;
#line 1478 "../src/umockdev.vala"
	_tmp33_ = devname;
#line 1478 "../src/umockdev.vala"
	_vala_assert (!g_hash_table_contains (_tmp32_, _tmp33_), "!this.dev_fd.contains (devname)");
#line 1479 "../src/umockdev.vala"
	_tmp34_ = self->priv->dev_fd;
#line 1479 "../src/umockdev.vala"
	_tmp35_ = devname;
#line 1479 "../src/umockdev.vala"
	_tmp36_ = g_strdup (_tmp35_);
#line 1479 "../src/umockdev.vala"
	g_hash_table_insert (_tmp34_, _tmp36_, (gpointer) ((gintptr) ptym));
#line 1481 "../src/umockdev.vala"
	umockdev_testbed_set_selinux_context (self, node_path, selinux_context);
#line 1421 "../src/umockdev.vala"
	_g_free0 (devname);
#line 1421 "../src/umockdev.vala"
	_g_free0 (ptyname);
#line 1421 "../src/umockdev.vala"
	ptyname_array = (g_free (ptyname_array), NULL);
#line 9534 "umockdev.c"
}

static void
umockdev_testbed_set_selinux_context (UMockdevTestbed* self,
                                      const gchar* path,
                                      const gchar* context)
{
#line 1484 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1484 "../src/umockdev.vala"
	g_return_if_fail (path != NULL);
#line 1487 "../src/umockdev.vala"
	if (context != NULL) {
#line 1489 "../src/umockdev.vala"
		if (lsetfilecon (path, context) < 0) {
#line 1490 "../src/umockdev.vala"
			g_debug ("umockdev.vala:1490: umockdev Testbed.create_node_for_device: setfileco" \
"n(%s, %s) failed: %m", path, context);
#line 9552 "umockdev.c"
		}
	}
}

/**
     * umockdev_testbed_record_parse_line:
     * @data: String to parse
     * @type: Pointer to a gchar which will get the line type (one of P, N,
     *        S, E, or H)
     * @key:  Pointer to a string which will get the key name; this will be
     *        set to %NULL for line types which do not have a key (P, N, S). You
     *        need to free this with g_free().
     * @value: Pointer to a string which will get the value. You need to
     *         free this with g_free().
     *
     * Parse one line from a device record file.
     *
     * Returns: Pointer to the next line start in @data, or %NULL if the first line
     * is not valid.
     */
static gchar*
umockdev_testbed_record_parse_line (UMockdevTestbed* self,
                                    const gchar* data,
                                    gchar* type,
                                    gchar** key,
                                    gchar** val)
{
	gchar _vala_type = '\0';
	gchar* _vala_key = NULL;
	gchar* _vala_val = NULL;
	GMatchInfo* match = NULL;
	GRegex* _tmp0_;
	GMatchInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
	gchar* type_str = NULL;
	GMatchInfo* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gint end_pos = 0;
	GMatchInfo* _tmp24_;
	gint _tmp25_ = 0;
	gboolean _tmp26_;
	gchar* _tmp27_;
	gchar* result;
#line 1511 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1511 "../src/umockdev.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 1515 "../src/umockdev.vala"
	_tmp0_ = self->priv->re_record_val;
#line 1515 "../src/umockdev.vala"
	_tmp2_ = g_regex_match (_tmp0_, data, 0, &_tmp1_);
#line 1515 "../src/umockdev.vala"
	_g_match_info_unref0 (match);
#line 1515 "../src/umockdev.vala"
	match = _tmp1_;
#line 1515 "../src/umockdev.vala"
	if (_tmp2_) {
#line 9612 "umockdev.c"
		GMatchInfo* _tmp3_;
		gchar* _tmp4_;
#line 1516 "../src/umockdev.vala"
		_g_free0 (_vala_key);
#line 1516 "../src/umockdev.vala"
		_vala_key = NULL;
#line 1517 "../src/umockdev.vala"
		_tmp3_ = match;
#line 1517 "../src/umockdev.vala"
		_tmp4_ = g_match_info_fetch (_tmp3_, 2);
#line 1517 "../src/umockdev.vala"
		_g_free0 (_vala_val);
#line 1517 "../src/umockdev.vala"
		_vala_val = _tmp4_;
#line 9627 "umockdev.c"
	} else {
		GRegex* _tmp5_;
		GMatchInfo* _tmp6_ = NULL;
		gboolean _tmp7_;
#line 1518 "../src/umockdev.vala"
		_tmp5_ = self->priv->re_record_keyval;
#line 1518 "../src/umockdev.vala"
		_tmp7_ = g_regex_match (_tmp5_, data, 0, &_tmp6_);
#line 1518 "../src/umockdev.vala"
		_g_match_info_unref0 (match);
#line 1518 "../src/umockdev.vala"
		match = _tmp6_;
#line 1518 "../src/umockdev.vala"
		if (_tmp7_) {
#line 9642 "umockdev.c"
			GMatchInfo* _tmp8_;
			gchar* _tmp9_;
			GMatchInfo* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
#line 1519 "../src/umockdev.vala"
			_tmp8_ = match;
#line 1519 "../src/umockdev.vala"
			_tmp9_ = g_match_info_fetch (_tmp8_, 2);
#line 1519 "../src/umockdev.vala"
			_g_free0 (_vala_key);
#line 1519 "../src/umockdev.vala"
			_vala_key = _tmp9_;
#line 1520 "../src/umockdev.vala"
			_tmp10_ = match;
#line 1520 "../src/umockdev.vala"
			_tmp11_ = g_match_info_fetch (_tmp10_, 3);
#line 1520 "../src/umockdev.vala"
			_g_free0 (_vala_val);
#line 1520 "../src/umockdev.vala"
			_vala_val = _tmp11_;
#line 1521 "../src/umockdev.vala"
			_tmp12_ = _vala_val;
#line 1521 "../src/umockdev.vala"
			_vala_assert (_tmp12_ != NULL, "val != null");
#line 9668 "umockdev.c"
		} else {
			GRegex* _tmp13_;
			GMatchInfo* _tmp14_ = NULL;
			gboolean _tmp15_;
#line 1522 "../src/umockdev.vala"
			_tmp13_ = self->priv->re_record_optval;
#line 1522 "../src/umockdev.vala"
			_tmp15_ = g_regex_match (_tmp13_, data, 0, &_tmp14_);
#line 1522 "../src/umockdev.vala"
			_g_match_info_unref0 (match);
#line 1522 "../src/umockdev.vala"
			match = _tmp14_;
#line 1522 "../src/umockdev.vala"
			if (_tmp15_) {
#line 9683 "umockdev.c"
				GMatchInfo* _tmp16_;
				gchar* _tmp17_;
				GMatchInfo* _tmp18_;
				gchar* _tmp19_;
#line 1523 "../src/umockdev.vala"
				_tmp16_ = match;
#line 1523 "../src/umockdev.vala"
				_tmp17_ = g_match_info_fetch (_tmp16_, 2);
#line 1523 "../src/umockdev.vala"
				_g_free0 (_vala_key);
#line 1523 "../src/umockdev.vala"
				_vala_key = _tmp17_;
#line 1524 "../src/umockdev.vala"
				_tmp18_ = match;
#line 1524 "../src/umockdev.vala"
				_tmp19_ = g_match_info_fetch (_tmp18_, 3);
#line 1524 "../src/umockdev.vala"
				_g_free0 (_vala_val);
#line 1524 "../src/umockdev.vala"
				_vala_val = _tmp19_;
#line 9704 "umockdev.c"
			} else {
#line 1526 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1526: record_parse_line: >%s< does not match anything, f" \
"ailing", data);
#line 1527 "../src/umockdev.vala"
				_vala_type = '\0';
#line 1528 "../src/umockdev.vala"
				_g_free0 (_vala_key);
#line 1528 "../src/umockdev.vala"
				_vala_key = NULL;
#line 1529 "../src/umockdev.vala"
				_g_free0 (_vala_val);
#line 1529 "../src/umockdev.vala"
				_vala_val = NULL;
#line 1530 "../src/umockdev.vala"
				result = NULL;
#line 1530 "../src/umockdev.vala"
				_g_match_info_unref0 (match);
#line 1530 "../src/umockdev.vala"
				if (type) {
#line 1530 "../src/umockdev.vala"
					*type = _vala_type;
#line 9726 "umockdev.c"
				}
#line 1530 "../src/umockdev.vala"
				if (key) {
#line 1530 "../src/umockdev.vala"
					*key = _vala_key;
#line 9732 "umockdev.c"
				} else {
#line 1530 "../src/umockdev.vala"
					_g_free0 (_vala_key);
#line 9736 "umockdev.c"
				}
#line 1530 "../src/umockdev.vala"
				if (val) {
#line 1530 "../src/umockdev.vala"
					*val = _vala_val;
#line 9742 "umockdev.c"
				} else {
#line 1530 "../src/umockdev.vala"
					_g_free0 (_vala_val);
#line 9746 "umockdev.c"
				}
#line 1530 "../src/umockdev.vala"
				return result;
#line 9750 "umockdev.c"
			}
		}
	}
#line 1533 "../src/umockdev.vala"
	_tmp20_ = match;
#line 1533 "../src/umockdev.vala"
	_tmp21_ = g_match_info_fetch (_tmp20_, 1);
#line 1533 "../src/umockdev.vala"
	type_str = _tmp21_;
#line 1534 "../src/umockdev.vala"
	_tmp22_ = type_str;
#line 1534 "../src/umockdev.vala"
	_vala_assert (_tmp22_ != NULL, "type_str != null");
#line 1535 "../src/umockdev.vala"
	_tmp23_ = type_str;
#line 1535 "../src/umockdev.vala"
	_vala_type = string_get (_tmp23_, (glong) 0);
#line 1538 "../src/umockdev.vala"
	_tmp24_ = match;
#line 1538 "../src/umockdev.vala"
	_tmp26_ = g_match_info_fetch_pos (_tmp24_, 0, NULL, &_tmp25_);
#line 1538 "../src/umockdev.vala"
	end_pos = _tmp25_;
#line 1538 "../src/umockdev.vala"
	_vala_assert (_tmp26_, "match.fetch_pos(0, null, out end_pos)");
#line 1539 "../src/umockdev.vala"
	_tmp27_ = string_substring (data, (glong) end_pos, (glong) -1);
#line 1539 "../src/umockdev.vala"
	result = _tmp27_;
#line 1539 "../src/umockdev.vala"
	_g_free0 (type_str);
#line 1539 "../src/umockdev.vala"
	_g_match_info_unref0 (match);
#line 1539 "../src/umockdev.vala"
	if (type) {
#line 1539 "../src/umockdev.vala"
		*type = _vala_type;
#line 9788 "umockdev.c"
	}
#line 1539 "../src/umockdev.vala"
	if (key) {
#line 1539 "../src/umockdev.vala"
		*key = _vala_key;
#line 9794 "umockdev.c"
	} else {
#line 1539 "../src/umockdev.vala"
		_g_free0 (_vala_key);
#line 9798 "umockdev.c"
	}
#line 1539 "../src/umockdev.vala"
	if (val) {
#line 1539 "../src/umockdev.vala"
		*val = _vala_val;
#line 9804 "umockdev.c"
	} else {
#line 1539 "../src/umockdev.vala"
		_g_free0 (_vala_val);
#line 9808 "umockdev.c"
	}
#line 1539 "../src/umockdev.vala"
	return result;
#line 9812 "umockdev.c"
}

/**
     * umockdev_testbed_disable:
     * @self: A #UMockdevTestbed.
     *
     * Disable the testbed.  This can be used for temporarily switching back to
     * the real /sys and /dev without having to destroy or change $UMOCKDEV_DIR
     * and the #UMockdevTestbed instance. Use @umockdev_testbed_enable() to
     * re-enable the testbed.
     */
void
umockdev_testbed_disable (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	FILE* _tmp3_;
	FILE* _tmp4_;
#line 1551 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1553 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 1553 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, "disabled", NULL);
#line 1553 "../src/umockdev.vala"
	_tmp2_ = _tmp1_;
#line 1553 "../src/umockdev.vala"
	_tmp3_ = g_fopen (_tmp2_, "w");
#line 1553 "../src/umockdev.vala"
	_tmp4_ = _tmp3_;
#line 1553 "../src/umockdev.vala"
	_fclose0 (_tmp4_);
#line 1553 "../src/umockdev.vala"
	_g_free0 (_tmp2_);
#line 9848 "umockdev.c"
}

/**
     * umockdev_testbed_enable:
     * @self: A #UMockdevTestbed.
     *
     * Re-enable the testbed after @@umockdev_testbed_disable().
     */
void
umockdev_testbed_enable (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 1562 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1564 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 1564 "../src/umockdev.vala"
	_tmp1_ = g_build_filename (_tmp0_, "disabled", NULL);
#line 1564 "../src/umockdev.vala"
	_tmp2_ = _tmp1_;
#line 1564 "../src/umockdev.vala"
	_tmp3_ = g_remove (_tmp2_) < 0;
#line 1564 "../src/umockdev.vala"
	_g_free0 (_tmp2_);
#line 1564 "../src/umockdev.vala"
	if (_tmp3_) {
#line 1565 "../src/umockdev.vala"
		g_debug ("umockdev.vala:1565: enable: failed to remove /disabled flag, ignoring:" \
" %m");
#line 9880 "umockdev.c"
	}
}

/**
     * umockdev_testbed_clear:
     * @self: A #UMockdevTestbed.
     *
     * Remove all added devices from testbed directory.  After that, the
     * umockdev root directory will be in the same state as directly after the
     * constructor.
     */
void
umockdev_testbed_clear (UMockdevTestbed* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1576 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1578 "../src/umockdev.vala"
	_tmp0_ = self->priv->root_dir;
#line 1578 "../src/umockdev.vala"
	umockdev_utils_remove_dir (_tmp0_, FALSE);
#line 1580 "../src/umockdev.vala"
	_tmp1_ = self->priv->sys_dir;
#line 1580 "../src/umockdev.vala"
	umockdev_checked_mkdir_with_parents (_tmp1_, 0755);
#line 9907 "umockdev.c"
}

/**
     * umockdev_testbed_get_dev_fd:
     * @self: A #UMockdevTestbed.
     * @devnode: Device node name ("/dev/...")
     *
     * Simulated devices without a pre-defined contents are backed by a
     * stream-like device node (PTY). Return the file descriptor
     * for accessing their "master" side, i. e. the end that gets
     * controlled by test suites. The tested program opens the "slave" side,
     * which is just openening the device specified by @devnode, e. g.
     * /dev/ttyUSB2. Once that happened, your test can directly communicate
     * with the tested program over that descriptor.
     *
     * Returns: File descriptor for communicating with clients that connect to
     *           @devnode, or -1 if @devnode does not exist or is not a
     *           simulated stream device. This must not be closed!
     */
gint
umockdev_testbed_get_dev_fd (UMockdevTestbed* self,
                             const gchar* devnode)
{
	GHashTable* _tmp0_;
	gint result;
#line 1600 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1600 "../src/umockdev.vala"
	g_return_val_if_fail (devnode != NULL, 0);
#line 1604 "../src/umockdev.vala"
	_tmp0_ = self->priv->dev_fd;
#line 1604 "../src/umockdev.vala"
	if (g_hash_table_contains (_tmp0_, devnode)) {
#line 9941 "umockdev.c"
		GHashTable* _tmp1_;
		gconstpointer _tmp2_;
#line 1605 "../src/umockdev.vala"
		_tmp1_ = self->priv->dev_fd;
#line 1605 "../src/umockdev.vala"
		_tmp2_ = g_hash_table_lookup (_tmp1_, devnode);
#line 1605 "../src/umockdev.vala"
		result = (gint) ((gintptr) _tmp2_);
#line 1605 "../src/umockdev.vala"
		return result;
#line 9952 "umockdev.c"
	} else {
#line 1607 "../src/umockdev.vala"
		result = -1;
#line 1607 "../src/umockdev.vala"
		return result;
#line 9958 "umockdev.c"
	}
}

static void
umockdev_testbed_class_init (UMockdevTestbedClass * klass,
                             gpointer klass_data)
{
#line 86 "../src/umockdev.vala"
	umockdev_testbed_parent_class = g_type_class_peek_parent (klass);
#line 86 "../src/umockdev.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevTestbed_private_offset);
#line 86 "../src/umockdev.vala"
	G_OBJECT_CLASS (klass)->finalize = umockdev_testbed_finalize;
#line 9972 "umockdev.c"
}

static void
umockdev_testbed_instance_init (UMockdevTestbed * self,
                                gpointer klass)
{
#line 86 "../src/umockdev.vala"
	self->priv = umockdev_testbed_get_instance_private (self);
#line 1615 "../src/umockdev.vala"
	self->priv->ev_sender = NULL;
#line 1618 "../src/umockdev.vala"
	self->priv->socket_server = NULL;
#line 9985 "umockdev.c"
}

static void
umockdev_testbed_finalize (GObject * obj)
{
	UMockdevTestbed * self;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	UMockdevSocketServer* _tmp6_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GMainLoop* _tmp10_;
#line 86 "../src/umockdev.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_TESTBED, UMockdevTestbed);
#line 133 "../src/umockdev.vala"
	_tmp0_ = self->priv->dev_script_runner;
#line 133 "../src/umockdev.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 10007 "umockdev.c"
	{
		GList* r_collection = NULL;
		GList* r_it = NULL;
#line 133 "../src/umockdev.vala"
		r_collection = _tmp1_;
#line 133 "../src/umockdev.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 10015 "umockdev.c"
			UMockdevScriptRunner* r = NULL;
#line 133 "../src/umockdev.vala"
			r = (UMockdevScriptRunner*) r_it->data;
#line 10019 "umockdev.c"
			{
				UMockdevScriptRunner* _tmp2_;
#line 134 "../src/umockdev.vala"
				_tmp2_ = r;
#line 134 "../src/umockdev.vala"
				umockdev_script_runner_stop (_tmp2_);
#line 10026 "umockdev.c"
			}
		}
#line 133 "../src/umockdev.vala"
		(r_collection == NULL) ? NULL : (r_collection = (g_list_free (r_collection), NULL));
#line 10031 "umockdev.c"
	}
#line 135 "../src/umockdev.vala"
	_tmp3_ = self->priv->dev_script_runner;
#line 135 "../src/umockdev.vala"
	g_hash_table_remove_all (_tmp3_);
#line 137 "../src/umockdev.vala"
	_tmp4_ = self->priv->custom_handlers;
#line 137 "../src/umockdev.vala"
	g_hash_table_foreach (_tmp4_, __umockdev_testbed___lambda5__gh_func, self);
#line 140 "../src/umockdev.vala"
	_tmp5_ = self->priv->custom_handlers;
#line 140 "../src/umockdev.vala"
	g_hash_table_remove_all (_tmp5_);
#line 148 "../src/umockdev.vala"
	_tmp6_ = self->priv->socket_server;
#line 148 "../src/umockdev.vala"
	if (_tmp6_ != NULL) {
#line 10049 "umockdev.c"
		UMockdevSocketServer* _tmp7_;
#line 149 "../src/umockdev.vala"
		g_debug ("umockdev.vala:149: shutting down socket server thread");
#line 150 "../src/umockdev.vala"
		_tmp7_ = self->priv->socket_server;
#line 150 "../src/umockdev.vala"
		umockdev_socket_server_stop (_tmp7_);
#line 151 "../src/umockdev.vala"
		_umockdev_socket_server_unref0 (self->priv->socket_server);
#line 151 "../src/umockdev.vala"
		self->priv->socket_server = NULL;
#line 10061 "umockdev.c"
	}
#line 154 "../src/umockdev.vala"
	_tmp8_ = self->priv->root_dir;
#line 154 "../src/umockdev.vala"
	g_debug ("umockdev.vala:154: Removing test bed %s", _tmp8_);
#line 155 "../src/umockdev.vala"
	_tmp9_ = self->priv->root_dir;
#line 155 "../src/umockdev.vala"
	umockdev_utils_remove_dir (_tmp9_, TRUE);
#line 156 "../src/umockdev.vala"
	_tmp10_ = self->priv->worker_loop;
#line 156 "../src/umockdev.vala"
	g_main_loop_quit (_tmp10_);
#line 157 "../src/umockdev.vala"
	g_unsetenv ("UMOCKDEV_DIR");
#line 1610 "../src/umockdev.vala"
	_g_free0 (self->priv->root_dir);
#line 1611 "../src/umockdev.vala"
	_g_free0 (self->priv->sys_dir);
#line 1612 "../src/umockdev.vala"
	_g_regex_unref0 (self->priv->re_record_val);
#line 1613 "../src/umockdev.vala"
	_g_regex_unref0 (self->priv->re_record_keyval);
#line 1614 "../src/umockdev.vala"
	_g_regex_unref0 (self->priv->re_record_optval);
#line 1615 "../src/umockdev.vala"
	_uevent_sender_close0 (self->priv->ev_sender);
#line 1616 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->dev_fd);
#line 1617 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->dev_script_runner);
#line 1618 "../src/umockdev.vala"
	_umockdev_socket_server_unref0 (self->priv->socket_server);
#line 1620 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->custom_handlers);
#line 1622 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->worker_thread);
#line 1623 "../src/umockdev.vala"
	_g_main_context_unref0 (self->priv->worker_ctx);
#line 1624 "../src/umockdev.vala"
	_g_main_loop_unref0 (self->priv->worker_loop);
#line 86 "../src/umockdev.vala"
	G_OBJECT_CLASS (umockdev_testbed_parent_class)->finalize (obj);
#line 10105 "umockdev.c"
}

static GType
umockdev_testbed_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevTestbedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_testbed_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevTestbed), 0, (GInstanceInitFunc) umockdev_testbed_instance_init, NULL };
	GType umockdev_testbed_type_id;
	umockdev_testbed_type_id = g_type_register_static (G_TYPE_OBJECT, "UMockdevTestbed", &g_define_type_info, 0);
	UMockdevTestbed_private_offset = g_type_add_instance_private (umockdev_testbed_type_id, sizeof (UMockdevTestbedPrivate));
	return umockdev_testbed_type_id;
}

GType
umockdev_testbed_get_type (void)
{
	static volatile gsize umockdev_testbed_type_id__once = 0;
	if (g_once_init_enter (&umockdev_testbed_type_id__once)) {
		GType umockdev_testbed_type_id;
		umockdev_testbed_type_id = umockdev_testbed_get_type_once ();
		g_once_init_leave (&umockdev_testbed_type_id__once, umockdev_testbed_type_id);
	}
	return umockdev_testbed_type_id__once;
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 10149 "umockdev.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 10157 "umockdev.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 10163 "umockdev.c"
	}
}

gchar*
umockdev_make_dotdots (const gchar* path)
{
	gint offset = 0;
	guint count = 0U;
	gchar* dots = NULL;
	gchar* _tmp2_;
	gchar* result;
#line 1628 "../src/umockdev.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 1631 "../src/umockdev.vala"
	offset = 0;
#line 1632 "../src/umockdev.vala"
	count = (guint) 0;
#line 1635 "../src/umockdev.vala"
	while (TRUE) {
#line 10183 "umockdev.c"
		guint _tmp0_;
		gint _tmp1_;
#line 1635 "../src/umockdev.vala"
		offset = string_index_of_char (path, (gunichar) '/', offset);
#line 1635 "../src/umockdev.vala"
		if (!(offset >= 0)) {
#line 1635 "../src/umockdev.vala"
			break;
#line 10192 "umockdev.c"
		}
#line 1636 "../src/umockdev.vala"
		count = count + 1;
#line 1636 "../src/umockdev.vala"
		_tmp0_ = count;
#line 1637 "../src/umockdev.vala"
		offset = offset + 1;
#line 1637 "../src/umockdev.vala"
		_tmp1_ = offset;
#line 10202 "umockdev.c"
	}
#line 1641 "../src/umockdev.vala"
	_tmp2_ = g_strdup ("");
#line 1641 "../src/umockdev.vala"
	dots = _tmp2_;
#line 1642 "../src/umockdev.vala"
	while (TRUE) {
#line 10210 "umockdev.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		guint _tmp5_;
#line 1642 "../src/umockdev.vala"
		if (!(count > ((guint) 1))) {
#line 1642 "../src/umockdev.vala"
			break;
#line 10218 "umockdev.c"
		}
#line 1643 "../src/umockdev.vala"
		_tmp3_ = dots;
#line 1643 "../src/umockdev.vala"
		_tmp4_ = g_strconcat (_tmp3_, "../", NULL);
#line 1643 "../src/umockdev.vala"
		_g_free0 (dots);
#line 1643 "../src/umockdev.vala"
		dots = _tmp4_;
#line 1644 "../src/umockdev.vala"
		count = count - 1;
#line 1644 "../src/umockdev.vala"
		_tmp5_ = count;
#line 10232 "umockdev.c"
	}
#line 1646 "../src/umockdev.vala"
	result = dots;
#line 1646 "../src/umockdev.vala"
	return result;
#line 10238 "umockdev.c"
}

guint8
umockdev_hexdigit (gchar c)
{
	gint _tmp0_ = 0;
	guint8 result;
#line 1652 "../src/umockdev.vala"
	if (c >= 'a') {
#line 1652 "../src/umockdev.vala"
		_tmp0_ = (c - 'a') + 10;
#line 10250 "umockdev.c"
	} else {
		gint _tmp1_ = 0;
#line 1653 "../src/umockdev.vala"
		if (c >= 'A') {
#line 1653 "../src/umockdev.vala"
			_tmp1_ = (c - 'A') + 10;
#line 10257 "umockdev.c"
		} else {
#line 1654 "../src/umockdev.vala"
			_tmp1_ = (gint) (c - '0');
#line 10261 "umockdev.c"
		}
#line 1653 "../src/umockdev.vala"
		_tmp0_ = _tmp1_;
#line 10265 "umockdev.c"
	}
#line 1652 "../src/umockdev.vala"
	result = (guint8) _tmp0_;
#line 1652 "../src/umockdev.vala"
	return result;
#line 10271 "umockdev.c"
}

guint8*
umockdev_decode_hex (const gchar* data,
                     gint* result_length1,
                     GError** error)
{
	gint _tmp0_;
	gint _tmp1_;
	gint len = 0;
	gint _tmp3_;
	gint _tmp4_;
	guint8* bin = NULL;
	guint8* _tmp5_;
	gint bin_length1;
	gint _bin_size_;
	guint8* _tmp10_;
	gint _tmp10__length1;
	GError* _inner_error0_ = NULL;
	guint8* result;
#line 1657 "../src/umockdev.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 1661 "../src/umockdev.vala"
	_tmp0_ = strlen (data);
#line 1661 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 1661 "../src/umockdev.vala"
	if ((_tmp1_ % 2) != 0) {
#line 10300 "umockdev.c"
		GError* _tmp2_;
#line 1662 "../src/umockdev.vala"
		_tmp2_ = g_error_new (UMOCKDEV_ERROR, UMOCKDEV_ERROR_PARSE, "malformed hexadecimal value: %s", data);
#line 1662 "../src/umockdev.vala"
		_inner_error0_ = _tmp2_;
#line 1662 "../src/umockdev.vala"
		if (_inner_error0_->domain == UMOCKDEV_ERROR) {
#line 1662 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1662 "../src/umockdev.vala"
			return NULL;
#line 10312 "umockdev.c"
		} else {
#line 1662 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1662 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1662 "../src/umockdev.vala"
			return NULL;
#line 10320 "umockdev.c"
		}
	}
#line 1663 "../src/umockdev.vala"
	_tmp3_ = strlen (data);
#line 1663 "../src/umockdev.vala"
	_tmp4_ = _tmp3_;
#line 1663 "../src/umockdev.vala"
	len = _tmp4_;
#line 1664 "../src/umockdev.vala"
	_tmp5_ = g_new0 (guint8, len / 2);
#line 1664 "../src/umockdev.vala"
	bin = _tmp5_;
#line 1664 "../src/umockdev.vala"
	bin_length1 = len / 2;
#line 1664 "../src/umockdev.vala"
	_bin_size_ = bin_length1;
#line 10337 "umockdev.c"
	{
		guint i = 0U;
#line 1666 "../src/umockdev.vala"
		i = (guint) 0;
#line 10342 "umockdev.c"
		{
			gboolean _tmp6_ = FALSE;
#line 1666 "../src/umockdev.vala"
			_tmp6_ = TRUE;
#line 1666 "../src/umockdev.vala"
			while (TRUE) {
#line 10349 "umockdev.c"
				guint8* _tmp8_;
				gint _tmp8__length1;
				guint8* _tmp9_;
				gint _tmp9__length1;
#line 1666 "../src/umockdev.vala"
				if (!_tmp6_) {
#line 10356 "umockdev.c"
					guint _tmp7_;
#line 1666 "../src/umockdev.vala"
					i = i + 1;
#line 1666 "../src/umockdev.vala"
					_tmp7_ = i;
#line 10362 "umockdev.c"
				}
#line 1666 "../src/umockdev.vala"
				_tmp6_ = FALSE;
#line 1666 "../src/umockdev.vala"
				_tmp8_ = bin;
#line 1666 "../src/umockdev.vala"
				_tmp8__length1 = bin_length1;
#line 1666 "../src/umockdev.vala"
				if (!(i < ((guint) _tmp8__length1))) {
#line 1666 "../src/umockdev.vala"
					break;
#line 10374 "umockdev.c"
				}
#line 1667 "../src/umockdev.vala"
				_tmp9_ = bin;
#line 1667 "../src/umockdev.vala"
				_tmp9__length1 = bin_length1;
#line 1667 "../src/umockdev.vala"
				_tmp9_[i] = (guint8) ((umockdev_hexdigit (string_get (data, (glong) (i * 2))) << 4) | umockdev_hexdigit (string_get (data, (glong) ((i * 2) + 1))));
#line 10382 "umockdev.c"
			}
		}
	}
#line 1669 "../src/umockdev.vala"
	_tmp10_ = bin;
#line 1669 "../src/umockdev.vala"
	_tmp10__length1 = bin_length1;
#line 1669 "../src/umockdev.vala"
	if (result_length1) {
#line 1669 "../src/umockdev.vala"
		*result_length1 = _tmp10__length1;
#line 10394 "umockdev.c"
	}
#line 1669 "../src/umockdev.vala"
	result = _tmp10_;
#line 1669 "../src/umockdev.vala"
	return result;
#line 10400 "umockdev.c"
}

gchar*
umockdev_find_devnode (const gchar* devpath)
{
	gchar* devname = NULL;
	GFile* f = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1672 "../src/umockdev.vala"
	g_return_val_if_fail (devpath != NULL, NULL);
#line 1675 "../src/umockdev.vala"
	devname = NULL;
#line 1678 "../src/umockdev.vala"
	_tmp0_ = g_build_filename (devpath, "uevent", NULL);
#line 1678 "../src/umockdev.vala"
	_tmp1_ = _tmp0_;
#line 1678 "../src/umockdev.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 1678 "../src/umockdev.vala"
	_tmp3_ = _tmp2_;
#line 1678 "../src/umockdev.vala"
	_g_free0 (_tmp1_);
#line 1678 "../src/umockdev.vala"
	f = _tmp3_;
#line 10430 "umockdev.c"
	{
		GFileInputStream* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFileInputStream* _tmp6_;
		GDataInputStream* inp = NULL;
		GDataInputStream* _tmp7_;
		gchar* line = NULL;
		gsize len = 0UL;
		GDataInputStream* _tmp20_;
#line 1680 "../src/umockdev.vala"
		_tmp5_ = f;
#line 1680 "../src/umockdev.vala"
		_tmp6_ = g_file_read (_tmp5_, NULL, &_inner_error0_);
#line 1680 "../src/umockdev.vala"
		_tmp4_ = _tmp6_;
#line 1680 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10448 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1680 "../src/umockdev.vala"
		_tmp7_ = g_data_input_stream_new ((GInputStream*) _tmp4_);
#line 1680 "../src/umockdev.vala"
		inp = _tmp7_;
#line 1683 "../src/umockdev.vala"
		while (TRUE) {
#line 10457 "umockdev.c"
			gchar* _tmp8_ = NULL;
			GDataInputStream* _tmp9_;
			gsize _tmp10_ = 0UL;
			gchar* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 1683 "../src/umockdev.vala"
			_tmp9_ = inp;
#line 1683 "../src/umockdev.vala"
			_tmp11_ = g_data_input_stream_read_line (_tmp9_, &_tmp10_, NULL, &_inner_error0_);
#line 1683 "../src/umockdev.vala"
			len = _tmp10_;
#line 1683 "../src/umockdev.vala"
			_tmp8_ = _tmp11_;
#line 1683 "../src/umockdev.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1683 "../src/umockdev.vala"
				_g_free0 (line);
#line 1683 "../src/umockdev.vala"
				_g_object_unref0 (inp);
#line 1683 "../src/umockdev.vala"
				_g_object_unref0 (_tmp4_);
#line 10481 "umockdev.c"
				goto __catch0_g_error;
			}
#line 1683 "../src/umockdev.vala"
			_tmp12_ = _tmp8_;
#line 1683 "../src/umockdev.vala"
			_tmp8_ = NULL;
#line 1683 "../src/umockdev.vala"
			_g_free0 (line);
#line 1683 "../src/umockdev.vala"
			line = _tmp12_;
#line 1683 "../src/umockdev.vala"
			_tmp13_ = line;
#line 1683 "../src/umockdev.vala"
			if (!(_tmp13_ != NULL)) {
#line 1683 "../src/umockdev.vala"
				_g_free0 (_tmp8_);
#line 1683 "../src/umockdev.vala"
				break;
#line 10500 "umockdev.c"
			}
#line 1684 "../src/umockdev.vala"
			_tmp14_ = line;
#line 1684 "../src/umockdev.vala"
			if (g_str_has_prefix (_tmp14_, "DEVNAME=")) {
#line 10506 "umockdev.c"
				const gchar* _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
#line 1685 "../src/umockdev.vala"
				_tmp15_ = line;
#line 1685 "../src/umockdev.vala"
				_tmp16_ = string_substring (_tmp15_, (glong) 8, (glong) -1);
#line 1685 "../src/umockdev.vala"
				_g_free0 (devname);
#line 1685 "../src/umockdev.vala"
				devname = _tmp16_;
#line 1686 "../src/umockdev.vala"
				_tmp17_ = devname;
#line 1686 "../src/umockdev.vala"
				if (!g_str_has_prefix (_tmp17_, "/dev/")) {
#line 10522 "umockdev.c"
					const gchar* _tmp18_;
					gchar* _tmp19_;
#line 1687 "../src/umockdev.vala"
					_tmp18_ = devname;
#line 1687 "../src/umockdev.vala"
					_tmp19_ = g_strconcat ("/dev/", _tmp18_, NULL);
#line 1687 "../src/umockdev.vala"
					_g_free0 (devname);
#line 1687 "../src/umockdev.vala"
					devname = _tmp19_;
#line 10533 "umockdev.c"
				}
#line 1688 "../src/umockdev.vala"
				_g_free0 (_tmp8_);
#line 1688 "../src/umockdev.vala"
				break;
#line 10539 "umockdev.c"
			}
#line 1683 "../src/umockdev.vala"
			_g_free0 (_tmp8_);
#line 10543 "umockdev.c"
		}
#line 1691 "../src/umockdev.vala"
		_tmp20_ = inp;
#line 1691 "../src/umockdev.vala"
		g_input_stream_close ((GInputStream*) _tmp20_, NULL, &_inner_error0_);
#line 1691 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1691 "../src/umockdev.vala"
			_g_free0 (line);
#line 1691 "../src/umockdev.vala"
			_g_object_unref0 (inp);
#line 1691 "../src/umockdev.vala"
			_g_object_unref0 (_tmp4_);
#line 10557 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1679 "../src/umockdev.vala"
		_g_free0 (line);
#line 1679 "../src/umockdev.vala"
		_g_object_unref0 (inp);
#line 1679 "../src/umockdev.vala"
		_g_object_unref0 (_tmp4_);
#line 10566 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 1679 "../src/umockdev.vala"
		e = _inner_error0_;
#line 1679 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 1693 "../src/umockdev.vala"
		_tmp21_ = e;
#line 1693 "../src/umockdev.vala"
		_tmp22_ = _tmp21_->message;
#line 1693 "../src/umockdev.vala"
		g_warning ("umockdev.vala:1693: Cannot read uevent file: %s\n", _tmp22_);
#line 1679 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 10586 "umockdev.c"
	}
	__finally0:
#line 1679 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1679 "../src/umockdev.vala"
		_g_object_unref0 (f);
#line 1679 "../src/umockdev.vala"
		_g_free0 (devname);
#line 1679 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1679 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 1679 "../src/umockdev.vala"
		return NULL;
#line 10601 "umockdev.c"
	}
#line 1695 "../src/umockdev.vala"
	result = devname;
#line 1695 "../src/umockdev.vala"
	_g_object_unref0 (f);
#line 1695 "../src/umockdev.vala"
	return result;
#line 10609 "umockdev.c"
}

static inline gpointer
umockdev_script_runner_get_instance_private (UMockdevScriptRunner* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevScriptRunner_private_offset);
}

static gpointer
_umockdev_script_runner_run_gthread_func (gpointer self)
{
	gpointer result;
	result = umockdev_script_runner_run ((UMockdevScriptRunner*) self);
#line 1711 "../src/umockdev.vala"
	umockdev_script_runner_unref (self);
#line 1711 "../src/umockdev.vala"
	return result;
#line 10627 "umockdev.c"
}

UMockdevScriptRunner*
umockdev_script_runner_construct (GType object_type,
                                  const gchar* device,
                                  const gchar* script_file,
                                  gint fd,
                                  GError** error)
{
	UMockdevScriptRunner* self = NULL;
	FILE* _tmp0_;
	FILE* _tmp1_;
	gchar* _tmp6_;
	GThread* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 1700 "../src/umockdev.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 1700 "../src/umockdev.vala"
	g_return_val_if_fail (script_file != NULL, NULL);
#line 1700 "../src/umockdev.vala"
	self = (UMockdevScriptRunner*) g_type_create_instance (object_type);
#line 1702 "../src/umockdev.vala"
	_tmp0_ = g_fopen (script_file, "r");
#line 1702 "../src/umockdev.vala"
	_fclose0 (self->priv->script);
#line 1702 "../src/umockdev.vala"
	self->priv->script = _tmp0_;
#line 1703 "../src/umockdev.vala"
	_tmp1_ = self->priv->script;
#line 1703 "../src/umockdev.vala"
	if (_tmp1_ == NULL) {
#line 10659 "umockdev.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 1704 "../src/umockdev.vala"
		_tmp2_ = g_strconcat ("Cannot open script record file ", script_file, NULL);
#line 1704 "../src/umockdev.vala"
		_tmp3_ = _tmp2_;
#line 1704 "../src/umockdev.vala"
		_tmp4_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp3_);
#line 1704 "../src/umockdev.vala"
		_tmp5_ = _tmp4_;
#line 1704 "../src/umockdev.vala"
		_g_free0 (_tmp3_);
#line 1704 "../src/umockdev.vala"
		_inner_error0_ = _tmp5_;
#line 1704 "../src/umockdev.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1704 "../src/umockdev.vala"
			g_propagate_error (error, _inner_error0_);
#line 1704 "../src/umockdev.vala"
			_umockdev_script_runner_unref0 (self);
#line 1704 "../src/umockdev.vala"
			return NULL;
#line 10684 "umockdev.c"
		} else {
#line 1704 "../src/umockdev.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1704 "../src/umockdev.vala"
			g_clear_error (&_inner_error0_);
#line 1704 "../src/umockdev.vala"
			return NULL;
#line 10692 "umockdev.c"
		}
	}
#line 1706 "../src/umockdev.vala"
	umockdev_script_runner_set_device (self, device);
#line 1707 "../src/umockdev.vala"
	_tmp6_ = g_strdup (script_file);
#line 1707 "../src/umockdev.vala"
	_g_free0 (self->priv->script_file);
#line 1707 "../src/umockdev.vala"
	self->priv->script_file = _tmp6_;
#line 1708 "../src/umockdev.vala"
	self->priv->fd = fd;
#line 1709 "../src/umockdev.vala"
	self->priv->running = TRUE;
#line 1711 "../src/umockdev.vala"
	_tmp7_ = g_thread_new (device, _umockdev_script_runner_run_gthread_func, umockdev_script_runner_ref (self));
#line 1711 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->thread);
#line 1711 "../src/umockdev.vala"
	self->priv->thread = _tmp7_;
#line 1700 "../src/umockdev.vala"
	return self;
#line 10715 "umockdev.c"
}

UMockdevScriptRunner*
umockdev_script_runner_new (const gchar* device,
                            const gchar* script_file,
                            gint fd,
                            GError** error)
{
#line 1700 "../src/umockdev.vala"
	return umockdev_script_runner_construct (UMOCKDEV_TYPE_SCRIPT_RUNNER, device, script_file, fd, error);
#line 10726 "umockdev.c"
}

void
umockdev_script_runner_stop (UMockdevScriptRunner* self)
{
	const gchar* _tmp0_;
	GThread* _tmp1_;
#line 1719 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1721 "../src/umockdev.vala"
	if (!self->priv->running) {
#line 1722 "../src/umockdev.vala"
		return;
#line 10740 "umockdev.c"
	}
#line 1724 "../src/umockdev.vala"
	_tmp0_ = self->priv->_device;
#line 1724 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1724: Stopping script runner for %s: joining thread", _tmp0_);
#line 1725 "../src/umockdev.vala"
	self->priv->running = FALSE;
#line 1726 "../src/umockdev.vala"
	_tmp1_ = self->priv->thread;
#line 1726 "../src/umockdev.vala"
	self->priv->thread = NULL;
#line 1726 "../src/umockdev.vala"
	g_thread_join (_tmp1_);
#line 10754 "umockdev.c"
}

static void*
umockdev_script_runner_run (UMockdevScriptRunner* self)
{
	gchar op = '\0';
	guint32 delta = 0U;
	guint8* data = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	const gchar* _tmp0_;
	const gchar* _tmp22_;
	void* result;
#line 1729 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1735 "../src/umockdev.vala"
	_tmp0_ = self->priv->_device;
#line 1735 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1735: ScriptRunner[%s]: start", _tmp0_);
#line 1737 "../src/umockdev.vala"
	while (TRUE) {
#line 10776 "umockdev.c"
		gchar _tmp1_ = '\0';
		guint32 _tmp2_ = 0U;
		gint _tmp3_ = 0;
		guint8* _tmp4_;
#line 1737 "../src/umockdev.vala"
		if (!self->priv->running) {
#line 1737 "../src/umockdev.vala"
			break;
#line 10785 "umockdev.c"
		}
#line 1738 "../src/umockdev.vala"
		_tmp4_ = umockdev_script_runner_next_line (self, &_tmp1_, &_tmp2_, &_tmp3_);
#line 1738 "../src/umockdev.vala"
		op = _tmp1_;
#line 1738 "../src/umockdev.vala"
		delta = _tmp2_;
#line 1738 "../src/umockdev.vala"
		data = (g_free (data), NULL);
#line 1738 "../src/umockdev.vala"
		data = _tmp4_;
#line 1738 "../src/umockdev.vala"
		data_length1 = _tmp3_;
#line 1738 "../src/umockdev.vala"
		_data_size_ = data_length1;
#line 1740 "../src/umockdev.vala"
		switch (op) {
#line 1740 "../src/umockdev.vala"
			case 'r':
#line 10805 "umockdev.c"
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gssize l = 0L;
				guint8* _tmp10_;
				gint _tmp10__length1;
				guint8* _tmp11_;
				gint _tmp11__length1;
				guint8* _tmp13_;
				gint _tmp13__length1;
#line 1742 "../src/umockdev.vala"
				_tmp5_ = self->priv->_device;
#line 1742 "../src/umockdev.vala"
				g_debug ("ScriptRunner[%s]: read op; sleeping %" G_GUINT32_FORMAT " ms", _tmp5_, delta);
#line 1744 "../src/umockdev.vala"
				g_usleep ((gulong) (delta * 1000));
#line 1745 "../src/umockdev.vala"
				_tmp6_ = self->priv->_device;
#line 1745 "../src/umockdev.vala"
				_tmp7_ = data;
#line 1745 "../src/umockdev.vala"
				_tmp7__length1 = data_length1;
#line 1745 "../src/umockdev.vala"
				_tmp8_ = umockdev_script_runner_encode (_tmp7_, (gint) _tmp7__length1);
#line 1745 "../src/umockdev.vala"
				_tmp9_ = _tmp8_;
#line 1745 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1745: ScriptRunner[%s]: read op after sleep; writing dat" \
"a '%s'", _tmp6_, _tmp9_);
#line 1745 "../src/umockdev.vala"
				_g_free0 (_tmp9_);
#line 1746 "../src/umockdev.vala"
				_tmp10_ = data;
#line 1746 "../src/umockdev.vala"
				_tmp10__length1 = data_length1;
#line 1746 "../src/umockdev.vala"
				_tmp11_ = data;
#line 1746 "../src/umockdev.vala"
				_tmp11__length1 = data_length1;
#line 1746 "../src/umockdev.vala"
				l = write (self->priv->fd, _tmp10_, (gsize) _tmp11__length1);
#line 1747 "../src/umockdev.vala"
				if (l < ((gssize) 0)) {
#line 10852 "umockdev.c"
					const gchar* _tmp12_;
#line 1748 "../src/umockdev.vala"
					_tmp12_ = self->priv->_device;
#line 1748 "../src/umockdev.vala"
					g_error ("umockdev.vala:1748: ScriptRunner[%s]: write failed: %m", _tmp12_);
#line 10858 "umockdev.c"
				}
#line 1749 "../src/umockdev.vala"
				_tmp13_ = data;
#line 1749 "../src/umockdev.vala"
				_tmp13__length1 = data_length1;
#line 1749 "../src/umockdev.vala"
				_vala_assert (l == ((gssize) _tmp13__length1), "l == data.length");
#line 1750 "../src/umockdev.vala"
				break;
#line 10868 "umockdev.c"
			}
#line 1740 "../src/umockdev.vala"
			case 'w':
#line 10872 "umockdev.c"
			{
				const gchar* _tmp14_;
				guint8* _tmp15_;
				gint _tmp15__length1;
				gchar* _tmp16_;
				gchar* _tmp17_;
				guint8* _tmp18_;
				gint _tmp18__length1;
#line 1753 "../src/umockdev.vala"
				_tmp14_ = self->priv->_device;
#line 1753 "../src/umockdev.vala"
				_tmp15_ = data;
#line 1753 "../src/umockdev.vala"
				_tmp15__length1 = data_length1;
#line 1753 "../src/umockdev.vala"
				_tmp16_ = umockdev_script_runner_encode (_tmp15_, (gint) _tmp15__length1);
#line 1753 "../src/umockdev.vala"
				_tmp17_ = _tmp16_;
#line 1753 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1753: ScriptRunner[%s]: write op, data '%s'", _tmp14_, _tmp17_);
#line 1753 "../src/umockdev.vala"
				_g_free0 (_tmp17_);
#line 1754 "../src/umockdev.vala"
				_tmp18_ = data;
#line 1754 "../src/umockdev.vala"
				_tmp18__length1 = data_length1;
#line 1754 "../src/umockdev.vala"
				umockdev_script_runner_op_write (self, _tmp18_, (gint) _tmp18__length1, delta);
#line 1755 "../src/umockdev.vala"
				break;
#line 10903 "umockdev.c"
			}
#line 1740 "../src/umockdev.vala"
			case 'Q':
#line 10907 "umockdev.c"
			{
#line 1758 "../src/umockdev.vala"
				self->priv->running = FALSE;
#line 1759 "../src/umockdev.vala"
				break;
#line 10913 "umockdev.c"
			}
#line 1740 "../src/umockdev.vala"
			case 'f':
#line 10917 "umockdev.c"
			{
				const gchar* _tmp20_;
#line 1762 "../src/umockdev.vala"
				if (delta > ((guint32) 100)) {
#line 10922 "umockdev.c"
					const gchar* _tmp19_;
#line 1763 "../src/umockdev.vala"
					_tmp19_ = self->priv->_device;
#line 1763 "../src/umockdev.vala"
					g_error ("umockdev.vala:1763: ScriptRunner[%s]: fuzz value %u is invalid (must b" \
"e between 0 and 100)", _tmp19_, (guint) delta);
#line 10928 "umockdev.c"
				}
#line 1765 "../src/umockdev.vala"
				self->priv->fuzz = (guint) delta;
#line 1766 "../src/umockdev.vala"
				_tmp20_ = self->priv->_device;
#line 1766 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1766: ScriptRunner[%s]: setting fuzz level to %u%%", _tmp20_, self->priv->fuzz);
#line 1767 "../src/umockdev.vala"
				break;
#line 10938 "umockdev.c"
			}
#line 1740 "../src/umockdev.vala"
			case 'd':
#line 10942 "umockdev.c"
			{
#line 1771 "../src/umockdev.vala"
				break;
#line 10946 "umockdev.c"
			}
			default:
			{
				const gchar* _tmp21_;
#line 1774 "../src/umockdev.vala"
				_tmp21_ = self->priv->_device;
#line 1774 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1774: ScriptRunner[%s]: got unknown line op %c, ignoring", _tmp21_, (gint) op);
#line 1775 "../src/umockdev.vala"
				break;
#line 10957 "umockdev.c"
			}
		}
	}
#line 1779 "../src/umockdev.vala"
	_tmp22_ = self->priv->_device;
#line 1779 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1779: ScriptRunner[%s]: not running any more, ending thr" \
"ead", _tmp22_);
#line 1780 "../src/umockdev.vala"
	result = NULL;
#line 1780 "../src/umockdev.vala"
	data = (g_free (data), NULL);
#line 1780 "../src/umockdev.vala"
	return result;
#line 10971 "umockdev.c"
}

static gchar*
g_file_stream_read_line (FILE* self)
{
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp3_;
	gchar* result;
#line 4064 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4066 "glib-2.0.vapi"
	ret = NULL;
#line 4067 "glib-2.0.vapi"
	while (TRUE) {
#line 10987 "umockdev.c"
		GString* _tmp0_;
		GString* _tmp2_;
#line 4067 "glib-2.0.vapi"
		c = fgetc (self);
#line 4067 "glib-2.0.vapi"
		if (!(c != EOF)) {
#line 4067 "glib-2.0.vapi"
			break;
#line 10996 "umockdev.c"
		}
#line 4068 "glib-2.0.vapi"
		_tmp0_ = ret;
#line 4068 "glib-2.0.vapi"
		if (_tmp0_ == NULL) {
#line 11002 "umockdev.c"
			GString* _tmp1_;
#line 4069 "glib-2.0.vapi"
			_tmp1_ = g_string_new ("");
#line 4069 "glib-2.0.vapi"
			_g_string_free0 (ret);
#line 4069 "glib-2.0.vapi"
			ret = _tmp1_;
#line 11010 "umockdev.c"
		}
#line 4071 "glib-2.0.vapi"
		if (c == ((gint) '\n')) {
#line 4072 "glib-2.0.vapi"
			break;
#line 11016 "umockdev.c"
		}
#line 4074 "glib-2.0.vapi"
		_tmp2_ = ret;
#line 4074 "glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp2_, (gchar) c);
#line 11022 "umockdev.c"
	}
#line 4076 "glib-2.0.vapi"
	_tmp3_ = ret;
#line 4076 "glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 4077 "glib-2.0.vapi"
		result = NULL;
#line 4077 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4077 "glib-2.0.vapi"
		return result;
#line 11034 "umockdev.c"
	} else {
		GString* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 4079 "glib-2.0.vapi"
		_tmp4_ = ret;
#line 4079 "glib-2.0.vapi"
		_tmp5_ = ((GString*) _tmp4_)->str;
#line 4079 "glib-2.0.vapi"
		_tmp6_ = g_strdup (_tmp5_);
#line 4079 "glib-2.0.vapi"
		result = _tmp6_;
#line 4079 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4079 "glib-2.0.vapi"
		return result;
#line 11051 "umockdev.c"
	}
}

static guint8*
umockdev_script_runner_next_line (UMockdevScriptRunner* self,
                                  gchar* op,
                                  guint32* delta,
                                  gint* result_length1)
{
	gchar _vala_op = '\0';
	guint32 _vala_delta = 0U;
	gint c = 0;
	glong cur_pos = 0L;
	FILE* _tmp9_;
	FILE* _tmp10_;
	FILE* _tmp12_;
	FILE* _tmp13_;
	guint32 _tmp14_ = 0U;
	gint _tmp15_;
	gchar* line = NULL;
	FILE* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gint _tmp21_ = 0;
	guint8* _tmp22_;
	guint8* _tmp23_;
	gint _tmp23__length1;
	guint8* result;
#line 1783 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 11083 "umockdev.c"
	{
		gboolean _tmp0_ = FALSE;
#line 1787 "../src/umockdev.vala"
		_tmp0_ = TRUE;
#line 1787 "../src/umockdev.vala"
		while (TRUE) {
#line 11090 "umockdev.c"
			FILE* _tmp1_;
#line 1787 "../src/umockdev.vala"
			if (!_tmp0_) {
#line 11094 "umockdev.c"
			}
#line 1787 "../src/umockdev.vala"
			_tmp0_ = FALSE;
#line 1788 "../src/umockdev.vala"
			_tmp1_ = self->priv->script;
#line 1788 "../src/umockdev.vala"
			c = fgetc (_tmp1_);
#line 1789 "../src/umockdev.vala"
			if (c == EOF) {
#line 11104 "umockdev.c"
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				guint8* _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
#line 1790 "../src/umockdev.vala"
				_tmp2_ = self->priv->_device;
#line 1790 "../src/umockdev.vala"
				_tmp3_ = self->priv->script_file;
#line 1790 "../src/umockdev.vala"
				g_debug ("umockdev.vala:1790: ScriptRunner[%s]: end of script %s, closing", _tmp2_, _tmp3_);
#line 1791 "../src/umockdev.vala"
				_vala_op = 'Q';
#line 1792 "../src/umockdev.vala"
				_vala_delta = (guint32) 0;
#line 1793 "../src/umockdev.vala"
				_tmp4_ = g_new0 (guint8, 0);
#line 1793 "../src/umockdev.vala"
				_tmp5_ = _tmp4_;
#line 1793 "../src/umockdev.vala"
				_tmp5__length1 = 0;
#line 1793 "../src/umockdev.vala"
				if (result_length1) {
#line 1793 "../src/umockdev.vala"
					*result_length1 = _tmp5__length1;
#line 11130 "umockdev.c"
				}
#line 1793 "../src/umockdev.vala"
				result = _tmp5_;
#line 1793 "../src/umockdev.vala"
				if (op) {
#line 1793 "../src/umockdev.vala"
					*op = _vala_op;
#line 11138 "umockdev.c"
				}
#line 1793 "../src/umockdev.vala"
				if (delta) {
#line 1793 "../src/umockdev.vala"
					*delta = _vala_delta;
#line 11144 "umockdev.c"
				}
#line 1793 "../src/umockdev.vala"
				return result;
#line 11148 "umockdev.c"
			} else {
#line 1794 "../src/umockdev.vala"
				if (c == ((gint) '#')) {
#line 11152 "umockdev.c"
					FILE* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
#line 1795 "../src/umockdev.vala"
					_tmp6_ = self->priv->script;
#line 1795 "../src/umockdev.vala"
					_tmp7_ = g_file_stream_read_line (_tmp6_);
#line 1795 "../src/umockdev.vala"
					_tmp8_ = _tmp7_;
#line 1795 "../src/umockdev.vala"
					_vala_assert (_tmp8_ != NULL, "this.script.read_line () != null");
#line 1795 "../src/umockdev.vala"
					_g_free0 (_tmp8_);
#line 11166 "umockdev.c"
				} else {
#line 1796 "../src/umockdev.vala"
					if (c != ((gint) '\n')) {
#line 1797 "../src/umockdev.vala"
						_vala_op = (gchar) c;
#line 1798 "../src/umockdev.vala"
						break;
#line 11174 "umockdev.c"
					}
				}
			}
		}
	}
#line 1802 "../src/umockdev.vala"
	_tmp9_ = self->priv->script;
#line 1802 "../src/umockdev.vala"
	cur_pos = ftell (_tmp9_);
#line 1803 "../src/umockdev.vala"
	_tmp10_ = self->priv->script;
#line 1803 "../src/umockdev.vala"
	if (fgetc (_tmp10_) != ((gint) ' ')) {
#line 11188 "umockdev.c"
		const gchar* _tmp11_;
#line 1804 "../src/umockdev.vala"
		_tmp11_ = self->priv->script_file;
#line 1804 "../src/umockdev.vala"
		g_error ("umockdev.vala:1804: Missing space after operation code in %s at positi" \
"on %li", _tmp11_, cur_pos);
#line 11194 "umockdev.c"
	}
#line 1807 "../src/umockdev.vala"
	_tmp12_ = self->priv->script;
#line 1807 "../src/umockdev.vala"
	cur_pos = ftell (_tmp12_);
#line 1808 "../src/umockdev.vala"
	_tmp13_ = self->priv->script;
#line 1808 "../src/umockdev.vala"
	_tmp15_ = fscanf (_tmp13_, "%" G_GUINT32_FORMAT " ", &_tmp14_);
#line 1808 "../src/umockdev.vala"
	_vala_delta = _tmp14_;
#line 1808 "../src/umockdev.vala"
	if (_tmp15_ != 1) {
#line 11208 "umockdev.c"
		const gchar* _tmp16_;
#line 1809 "../src/umockdev.vala"
		_tmp16_ = self->priv->script_file;
#line 1809 "../src/umockdev.vala"
		g_error ("umockdev.vala:1809: Cannot parse time in %s at position %li", _tmp16_, cur_pos);
#line 11214 "umockdev.c"
	}
#line 1812 "../src/umockdev.vala"
	_tmp17_ = self->priv->script;
#line 1812 "../src/umockdev.vala"
	_tmp18_ = g_file_stream_read_line (_tmp17_);
#line 1812 "../src/umockdev.vala"
	line = _tmp18_;
#line 1813 "../src/umockdev.vala"
	_tmp19_ = line;
#line 1813 "../src/umockdev.vala"
	_vala_assert (_tmp19_ != NULL, "line != null");
#line 1815 "../src/umockdev.vala"
	_tmp20_ = line;
#line 1815 "../src/umockdev.vala"
	_tmp22_ = umockdev_script_runner_decode (_tmp20_, &_tmp21_);
#line 1815 "../src/umockdev.vala"
	_tmp23_ = _tmp22_;
#line 1815 "../src/umockdev.vala"
	_tmp23__length1 = _tmp21_;
#line 1815 "../src/umockdev.vala"
	if (result_length1) {
#line 1815 "../src/umockdev.vala"
		*result_length1 = _tmp23__length1;
#line 11238 "umockdev.c"
	}
#line 1815 "../src/umockdev.vala"
	result = _tmp23_;
#line 1815 "../src/umockdev.vala"
	_g_free0 (line);
#line 1815 "../src/umockdev.vala"
	if (op) {
#line 1815 "../src/umockdev.vala"
		*op = _vala_op;
#line 11248 "umockdev.c"
	}
#line 1815 "../src/umockdev.vala"
	if (delta) {
#line 1815 "../src/umockdev.vala"
		*delta = _vala_delta;
#line 11254 "umockdev.c"
	}
#line 1815 "../src/umockdev.vala"
	return result;
#line 11258 "umockdev.c"
}

static void
umockdev_script_runner_op_write (UMockdevScriptRunner* self,
                                 guint8* data,
                                 gint data_length1,
                                 guint32 delta)
{
	fd_set fds = {0};
	struct timeval timeout = {0};
	struct timeval _tmp0_ = {0};
	gssize len = 0L;
	guint8* buf = NULL;
	guint8* _tmp1_;
	gint buf_length1;
	gint _buf_size_;
#line 1818 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1821 "../src/umockdev.vala"
	_tmp0_.tv_sec = (time_t) 0;
#line 1821 "../src/umockdev.vala"
	_tmp0_.tv_usec = (glong) 200000;
#line 1821 "../src/umockdev.vala"
	timeout = _tmp0_;
#line 1822 "../src/umockdev.vala"
	len = (gssize) 0;
#line 1823 "../src/umockdev.vala"
	_tmp1_ = g_new0 (guint8, data_length1);
#line 1823 "../src/umockdev.vala"
	buf = _tmp1_;
#line 1823 "../src/umockdev.vala"
	buf_length1 = data_length1;
#line 1823 "../src/umockdev.vala"
	_buf_size_ = buf_length1;
#line 1827 "../src/umockdev.vala"
	while (TRUE) {
#line 11295 "umockdev.c"
		gboolean _tmp2_ = FALSE;
		fd_set _tmp3_ = {0};
		gint res = 0;
		struct timeval _tmp4_;
		gssize ret = 0L;
		guint8* _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp14_;
#line 1827 "../src/umockdev.vala"
		if (self->priv->running) {
#line 1827 "../src/umockdev.vala"
			_tmp2_ = len < ((gssize) data_length1);
#line 11308 "umockdev.c"
		} else {
#line 1827 "../src/umockdev.vala"
			_tmp2_ = FALSE;
#line 11312 "umockdev.c"
		}
#line 1827 "../src/umockdev.vala"
		if (!_tmp2_) {
#line 1827 "../src/umockdev.vala"
			break;
#line 11318 "umockdev.c"
		}
#line 1828 "../src/umockdev.vala"
		FD_ZERO (&_tmp3_);
#line 1828 "../src/umockdev.vala"
		fds = _tmp3_;
#line 1829 "../src/umockdev.vala"
		FD_SET (self->priv->fd, &fds);
#line 1830 "../src/umockdev.vala"
		_tmp4_ = timeout;
#line 1830 "../src/umockdev.vala"
		res = select (self->priv->fd + 1, &fds, NULL, NULL, &_tmp4_);
#line 1831 "../src/umockdev.vala"
		if (res < 0) {
#line 11332 "umockdev.c"
			const gchar* _tmp5_;
#line 1832 "../src/umockdev.vala"
			if (errno == EINTR) {
#line 1833 "../src/umockdev.vala"
				continue;
#line 11338 "umockdev.c"
			}
#line 1834 "../src/umockdev.vala"
			_tmp5_ = self->priv->_device;
#line 1834 "../src/umockdev.vala"
			g_error ("umockdev.vala:1834: ScriptRunner op_write[%s]: select() failed: %m", _tmp5_);
#line 11344 "umockdev.c"
		}
#line 1837 "../src/umockdev.vala"
		if (res == 0) {
#line 11348 "umockdev.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 1838 "../src/umockdev.vala"
			_tmp6_ = self->priv->_device;
#line 1838 "../src/umockdev.vala"
			_tmp7_ = umockdev_script_runner_encode (data + ((gint) len), (gint) (data_length1 - ((gint) len)));
#line 1838 "../src/umockdev.vala"
			_tmp8_ = _tmp7_;
#line 1838 "../src/umockdev.vala"
			g_debug ("umockdev.vala:1838: ScriptRunner[%s]: timed out on read operation on e" \
"xpected block '%s', trying again", _tmp6_, _tmp8_);
#line 1838 "../src/umockdev.vala"
			_g_free0 (_tmp8_);
#line 1840 "../src/umockdev.vala"
			continue;
#line 11364 "umockdev.c"
		}
#line 1843 "../src/umockdev.vala"
		_tmp9_ = buf;
#line 1843 "../src/umockdev.vala"
		_tmp9__length1 = buf_length1;
#line 1843 "../src/umockdev.vala"
		ret = read (self->priv->fd, &_tmp9_[len], (gsize) (data_length1 - len));
#line 1845 "../src/umockdev.vala"
		if (ret <= ((gssize) 0)) {
#line 11374 "umockdev.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			FILE* _tmp13_;
#line 1846 "../src/umockdev.vala"
			_tmp10_ = self->priv->_device;
#line 1846 "../src/umockdev.vala"
			_tmp11_ = umockdev_script_runner_encode (data + ((gint) len), (gint) (data_length1 - ((gint) len)));
#line 1846 "../src/umockdev.vala"
			_tmp12_ = _tmp11_;
#line 1846 "../src/umockdev.vala"
			g_debug ("umockdev.vala:1846: ScriptRunner[%s]: got failure or EOF on read opera" \
"tion on expected block '%s', resetting", _tmp10_, _tmp12_);
#line 1846 "../src/umockdev.vala"
			_g_free0 (_tmp12_);
#line 1848 "../src/umockdev.vala"
			_tmp13_ = self->priv->script;
#line 1848 "../src/umockdev.vala"
			fseek (_tmp13_, (glong) 0, SEEK_SET);
#line 1849 "../src/umockdev.vala"
			buf = (g_free (buf), NULL);
#line 1849 "../src/umockdev.vala"
			return;
#line 11397 "umockdev.c"
		}
#line 1852 "../src/umockdev.vala"
		len += ret;
#line 1853 "../src/umockdev.vala"
		_tmp14_ = self->priv->_device;
#line 1853 "../src/umockdev.vala"
		g_debug ("ScriptRunner[%s]: op_write, got %" G_GSSIZE_FORMAT " bytes; expecting  %" G_GSSIZE_FORMAT " more, full block size %i", _tmp14_, ret, data_length1 - len, data_length1);
#line 11405 "umockdev.c"
	}
#line 1858 "../src/umockdev.vala"
	if (!self->priv->running) {
#line 1859 "../src/umockdev.vala"
		buf = (g_free (buf), NULL);
#line 1859 "../src/umockdev.vala"
		return;
#line 11413 "umockdev.c"
	}
#line 1861 "../src/umockdev.vala"
	_vala_assert (len == ((gssize) data_length1), "len == data.length");
#line 1863 "../src/umockdev.vala"
	if (self->priv->fuzz == ((guint) 0)) {
#line 11419 "umockdev.c"
		guint8* _tmp15_;
		gint _tmp15__length1;
#line 1864 "../src/umockdev.vala"
		_tmp15_ = buf;
#line 1864 "../src/umockdev.vala"
		_tmp15__length1 = buf_length1;
#line 1864 "../src/umockdev.vala"
		if (memcmp (_tmp15_, data, (gsize) len) != 0) {
#line 11428 "umockdev.c"
			const gchar* _tmp16_;
			guint8* _tmp17_;
			gint _tmp17__length1;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 1865 "../src/umockdev.vala"
			_tmp16_ = self->priv->_device;
#line 1865 "../src/umockdev.vala"
			_tmp17_ = buf;
#line 1865 "../src/umockdev.vala"
			_tmp17__length1 = buf_length1;
#line 1865 "../src/umockdev.vala"
			_tmp18_ = umockdev_script_runner_encode (_tmp17_, (gint) _tmp17__length1);
#line 1865 "../src/umockdev.vala"
			_tmp19_ = _tmp18_;
#line 1865 "../src/umockdev.vala"
			_tmp20_ = umockdev_script_runner_encode (data, (gint) data_length1);
#line 1865 "../src/umockdev.vala"
			_tmp21_ = _tmp20_;
#line 1865 "../src/umockdev.vala"
			g_error ("ScriptRunner op_write[%s]: data mismatch; got block '%s' (%" G_GSSIZE_FORMAT " bytes), expected block '%s'", _tmp16_, _tmp19_, len, _tmp21_);
#line 1865 "../src/umockdev.vala"
			_g_free0 (_tmp21_);
#line 1865 "../src/umockdev.vala"
			_g_free0 (_tmp19_);
#line 11456 "umockdev.c"
		}
	} else {
		guint d = 0U;
		guint8* _tmp22_;
		gint _tmp22__length1;
#line 1869 "../src/umockdev.vala"
		_tmp22_ = buf;
#line 1869 "../src/umockdev.vala"
		_tmp22__length1 = buf_length1;
#line 1869 "../src/umockdev.vala"
		d = umockdev_script_runner_hamming (_tmp22_, (gint) _tmp22__length1, data, (gint) data_length1);
#line 1870 "../src/umockdev.vala"
		if (((gssize) (d * 100)) > (self->priv->fuzz * len)) {
#line 11470 "umockdev.c"
			const gchar* _tmp23_;
			guint8* _tmp24_;
			gint _tmp24__length1;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
#line 1871 "../src/umockdev.vala"
			_tmp23_ = self->priv->_device;
#line 1871 "../src/umockdev.vala"
			_tmp24_ = buf;
#line 1871 "../src/umockdev.vala"
			_tmp24__length1 = buf_length1;
#line 1871 "../src/umockdev.vala"
			_tmp25_ = umockdev_script_runner_encode (_tmp24_, (gint) _tmp24__length1);
#line 1871 "../src/umockdev.vala"
			_tmp26_ = _tmp25_;
#line 1871 "../src/umockdev.vala"
			_tmp27_ = umockdev_script_runner_encode (data, (gint) data_length1);
#line 1871 "../src/umockdev.vala"
			_tmp28_ = _tmp27_;
#line 1871 "../src/umockdev.vala"
			g_error ("ScriptRunner op_write[%s]: data mismatch; got block '%s' (%" G_GSSIZE_FORMAT " bytes), expected block '%s', difference %u%% > fuzz level %u%%", _tmp23_, _tmp26_, len, _tmp28_, ((guint) (((d * 1000) / len) + 5)) / 10, self->priv->fuzz);
#line 1871 "../src/umockdev.vala"
			_g_free0 (_tmp28_);
#line 1871 "../src/umockdev.vala"
			_g_free0 (_tmp26_);
#line 11498 "umockdev.c"
		} else {
			const gchar* _tmp29_;
			guint8* _tmp30_;
			gint _tmp30__length1;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
#line 1876 "../src/umockdev.vala"
			_tmp29_ = self->priv->_device;
#line 1876 "../src/umockdev.vala"
			_tmp30_ = buf;
#line 1876 "../src/umockdev.vala"
			_tmp30__length1 = buf_length1;
#line 1876 "../src/umockdev.vala"
			_tmp31_ = umockdev_script_runner_encode (_tmp30_, (gint) _tmp30__length1);
#line 1876 "../src/umockdev.vala"
			_tmp32_ = _tmp31_;
#line 1876 "../src/umockdev.vala"
			_tmp33_ = umockdev_script_runner_encode (data, (gint) data_length1);
#line 1876 "../src/umockdev.vala"
			_tmp34_ = _tmp33_;
#line 1876 "../src/umockdev.vala"
			g_debug ("ScriptRunner op_write[%s]: data matches: got block '%s' (%" G_GSSIZE_FORMAT " bytes), expected block '%s', difference %u%% <= fuzz level %u%%", _tmp29_, _tmp32_, len, _tmp34_, ((guint) (((d * 1000) / len) + 5)) / 10, self->priv->fuzz);
#line 1876 "../src/umockdev.vala"
			_g_free0 (_tmp34_);
#line 1876 "../src/umockdev.vala"
			_g_free0 (_tmp32_);
#line 11527 "umockdev.c"
		}
	}
#line 1818 "../src/umockdev.vala"
	buf = (g_free (buf), NULL);
#line 11532 "umockdev.c"
}

static void
_vala_array_add12 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1890 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1890 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1890 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11547 "umockdev.c"
	}
#line 1890 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11551 "umockdev.c"
}

static void
_vala_array_add13 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1893 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1893 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1893 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11566 "umockdev.c"
	}
#line 1893 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11570 "umockdev.c"
}

static guint8*
umockdev_script_runner_decode (const gchar* quoted,
                               gint* result_length1)
{
	guint8* data = NULL;
	guint8* _tmp0_;
	gint data_length1;
	gint _data_size_;
	guint8* _tmp25_;
	gint _tmp25__length1;
	guint8* result;
#line 1884 "../src/umockdev.vala"
	g_return_val_if_fail (quoted != NULL, NULL);
#line 1886 "../src/umockdev.vala"
	_tmp0_ = g_new0 (guint8, 0);
#line 1886 "../src/umockdev.vala"
	data = _tmp0_;
#line 1886 "../src/umockdev.vala"
	data_length1 = 0;
#line 1886 "../src/umockdev.vala"
	_data_size_ = data_length1;
#line 11594 "umockdev.c"
	{
		gint i = 0;
#line 1887 "../src/umockdev.vala"
		i = 0;
#line 11599 "umockdev.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1887 "../src/umockdev.vala"
			_tmp1_ = TRUE;
#line 1887 "../src/umockdev.vala"
			while (TRUE) {
#line 11606 "umockdev.c"
				gint _tmp3_;
				gint _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
				gint _tmp6_ = 0;
				guint8* _tmp7_;
				gint _tmp7__length1;
				guint8 _tmp8_;
#line 1887 "../src/umockdev.vala"
				if (!_tmp1_) {
#line 11617 "umockdev.c"
					gint _tmp2_;
#line 1887 "../src/umockdev.vala"
					i = i + 1;
#line 1887 "../src/umockdev.vala"
					_tmp2_ = i;
#line 11623 "umockdev.c"
				}
#line 1887 "../src/umockdev.vala"
				_tmp1_ = FALSE;
#line 1887 "../src/umockdev.vala"
				_tmp3_ = strlen (quoted);
#line 1887 "../src/umockdev.vala"
				_tmp4_ = _tmp3_;
#line 1887 "../src/umockdev.vala"
				if (!(i < _tmp4_)) {
#line 1887 "../src/umockdev.vala"
					break;
#line 11635 "umockdev.c"
				}
#line 1888 "../src/umockdev.vala"
				_tmp5_ = string_get_data (quoted, &_tmp6_);
#line 1888 "../src/umockdev.vala"
				_tmp5__length1 = _tmp6_;
#line 1888 "../src/umockdev.vala"
				_tmp7_ = _tmp5_;
#line 1888 "../src/umockdev.vala"
				_tmp7__length1 = _tmp5__length1;
#line 1888 "../src/umockdev.vala"
				_tmp8_ = _tmp7_[i];
#line 1888 "../src/umockdev.vala"
				if (_tmp8_ == ((guint8) '^')) {
#line 11649 "umockdev.c"
					gint _tmp9_;
					gint _tmp10_;
					gchar _tmp11_ = '\0';
					guint8* _tmp12_;
					gint _tmp12__length1;
					gint _tmp13_ = 0;
					guint8* _tmp14_;
					gint _tmp14__length1;
					guint8 _tmp15_;
					gint _tmp20_;
#line 1889 "../src/umockdev.vala"
					_tmp9_ = strlen (quoted);
#line 1889 "../src/umockdev.vala"
					_tmp10_ = _tmp9_;
#line 1889 "../src/umockdev.vala"
					_vala_assert ((i + 1) < _tmp10_, "i + 1 < quoted.length");
#line 1890 "../src/umockdev.vala"
					_tmp12_ = string_get_data (quoted, &_tmp13_);
#line 1890 "../src/umockdev.vala"
					_tmp12__length1 = _tmp13_;
#line 1890 "../src/umockdev.vala"
					_tmp14_ = _tmp12_;
#line 1890 "../src/umockdev.vala"
					_tmp14__length1 = _tmp12__length1;
#line 1890 "../src/umockdev.vala"
					_tmp15_ = _tmp14_[i + 1];
#line 1890 "../src/umockdev.vala"
					if (_tmp15_ == ((guint8) '`')) {
#line 1890 "../src/umockdev.vala"
						_tmp11_ = '^';
#line 11680 "umockdev.c"
					} else {
						guint8* _tmp16_;
						gint _tmp16__length1;
						gint _tmp17_ = 0;
						guint8* _tmp18_;
						gint _tmp18__length1;
						guint8 _tmp19_;
#line 1890 "../src/umockdev.vala"
						_tmp16_ = string_get_data (quoted, &_tmp17_);
#line 1890 "../src/umockdev.vala"
						_tmp16__length1 = _tmp17_;
#line 1890 "../src/umockdev.vala"
						_tmp18_ = _tmp16_;
#line 1890 "../src/umockdev.vala"
						_tmp18__length1 = _tmp16__length1;
#line 1890 "../src/umockdev.vala"
						_tmp19_ = _tmp18_[i + 1];
#line 1890 "../src/umockdev.vala"
						_tmp11_ = (gchar) (_tmp19_ - 64);
#line 11700 "umockdev.c"
					}
#line 1890 "../src/umockdev.vala"
					_vala_array_add12 (&data, &data_length1, &_data_size_, (guint8) _tmp11_);
#line 1891 "../src/umockdev.vala"
					i = i + 1;
#line 1891 "../src/umockdev.vala"
					_tmp20_ = i;
#line 11708 "umockdev.c"
				} else {
					guint8* _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_ = 0;
					guint8* _tmp23_;
					gint _tmp23__length1;
					guint8 _tmp24_;
#line 1893 "../src/umockdev.vala"
					_tmp21_ = string_get_data (quoted, &_tmp22_);
#line 1893 "../src/umockdev.vala"
					_tmp21__length1 = _tmp22_;
#line 1893 "../src/umockdev.vala"
					_tmp23_ = _tmp21_;
#line 1893 "../src/umockdev.vala"
					_tmp23__length1 = _tmp21__length1;
#line 1893 "../src/umockdev.vala"
					_tmp24_ = _tmp23_[i];
#line 1893 "../src/umockdev.vala"
					_vala_array_add13 (&data, &data_length1, &_data_size_, _tmp24_);
#line 11728 "umockdev.c"
				}
			}
		}
	}
#line 1895 "../src/umockdev.vala"
	_tmp25_ = data;
#line 1895 "../src/umockdev.vala"
	_tmp25__length1 = data_length1;
#line 1895 "../src/umockdev.vala"
	if (result_length1) {
#line 1895 "../src/umockdev.vala"
		*result_length1 = _tmp25__length1;
#line 11741 "umockdev.c"
	}
#line 1895 "../src/umockdev.vala"
	result = _tmp25_;
#line 1895 "../src/umockdev.vala"
	return result;
#line 11747 "umockdev.c"
}

static void
_vala_array_add14 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1903 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1903 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1903 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11762 "umockdev.c"
	}
#line 1903 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11766 "umockdev.c"
}

static void
_vala_array_add15 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1904 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1904 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1904 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11781 "umockdev.c"
	}
#line 1904 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11785 "umockdev.c"
}

static void
_vala_array_add16 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1908 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1908 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1908 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11800 "umockdev.c"
	}
#line 1908 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11804 "umockdev.c"
}

static void
_vala_array_add17 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1909 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1909 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1909 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11819 "umockdev.c"
	}
#line 1909 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11823 "umockdev.c"
}

static void
_vala_array_add18 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1911 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1911 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1911 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11838 "umockdev.c"
	}
#line 1911 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11842 "umockdev.c"
}

static void
_vala_array_add19 (guint8* * array,
                   gint* length,
                   gint* size,
                   guint8 value)
{
#line 1915 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1915 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1915 "../src/umockdev.vala"
		*array = g_renew (guint8, *array, *size);
#line 11857 "umockdev.c"
	}
#line 1915 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 11861 "umockdev.c"
}

gchar*
umockdev_script_runner_encode (guint8* data,
                               gint data_length1)
{
	guint8* quoted = NULL;
	guint8* _tmp0_;
	gint quoted_length1;
	gint _quoted_size_;
	guint8* _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_;
	gchar* result;
#line 1900 "../src/umockdev.vala"
	_tmp0_ = g_new0 (guint8, 0);
#line 1900 "../src/umockdev.vala"
	quoted = _tmp0_;
#line 1900 "../src/umockdev.vala"
	quoted_length1 = 0;
#line 1900 "../src/umockdev.vala"
	_quoted_size_ = quoted_length1;
#line 11884 "umockdev.c"
	{
		gint i = 0;
#line 1901 "../src/umockdev.vala"
		i = 0;
#line 11889 "umockdev.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1901 "../src/umockdev.vala"
			_tmp1_ = TRUE;
#line 1901 "../src/umockdev.vala"
			while (TRUE) {
#line 11896 "umockdev.c"
				guint8 _tmp3_;
#line 1901 "../src/umockdev.vala"
				if (!_tmp1_) {
#line 11900 "umockdev.c"
					gint _tmp2_;
#line 1901 "../src/umockdev.vala"
					i = i + 1;
#line 1901 "../src/umockdev.vala"
					_tmp2_ = i;
#line 11906 "umockdev.c"
				}
#line 1901 "../src/umockdev.vala"
				_tmp1_ = FALSE;
#line 1901 "../src/umockdev.vala"
				if (!(i < data_length1)) {
#line 1901 "../src/umockdev.vala"
					break;
#line 11914 "umockdev.c"
				}
#line 1902 "../src/umockdev.vala"
				_tmp3_ = data[i];
#line 1902 "../src/umockdev.vala"
				if (((gint) _tmp3_) < 32) {
#line 11920 "umockdev.c"
					guint8 _tmp4_;
#line 1903 "../src/umockdev.vala"
					_vala_array_add14 (&quoted, &quoted_length1, &_quoted_size_, (guint8) '^');
#line 1904 "../src/umockdev.vala"
					_tmp4_ = data[i];
#line 1904 "../src/umockdev.vala"
					_vala_array_add15 (&quoted, &quoted_length1, &_quoted_size_, (guint8) (_tmp4_ + 64));
#line 11928 "umockdev.c"
				} else {
					guint8 _tmp5_;
#line 1905 "../src/umockdev.vala"
					_tmp5_ = data[i];
#line 1905 "../src/umockdev.vala"
					if (_tmp5_ == ((guint8) '^')) {
#line 1908 "../src/umockdev.vala"
						_vala_array_add16 (&quoted, &quoted_length1, &_quoted_size_, (guint8) '^');
#line 1909 "../src/umockdev.vala"
						_vala_array_add17 (&quoted, &quoted_length1, &_quoted_size_, (guint8) '`');
#line 11939 "umockdev.c"
					} else {
						guint8 _tmp6_;
#line 1911 "../src/umockdev.vala"
						_tmp6_ = data[i];
#line 1911 "../src/umockdev.vala"
						_vala_array_add18 (&quoted, &quoted_length1, &_quoted_size_, _tmp6_);
#line 11946 "umockdev.c"
					}
				}
			}
		}
	}
#line 1915 "../src/umockdev.vala"
	_vala_array_add19 (&quoted, &quoted_length1, &_quoted_size_, (guint8) 0);
#line 1916 "../src/umockdev.vala"
	_tmp7_ = quoted;
#line 1916 "../src/umockdev.vala"
	_tmp7__length1 = quoted_length1;
#line 1916 "../src/umockdev.vala"
	_tmp8_ = g_strdup ((const gchar*) _tmp7_);
#line 1916 "../src/umockdev.vala"
	result = _tmp8_;
#line 1916 "../src/umockdev.vala"
	quoted = (g_free (quoted), NULL);
#line 1916 "../src/umockdev.vala"
	return result;
#line 11966 "umockdev.c"
}

static guint
umockdev_script_runner_hamming (guint8* d1,
                                gint d1_length1,
                                guint8* d2,
                                gint d2_length1)
{
	guint d = 0U;
	guint i = 0U;
	guint result;
#line 1921 "../src/umockdev.vala"
	_vala_assert (d1_length1 == d2_length1, "d1.length == d2.length");
#line 1922 "../src/umockdev.vala"
	d = (guint) 0;
#line 11982 "umockdev.c"
	{
		gboolean _tmp0_ = FALSE;
#line 1926 "../src/umockdev.vala"
		i = (guint) 0;
#line 1926 "../src/umockdev.vala"
		_tmp0_ = TRUE;
#line 1926 "../src/umockdev.vala"
		while (TRUE) {
#line 11991 "umockdev.c"
			guint8 _tmp2_;
			guint8 _tmp3_;
#line 1926 "../src/umockdev.vala"
			if (!_tmp0_) {
#line 11996 "umockdev.c"
				guint _tmp1_;
#line 1926 "../src/umockdev.vala"
				i = i + 1;
#line 1926 "../src/umockdev.vala"
				_tmp1_ = i;
#line 12002 "umockdev.c"
			}
#line 1926 "../src/umockdev.vala"
			_tmp0_ = FALSE;
#line 1926 "../src/umockdev.vala"
			if (!(i < ((guint) d1_length1))) {
#line 1926 "../src/umockdev.vala"
				break;
#line 12010 "umockdev.c"
			}
#line 1927 "../src/umockdev.vala"
			_tmp2_ = d1[i];
#line 1927 "../src/umockdev.vala"
			_tmp3_ = d2[i];
#line 1927 "../src/umockdev.vala"
			d += (guint) (((gint) (_tmp2_ ^ _tmp3_)) > 0);
#line 12018 "umockdev.c"
		}
	}
#line 1928 "../src/umockdev.vala"
	result = d;
#line 1928 "../src/umockdev.vala"
	return result;
#line 12025 "umockdev.c"
}

const gchar*
umockdev_script_runner_get_device (UMockdevScriptRunner* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1931 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1931 "../src/umockdev.vala"
	_tmp0_ = self->priv->_device;
#line 1931 "../src/umockdev.vala"
	result = _tmp0_;
#line 1931 "../src/umockdev.vala"
	return result;
#line 12041 "umockdev.c"
}

static void
umockdev_script_runner_set_device (UMockdevScriptRunner* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 1931 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1931 "../src/umockdev.vala"
	_tmp0_ = g_strdup (value);
#line 1931 "../src/umockdev.vala"
	_g_free0 (self->priv->_device);
#line 1931 "../src/umockdev.vala"
	self->priv->_device = _tmp0_;
#line 12057 "umockdev.c"
}

static void
umockdev_value_script_runner_init (GValue* value)
{
#line 1698 "../src/umockdev.vala"
	value->data[0].v_pointer = NULL;
#line 12065 "umockdev.c"
}

static void
umockdev_value_script_runner_free_value (GValue* value)
{
#line 1698 "../src/umockdev.vala"
	if (value->data[0].v_pointer) {
#line 1698 "../src/umockdev.vala"
		umockdev_script_runner_unref (value->data[0].v_pointer);
#line 12075 "umockdev.c"
	}
}

static void
umockdev_value_script_runner_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 1698 "../src/umockdev.vala"
	if (src_value->data[0].v_pointer) {
#line 1698 "../src/umockdev.vala"
		dest_value->data[0].v_pointer = umockdev_script_runner_ref (src_value->data[0].v_pointer);
#line 12087 "umockdev.c"
	} else {
#line 1698 "../src/umockdev.vala"
		dest_value->data[0].v_pointer = NULL;
#line 12091 "umockdev.c"
	}
}

static gpointer
umockdev_value_script_runner_peek_pointer (const GValue* value)
{
#line 1698 "../src/umockdev.vala"
	return value->data[0].v_pointer;
#line 12100 "umockdev.c"
}

static gchar*
umockdev_value_script_runner_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 1698 "../src/umockdev.vala"
	if (collect_values[0].v_pointer) {
#line 12111 "umockdev.c"
		UMockdevScriptRunner * object;
		object = collect_values[0].v_pointer;
#line 1698 "../src/umockdev.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1698 "../src/umockdev.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 12118 "umockdev.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1698 "../src/umockdev.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 12122 "umockdev.c"
		}
#line 1698 "../src/umockdev.vala"
		value->data[0].v_pointer = umockdev_script_runner_ref (object);
#line 12126 "umockdev.c"
	} else {
#line 1698 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 12130 "umockdev.c"
	}
#line 1698 "../src/umockdev.vala"
	return NULL;
#line 12134 "umockdev.c"
}

static gchar*
umockdev_value_script_runner_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	UMockdevScriptRunner ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1698 "../src/umockdev.vala"
	if (!object_p) {
#line 1698 "../src/umockdev.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 12149 "umockdev.c"
	}
#line 1698 "../src/umockdev.vala"
	if (!value->data[0].v_pointer) {
#line 1698 "../src/umockdev.vala"
		*object_p = NULL;
#line 12155 "umockdev.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1698 "../src/umockdev.vala"
		*object_p = value->data[0].v_pointer;
#line 12159 "umockdev.c"
	} else {
#line 1698 "../src/umockdev.vala"
		*object_p = umockdev_script_runner_ref (value->data[0].v_pointer);
#line 12163 "umockdev.c"
	}
#line 1698 "../src/umockdev.vala"
	return NULL;
#line 12167 "umockdev.c"
}

GParamSpec*
umockdev_param_spec_script_runner (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	UMockdevParamSpecScriptRunner* spec;
#line 1698 "../src/umockdev.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UMOCKDEV_TYPE_SCRIPT_RUNNER), NULL);
#line 1698 "../src/umockdev.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1698 "../src/umockdev.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1698 "../src/umockdev.vala"
	return G_PARAM_SPEC (spec);
#line 12186 "umockdev.c"
}

gpointer
umockdev_value_get_script_runner (const GValue* value)
{
#line 1698 "../src/umockdev.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SCRIPT_RUNNER), NULL);
#line 1698 "../src/umockdev.vala"
	return value->data[0].v_pointer;
#line 12196 "umockdev.c"
}

void
umockdev_value_set_script_runner (GValue* value,
                                  gpointer v_object)
{
	UMockdevScriptRunner * old;
#line 1698 "../src/umockdev.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SCRIPT_RUNNER));
#line 1698 "../src/umockdev.vala"
	old = value->data[0].v_pointer;
#line 1698 "../src/umockdev.vala"
	if (v_object) {
#line 1698 "../src/umockdev.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_SCRIPT_RUNNER));
#line 1698 "../src/umockdev.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1698 "../src/umockdev.vala"
		value->data[0].v_pointer = v_object;
#line 1698 "../src/umockdev.vala"
		umockdev_script_runner_ref (value->data[0].v_pointer);
#line 12218 "umockdev.c"
	} else {
#line 1698 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 12222 "umockdev.c"
	}
#line 1698 "../src/umockdev.vala"
	if (old) {
#line 1698 "../src/umockdev.vala"
		umockdev_script_runner_unref (old);
#line 12228 "umockdev.c"
	}
}

void
umockdev_value_take_script_runner (GValue* value,
                                   gpointer v_object)
{
	UMockdevScriptRunner * old;
#line 1698 "../src/umockdev.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SCRIPT_RUNNER));
#line 1698 "../src/umockdev.vala"
	old = value->data[0].v_pointer;
#line 1698 "../src/umockdev.vala"
	if (v_object) {
#line 1698 "../src/umockdev.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_SCRIPT_RUNNER));
#line 1698 "../src/umockdev.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1698 "../src/umockdev.vala"
		value->data[0].v_pointer = v_object;
#line 12249 "umockdev.c"
	} else {
#line 1698 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 12253 "umockdev.c"
	}
#line 1698 "../src/umockdev.vala"
	if (old) {
#line 1698 "../src/umockdev.vala"
		umockdev_script_runner_unref (old);
#line 12259 "umockdev.c"
	}
}

static void
umockdev_script_runner_class_init (UMockdevScriptRunnerClass * klass,
                                   gpointer klass_data)
{
#line 1698 "../src/umockdev.vala"
	umockdev_script_runner_parent_class = g_type_class_peek_parent (klass);
#line 1698 "../src/umockdev.vala"
	((UMockdevScriptRunnerClass *) klass)->finalize = umockdev_script_runner_finalize;
#line 1698 "../src/umockdev.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevScriptRunner_private_offset);
#line 12273 "umockdev.c"
}

static void
umockdev_script_runner_instance_init (UMockdevScriptRunner * self,
                                      gpointer klass)
{
#line 1698 "../src/umockdev.vala"
	self->priv = umockdev_script_runner_get_instance_private (self);
#line 1937 "../src/umockdev.vala"
	self->priv->fuzz = (guint) 0;
#line 1698 "../src/umockdev.vala"
	self->ref_count = 1;
#line 12286 "umockdev.c"
}

static void
umockdev_script_runner_finalize (UMockdevScriptRunner * obj)
{
	UMockdevScriptRunner * self;
#line 1698 "../src/umockdev.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_SCRIPT_RUNNER, UMockdevScriptRunner);
#line 1698 "../src/umockdev.vala"
	g_signal_handlers_destroy (self);
#line 1716 "../src/umockdev.vala"
	umockdev_script_runner_stop (self);
#line 1931 "../src/umockdev.vala"
	_g_free0 (self->priv->_device);
#line 1932 "../src/umockdev.vala"
	_g_free0 (self->priv->script_file);
#line 1933 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->thread);
#line 1934 "../src/umockdev.vala"
	_fclose0 (self->priv->script);
#line 12307 "umockdev.c"
}

static GType
umockdev_script_runner_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { umockdev_value_script_runner_init, umockdev_value_script_runner_free_value, umockdev_value_script_runner_copy_value, umockdev_value_script_runner_peek_pointer, "p", umockdev_value_script_runner_collect_value, "p", umockdev_value_script_runner_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevScriptRunnerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_script_runner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevScriptRunner), 0, (GInstanceInitFunc) umockdev_script_runner_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType umockdev_script_runner_type_id;
	umockdev_script_runner_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UMockdevScriptRunner", &g_define_type_info, &g_define_type_fundamental_info, 0);
	UMockdevScriptRunner_private_offset = g_type_add_instance_private (umockdev_script_runner_type_id, sizeof (UMockdevScriptRunnerPrivate));
	return umockdev_script_runner_type_id;
}

GType
umockdev_script_runner_get_type (void)
{
	static volatile gsize umockdev_script_runner_type_id__once = 0;
	if (g_once_init_enter (&umockdev_script_runner_type_id__once)) {
		GType umockdev_script_runner_type_id;
		umockdev_script_runner_type_id = umockdev_script_runner_get_type_once ();
		g_once_init_leave (&umockdev_script_runner_type_id__once, umockdev_script_runner_type_id);
	}
	return umockdev_script_runner_type_id__once;
}

gpointer
umockdev_script_runner_ref (gpointer instance)
{
	UMockdevScriptRunner * self;
	self = instance;
#line 1698 "../src/umockdev.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1698 "../src/umockdev.vala"
	return instance;
#line 12343 "umockdev.c"
}

void
umockdev_script_runner_unref (gpointer instance)
{
	UMockdevScriptRunner * self;
	self = instance;
#line 1698 "../src/umockdev.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1698 "../src/umockdev.vala"
		UMOCKDEV_SCRIPT_RUNNER_GET_CLASS (self)->finalize (self);
#line 1698 "../src/umockdev.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 12357 "umockdev.c"
	}
}

static inline gpointer
umockdev_socket_server_get_instance_private (UMockdevSocketServer* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevSocketServer_private_offset);
}

static gpointer
_umockdev_socket_server_run_gthread_func (gpointer self)
{
	gpointer result;
	result = umockdev_socket_server_run ((UMockdevSocketServer*) self);
#line 1956 "../src/umockdev.vala"
	umockdev_socket_server_unref (self);
#line 1956 "../src/umockdev.vala"
	return result;
#line 12376 "umockdev.c"
}

UMockdevSocketServer*
umockdev_socket_server_construct (GType object_type)
{
	UMockdevSocketServer* self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	gint* fds = NULL;
	gint* _tmp6_;
	gint fds_length1;
	gint _fds_size_;
	gint _tmp7_;
	gint _tmp8_;
	GThread* _tmp9_;
#line 1943 "../src/umockdev.vala"
	self = (UMockdevSocketServer*) g_type_create_instance (object_type);
#line 1945 "../src/umockdev.vala"
	self->priv->running = TRUE;
#line 1946 "../src/umockdev.vala"
	_tmp0_ = g_str_hash;
#line 1946 "../src/umockdev.vala"
	_tmp1_ = g_str_equal;
#line 1946 "../src/umockdev.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 1946 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->socket_scriptfile);
#line 1946 "../src/umockdev.vala"
	self->priv->socket_scriptfile = _tmp2_;
#line 1947 "../src/umockdev.vala"
	_tmp3_ = g_str_hash;
#line 1947 "../src/umockdev.vala"
	_tmp4_ = g_str_equal;
#line 1947 "../src/umockdev.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _umockdev_script_runner_unref0_);
#line 1947 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->script_runners);
#line 1947 "../src/umockdev.vala"
	self->priv->script_runners = _tmp5_;
#line 1951 "../src/umockdev.vala"
	_tmp6_ = g_new0 (gint, 2);
#line 1951 "../src/umockdev.vala"
	fds = _tmp6_;
#line 1951 "../src/umockdev.vala"
	fds_length1 = 2;
#line 1951 "../src/umockdev.vala"
	_fds_size_ = fds_length1;
#line 1952 "../src/umockdev.vala"
	_vala_assert (pipe (fds) == 0, "Posix.pipe (fds) == 0");
#line 1953 "../src/umockdev.vala"
	_tmp7_ = fds[0];
#line 1953 "../src/umockdev.vala"
	self->priv->ctrl_r = _tmp7_;
#line 1954 "../src/umockdev.vala"
	_tmp8_ = fds[1];
#line 1954 "../src/umockdev.vala"
	self->priv->ctrl_w = _tmp8_;
#line 1956 "../src/umockdev.vala"
	_tmp9_ = g_thread_new ("SocketServer", _umockdev_socket_server_run_gthread_func, umockdev_socket_server_ref (self));
#line 1956 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->thread);
#line 1956 "../src/umockdev.vala"
	self->priv->thread = _tmp9_;
#line 1943 "../src/umockdev.vala"
	fds = (g_free (fds), NULL);
#line 1943 "../src/umockdev.vala"
	return self;
#line 12448 "umockdev.c"
}

UMockdevSocketServer*
umockdev_socket_server_new (void)
{
#line 1943 "../src/umockdev.vala"
	return umockdev_socket_server_construct (UMOCKDEV_TYPE_SOCKET_SERVER);
#line 12456 "umockdev.c"
}

void
umockdev_socket_server_stop (UMockdevSocketServer* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GHashTable* _tmp3_;
	GThread* _tmp4_;
#line 1964 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1966 "../src/umockdev.vala"
	if (!self->priv->running) {
#line 1967 "../src/umockdev.vala"
		return;
#line 12472 "umockdev.c"
	}
#line 1970 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1970: Stopping SocketServer: signalling thread");
#line 1971 "../src/umockdev.vala"
	close (self->priv->ctrl_w);
#line 1974 "../src/umockdev.vala"
	_tmp0_ = self->priv->script_runners;
#line 1974 "../src/umockdev.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 12482 "umockdev.c"
	{
		GList* r_collection = NULL;
		GList* r_it = NULL;
#line 1974 "../src/umockdev.vala"
		r_collection = _tmp1_;
#line 1974 "../src/umockdev.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 12490 "umockdev.c"
			UMockdevScriptRunner* r = NULL;
#line 1974 "../src/umockdev.vala"
			r = (UMockdevScriptRunner*) r_it->data;
#line 12494 "umockdev.c"
			{
				UMockdevScriptRunner* _tmp2_;
#line 1975 "../src/umockdev.vala"
				_tmp2_ = r;
#line 1975 "../src/umockdev.vala"
				umockdev_script_runner_stop (_tmp2_);
#line 12501 "umockdev.c"
			}
		}
#line 1974 "../src/umockdev.vala"
		(r_collection == NULL) ? NULL : (r_collection = (g_list_free (r_collection), NULL));
#line 12506 "umockdev.c"
	}
#line 1976 "../src/umockdev.vala"
	_tmp3_ = self->priv->script_runners;
#line 1976 "../src/umockdev.vala"
	g_hash_table_remove_all (_tmp3_);
#line 1978 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1978: Stopping SocketServer: joining thread");
#line 1979 "../src/umockdev.vala"
	_tmp4_ = self->priv->thread;
#line 1979 "../src/umockdev.vala"
	self->priv->thread = NULL;
#line 1979 "../src/umockdev.vala"
	g_thread_join (_tmp4_);
#line 12520 "umockdev.c"
}

static void
_vala_array_add20 (GSocket** * array,
                   gint* length,
                   gint* size,
                   GSocket* value)
{
#line 1989 "../src/umockdev.vala"
	if ((*length) == (*size)) {
#line 1989 "../src/umockdev.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1989 "../src/umockdev.vala"
		*array = g_renew (GSocket*, *array, (*size) + 1);
#line 12535 "umockdev.c"
	}
#line 1989 "../src/umockdev.vala"
	(*array)[(*length)++] = value;
#line 1989 "../src/umockdev.vala"
	(*array)[*length] = NULL;
#line 12541 "umockdev.c"
}

void
umockdev_socket_server_add (UMockdevSocketServer* self,
                            const gchar* sock_path,
                            gint fd,
                            const gchar* record_file)
{
	GHashTable* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar b = '\0';
	GError* _inner_error0_ = NULL;
#line 1982 "../src/umockdev.vala"
	g_return_if_fail (self != NULL);
#line 1982 "../src/umockdev.vala"
	g_return_if_fail (sock_path != NULL);
#line 1982 "../src/umockdev.vala"
	g_return_if_fail (record_file != NULL);
#line 12561 "umockdev.c"
	{
		GSocket* s = NULL;
		GSocket* _tmp0_;
		GSocket* _tmp1_;
		gboolean _tmp2_ = FALSE;
		GSocket* _tmp3_;
		GUnixSocketAddress* _tmp4_;
		GUnixSocketAddress* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_ = FALSE;
		GSocket* _tmp8_;
		GSocket* _tmp9_;
		GSocket* _tmp10_;
#line 1985 "../src/umockdev.vala"
		_tmp0_ = g_socket_new_from_fd (fd, &_inner_error0_);
#line 1985 "../src/umockdev.vala"
		s = _tmp0_;
#line 1985 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12581 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1986 "../src/umockdev.vala"
		_tmp1_ = s;
#line 1986 "../src/umockdev.vala"
		_vala_assert (_tmp1_ != NULL, "s != null");
#line 1987 "../src/umockdev.vala"
		_tmp3_ = s;
#line 1987 "../src/umockdev.vala"
		_tmp4_ = (GUnixSocketAddress*) g_unix_socket_address_new (sock_path);
#line 1987 "../src/umockdev.vala"
		_tmp5_ = _tmp4_;
#line 1987 "../src/umockdev.vala"
		_tmp6_ = g_socket_bind (_tmp3_, (GSocketAddress*) _tmp5_, TRUE, &_inner_error0_);
#line 1987 "../src/umockdev.vala"
		_g_object_unref0 (_tmp5_);
#line 1987 "../src/umockdev.vala"
		_tmp2_ = _tmp6_;
#line 1987 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1987 "../src/umockdev.vala"
			_g_object_unref0 (s);
#line 12604 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1987 "../src/umockdev.vala"
		_vala_assert (_tmp2_, "s.bind (new UnixSocketAddress (sock_path), true)");
#line 1988 "../src/umockdev.vala"
		_tmp8_ = s;
#line 1988 "../src/umockdev.vala"
		_tmp7_ = g_socket_listen (_tmp8_, &_inner_error0_);
#line 1988 "../src/umockdev.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1988 "../src/umockdev.vala"
			_g_object_unref0 (s);
#line 12617 "umockdev.c"
			goto __catch0_g_error;
		}
#line 1988 "../src/umockdev.vala"
		_vala_assert (_tmp7_, "s.listen ()");
#line 1989 "../src/umockdev.vala"
		_tmp9_ = s;
#line 1989 "../src/umockdev.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1989 "../src/umockdev.vala"
		_vala_array_add20 (&self->priv->listen_sockets, &self->priv->listen_sockets_length1, &self->priv->_listen_sockets_size_, _tmp10_);
#line 1984 "../src/umockdev.vala"
		_g_object_unref0 (s);
#line 12630 "umockdev.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp11_;
#line 1984 "../src/umockdev.vala"
		e = _inner_error0_;
#line 1984 "../src/umockdev.vala"
		_inner_error0_ = NULL;
#line 1991 "../src/umockdev.vala"
		_tmp11_ = e->message;
#line 1991 "../src/umockdev.vala"
		g_error ("umockdev.vala:1991: load_socket_script(): cannot create Socket: %s", _tmp11_);
#line 1984 "../src/umockdev.vala"
		_g_error_free0 (e);
#line 12647 "umockdev.c"
	}
	__finally0:
#line 1984 "../src/umockdev.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1984 "../src/umockdev.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1984 "../src/umockdev.vala"
		g_clear_error (&_inner_error0_);
#line 1984 "../src/umockdev.vala"
		return;
#line 12658 "umockdev.c"
	}
#line 1994 "../src/umockdev.vala"
	g_debug ("umockdev.vala:1994: SocketServer.add: Created socket path %s, fd %i", sock_path, fd);
#line 1996 "../src/umockdev.vala"
	_tmp12_ = self->priv->socket_scriptfile;
#line 1996 "../src/umockdev.vala"
	_tmp13_ = g_strdup (sock_path);
#line 1996 "../src/umockdev.vala"
	_tmp14_ = g_strdup (record_file);
#line 1996 "../src/umockdev.vala"
	g_hash_table_insert (_tmp12_, _tmp13_, _tmp14_);
#line 1999 "../src/umockdev.vala"
	b = '1';
#line 2000 "../src/umockdev.vala"
	_vala_assert (write (self->priv->ctrl_w, &b, (gsize) 1) == ((gssize) 1), "Posix.write (this.ctrl_w, &b, 1) == 1");
#line 12674 "umockdev.c"
}

static void*
umockdev_socket_server_run (UMockdevSocketServer* self)
{
	GError* _inner_error0_ = NULL;
	void* result;
#line 2003 "../src/umockdev.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2005 "../src/umockdev.vala"
	g_debug ("umockdev.vala:2005: starting SocketServer thread");
#line 2006 "../src/umockdev.vala"
	while (TRUE) {
#line 12688 "umockdev.c"
		fd_set fds = {0};
		fd_set _tmp0_ = {0};
		gint max = 0;
		GSocket** _tmp1_;
		gint _tmp1__length1;
		gint res = 0;
		struct timeval _tmp11_ = {0};
		fd_set _tmp12_;
		GSocket** _tmp13_;
		gint _tmp13__length1;
#line 2006 "../src/umockdev.vala"
		if (!self->priv->running) {
#line 2006 "../src/umockdev.vala"
			break;
#line 12703 "umockdev.c"
		}
#line 2009 "../src/umockdev.vala"
		FD_ZERO (&_tmp0_);
#line 2009 "../src/umockdev.vala"
		fds = _tmp0_;
#line 2010 "../src/umockdev.vala"
		FD_SET (self->priv->ctrl_r, &fds);
#line 2011 "../src/umockdev.vala"
		max = self->priv->ctrl_r;
#line 2012 "../src/umockdev.vala"
		_tmp1_ = self->priv->listen_sockets;
#line 2012 "../src/umockdev.vala"
		_tmp1__length1 = self->priv->listen_sockets_length1;
#line 12717 "umockdev.c"
		{
			GSocket** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 2012 "../src/umockdev.vala"
			s_collection = _tmp1_;
#line 2012 "../src/umockdev.vala"
			s_collection_length1 = _tmp1__length1;
#line 2012 "../src/umockdev.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 12729 "umockdev.c"
				GSocket* s = NULL;
#line 2012 "../src/umockdev.vala"
				s = s_collection[s_it];
#line 12733 "umockdev.c"
				{
					GSocket* _tmp2_;
					gint _tmp3_;
					gint _tmp4_;
					GSocket* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
#line 2013 "../src/umockdev.vala"
					_tmp2_ = s;
#line 2013 "../src/umockdev.vala"
					_tmp3_ = g_socket_get_fd (_tmp2_);
#line 2013 "../src/umockdev.vala"
					_tmp4_ = _tmp3_;
#line 2013 "../src/umockdev.vala"
					FD_SET (_tmp4_, &fds);
#line 2014 "../src/umockdev.vala"
					_tmp5_ = s;
#line 2014 "../src/umockdev.vala"
					_tmp6_ = g_socket_get_fd (_tmp5_);
#line 2014 "../src/umockdev.vala"
					_tmp7_ = _tmp6_;
#line 2014 "../src/umockdev.vala"
					if (_tmp7_ > max) {
#line 12757 "umockdev.c"
						GSocket* _tmp8_;
						gint _tmp9_;
						gint _tmp10_;
#line 2015 "../src/umockdev.vala"
						_tmp8_ = s;
#line 2015 "../src/umockdev.vala"
						_tmp9_ = g_socket_get_fd (_tmp8_);
#line 2015 "../src/umockdev.vala"
						_tmp10_ = _tmp9_;
#line 2015 "../src/umockdev.vala"
						max = _tmp10_;
#line 12769 "umockdev.c"
					}
				}
			}
		}
#line 2020 "../src/umockdev.vala"
		_tmp11_.tv_sec = (time_t) 0;
#line 2020 "../src/umockdev.vala"
		_tmp11_.tv_usec = (glong) 500000;
#line 2020 "../src/umockdev.vala"
		res = select (max + 1, &fds, NULL, NULL, &_tmp11_);
#line 2021 "../src/umockdev.vala"
		if (res < 0) {
#line 2022 "../src/umockdev.vala"
			if (errno == EINTR) {
#line 2023 "../src/umockdev.vala"
				continue;
#line 12786 "umockdev.c"
			}
#line 2024 "../src/umockdev.vala"
			g_error ("umockdev.vala:2024: socket server thread: select() failed: %m");
#line 12790 "umockdev.c"
		}
#line 2026 "../src/umockdev.vala"
		if (res == 0) {
#line 2027 "../src/umockdev.vala"
			continue;
#line 12796 "umockdev.c"
		}
#line 2030 "../src/umockdev.vala"
		_tmp12_ = fds;
#line 2030 "../src/umockdev.vala"
		if (FD_ISSET (self->priv->ctrl_r, &_tmp12_) > 0) {
#line 12802 "umockdev.c"
			gchar buf = '\0';
			gssize r = 0L;
#line 2031 "../src/umockdev.vala"
			g_debug ("umockdev.vala:2031: socket server thread: woken up by control fd");
#line 2033 "../src/umockdev.vala"
			r = read (self->priv->ctrl_r, &buf, (gsize) 1);
#line 2034 "../src/umockdev.vala"
			if (r == ((gssize) 0)) {
#line 2036 "../src/umockdev.vala"
				self->priv->running = FALSE;
#line 2037 "../src/umockdev.vala"
				close (self->priv->ctrl_r);
#line 12815 "umockdev.c"
			} else {
#line 2039 "../src/umockdev.vala"
				_vala_assert (r == ((gssize) 1), "r == 1");
#line 12819 "umockdev.c"
			}
#line 2041 "../src/umockdev.vala"
			continue;
#line 12823 "umockdev.c"
		}
#line 2044 "../src/umockdev.vala"
		g_debug ("umockdev.vala:2044: socket server thread: select() got requests");
#line 2047 "../src/umockdev.vala"
		_tmp13_ = self->priv->listen_sockets;
#line 2047 "../src/umockdev.vala"
		_tmp13__length1 = self->priv->listen_sockets_length1;
#line 12831 "umockdev.c"
		{
			GSocket** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 2047 "../src/umockdev.vala"
			s_collection = _tmp13_;
#line 2047 "../src/umockdev.vala"
			s_collection_length1 = _tmp13__length1;
#line 2047 "../src/umockdev.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 12843 "umockdev.c"
				GSocket* s = NULL;
#line 2047 "../src/umockdev.vala"
				s = s_collection[s_it];
#line 12847 "umockdev.c"
				{
					GSocket* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					fd_set _tmp17_;
#line 2048 "../src/umockdev.vala"
					_tmp14_ = s;
#line 2048 "../src/umockdev.vala"
					_tmp15_ = g_socket_get_fd (_tmp14_);
#line 2048 "../src/umockdev.vala"
					_tmp16_ = _tmp15_;
#line 2048 "../src/umockdev.vala"
					_tmp17_ = fds;
#line 2048 "../src/umockdev.vala"
					if (FD_ISSET (_tmp16_, &_tmp17_) > 0) {
#line 12863 "umockdev.c"
						gint fd = 0;
						GSocket* _tmp18_;
						gint _tmp19_;
						gint _tmp20_;
						gchar* sock_path = NULL;
#line 2049 "../src/umockdev.vala"
						_tmp18_ = s;
#line 2049 "../src/umockdev.vala"
						_tmp19_ = g_socket_get_fd (_tmp18_);
#line 2049 "../src/umockdev.vala"
						_tmp20_ = _tmp19_;
#line 2049 "../src/umockdev.vala"
						fd = accept (_tmp20_, NULL, NULL);
#line 2050 "../src/umockdev.vala"
						if (fd < 0) {
#line 2051 "../src/umockdev.vala"
							g_error ("umockdev.vala:2051: socket server thread: accept() failed: %m");
#line 12881 "umockdev.c"
						}
#line 2052 "../src/umockdev.vala"
						sock_path = NULL;
#line 12885 "umockdev.c"
						{
							GSocketAddress* _tmp21_ = NULL;
							GSocket* _tmp22_;
							GSocketAddress* _tmp23_;
							const gchar* _tmp24_;
							const gchar* _tmp25_;
							gchar* _tmp26_;
							gchar* script = NULL;
							GHashTable* _tmp27_;
							const gchar* _tmp28_;
							gconstpointer _tmp29_;
							gchar* _tmp30_;
							GSocket* _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							const gchar* _tmp34_;
							const gchar* _tmp35_;
							gchar* key = NULL;
							const gchar* _tmp36_;
							gchar* _tmp37_;
							UMockdevScriptRunner* _tmp38_ = NULL;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							UMockdevScriptRunner* _tmp41_;
							GHashTable* _tmp42_;
							const gchar* _tmp43_;
							gchar* _tmp44_;
							UMockdevScriptRunner* _tmp45_;
#line 2054 "../src/umockdev.vala"
							_tmp22_ = s;
#line 2054 "../src/umockdev.vala"
							_tmp23_ = g_socket_get_local_address (_tmp22_, &_inner_error0_);
#line 2054 "../src/umockdev.vala"
							_tmp21_ = _tmp23_;
#line 2054 "../src/umockdev.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12922 "umockdev.c"
								goto __catch0_g_error;
							}
#line 2054 "../src/umockdev.vala"
							_tmp24_ = g_unix_socket_address_get_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, G_TYPE_UNIX_SOCKET_ADDRESS, GUnixSocketAddress));
#line 2054 "../src/umockdev.vala"
							_tmp25_ = _tmp24_;
#line 2054 "../src/umockdev.vala"
							_tmp26_ = g_strdup (_tmp25_);
#line 2054 "../src/umockdev.vala"
							_g_free0 (sock_path);
#line 2054 "../src/umockdev.vala"
							sock_path = _tmp26_;
#line 2055 "../src/umockdev.vala"
							_tmp27_ = self->priv->socket_scriptfile;
#line 2055 "../src/umockdev.vala"
							_tmp28_ = sock_path;
#line 2055 "../src/umockdev.vala"
							_tmp29_ = g_hash_table_lookup (_tmp27_, _tmp28_);
#line 2055 "../src/umockdev.vala"
							_tmp30_ = g_strdup ((const gchar*) _tmp29_);
#line 2055 "../src/umockdev.vala"
							script = _tmp30_;
#line 2056 "../src/umockdev.vala"
							_tmp31_ = s;
#line 2056 "../src/umockdev.vala"
							_tmp32_ = g_socket_get_fd (_tmp31_);
#line 2056 "../src/umockdev.vala"
							_tmp33_ = _tmp32_;
#line 2056 "../src/umockdev.vala"
							_tmp34_ = sock_path;
#line 2056 "../src/umockdev.vala"
							_tmp35_ = script;
#line 2056 "../src/umockdev.vala"
							g_debug ("umockdev.vala:2056: socket server thread: accepted request on server s" \
"ocket fd %i, path %s, script %s", _tmp33_, _tmp34_, _tmp35_);
#line 2058 "../src/umockdev.vala"
							_tmp36_ = sock_path;
#line 2058 "../src/umockdev.vala"
							_tmp37_ = g_strdup_printf ("%s%i", _tmp36_, fd);
#line 2058 "../src/umockdev.vala"
							key = _tmp37_;
#line 2059 "../src/umockdev.vala"
							_tmp39_ = key;
#line 2059 "../src/umockdev.vala"
							_tmp40_ = script;
#line 2059 "../src/umockdev.vala"
							_tmp41_ = umockdev_script_runner_new (_tmp39_, _tmp40_, fd, &_inner_error0_);
#line 2059 "../src/umockdev.vala"
							_tmp38_ = _tmp41_;
#line 2059 "../src/umockdev.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2059 "../src/umockdev.vala"
								_g_free0 (key);
#line 2059 "../src/umockdev.vala"
								_g_free0 (script);
#line 2059 "../src/umockdev.vala"
								_g_object_unref0 (_tmp21_);
#line 12979 "umockdev.c"
								goto __catch0_g_error;
							}
#line 2059 "../src/umockdev.vala"
							_tmp42_ = self->priv->script_runners;
#line 2059 "../src/umockdev.vala"
							_tmp43_ = key;
#line 2059 "../src/umockdev.vala"
							_tmp44_ = g_strdup (_tmp43_);
#line 2059 "../src/umockdev.vala"
							_tmp45_ = _tmp38_;
#line 2059 "../src/umockdev.vala"
							_tmp38_ = NULL;
#line 2059 "../src/umockdev.vala"
							g_hash_table_insert (_tmp42_, _tmp44_, _tmp45_);
#line 2053 "../src/umockdev.vala"
							_umockdev_script_runner_unref0 (_tmp38_);
#line 2053 "../src/umockdev.vala"
							_g_free0 (key);
#line 2053 "../src/umockdev.vala"
							_g_free0 (script);
#line 2053 "../src/umockdev.vala"
							_g_object_unref0 (_tmp21_);
#line 13002 "umockdev.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* e = NULL;
							const gchar* _tmp46_;
#line 2053 "../src/umockdev.vala"
							e = _inner_error0_;
#line 2053 "../src/umockdev.vala"
							_inner_error0_ = NULL;
#line 2061 "../src/umockdev.vala"
							_tmp46_ = e->message;
#line 2061 "../src/umockdev.vala"
							g_error ("umockdev.vala:2061: socket server thread: cannot launch ScriptRunner: " \
"%s", _tmp46_);
#line 2053 "../src/umockdev.vala"
							_g_error_free0 (e);
#line 13019 "umockdev.c"
						}
						__finally0:
#line 2053 "../src/umockdev.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2053 "../src/umockdev.vala"
							_g_free0 (sock_path);
#line 2053 "../src/umockdev.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2053 "../src/umockdev.vala"
							g_clear_error (&_inner_error0_);
#line 2053 "../src/umockdev.vala"
							return NULL;
#line 13032 "umockdev.c"
						}
#line 2048 "../src/umockdev.vala"
						_g_free0 (sock_path);
#line 13036 "umockdev.c"
					}
				}
			}
		}
	}
#line 2067 "../src/umockdev.vala"
	g_debug ("umockdev.vala:2067: socket server thread: end");
#line 2068 "../src/umockdev.vala"
	result = NULL;
#line 2068 "../src/umockdev.vala"
	return result;
#line 13048 "umockdev.c"
}

static void
umockdev_value_socket_server_init (GValue* value)
{
#line 1941 "../src/umockdev.vala"
	value->data[0].v_pointer = NULL;
#line 13056 "umockdev.c"
}

static void
umockdev_value_socket_server_free_value (GValue* value)
{
#line 1941 "../src/umockdev.vala"
	if (value->data[0].v_pointer) {
#line 1941 "../src/umockdev.vala"
		umockdev_socket_server_unref (value->data[0].v_pointer);
#line 13066 "umockdev.c"
	}
}

static void
umockdev_value_socket_server_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 1941 "../src/umockdev.vala"
	if (src_value->data[0].v_pointer) {
#line 1941 "../src/umockdev.vala"
		dest_value->data[0].v_pointer = umockdev_socket_server_ref (src_value->data[0].v_pointer);
#line 13078 "umockdev.c"
	} else {
#line 1941 "../src/umockdev.vala"
		dest_value->data[0].v_pointer = NULL;
#line 13082 "umockdev.c"
	}
}

static gpointer
umockdev_value_socket_server_peek_pointer (const GValue* value)
{
#line 1941 "../src/umockdev.vala"
	return value->data[0].v_pointer;
#line 13091 "umockdev.c"
}

static gchar*
umockdev_value_socket_server_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 1941 "../src/umockdev.vala"
	if (collect_values[0].v_pointer) {
#line 13102 "umockdev.c"
		UMockdevSocketServer * object;
		object = collect_values[0].v_pointer;
#line 1941 "../src/umockdev.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1941 "../src/umockdev.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 13109 "umockdev.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1941 "../src/umockdev.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 13113 "umockdev.c"
		}
#line 1941 "../src/umockdev.vala"
		value->data[0].v_pointer = umockdev_socket_server_ref (object);
#line 13117 "umockdev.c"
	} else {
#line 1941 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 13121 "umockdev.c"
	}
#line 1941 "../src/umockdev.vala"
	return NULL;
#line 13125 "umockdev.c"
}

static gchar*
umockdev_value_socket_server_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	UMockdevSocketServer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1941 "../src/umockdev.vala"
	if (!object_p) {
#line 1941 "../src/umockdev.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 13140 "umockdev.c"
	}
#line 1941 "../src/umockdev.vala"
	if (!value->data[0].v_pointer) {
#line 1941 "../src/umockdev.vala"
		*object_p = NULL;
#line 13146 "umockdev.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1941 "../src/umockdev.vala"
		*object_p = value->data[0].v_pointer;
#line 13150 "umockdev.c"
	} else {
#line 1941 "../src/umockdev.vala"
		*object_p = umockdev_socket_server_ref (value->data[0].v_pointer);
#line 13154 "umockdev.c"
	}
#line 1941 "../src/umockdev.vala"
	return NULL;
#line 13158 "umockdev.c"
}

GParamSpec*
umockdev_param_spec_socket_server (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	UMockdevParamSpecSocketServer* spec;
#line 1941 "../src/umockdev.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UMOCKDEV_TYPE_SOCKET_SERVER), NULL);
#line 1941 "../src/umockdev.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1941 "../src/umockdev.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1941 "../src/umockdev.vala"
	return G_PARAM_SPEC (spec);
#line 13177 "umockdev.c"
}

gpointer
umockdev_value_get_socket_server (const GValue* value)
{
#line 1941 "../src/umockdev.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SOCKET_SERVER), NULL);
#line 1941 "../src/umockdev.vala"
	return value->data[0].v_pointer;
#line 13187 "umockdev.c"
}

void
umockdev_value_set_socket_server (GValue* value,
                                  gpointer v_object)
{
	UMockdevSocketServer * old;
#line 1941 "../src/umockdev.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SOCKET_SERVER));
#line 1941 "../src/umockdev.vala"
	old = value->data[0].v_pointer;
#line 1941 "../src/umockdev.vala"
	if (v_object) {
#line 1941 "../src/umockdev.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_SOCKET_SERVER));
#line 1941 "../src/umockdev.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1941 "../src/umockdev.vala"
		value->data[0].v_pointer = v_object;
#line 1941 "../src/umockdev.vala"
		umockdev_socket_server_ref (value->data[0].v_pointer);
#line 13209 "umockdev.c"
	} else {
#line 1941 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 13213 "umockdev.c"
	}
#line 1941 "../src/umockdev.vala"
	if (old) {
#line 1941 "../src/umockdev.vala"
		umockdev_socket_server_unref (old);
#line 13219 "umockdev.c"
	}
}

void
umockdev_value_take_socket_server (GValue* value,
                                   gpointer v_object)
{
	UMockdevSocketServer * old;
#line 1941 "../src/umockdev.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_SOCKET_SERVER));
#line 1941 "../src/umockdev.vala"
	old = value->data[0].v_pointer;
#line 1941 "../src/umockdev.vala"
	if (v_object) {
#line 1941 "../src/umockdev.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_SOCKET_SERVER));
#line 1941 "../src/umockdev.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1941 "../src/umockdev.vala"
		value->data[0].v_pointer = v_object;
#line 13240 "umockdev.c"
	} else {
#line 1941 "../src/umockdev.vala"
		value->data[0].v_pointer = NULL;
#line 13244 "umockdev.c"
	}
#line 1941 "../src/umockdev.vala"
	if (old) {
#line 1941 "../src/umockdev.vala"
		umockdev_socket_server_unref (old);
#line 13250 "umockdev.c"
	}
}

static void
umockdev_socket_server_class_init (UMockdevSocketServerClass * klass,
                                   gpointer klass_data)
{
#line 1941 "../src/umockdev.vala"
	umockdev_socket_server_parent_class = g_type_class_peek_parent (klass);
#line 1941 "../src/umockdev.vala"
	((UMockdevSocketServerClass *) klass)->finalize = umockdev_socket_server_finalize;
#line 1941 "../src/umockdev.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevSocketServer_private_offset);
#line 13264 "umockdev.c"
}

static void
umockdev_socket_server_instance_init (UMockdevSocketServer * self,
                                      gpointer klass)
{
	GSocket** _tmp0_;
#line 1941 "../src/umockdev.vala"
	self->priv = umockdev_socket_server_get_instance_private (self);
#line 2071 "../src/umockdev.vala"
	_tmp0_ = g_new0 (GSocket*, 0 + 1);
#line 2071 "../src/umockdev.vala"
	self->priv->listen_sockets = _tmp0_;
#line 2071 "../src/umockdev.vala"
	self->priv->listen_sockets_length1 = 0;
#line 2071 "../src/umockdev.vala"
	self->priv->_listen_sockets_size_ = self->priv->listen_sockets_length1;
#line 1941 "../src/umockdev.vala"
	self->ref_count = 1;
#line 13284 "umockdev.c"
}

static void
umockdev_socket_server_finalize (UMockdevSocketServer * obj)
{
	UMockdevSocketServer * self;
#line 1941 "../src/umockdev.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_SOCKET_SERVER, UMockdevSocketServer);
#line 1941 "../src/umockdev.vala"
	g_signal_handlers_destroy (self);
#line 1961 "../src/umockdev.vala"
	umockdev_socket_server_stop (self);
#line 2071 "../src/umockdev.vala"
	self->priv->listen_sockets = (_vala_array_free (self->priv->listen_sockets, self->priv->listen_sockets_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2072 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->socket_scriptfile);
#line 2073 "../src/umockdev.vala"
	_g_hash_table_unref0 (self->priv->script_runners);
#line 2074 "../src/umockdev.vala"
	_g_thread_unref0 (self->priv->thread);
#line 13305 "umockdev.c"
}

static GType
umockdev_socket_server_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { umockdev_value_socket_server_init, umockdev_value_socket_server_free_value, umockdev_value_socket_server_copy_value, umockdev_value_socket_server_peek_pointer, "p", umockdev_value_socket_server_collect_value, "p", umockdev_value_socket_server_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevSocketServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_socket_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevSocketServer), 0, (GInstanceInitFunc) umockdev_socket_server_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType umockdev_socket_server_type_id;
	umockdev_socket_server_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UMockdevSocketServer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	UMockdevSocketServer_private_offset = g_type_add_instance_private (umockdev_socket_server_type_id, sizeof (UMockdevSocketServerPrivate));
	return umockdev_socket_server_type_id;
}

GType
umockdev_socket_server_get_type (void)
{
	static volatile gsize umockdev_socket_server_type_id__once = 0;
	if (g_once_init_enter (&umockdev_socket_server_type_id__once)) {
		GType umockdev_socket_server_type_id;
		umockdev_socket_server_type_id = umockdev_socket_server_get_type_once ();
		g_once_init_leave (&umockdev_socket_server_type_id__once, umockdev_socket_server_type_id);
	}
	return umockdev_socket_server_type_id__once;
}

gpointer
umockdev_socket_server_ref (gpointer instance)
{
	UMockdevSocketServer * self;
	self = instance;
#line 1941 "../src/umockdev.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1941 "../src/umockdev.vala"
	return instance;
#line 13341 "umockdev.c"
}

void
umockdev_socket_server_unref (gpointer instance)
{
	UMockdevSocketServer * self;
	self = instance;
#line 1941 "../src/umockdev.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1941 "../src/umockdev.vala"
		UMOCKDEV_SOCKET_SERVER_GET_CLASS (self)->finalize (self);
#line 1941 "../src/umockdev.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 13355 "umockdev.c"
	}
}

/**
 * umockdev_in_mock_environment:
 *
 * Check whether the current process is running under umockdev-wrapper, i. e.
 * the umockdev preload library.
 *
 * Returns: %TRUE if running under preload with mocked devices, %FALSE if
 *          running against the real system.
 */
gboolean
umockdev_in_mock_environment (void)
{
	gboolean result;
#line 2100 "../src/umockdev.vala"
	if (!umockdev___in_mock_env_initialized) {
#line 13374 "umockdev.c"
		struct stat st = {0};
		struct stat _tmp0_ = {0};
		gint _tmp1_;
#line 2102 "../src/umockdev.vala"
		_tmp1_ = stat ("/sys", &_tmp0_);
#line 2102 "../src/umockdev.vala"
		st = _tmp0_;
#line 2102 "../src/umockdev.vala"
		if (_tmp1_ >= 0) {
#line 13384 "umockdev.c"
			struct stat _tmp2_;
#line 2103 "../src/umockdev.vala"
			_tmp2_ = st;
#line 2103 "../src/umockdev.vala"
			umockdev___in_mock_env_result = _tmp2_.st_ino > ((ino_t) 1);
#line 13390 "umockdev.c"
		}
#line 2104 "../src/umockdev.vala"
		umockdev___in_mock_env_initialized = TRUE;
#line 13394 "umockdev.c"
	}
#line 2107 "../src/umockdev.vala"
	result = umockdev___in_mock_env_result;
#line 2107 "../src/umockdev.vala"
	return result;
#line 13400 "umockdev.c"
}

GQuark
umockdev_error_quark (void)
{
	return g_quark_from_static_string ("umockdev-error-quark");
}

static GType
umockdev_error_get_type_once (void)
{
	static const GEnumValue values[] = {{UMOCKDEV_ERROR_PARSE, "UMOCKDEV_ERROR_PARSE", "parse"}, {UMOCKDEV_ERROR_VALUE, "UMOCKDEV_ERROR_VALUE", "value"}, {0, NULL, NULL}};
	GType umockdev_error_type_id;
	umockdev_error_type_id = g_enum_register_static ("UMockdevError", values);
	return umockdev_error_type_id;
}

GType
umockdev_error_get_type (void)
{
	static volatile gsize umockdev_error_type_id__once = 0;
	if (g_once_init_enter (&umockdev_error_type_id__once)) {
		GType umockdev_error_type_id;
		umockdev_error_type_id = umockdev_error_get_type_once ();
		g_once_init_leave (&umockdev_error_type_id__once, umockdev_error_type_id);
	}
	return umockdev_error_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

